/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, Delegate_$type, fromEnum, runOn, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, enumGetBox, String_$type } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { XRipple } from "./XRipple";
import { NativeUI } from "igniteui-react-core";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { HorizontalAlignment_$type } from "igniteui-react-core";
import { KeyFrameAnimationFactory } from "igniteui-react-core";
import { ElevationMode_$type } from "igniteui-react-core";
import { ElevationHelper } from "./ElevationHelper";
import { ButtonDisplayStyle_$type } from "./ButtonDisplayStyle";
import { isNaN_ } from "igniteui-react-core";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { CornerRadius } from "igniteui-react-core";
import { VerticalAlignment_$type } from "igniteui-react-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-react-core";
import { ThemeResolver } from "./ThemeResolver";
import { ButtonClickEventArgs } from "./ButtonClickEventArgs";
import { MouseEventArgs } from "igniteui-react-core";
import { FocusEventArgs } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
import { ButtonVisualModelExport } from "./ButtonVisualModelExport";
import { UIElementPropertyAccessorFactory } from "igniteui-react-core";
import { AppearanceHelper } from "igniteui-react-core";
import { FontUtil } from "igniteui-react-core";
import { Dictionary$2 } from "igniteui-react-core";
import { Theme } from "./Theme";
/**
 * @hidden
 */
export let ButtonView = /*@__PURE__*/ (() => {
    class ButtonView extends Base {
        constructor() {
            super();
            this.b = null;
            this.k = null;
            this.d = null;
            this.h = new List$1(Delegate_$type, 0);
            this.e = true;
            this.n = null;
            this.j = NaN;
            this.i = NaN;
            this.l = null;
            this.c = null;
            this.m = null;
            this.p = null;
            this.o = null;
        }
        ao() {
        }
        g() {
            return true;
        }
        get q() {
            return this.n;
        }
        get s() {
            return this.m;
        }
        ai(a) {
            if (a == null) {
                for (let b of fromEnum(this.h)) {
                    b();
                }
                this.h.clear();
                return;
            }
            this.k = a;
            this.k.rootWrapper.setStyleProperty("display", "flex");
            this.k.rootWrapper.setStyleProperty("flex-direction", "row");
            this.k.rootWrapper.setStyleProperty("flex-wrap", "no-wrap");
            this.k.rootWrapper.setStyleProperty("align-items", "center");
            let c = this.k.createElement("button");
            this.n = c;
            this.n.setStyleProperty("position", "relative");
            this.n.setStyleProperty("display", "inline-flex");
            this.n.setStyleProperty("align-items", "center");
            this.n.setStyleProperty("justify-content", "center");
            this.ay();
            this.n.setStyleProperty("border", "none");
            this.n.setStyleProperty("cursor", "pointer");
            this.n.setStyleProperty("user-select", "none");
            this.n.setStyleProperty("outline-style", "none");
            this.n.setStyleProperty("-webkit-tap-highlight-color", "transparent");
            this.n.setStyleProperty("overflow", "hidden");
            this.n.setStyleProperty("white-space", "no-wrap");
            this.n.setStyleProperty("color", "#000");
            this.n.setStyleProperty("background", this.b.nf._fill);
            NativeUI.o(this.n, this.b.kr);
            this.n.setAttribute("id", this.b.hu);
            this.av();
            this.h.add(c.listen("change", runOn(this, this.x)));
            this.h.add(c.listen("click", runOn(this, this.y)));
            this.h.add(c.listen("focus", runOn(this, this.z)));
            this.h.add(c.listen("blur", runOn(this, this.w)));
            this.h.add(this.k.rootWrapper.listen("mouseenter", runOn(this, this.u)));
            this.h.add(this.k.rootWrapper.listen("mouseleave", runOn(this, this.v)));
            this.h.add(this.k.rootWrapper.listen("focusin", runOn(this, this.aa)));
            this.h.add(this.k.rootWrapper.listen("focusout", runOn(this, this.ab)));
            this.k.append(c);
            let d = this.k.createElement("div");
            let e = this.k.getSubRenderer(d);
            d.setStyleProperty("position", "absolute");
            d.setStyleProperty("width", "100%");
            d.setStyleProperty("height", "100%");
            d.setStyleProperty("left", "0px");
            d.setStyleProperty("top", "0px");
            d.setStyleProperty("overflow", "hidden");
            let f = new XRipple();
            f.provideContainer(e);
            f.q = c;
            let g = this.k.getExternal(f, this.k.rootWrapper, this.k.getExternal(this.b, null, null));
            f.h = false;
            f.k = true;
            this.c = f;
            this.n.append(d);
            let h = this.k.createElement("div");
            h.addClass("ig-button-content");
            h.setStyleProperty("font-family", "Verdana");
            h.setStyleProperty("font-weight", "400");
            h.setStyleProperty("font-size", ".875rem");
            this.m = h;
            this.h.add(h.listen("click", runOn(this, this.t)));
            this.n.append(h);
            this.o = h;
            this.k.getPortal(h, "ChildContent", (i) => {
                let comp_ = i.componentRef;
                this.p = comp_;
                {
                    this.o.setStyleProperty("flex-direction", this.b.g0);
                    this.o.setStyleProperty("align-items", this.b.e7);
                    let direction_ = this.b.g0;
                    let display_ = this.b.ff != null ? this.b.ff : this.b.fw;
                    let alignItems_ = this.b.e7;
                    comp_.display = display_;
                    comp_.flexDirection = direction_;
                    comp_.alignItems = alignItems_;
                }
            }, true);
            this.b.ke();
        }
        ak() {
            this.c.i = this.b.ap;
        }
        ay() {
            let a = "2.25rem";
            let b = "2.25rem";
            let c = "2.25rem";
            let d = "2.25rem";
            let e = "3.5rem";
            let f = "3.5rem";
            let g = "3.5rem";
            let h = "3.5rem";
            let i = "5.5rem";
            let j = "2.25rem";
            let k = "0px";
            let l = ".9375rem";
            let m = ".5625rem 1rem";
            switch (this.b.q) {
                case 2:
                    m = ".375rem .75rem";
                    j = "1.875rem";
                    e = "3rem";
                    f = "3rem";
                    g = "3rem";
                    h = "3rem";
                    l = ".6875rem";
                    break;
                case 3:
                    m = ".1875rem 1rem";
                    j = "1.5rem";
                    f = "2.5rem";
                    e = "2.5rem";
                    h = "2.5rem";
                    g = "2.5rem";
                    l = ".4375rem";
                    break;
            }
            if (!isNaN_(this.b.bi) && !isNaN_(this.b.bk) && !isNaN_(this.b.bj) && !isNaN_(this.b.bh)) {
                m = this.b.bk + "px " + this.b.bj + "px " + this.b.bh + "px " + this.b.bi + "px";
            }
            if (this.b.e == 4) {
                this.n.setStyleProperty("min-width", a);
                this.n.setStyleProperty("min-height", b);
                this.n.setStyleProperty("padding", k);
                this.n.setStyleProperty("width", c);
                this.n.setStyleProperty("height", d);
            }
            else if (this.b.e == 3) {
                this.n.setStyleProperty("min-width", e);
                this.n.setStyleProperty("min-height", f);
                this.n.setStyleProperty("padding", l);
                this.n.setStyleProperty("width", g);
                this.n.setStyleProperty("height", h);
            }
            else {
                this.n.setStyleProperty("min-width", i);
                this.n.setStyleProperty("min-height", j);
                this.n.setStyleProperty("padding", m);
            }
            if (!isNaN_(this.b.bf) && this.b.bf > 0) {
                this.n.setStyleProperty("border-style", "solid");
            }
            else {
                this.n.setStyleProperty("border-style", "none");
            }
            if (!isNaN_(this.j)) {
                this.n.setStyleProperty("min-width", this.j.toString() + "px");
            }
            if (!isNaN_(this.i)) {
                this.n.setStyleProperty("min-height", this.i.toString() + "px");
            }
            if (this.b.av) {
                this.n.setStyleProperty("width", "100%");
                this.n.setStyleProperty("height", "100%");
                this.k.rootWrapper.setStyleProperty("height", "100%");
            }
            else {
                this.n.setStyleProperty("width", "auto");
                this.n.setStyleProperty("height", "auto");
                this.k.rootWrapper.setStyleProperty("height", "auto");
            }
        }
        as() {
            switch (this.b.k5) {
                case 1:
                    this.n.setStyleProperty("justify-content", "center");
                    this.o.setStyleProperty("flex-grow", "unset");
                    break;
                case 3:
                    this.n.setStyleProperty("justify-content", "stretch");
                    this.o.setStyleProperty("flex-grow", "1");
                    break;
                case 0:
                    this.n.setStyleProperty("justify-content", "left");
                    this.o.setStyleProperty("flex-grow", "unset");
                    break;
                case 2:
                    this.n.setStyleProperty("justify-content", "right");
                    this.o.setStyleProperty("flex-grow", "unset");
                    break;
            }
        }
        au(a) {
            this.j = a;
        }
        at(a) {
            this.i = a;
        }
        aq() {
            this.n.setAttribute("disabled", this.b.disabled ? "true" : "false");
            this.n.setProperty("disabled", this.b.disabled);
        }
        al() {
            if (this.k != null) {
                this.k.rootWrapper.setStyleProperty("display", this.b.fw);
                let comp_ = this.p;
                if (this.p != null) {
                    this.o.setStyleProperty("display", this.b.fw);
                    let display_ = this.b.ff != null ? this.b.fw : this.b.ff;
                    comp_.display = display_;
                }
                let ext_ = this.k.getExternal(this.b, null, null);
                if (ext_ && ext_._onDisplayChanged) {
                    ext_._onDisplayChanged();
                }
                ;
            }
        }
        ah() {
            if (this.k != null) {
                let comp_ = this.p;
                if (this.p != null) {
                    let display_ = this.b.ff != null ? this.b.ff : this.b.fw;
                    comp_.display = display_;
                }
            }
        }
        af() {
            if (this.k != null) {
                this.k.rootWrapper.setStyleProperty("align-items", this.b.e7);
                this.n.setStyleProperty("align-items", this.b.e7);
                let comp_ = this.p;
                if (this.p != null) {
                    this.o.setStyleProperty("align-items", this.b.e7);
                    let alignItems_ = this.b.e7;
                    comp_.alignItems = alignItems_;
                }
                let ext_ = this.k.getExternal(this.b, null, null);
                if (ext_ && ext_._onAlignItemsChanged) {
                    ext_._onAlignItemsChanged();
                }
                ;
            }
        }
        am() {
            if (this.k != null) {
                this.k.rootWrapper.setStyleProperty("flex-direction", this.b.g0);
                this.n.setStyleProperty("flex-direction", this.b.g0);
                let ext_ = this.k.getExternal(this.b, null, null);
                let comp_ = this.p;
                if (this.p != null) {
                    this.o.setStyleProperty("flex-direction", this.b.g0);
                    let direction_ = this.b.g0;
                    comp_.flexDirection = direction_;
                }
                if (ext_ && ext_._onFlexDirectionChanged) {
                    ext_._onFlexDirectionChanged();
                }
                ;
            }
        }
        an() {
            if (this.k != null) {
                this.k.rootWrapper.setStyleProperty("flex-grow", this.b.g2);
                this.n.setStyleProperty("flex-grow", this.b.g2);
                let ext_ = this.k.getExternal(this.b, null, null);
                if (ext_ && ext_._onFlexGrowChanged) {
                    ext_._onFlexGrowChanged();
                }
                ;
            }
        }
        t(a) {
        }
        av() {
            if (this.g()) {
                let a = this.b.hu;
                this.n.setAttribute("name", this.b.h2);
                this.n.setProperty("value", this.b.ea);
                if (this.b.aw) {
                    this.n.setAttribute("tabindex", this.b.d3.toString());
                }
                this.n.setProperty("disabled", this.b.disabled);
                {
                }
                this.n.setAttribute("aria-label", this.b.e9);
                this.n.setStyleProperty("cursor", !this.b.as ? "pointer" : "unset");
            }
        }
        ap() {
            if (this.g()) {
                let a = this.b.hu;
                this.n.setAttribute("id", a);
            }
        }
        u(a) {
            this.b.kb();
        }
        v(a) {
            this.b.kc();
        }
        w(a) {
            this.b.j5();
        }
        z(a) {
            this.b.j8();
        }
        y(a) {
            if (!this.b.aq) {
                a.preventDefault();
            }
            this.b.j6();
        }
        aa(a) {
            this.b.j9();
        }
        ab(a) {
            this.b.ka(a.originalEvent.relatedTarget);
        }
        f() {
            return false;
        }
        x(a) {
        }
        ae() {
            if (KeyFrameAnimationFactory.h == null) {
                KeyFrameAnimationFactory.h = this.k;
            }
        }
        ag() {
            this.e = true;
            this.h.add(this.n.listen("change", runOn(this, this.x)));
            this.h.add(this.n.listen("click", runOn(this, this.y)));
            this.h.add(this.n.listen("focus", runOn(this, this.z)));
            this.h.add(this.n.listen("blur", runOn(this, this.w)));
            this.h.add(this.m.listen("click", runOn(this, this.t)));
            this.h.add(this.n.listen("mouseenter", runOn(this, this.u)));
            this.h.add(this.n.listen("mouseleave", runOn(this, this.v)));
            this.h.add(this.n.listen("focusin", runOn(this, this.aa)));
            this.h.add(this.n.listen("focusout", runOn(this, this.ab)));
        }
        aj() {
            this.e = false;
            for (let a of fromEnum(this.h)) {
                a();
            }
            this.h.clear();
        }
        ar() {
            let model_ = this.b;
            if (model_.externalObject && model_.externalObject.refreshDefaults) {
                model_.externalObject.refreshDefaults();
            }
            ;
        }
        aw(a, b) {
            this.c.ax = a;
            this.c.aw = b;
        }
        ax(a, b) {
            let c = ElevationHelper.e(a, this.b.nr, this.b.no, this.b.ne, b);
            this.n.setStyleProperty("box-shadow", c);
        }
        az(a) {
            if (a != null) {
                this.m.setStyleProperty("font", a.fontString);
            }
        }
        ac(a) {
            this.m.append(a);
        }
        ad() {
            this.m.removeChildren();
        }
        r() {
            return this.m.getChildCount() > 0 ? this.m.getChildAt(0) : null;
        }
        a() {
            let rect_ = this.k.rootWrapper.getNativeElement().getBoundingClientRect();
            let a = (rect_.top);
            let b = (rect_.left);
            let c = new Array(2);
            c[0] = a;
            c[1] = b;
            return c;
        }
    }
    ButtonView.$t = /*@__PURE__*/ markType(ButtonView, 'ButtonView');
    return ButtonView;
})();
/**
 * @hidden
 */
export let XButton = /*@__PURE__*/ (() => {
    class XButton extends Base {
        constructor() {
            super();
            this._view = null;
            this.d9 = null;
            this.pf = XButton.k.ae(XButton.m, "UmbraShadowColor");
            this.o3 = XButton.k.ae(XButton.m, "PenumbraShadowColor");
            this.nu = XButton.k.ae(XButton.m, "AmbientShadowColor");
            this.v = XButton.k.d(XButton.m, "ElevationMode");
            this.o6 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledBackgroundColor");
            this.o7 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledBorderColor");
            this.o8 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledTextColor");
            this.da = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledElevation");
            this.dd = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "RestingElevation");
            this.dc = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverElevation");
            this.db = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusElevation");
            this.o5 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "BorderColor");
            this.pd = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "RippleColor");
            this.ky = XButton.k.y(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "CornerRadius");
            this.bp = XButton.k.i(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "BorderWidth");
            this.o4 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "BackgroundColor");
            this.pe = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "TextColor");
            this.pc = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverTextColor");
            this.pb = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverBackgroundColor");
            this.o9 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusBackgroundColor");
            this.pa = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusTextColor");
            this.n8 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "DisabledBackgroundColor");
            this.n9 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "DisabledBorderColor");
            this.oa = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "DisabledTextColor");
            this.cy = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "DisabledElevation");
            this.c1 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "RestingElevation");
            this.c0 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "HoverElevation");
            this.cz = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "FocusElevation");
            this.n7 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "BorderColor");
            this.of = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "RippleColor");
            this.kv = XButton.k.y(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "CornerRadius");
            this.bm = XButton.k.i(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "BorderWidth");
            this.n6 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "BackgroundColor");
            this.og = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "TextColor");
            this.oe = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "HoverTextColor");
            this.od = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "HoverBackgroundColor");
            this.ob = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "FocusBackgroundColor");
            this.oc = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "FocusTextColor");
            this.ou = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "DisabledBackgroundColor");
            this.ov = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "DisabledBorderColor");
            this.ow = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "DisabledTextColor");
            this.c6 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "DisabledElevation");
            this.c9 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "RestingElevation");
            this.c8 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "HoverElevation");
            this.c7 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "FocusElevation");
            this.ot = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "BorderColor");
            this.o1 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "RippleColor");
            this.kx = XButton.k.y(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "CornerRadius");
            this.bo = XButton.k.i(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "BorderWidth");
            this.os = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "BackgroundColor");
            this.o2 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "TextColor");
            this.o0 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "HoverTextColor");
            this.oz = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "HoverBackgroundColor");
            this.ox = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "FocusBackgroundColor");
            this.oy = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "FocusTextColor");
            this.oj = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "DisabledBackgroundColor");
            this.ok = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "DisabledBorderColor");
            this.ol = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "DisabledTextColor");
            this.c2 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "DisabledElevation");
            this.c5 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "RestingElevation");
            this.c4 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "HoverElevation");
            this.c3 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "FocusElevation");
            this.oi = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "BorderColor");
            this.oq = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "RippleColor");
            this.kw = XButton.k.y(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "CornerRadius");
            this.bn = XButton.k.i(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "BorderWidth");
            this.oh = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "BackgroundColor");
            this.or = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "TextColor");
            this.op = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "HoverTextColor");
            this.oo = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "HoverBackgroundColor");
            this.om = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "FocusBackgroundColor");
            this.on = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "FocusTextColor");
            this.nx = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "DisabledBackgroundColor");
            this.ny = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "DisabledBorderColor");
            this.nz = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "DisabledTextColor");
            this.cu = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "DisabledElevation");
            this.cx = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "RestingElevation");
            this.cw = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "HoverElevation");
            this.cv = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "FocusElevation");
            this.nw = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "BorderColor");
            this.n4 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "RippleColor");
            this.ku = XButton.k.y(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "CornerRadius");
            this.bl = XButton.k.i(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "BorderWidth");
            this.nv = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "BackgroundColor");
            this.n5 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "TextColor");
            this.n3 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "HoverTextColor");
            this.n2 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "HoverBackgroundColor");
            this.n0 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "FocusBackgroundColor");
            this.n1 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "FocusTextColor");
            this.bc = NaN;
            this.bb = NaN;
            this.d = 0;
            this.p = 0;
            this.l = 0;
            this.o = 1;
            this.k8 = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "BorderColor");
            this.lj = ThemeResolver.ag(XButton.m, XButton.k, "UmbraShadowColor");
            this.lg = ThemeResolver.ag(XButton.m, XButton.k, "PenumbraShadowColor");
            this.k6 = ThemeResolver.ag(XButton.m, XButton.k, "AmbientShadowColor");
            this.b0 = ThemeResolver.p(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "RestingElevation");
            this.by = ThemeResolver.p(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusElevation");
            this.bz = ThemeResolver.p(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverElevation");
            this.lh = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "RippleColor");
            this.kk = ThemeResolver.aa(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "CornerRadius");
            this.k7 = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "BackgroundColor");
            this.k9 = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledBackgroundColor");
            this.la = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledBorderColor");
            this.lb = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledTextColor");
            this.bx = ThemeResolver.p(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledElevation");
            this.s = ThemeResolver.f(XButton.m, XButton.k, "ElevationMode");
            this.li = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "TextColor");
            this.lf = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverTextColor");
            this.lc = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusBackgroundColor");
            this.ld = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusTextColor");
            this.le = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverBackgroundColor");
            this.a2 = ThemeResolver.k(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "BorderWidth");
            this.m1 = null;
            this.m3 = null;
            this.m4 = null;
            this.m5 = null;
            this.ck = -1;
            this.m8 = null;
            this.m2 = null;
            this.cn = -1;
            this.cm = -1;
            this.cl = -1;
            this.be = NaN;
            this.kq = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.na = null;
            this.lz = null;
            this.l1 = null;
            this.l2 = null;
            this.l3 = null;
            this.b6 = -1;
            this.l6 = null;
            this.l0 = null;
            this.b9 = -1;
            this.b8 = -1;
            this.b7 = -1;
            this.l8 = null;
            this.l9 = null;
            this.l7 = null;
            this.l4 = null;
            this.l5 = null;
            this.a9 = NaN;
            this.kn = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.lk = null;
            this.lm = null;
            this.ln = null;
            this.lo = null;
            this.b1 = -1;
            this.t = 0;
            this.mc = null;
            this.ll = null;
            this.co = -1;
            this.cb = -1;
            this.ca = -1;
            this.z = null;
            this.nd = null;
            this.me = null;
            this.nc = null;
            this.nb = null;
            this.m9 = null;
            this.m6 = null;
            this.m7 = null;
            this.ma = null;
            this.mb = null;
            this.a3 = NaN;
            this.kl = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.mq = null;
            this.ms = null;
            this.mt = null;
            this.mu = null;
            this.cg = -1;
            this.mx = null;
            this.mr = null;
            this.cj = -1;
            this.ci = -1;
            this.ch = -1;
            this.bd = NaN;
            this.kp = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.mz = null;
            this.m0 = null;
            this.my = null;
            this.mv = null;
            this.mw = null;
            this.lp = null;
            this.lr = null;
            this.ls = null;
            this.lt = null;
            this.b2 = -1;
            this.md = null;
            this.lq = null;
            this.b5 = -1;
            this.b4 = -1;
            this.b3 = -1;
            this.a8 = NaN;
            this.km = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.lx = null;
            this.ly = null;
            this.lw = null;
            this.lu = null;
            this.lv = null;
            this.mf = null;
            this.mh = null;
            this.mi = null;
            this.mj = null;
            this.cc = -1;
            this.mm = null;
            this.mg = null;
            this.cf = -1;
            this.ce = -1;
            this.cd = -1;
            this.ba = NaN;
            this.ko = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.mo = null;
            this.mp = null;
            this.mn = null;
            this.mk = null;
            this.ml = null;
            this.ei = "ig-native-button-" + XButton.d5++;
            this.eh = "ig-button-" + XButton.d4++;
            this.ee = "inline-block";
            this.ed = null;
            this.ef = "inline-block";
            this.eg = null;
            this.eb = "center";
            this.d6 = null;
            this.ej = null;
            this.cp = 0;
            this.ak = false;
            this.ec = null;
            this.aj = false;
            this.am = false;
            this.an = true;
            this.ah = false;
            this.ad = false;
            this.af = false;
            this.ao = false;
            this.al = false;
            this.ai = false;
            this.ag = false;
            this.a5 = NaN;
            this.a7 = NaN;
            this.a6 = NaN;
            this.a4 = NaN;
            this.k4 = 1;
            this.q8 = 1;
            this.ae = true;
            this.propertyChanged = null;
            this.clicked = null;
            this.mouseEnter = null;
            this.mouseLeave = null;
            this.gotFocus = null;
            this.lostFocus = null;
            let a = new ButtonView();
            a.b = this;
            this.view = a;
            this.view.ao();
        }
        get view() {
            return this._view;
        }
        set view(a) {
            this._view = a;
        }
        destroy() {
            this.provideContainer(null);
        }
        kd(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.kf(a, b, c);
        }
        kf(a, b, c) {
            switch (a) {
                case "CornerRadius":
                case "BorderColor":
                case "RestingElevation":
                case "HoverElevation":
                case "FocusElevation":
                case "RippleColor":
                case "BorderWidth":
                case "BackgroundColor":
                case "DisabledBackgroundColor":
                case "DisabledBorderColor":
                case "DisabledTextColor":
                case "DisabledElevation":
                case "HoverBackgroundColor":
                case "FocusTextColor":
                case "TextColor":
                case "HoverTextColor":
                case "FocusBackgroundColor":
                case "RaisedBorderColor":
                case "RaisedRestingElevation":
                case "RaisedFocusElevation":
                case "RaisedHoverElevation":
                case "RaisedRippleColor":
                case "RaisedBorderWidth":
                case "RaisedBackgroundColor":
                case "RaisedDisabledBackgroundColor":
                case "RaisedDisabledBorderColor":
                case "RaisedDisabledTextColor":
                case "RaisedDisabledElevation":
                case "RaisedHoverBackgroundColor":
                case "RaisedCornerRadius":
                case "RaisedFocusBackgroundColor":
                case "RaisedFocusTextColor":
                case "RaisedTextColor":
                case "RaisedHoverTextColor":
                case "FlatBorderColor":
                case "FlatRestingElevation":
                case "FlatFocusElevation":
                case "FlatHoverElevation":
                case "FlatRippleColor":
                case "FlatBorderWidth":
                case "FlatBackgroundColor":
                case "FlatDisabledBackgroundColor":
                case "FlatDisabledBorderColor":
                case "FlatDisabledTextColor":
                case "FlatDisabledElevation":
                case "FlatHoverBackgroundColor":
                case "FlatCornerRadius":
                case "FlatFocusBackgroundColor":
                case "FlatFocusTextColor":
                case "FlatTextColor":
                case "FlatHoverTextColor":
                case "OutlinedRippleColor":
                case "OutlinedRestingElevation":
                case "OutlinedFocusElevation":
                case "OutlinedHoverElevation":
                case "OutlinedBorderColor":
                case "OutlinedBorderWidth":
                case "OutlinedBackgroundColor":
                case "OutlinedDisabledBackgroundColor":
                case "OutlinedDisabledBorderColor":
                case "OutlinedDisabledTextColor":
                case "OutlinedDisabledElevation":
                case "OutlinedHoverBackgroundColor":
                case "OutlinedCornerRadius":
                case "OutlinedFocusBackgroundColor":
                case "OutlinedFocusTextColor":
                case "OutlinedTextColor":
                case "OutlinedHoverTextColor":
                case "FabBorderColor":
                case "FabRippleColor":
                case "FabRestingElevation":
                case "FabFocusElevation":
                case "FabHoverElevation":
                case "FabBorderWidth":
                case "FabBackgroundColor":
                case "FabDisabledBackgroundColor":
                case "FabDisabledBorderColor":
                case "FabDisabledTextColor":
                case "FabDisabledElevation":
                case "FabHoverBackgroundColor":
                case "FabCornerRadius":
                case "FabFocusBackgroundColor":
                case "FabFocusTextColor":
                case "FabTextColor":
                case "FabHoverTextColor":
                case "IconRestingElevation":
                case "IconFocusElevation":
                case "IconHoverElevation":
                case "IconBorderColor":
                case "IconRippleColor":
                case "IconBorderWidth":
                case "IconBackgroundColor":
                case "IconDisabledBackgroundColor":
                case "IconDisabledBorderColor":
                case "IconDisabledTextColor":
                case "IconDisabledElevation":
                case "IconHoverBackgroundColor":
                case "IconCornerRadius":
                case "IconFocusBackgroundColor":
                case "IconFocusTextColor":
                case "IconTextColor":
                case "IconHoverTextColor":
                case "ElevationMode":
                    this.ki();
                    break;
                case "BaseTheme":
                    this.kj(this.n == 0 ? 2 : this.n);
                    this.ki();
                    break;
                case "IsDisabled":
                    this.ap = this.disabled || this.at;
                    this.ki();
                    this.view.aq();
                    break;
                case "DisableRipple":
                    this.ap = this.disabled || this.at;
                    this.ki();
                    break;
                case "TextStyle":
                case "DisableHover":
                    this.kh();
                    break;
                case "ActualDisableRipple":
                    this.view.ak();
                    break;
                case "ActualBackgroundColor":
                case "ActualDisabledBackgroundColor":
                case "ActualDisabledBorderColor":
                case "ActualDisabledTextColor":
                case "ActualDisabledElevation":
                case "ActualHoverBackgroundColor":
                case "ActualBorderColor":
                case "ActualFocusTextColor":
                case "ActualHoverTextColor":
                case "ActualElevationMode":
                    this.kh();
                    break;
                case "Density":
                    this.q = this.r == 0 ? 1 : this.r;
                    break;
                case "ActualDensity":
                case "ActualBorderWidth":
                case "ActualCornerRadius":
                    this.view.ay();
                    this.kh();
                    break;
                case "DisplayType":
                    this.view.ay();
                    this.ki();
                    this.kh();
                    break;
                case "ContentPaddingLeft":
                case "ContentPaddingTop":
                case "ContentPaddingRight":
                case "ContentPaddingBottom":
                case "FillAvailableSpace":
                    this.view.ay();
                    break;
                case "HorizontalContentAlignment":
                case "VerticalContentAlignment":
                    this.view.as();
                    break;
                case "InputId":
                    this.view.ap();
                    break;
                case "Display":
                    this.view.al();
                    break;
                case "ChildContentDisplay":
                    this.view.ah();
                    break;
                case "FlexDirection":
                    this.view.am();
                    break;
                case "FlexGrow":
                    this.view.an();
                    break;
                case "AlignItems":
                    this.view.af();
                    break;
                case "TabIndex":
                case "DisablePointer":
                    this.view.av();
                    break;
                case "MinWidth":
                    this.view.au(this.bu);
                    this.view.ay();
                    break;
                case "MinHeight":
                    this.view.at(this.bt);
                    this.view.ay();
                    break;
            }
        }
        ks(a, b) {
            return new CornerRadius(1, !isNaN_(a.c) ? a.c : b.c, !isNaN_(a.d) ? a.d : b.d, !isNaN_(a.b) ? a.b : b.b, !isNaN_(a.a) ? a.a : b.a);
        }
        ki() {
            this.u = this.w != 0 ? this.w : this.v;
            this.nr = this.pf;
            this.no = this.o3;
            this.ne = this.nu;
            switch (this.e) {
                case 0:
                    this.nh = this.pg != null ? this.pg : this.qx != null ? this.qx : this.o6;
                    this.ni = this.ph != null ? this.ph : this.qy != null ? this.qy : this.o7;
                    this.nj = this.pi != null ? this.pi : this.qz != null ? this.qz : this.o8;
                    this.cq = this.de >= 0 ? this.de : this.dy >= 0 ? this.dy : this.da;
                    this.ct = this.d2 >= 0 ? this.d2 : this.d1 >= 0 ? this.d1 : this.dd;
                    this.cs = this.dp >= 0 ? this.dp : this.d0 >= 0 ? this.d0 : this.dc;
                    this.cr = this.dn >= 0 ? this.dn : this.dz >= 0 ? this.dz : this.db;
                    this.ng = this.nt != null ? this.nt : this.qw != null ? this.qw : this.o5;
                    this.nf = this.ns != null ? this.ns : this.qv != null ? this.qv : this.o4;
                    this.nm = this.p7 != null ? this.p7 : this.q2 != null ? this.q2 : this.pb;
                    this.kr = this.ks(this.kt, this.ks(this.k3, this.ky));
                    this.bf = !isNaN_(this.bg) ? this.bg : !isNaN_(this.bw) ? this.bw : this.bp;
                    this.np = this.q6 != null ? this.q6 : this.q4 != null ? this.q4 : this.pd;
                    this.nk = this.p5 != null ? this.p5 : this.q0 != null ? this.q0 : this.o9;
                    this.nl = this.p6 != null ? this.p6 : this.q1 != null ? this.q1 : this.pa;
                    this.nq = this.q7 != null ? this.q7 : this.q5 != null ? this.q5 : this.pe;
                    this.nn = this.p8 != null ? this.p8 : this.q3 != null ? this.q3 : this.pc;
                    break;
                case 2:
                    this.nh = this.pg != null ? this.pg : this.qm != null ? this.qm : this.ou;
                    this.ni = this.ph != null ? this.ph : this.qn != null ? this.qn : this.ov;
                    this.nj = this.pi != null ? this.pi : this.qo != null ? this.qo : this.ow;
                    this.cq = this.de >= 0 ? this.de : this.du >= 0 ? this.du : this.c6;
                    this.ct = this.d2 >= 0 ? this.d2 : this.dx >= 0 ? this.dx : this.c9;
                    this.cs = this.dp >= 0 ? this.dp : this.dw >= 0 ? this.dw : this.c8;
                    this.cr = this.dn >= 0 ? this.dn : this.dv >= 0 ? this.dv : this.c7;
                    this.ng = this.nt != null ? this.nt : this.ql != null ? this.ql : this.ot;
                    this.nf = this.p7 != null ? this.p7 : this.ns != null ? this.ns : this.qk != null ? this.qk : this.os;
                    this.nm = this.qr != null ? this.qr : this.oz;
                    this.kr = this.ks(this.kt, this.ks(this.k2, this.kx));
                    this.bf = !isNaN_(this.bg) ? this.bg : !isNaN_(this.bv) ? this.bv : this.bo;
                    this.np = this.q6 != null ? this.q6 : this.qt != null ? this.qt : this.o1;
                    this.nk = this.p5 != null ? this.p5 : this.qp != null ? this.qp : this.ox;
                    this.nl = this.p6 != null ? this.p6 : this.qq != null ? this.qq : this.oy;
                    this.nq = this.q7 != null ? this.q7 : this.qu != null ? this.qu : this.o2;
                    this.nn = this.p8 != null ? this.p8 : this.qs != null ? this.qs : this.o0;
                    break;
                case 1:
                    this.nh = this.pg != null ? this.pg : this.pw != null ? this.pw : this.n8;
                    this.ni = this.ph != null ? this.ph : this.px != null ? this.px : this.n9;
                    this.nj = this.pi != null ? this.pi : this.py != null ? this.py : this.oa;
                    this.cq = this.de >= 0 ? this.de : this.dj >= 0 ? this.dj : this.cy;
                    this.ct = this.d2 >= 0 ? this.d2 : this.dm >= 0 ? this.dm : this.c1;
                    this.cs = this.dp >= 0 ? this.dp : this.dl >= 0 ? this.dl : this.c0;
                    this.cr = this.dn >= 0 ? this.dn : this.dk >= 0 ? this.dk : this.cz;
                    this.ng = this.nt != null ? this.nt : this.pv != null ? this.pv : this.n7;
                    this.nf = this.ns != null ? this.ns : this.pu != null ? this.pu : this.n6;
                    this.nm = this.p7 != null ? this.p7 : this.p1 != null ? this.p1 : this.od;
                    this.kr = this.ks(this.kt, this.ks(this.k0, this.kv));
                    this.bf = !isNaN_(this.bg) ? this.bg : !isNaN_(this.br) ? this.br : this.bm;
                    this.np = this.q6 != null ? this.q6 : this.p3 != null ? this.p3 : this.of;
                    this.nk = this.p5 != null ? this.p5 : this.pz != null ? this.pz : this.ob;
                    this.nl = this.p6 != null ? this.p6 : this.p0 != null ? this.p0 : this.oc;
                    this.nq = this.q7 != null ? this.q7 : this.p4 != null ? this.p4 : this.og;
                    this.nn = this.p8 != null ? this.p8 : this.p2 != null ? this.p2 : this.oe;
                    break;
                case 4:
                    this.nh = this.pg != null ? this.pg : this.qb != null ? this.qb : this.oj;
                    this.ni = this.ph != null ? this.ph : this.qc != null ? this.qc : this.ok;
                    this.nj = this.pi != null ? this.pi : this.qd != null ? this.qd : this.ol;
                    this.cq = this.de >= 0 ? this.de : this.dq >= 0 ? this.dq : this.c2;
                    this.ct = this.d2 >= 0 ? this.d2 : this.dt >= 0 ? this.dt : this.c5;
                    this.cs = this.dp >= 0 ? this.dp : this.ds >= 0 ? this.ds : this.c4;
                    this.cr = this.dn >= 0 ? this.dn : this.dr >= 0 ? this.dr : this.c3;
                    this.ng = this.nt != null ? this.nt : this.qa != null ? this.qa : this.oi;
                    this.nf = this.ns != null ? this.ns : this.p9 != null ? this.p9 : this.oh;
                    this.nm = this.p7 != null ? this.p7 : this.qg != null ? this.qg : this.oo;
                    this.kr = this.ks(this.kt, this.ks(this.k1, this.kw));
                    this.bf = !isNaN_(this.bg) ? this.bg : !isNaN_(this.bs) ? this.bs : this.bn;
                    this.np = this.q6 != null ? this.q6 : this.qi != null ? this.qi : this.oq;
                    this.nk = this.p5 != null ? this.p5 : this.qe != null ? this.qe : this.om;
                    this.nl = this.p6 != null ? this.p6 : this.qf != null ? this.qf : this.on;
                    this.nq = this.q7 != null ? this.q7 : this.qj != null ? this.qj : this.or;
                    this.nn = this.p8 != null ? this.p8 : this.qh != null ? this.qh : this.op;
                    break;
                case 3:
                    this.nh = this.pg != null ? this.pg : this.pl != null ? this.pl : this.nx;
                    this.ni = this.ph != null ? this.ph : this.pm != null ? this.pm : this.ny;
                    this.nj = this.pi != null ? this.pi : this.pn != null ? this.pn : this.nz;
                    this.cq = this.de >= 0 ? this.de : this.df >= 0 ? this.df : this.cu;
                    this.ct = this.d2 >= 0 ? this.d2 : this.di >= 0 ? this.di : this.cx;
                    this.cs = this.dp >= 0 ? this.dp : this.dh >= 0 ? this.dh : this.cw;
                    this.cr = this.dn >= 0 ? this.dn : this.dg >= 0 ? this.dg : this.cv;
                    this.ng = this.nt != null ? this.nt : this.pk != null ? this.pk : this.nw;
                    this.nf = this.ns != null ? this.ns : this.pj != null ? this.pj : this.nv;
                    this.nm = this.p7 != null ? this.p7 : this.pq != null ? this.pq : this.n2;
                    this.kr = this.ks(this.kt, this.ks(this.kz, this.ku));
                    this.bf = !isNaN_(this.bg) ? this.bg : !isNaN_(this.bq) ? this.bq : this.bl;
                    this.np = this.q6 != null ? this.q6 : this.ps != null ? this.ps : this.pd;
                    this.nk = this.p5 != null ? this.p5 : this.po != null ? this.po : this.n0;
                    this.nl = this.p6 != null ? this.p6 : this.pp != null ? this.pp : this.n1;
                    this.nq = this.q7 != null ? this.q7 : this.pt != null ? this.pt : this.n5;
                    this.nn = this.p8 != null ? this.p8 : this.pr != null ? this.pr : this.n3;
                    break;
            }
        }
        j6() {
            if (this.disabled) {
                return;
            }
            if (this.clicked != null) {
                this.clicked(this, new ButtonClickEventArgs());
            }
        }
        j5() {
            this.focused = false;
            this.kh();
        }
        j8() {
            this.focused = true;
            this.kh();
        }
        kc() {
            this.a0 = false;
            this.kh();
            if (this.mouseLeave != null) {
                this.mouseLeave(this, new MouseEventArgs());
            }
        }
        kb() {
            this.a0 = true;
            this.kh();
            if (this.mouseEnter != null) {
                this.mouseEnter(this, new MouseEventArgs());
            }
        }
        j9() {
            if (this.gotFocus != null) {
                this.gotFocus(this, new FocusEventArgs());
            }
        }
        ka(a) {
            if (this.lostFocus != null) {
                this.lostFocus(this, ((() => {
                    let $ret = new FocusEventArgs();
                    $ret.a = a;
                    return $ret;
                })()));
            }
        }
        kh() {
            let a = this.view.q;
            if (a == null) {
                return;
            }
            NativeUI.o(a, this.kr);
            NativeUI.n(a, this.ng);
            if (!isNaN_(this.bf)) {
                NativeUI.p(a, new Thickness(0, this.bf));
            }
            if (this.disabled) {
                this.view.ax(this.cq, this.u);
            }
            else if (this.focused && this.az) {
                this.view.ax(this.cr, this.u);
            }
            else {
                if (this.a0 && !this.ar) {
                    this.view.ax(this.cs, this.u);
                }
                else {
                    this.view.ax(this.ct, this.u);
                }
            }
            if (this.disabled) {
                NativeUI.m(a, this.nh);
            }
            else if (this.focused && this.az) {
                NativeUI.m(a, this.nk);
            }
            else {
                if (this.a0 && !this.ar) {
                    NativeUI.m(a, this.nm);
                }
                else {
                    NativeUI.m(a, this.nf);
                }
            }
            this.view.aw(this.np, BrushUtil.h(0, 0, 0, 0));
            if (this.aa != null) {
                this.view.az(this.aa);
            }
            if (this.disabled) {
                NativeUI.q(this.view.s, this.nj);
                NativeUI.r(this.view.s, this.nj);
            }
            else if (this.focused && this.az) {
                NativeUI.q(this.view.s, this.nl);
                NativeUI.r(this.view.s, this.nl);
            }
            else {
                if (this.a0 && !this.ar) {
                    NativeUI.q(this.view.s, this.nn);
                    NativeUI.r(this.view.s, this.nn);
                }
                else {
                    NativeUI.q(this.view.s, this.nq);
                    NativeUI.r(this.view.s, this.nq);
                }
            }
        }
        kj(a) {
            this.pf = XButton.k.ae(a, "UmbraShadowColor");
            this.o3 = XButton.k.ae(a, "PenumbraShadowColor");
            this.nu = XButton.k.ae(a, "AmbientShadowColor");
            this.v = XButton.k.d(a, "ElevationMode");
            this.o6 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledBackgroundColor");
            this.o7 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledBorderColor");
            this.o8 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledTextColor");
            this.da = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledElevation");
            this.dd = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 0), "RestingElevation");
            this.dc = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverElevation");
            this.db = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusElevation");
            this.o5 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "BorderColor");
            this.pd = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "RippleColor");
            this.ky = XButton.k.y(a, enumGetBox(ButtonDisplayStyle_$type, 0), "CornerRadius");
            this.bp = XButton.k.i(a, enumGetBox(ButtonDisplayStyle_$type, 0), "BorderWidth");
            this.o4 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "BackgroundColor");
            this.pe = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "TextColor");
            this.pc = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverTextColor");
            this.pb = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverBackgroundColor");
            this.o9 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusBackgroundColor");
            this.pa = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusTextColor");
            this.n8 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "DisabledBackgroundColor");
            this.n9 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "DisabledBorderColor");
            this.oa = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "DisabledTextColor");
            this.cy = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 1), "DisabledElevation");
            this.c1 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 1), "RestingElevation");
            this.c0 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 1), "HoverElevation");
            this.cz = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 1), "FocusElevation");
            this.n7 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "BorderColor");
            this.of = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "RippleColor");
            this.kv = XButton.k.y(a, enumGetBox(ButtonDisplayStyle_$type, 1), "CornerRadius");
            this.bm = XButton.k.i(a, enumGetBox(ButtonDisplayStyle_$type, 1), "BorderWidth");
            this.n6 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "BackgroundColor");
            this.og = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "TextColor");
            this.oe = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "HoverTextColor");
            this.od = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "HoverBackgroundColor");
            this.ob = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "FocusBackgroundColor");
            this.oc = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "FocusTextColor");
            this.ou = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "DisabledBackgroundColor");
            this.ov = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "DisabledBorderColor");
            this.ow = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "DisabledTextColor");
            this.c6 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 2), "DisabledElevation");
            this.c9 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 2), "RestingElevation");
            this.c8 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 2), "HoverElevation");
            this.c7 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 2), "FocusElevation");
            this.ot = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "BorderColor");
            this.o1 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "RippleColor");
            this.kx = XButton.k.y(a, enumGetBox(ButtonDisplayStyle_$type, 2), "CornerRadius");
            this.bo = XButton.k.i(a, enumGetBox(ButtonDisplayStyle_$type, 2), "BorderWidth");
            this.os = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "BackgroundColor");
            this.o2 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "TextColor");
            this.o0 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "HoverTextColor");
            this.oz = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "HoverBackgroundColor");
            this.ox = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "FocusBackgroundColor");
            this.oy = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "FocusTextColor");
            this.oj = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "DisabledBackgroundColor");
            this.ok = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "DisabledBorderColor");
            this.ol = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "DisabledTextColor");
            this.c2 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 4), "DisabledElevation");
            this.c5 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 4), "RestingElevation");
            this.c4 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 4), "HoverElevation");
            this.c3 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 4), "FocusElevation");
            this.oi = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "BorderColor");
            this.oq = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "RippleColor");
            this.kw = XButton.k.y(a, enumGetBox(ButtonDisplayStyle_$type, 4), "CornerRadius");
            this.bn = XButton.k.i(a, enumGetBox(ButtonDisplayStyle_$type, 4), "BorderWidth");
            this.oh = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "BackgroundColor");
            this.or = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "TextColor");
            this.op = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "HoverTextColor");
            this.oo = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "HoverBackgroundColor");
            this.om = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "FocusBackgroundColor");
            this.on = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "FocusTextColor");
            this.nx = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "DisabledBackgroundColor");
            this.ny = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "DisabledBorderColor");
            this.nz = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "DisabledTextColor");
            this.cu = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 3), "DisabledElevation");
            this.cx = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 3), "RestingElevation");
            this.cw = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 3), "HoverElevation");
            this.cv = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 3), "FocusElevation");
            this.nw = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "BorderColor");
            this.n4 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "RippleColor");
            this.ku = XButton.k.y(a, enumGetBox(ButtonDisplayStyle_$type, 3), "CornerRadius");
            this.bl = XButton.k.i(a, enumGetBox(ButtonDisplayStyle_$type, 3), "BorderWidth");
            this.nv = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "BackgroundColor");
            this.n5 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "TextColor");
            this.n3 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "HoverTextColor");
            this.n2 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "HoverBackgroundColor");
            this.n0 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "FocusBackgroundColor");
            this.n1 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "FocusTextColor");
        }
        get bu() {
            return this.bc;
        }
        set bu(a) {
            let b = this.bc;
            this.bc = a;
            if (b != this.bc) {
                this.kd("MinWidth", b, a);
            }
        }
        get bt() {
            return this.bb;
        }
        set bt(a) {
            let b = this.bb;
            this.bb = a;
            if (b != this.bb) {
                this.kd("MinHeight", b, a);
            }
        }
        get e() {
            return this.d;
        }
        set e(a) {
            let b = this.d;
            this.d = a;
            if (b != this.d) {
                this.kd("DisplayType", enumGetBox(ButtonDisplayStyle_$type, b), enumGetBox(ButtonDisplayStyle_$type, a));
            }
        }
        get r() {
            return this.p;
        }
        set r(a) {
            let b = this.p;
            this.p = a;
            if (b != this.p) {
                this.kd("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        get n() {
            return this.l;
        }
        set n(a) {
            let b = this.l;
            this.l = a;
            if (b != this.l) {
                this.kd("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        }
        get q() {
            return this.o;
        }
        set q(a) {
            let b = this.o;
            this.o = a;
            if (b != this.o) {
                this.kd("ActualDensity", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        get ng() {
            return this.k8;
        }
        set ng(a) {
            let b = this.k8;
            this.k8 = a;
            if (b != this.k8) {
                this.kd("ActualBorderColor", b, a);
            }
        }
        get nr() {
            return this.lj;
        }
        set nr(a) {
            let b = this.lj;
            this.lj = a;
            if (b != this.lj) {
                this.kd("ActualUmbraShadowColor", b, a);
            }
        }
        get no() {
            return this.lg;
        }
        set no(a) {
            let b = this.lg;
            this.lg = a;
            if (b != this.lg) {
                this.kd("ActualPenumbraShadowColor", b, a);
            }
        }
        get ne() {
            return this.k6;
        }
        set ne(a) {
            let b = this.k6;
            this.k6 = a;
            if (b != this.k6) {
                this.kd("ActualAmbientShadowColor", b, a);
            }
        }
        get ct() {
            return this.b0;
        }
        set ct(a) {
            let b = this.b0;
            this.b0 = a;
            if (b != this.b0) {
                this.kd("ActualRestingElevation", b, a);
            }
        }
        get cr() {
            return this.by;
        }
        set cr(a) {
            let b = this.by;
            this.by = a;
            if (b != this.by) {
                this.kd("ActualFocusElevation", b, a);
            }
        }
        get cs() {
            return this.bz;
        }
        set cs(a) {
            let b = this.bz;
            this.bz = a;
            if (b != this.bz) {
                this.kd("ActualHoverElevation", b, a);
            }
        }
        get np() {
            return this.lh;
        }
        set np(a) {
            let b = this.lh;
            this.lh = a;
            if (b != this.lh) {
                this.kd("ActualRippleColor", b, a);
            }
        }
        get kr() {
            return this.kk;
        }
        set kr(a) {
            let b = this.kk;
            this.kk = a;
            if (b != this.kk) {
                this.kd("ActualCornerRadius", b, a);
            }
        }
        get nf() {
            return this.k7;
        }
        set nf(a) {
            let b = this.k7;
            this.k7 = a;
            if (b != this.k7) {
                this.kd("ActualBackgroundColor", b, a);
            }
        }
        get nh() {
            return this.k9;
        }
        set nh(a) {
            let b = this.k9;
            this.k9 = a;
            if (b != this.k9) {
                this.kd("ActualDisabledBackgroundColor", b, a);
            }
        }
        get ni() {
            return this.la;
        }
        set ni(a) {
            let b = this.la;
            this.la = a;
            if (b != this.la) {
                this.kd("ActualDisabledBorderColor", b, a);
            }
        }
        get nj() {
            return this.lb;
        }
        set nj(a) {
            let b = this.lb;
            this.lb = a;
            if (b != this.lb) {
                this.kd("ActualDisabledTextColor", b, a);
            }
        }
        get cq() {
            return this.bx;
        }
        set cq(a) {
            let b = this.bx;
            this.bx = a;
            if (b != this.bx) {
                this.kd("ActualDisabledElevation", b, a);
            }
        }
        get u() {
            return this.s;
        }
        set u(a) {
            let b = this.s;
            this.s = a;
            if (b != this.s) {
                this.kd("ActualElevationMode", enumGetBox(ElevationMode_$type, b), enumGetBox(ElevationMode_$type, a));
            }
        }
        get nq() {
            return this.li;
        }
        set nq(a) {
            let b = this.li;
            this.li = a;
            if (b != this.li) {
                this.kd("ActualTextColor", b, a);
            }
        }
        get nn() {
            return this.lf;
        }
        set nn(a) {
            let b = this.lf;
            this.lf = a;
            if (b != this.lf) {
                this.kd("ActualHoverTextColor", b, a);
            }
        }
        get nk() {
            return this.lc;
        }
        set nk(a) {
            let b = this.lc;
            this.lc = a;
            if (b != this.lc) {
                this.kd("ActualFocusBackgroundColor", b, a);
            }
        }
        get nl() {
            return this.ld;
        }
        set nl(a) {
            let b = this.ld;
            this.ld = a;
            if (b != this.ld) {
                this.kd("ActualFocusTextColor", b, a);
            }
        }
        get nm() {
            return this.le;
        }
        set nm(a) {
            let b = this.le;
            this.le = a;
            if (b != this.le) {
                this.kd("ActualHoverBackgroundColor", b, a);
            }
        }
        get bf() {
            return this.a2;
        }
        set bf(a) {
            let b = this.a2;
            this.a2 = a;
            if (b != this.a2) {
                this.kd("ActualBorderWidth", b, a);
            }
        }
        get qv() {
            return this.m1;
        }
        set qv(a) {
            let b = this.m1;
            this.m1 = a;
            if (b != this.m1) {
                this.kd("RaisedBackgroundColor", b, a);
            }
        }
        get qx() {
            return this.m3;
        }
        set qx(a) {
            let b = this.m3;
            this.m3 = a;
            if (b != this.m3) {
                this.kd("RaisedDisabledBackgroundColor", b, a);
            }
        }
        get qy() {
            return this.m4;
        }
        set qy(a) {
            let b = this.m4;
            this.m4 = a;
            if (b != this.m4) {
                this.kd("RaisedDisabledBorderColor", b, a);
            }
        }
        get qz() {
            return this.m5;
        }
        set qz(a) {
            let b = this.m5;
            this.m5 = a;
            if (b != this.m5) {
                this.kd("RaisedDisabledTextColor", b, a);
            }
        }
        get dy() {
            return this.ck;
        }
        set dy(a) {
            let b = this.ck;
            this.ck = a;
            if (b != this.ck) {
                this.kd("RaisedDisabledElevation", b, a);
            }
        }
        get q2() {
            return this.m8;
        }
        set q2(a) {
            let b = this.m8;
            this.m8 = a;
            if (b != this.m8) {
                this.kd("RaisedHoverBackgroundColor", b, a);
            }
        }
        get qw() {
            return this.m2;
        }
        set qw(a) {
            let b = this.m2;
            this.m2 = a;
            if (b != this.m2) {
                this.kd("RaisedBorderColor", b, a);
            }
        }
        get d1() {
            return this.cn;
        }
        set d1(a) {
            let b = this.cn;
            this.cn = a;
            if (b != this.cn) {
                this.kd("RaisedRestingElevation", b, a);
            }
        }
        get d0() {
            return this.cm;
        }
        set d0(a) {
            let b = this.cm;
            this.cm = a;
            if (b != this.cm) {
                this.kd("RaisedHoverElevation", b, a);
            }
        }
        get dz() {
            return this.cl;
        }
        set dz(a) {
            let b = this.cl;
            this.cl = a;
            if (b != this.cl) {
                this.kd("RaisedFocusElevation", b, a);
            }
        }
        get bw() {
            return this.be;
        }
        set bw(a) {
            let b = this.be;
            this.be = a;
            if (b != this.be) {
                this.kd("RaisedBorderWidth", b, a);
            }
        }
        get k3() {
            return this.kq;
        }
        set k3(a) {
            let b = this.kq;
            this.kq = a;
            {
                this.kd("RaisedCornerRadius", b, a);
            }
        }
        get q4() {
            return this.na;
        }
        set q4(a) {
            let b = this.na;
            this.na = a;
            if (b != this.na) {
                this.kd("RaisedRippleColor", b, a);
            }
        }
        get pu() {
            return this.lz;
        }
        set pu(a) {
            let b = this.lz;
            this.lz = a;
            if (b != this.lz) {
                this.kd("FlatBackgroundColor", b, a);
            }
        }
        get pw() {
            return this.l1;
        }
        set pw(a) {
            let b = this.l1;
            this.l1 = a;
            if (b != this.l1) {
                this.kd("FlatDisabledBackgroundColor", b, a);
            }
        }
        get px() {
            return this.l2;
        }
        set px(a) {
            let b = this.l2;
            this.l2 = a;
            if (b != this.l2) {
                this.kd("FlatDisabledBorderColor", b, a);
            }
        }
        get py() {
            return this.l3;
        }
        set py(a) {
            let b = this.l3;
            this.l3 = a;
            if (b != this.l3) {
                this.kd("FlatDisabledTextColor", b, a);
            }
        }
        get dj() {
            return this.b6;
        }
        set dj(a) {
            let b = this.b6;
            this.b6 = a;
            if (b != this.b6) {
                this.kd("FlatDisabledElevation", b, a);
            }
        }
        get p1() {
            return this.l6;
        }
        set p1(a) {
            let b = this.l6;
            this.l6 = a;
            if (b != this.l6) {
                this.kd("FlatHoverBackgroundColor", b, a);
            }
        }
        get pv() {
            return this.l0;
        }
        set pv(a) {
            let b = this.l0;
            this.l0 = a;
            if (b != this.l0) {
                this.kd("FlatBorderColor", b, a);
            }
        }
        get dm() {
            return this.b9;
        }
        set dm(a) {
            let b = this.b9;
            this.b9 = a;
            if (b != this.b9) {
                this.kd("FlatRestingElevation", b, a);
            }
        }
        get dl() {
            return this.b8;
        }
        set dl(a) {
            let b = this.b8;
            this.b8 = a;
            if (b != this.b8) {
                this.kd("FlatHoverElevation", b, a);
            }
        }
        get dk() {
            return this.b7;
        }
        set dk(a) {
            let b = this.b7;
            this.b7 = a;
            if (b != this.b7) {
                this.kd("FlatFocusElevation", b, a);
            }
        }
        get p3() {
            return this.l8;
        }
        set p3(a) {
            let b = this.l8;
            this.l8 = a;
            if (b != this.l8) {
                this.kd("FlatRippleColor", b, a);
            }
        }
        get p4() {
            return this.l9;
        }
        set p4(a) {
            let b = this.l9;
            this.l9 = a;
            if (b != this.l9) {
                this.kd("FlatTextColor", b, a);
            }
        }
        get p2() {
            return this.l7;
        }
        set p2(a) {
            let b = this.l7;
            this.l7 = a;
            if (b != this.l7) {
                this.kd("FlatHoverTextColor", b, a);
            }
        }
        get pz() {
            return this.l4;
        }
        set pz(a) {
            let b = this.l4;
            this.l4 = a;
            if (b != this.l4) {
                this.kd("FlatFocusBackgroundColor", b, a);
            }
        }
        get p0() {
            return this.l5;
        }
        set p0(a) {
            let b = this.l5;
            this.l5 = a;
            if (b != this.l5) {
                this.kd("FlatFocusTextColor", b, a);
            }
        }
        get br() {
            return this.a9;
        }
        set br(a) {
            let b = this.a9;
            this.a9 = a;
            if (b != this.a9) {
                this.kd("FlatBorderWidth", b, a);
            }
        }
        get k0() {
            return this.kn;
        }
        set k0(a) {
            let b = this.kn;
            this.kn = a;
            {
                this.kd("FlatCornerRadius", b, a);
            }
        }
        get ns() {
            return this.lk;
        }
        set ns(a) {
            let b = this.lk;
            this.lk = a;
            if (b != this.lk) {
                this.kd("BackgroundColor", b, a);
            }
        }
        get pg() {
            return this.lm;
        }
        set pg(a) {
            let b = this.lm;
            this.lm = a;
            if (b != this.lm) {
                this.kd("DisabledBackgroundColor", b, a);
            }
        }
        get ph() {
            return this.ln;
        }
        set ph(a) {
            let b = this.ln;
            this.ln = a;
            if (b != this.ln) {
                this.kd("DisabledBorderColor", b, a);
            }
        }
        get pi() {
            return this.lo;
        }
        set pi(a) {
            let b = this.lo;
            this.lo = a;
            if (b != this.lo) {
                this.kd("DisabledTextColor", b, a);
            }
        }
        get de() {
            return this.b1;
        }
        set de(a) {
            let b = this.b1;
            this.b1 = a;
            if (b != this.b1) {
                this.kd("DisabledElevation", b, a);
            }
        }
        get w() {
            return this.t;
        }
        set w(a) {
            let b = this.t;
            this.t = a;
            if (b != this.t) {
                this.kd("ElevationMode", enumGetBox(ElevationMode_$type, b), enumGetBox(ElevationMode_$type, a));
            }
        }
        get p7() {
            return this.mc;
        }
        set p7(a) {
            let b = this.mc;
            this.mc = a;
            if (b != this.mc) {
                this.kd("HoverBackgroundColor", b, a);
            }
        }
        get nt() {
            return this.ll;
        }
        set nt(a) {
            let b = this.ll;
            this.ll = a;
            if (b != this.ll) {
                this.kd("BorderColor", b, a);
            }
        }
        get d2() {
            return this.co;
        }
        set d2(a) {
            let b = this.co;
            this.co = a;
            if (b != this.co) {
                this.kd("RestingElevation", b, a);
            }
        }
        get dp() {
            return this.cb;
        }
        set dp(a) {
            let b = this.cb;
            this.cb = a;
            if (b != this.cb) {
                this.kd("HoverElevation", b, a);
            }
        }
        get dn() {
            return this.ca;
        }
        set dn(a) {
            let b = this.ca;
            this.ca = a;
            if (b != this.ca) {
                this.kd("FocusElevation", b, a);
            }
        }
        get aa() {
            return this.z;
        }
        set aa(a) {
            let b = this.z;
            this.z = a;
            if (b != this.z) {
                this.kd("TextStyle", b, a);
            }
        }
        get q7() {
            return this.nd;
        }
        set q7(a) {
            let b = this.nd;
            this.nd = a;
            if (b != this.nd) {
                this.kd("TextColor", b, a);
            }
        }
        get p8() {
            return this.me;
        }
        set p8(a) {
            let b = this.me;
            this.me = a;
            if (b != this.me) {
                this.kd("HoverTextColor", b, a);
            }
        }
        get q6() {
            return this.nc;
        }
        set q6(a) {
            let b = this.nc;
            this.nc = a;
            if (b != this.nc) {
                this.kd("RippleColor", b, a);
            }
        }
        get q5() {
            return this.nb;
        }
        set q5(a) {
            let b = this.nb;
            this.nb = a;
            if (b != this.nb) {
                this.kd("RaisedTextColor", b, a);
            }
        }
        get q3() {
            return this.m9;
        }
        set q3(a) {
            let b = this.m9;
            this.m9 = a;
            if (b != this.m9) {
                this.kd("RaisedHoverTextColor", b, a);
            }
        }
        get q0() {
            return this.m6;
        }
        set q0(a) {
            let b = this.m6;
            this.m6 = a;
            if (b != this.m6) {
                this.kd("RaisedFocusBackgroundColor", b, a);
            }
        }
        get q1() {
            return this.m7;
        }
        set q1(a) {
            let b = this.m7;
            this.m7 = a;
            if (b != this.m7) {
                this.kd("RaisedFocusTextColor", b, a);
            }
        }
        get p5() {
            return this.ma;
        }
        set p5(a) {
            let b = this.ma;
            this.ma = a;
            if (b != this.ma) {
                this.kd("FocusBackgroundColor", b, a);
            }
        }
        get p6() {
            return this.mb;
        }
        set p6(a) {
            let b = this.mb;
            this.mb = a;
            if (b != this.mb) {
                this.kd("FocusTextColor", b, a);
            }
        }
        get bg() {
            return this.a3;
        }
        set bg(a) {
            let b = this.a3;
            this.a3 = a;
            if (b != this.a3) {
                this.kd("BorderWidth", b, a);
            }
        }
        get kt() {
            return this.kl;
        }
        set kt(a) {
            let b = this.kl;
            this.kl = a;
            {
                this.kd("CornerRadius", b, a);
            }
        }
        get qk() {
            return this.mq;
        }
        set qk(a) {
            let b = this.mq;
            this.mq = a;
            if (b != this.mq) {
                this.kd("OutlinedBackgroundColor", b, a);
            }
        }
        get qm() {
            return this.ms;
        }
        set qm(a) {
            let b = this.ms;
            this.ms = a;
            if (b != this.ms) {
                this.kd("OutlinedDisabledBackgroundColor", b, a);
            }
        }
        get qn() {
            return this.mt;
        }
        set qn(a) {
            let b = this.mt;
            this.mt = a;
            if (b != this.mt) {
                this.kd("OutlinedDisabledBorderColor", b, a);
            }
        }
        get qo() {
            return this.mu;
        }
        set qo(a) {
            let b = this.mu;
            this.mu = a;
            if (b != this.mu) {
                this.kd("OutlinedDisabledTextColor", b, a);
            }
        }
        get du() {
            return this.cg;
        }
        set du(a) {
            let b = this.cg;
            this.cg = a;
            if (b != this.cg) {
                this.kd("OutlinedDisabledElevation", b, a);
            }
        }
        get qr() {
            return this.mx;
        }
        set qr(a) {
            let b = this.mx;
            this.mx = a;
            if (b != this.mx) {
                this.kd("OutlinedHoverBackgroundColor", b, a);
            }
        }
        get ql() {
            return this.mr;
        }
        set ql(a) {
            let b = this.mr;
            this.mr = a;
            if (b != this.mr) {
                this.kd("OutlinedBorderColor", b, a);
            }
        }
        get dx() {
            return this.cj;
        }
        set dx(a) {
            let b = this.cj;
            this.cj = a;
            if (b != this.cj) {
                this.kd("OutlinedRestingElevation", b, a);
            }
        }
        get dw() {
            return this.ci;
        }
        set dw(a) {
            let b = this.ci;
            this.ci = a;
            if (b != this.ci) {
                this.kd("OutlinedHoverElevation", b, a);
            }
        }
        get dv() {
            return this.ch;
        }
        set dv(a) {
            let b = this.ch;
            this.ch = a;
            if (b != this.ch) {
                this.kd("OutlinedFocusElevation", b, a);
            }
        }
        get bv() {
            return this.bd;
        }
        set bv(a) {
            let b = this.bd;
            this.bd = a;
            if (b != this.bd) {
                this.kd("OutlinedBorderWidth", b, a);
            }
        }
        get k2() {
            return this.kp;
        }
        set k2(a) {
            let b = this.kp;
            this.kp = a;
            {
                this.kd("OutlinedCornerRadius", b, a);
            }
        }
        get qt() {
            return this.mz;
        }
        set qt(a) {
            let b = this.mz;
            this.mz = a;
            if (b != this.mz) {
                this.kd("OutlinedRippleColor", b, a);
            }
        }
        get qu() {
            return this.m0;
        }
        set qu(a) {
            let b = this.m0;
            this.m0 = a;
            if (b != this.m0) {
                this.kd("OutlinedTextColor", b, a);
            }
        }
        get qs() {
            return this.my;
        }
        set qs(a) {
            let b = this.my;
            this.my = a;
            if (b != this.my) {
                this.kd("OutlinedHoverTextColor", b, a);
            }
        }
        get qp() {
            return this.mv;
        }
        set qp(a) {
            let b = this.mv;
            this.mv = a;
            if (b != this.mv) {
                this.kd("OutlinedFocusBackgroundColor", b, a);
            }
        }
        get qq() {
            return this.mw;
        }
        set qq(a) {
            let b = this.mw;
            this.mw = a;
            if (b != this.mw) {
                this.kd("OutlinedFocusTextColor", b, a);
            }
        }
        get pj() {
            return this.lp;
        }
        set pj(a) {
            let b = this.lp;
            this.lp = a;
            if (b != this.lp) {
                this.kd("FabBackgroundColor", b, a);
            }
        }
        get pl() {
            return this.lr;
        }
        set pl(a) {
            let b = this.lr;
            this.lr = a;
            if (b != this.lr) {
                this.kd("FabDisabledBackgroundColor", b, a);
            }
        }
        get pm() {
            return this.ls;
        }
        set pm(a) {
            let b = this.ls;
            this.ls = a;
            if (b != this.ls) {
                this.kd("FabDisabledBorderColor", b, a);
            }
        }
        get pn() {
            return this.lt;
        }
        set pn(a) {
            let b = this.lt;
            this.lt = a;
            if (b != this.lt) {
                this.kd("FabDisabledTextColor", b, a);
            }
        }
        get df() {
            return this.b2;
        }
        set df(a) {
            let b = this.b2;
            this.b2 = a;
            if (b != this.b2) {
                this.kd("FabDisabledElevation", b, a);
            }
        }
        get pq() {
            return this.md;
        }
        set pq(a) {
            let b = this.md;
            this.md = a;
            if (b != this.md) {
                this.kd("FabHoverBackgroundColor", b, a);
            }
        }
        get pk() {
            return this.lq;
        }
        set pk(a) {
            let b = this.lq;
            this.lq = a;
            if (b != this.lq) {
                this.kd("FabBorderColor", b, a);
            }
        }
        get di() {
            return this.b5;
        }
        set di(a) {
            let b = this.b5;
            this.b5 = a;
            if (b != this.b5) {
                this.kd("FabRestingElevation", b, a);
            }
        }
        get dh() {
            return this.b4;
        }
        set dh(a) {
            let b = this.b4;
            this.b4 = a;
            if (b != this.b4) {
                this.kd("FabHoverElevation", b, a);
            }
        }
        get dg() {
            return this.b3;
        }
        set dg(a) {
            let b = this.b3;
            this.b3 = a;
            if (b != this.b3) {
                this.kd("FabFocusElevation", b, a);
            }
        }
        get bq() {
            return this.a8;
        }
        set bq(a) {
            let b = this.a8;
            this.a8 = a;
            if (b != this.a8) {
                this.kd("FabBorderWidth", b, a);
            }
        }
        get kz() {
            return this.km;
        }
        set kz(a) {
            let b = this.km;
            this.km = a;
            {
                this.kd("FabCornerRadius", b, a);
            }
        }
        get ps() {
            return this.lx;
        }
        set ps(a) {
            let b = this.lx;
            this.lx = a;
            if (b != this.lx) {
                this.kd("FabRippleColor", b, a);
            }
        }
        get pt() {
            return this.ly;
        }
        set pt(a) {
            let b = this.ly;
            this.ly = a;
            if (b != this.ly) {
                this.kd("FabTextColor", b, a);
            }
        }
        get pr() {
            return this.lw;
        }
        set pr(a) {
            let b = this.lw;
            this.lw = a;
            if (b != this.lw) {
                this.kd("FabHoverTextColor", b, a);
            }
        }
        get po() {
            return this.lu;
        }
        set po(a) {
            let b = this.lu;
            this.lu = a;
            if (b != this.lu) {
                this.kd("FabFocusBackgroundColor", b, a);
            }
        }
        get pp() {
            return this.lv;
        }
        set pp(a) {
            let b = this.lv;
            this.lv = a;
            if (b != this.lv) {
                this.kd("FabFocusTextColor", b, a);
            }
        }
        get p9() {
            return this.mf;
        }
        set p9(a) {
            let b = this.mf;
            this.mf = a;
            if (b != this.mf) {
                this.kd("IconBackgroundColor", b, a);
            }
        }
        get qb() {
            return this.mh;
        }
        set qb(a) {
            let b = this.mh;
            this.mh = a;
            if (b != this.mh) {
                this.kd("IconDisabledBackgroundColor", b, a);
            }
        }
        get qc() {
            return this.mi;
        }
        set qc(a) {
            let b = this.mi;
            this.mi = a;
            if (b != this.mi) {
                this.kd("IconDisabledBorderColor", b, a);
            }
        }
        get qd() {
            return this.mj;
        }
        set qd(a) {
            let b = this.mj;
            this.mj = a;
            if (b != this.mj) {
                this.kd("IconDisabledTextColor", b, a);
            }
        }
        get dq() {
            return this.cc;
        }
        set dq(a) {
            let b = this.cc;
            this.cc = a;
            if (b != this.cc) {
                this.kd("IconDisabledElevation", b, a);
            }
        }
        get qg() {
            return this.mm;
        }
        set qg(a) {
            let b = this.mm;
            this.mm = a;
            if (b != this.mm) {
                this.kd("IconHoverBackgroundColor", b, a);
            }
        }
        get qa() {
            return this.mg;
        }
        set qa(a) {
            let b = this.mg;
            this.mg = a;
            if (b != this.mg) {
                this.kd("IconBorderColor", b, a);
            }
        }
        get dt() {
            return this.cf;
        }
        set dt(a) {
            let b = this.cf;
            this.cf = a;
            if (b != this.cf) {
                this.kd("IconRestingElevation", b, a);
            }
        }
        get ds() {
            return this.ce;
        }
        set ds(a) {
            let b = this.ce;
            this.ce = a;
            if (b != this.ce) {
                this.kd("IconHoverElevation", b, a);
            }
        }
        get dr() {
            return this.cd;
        }
        set dr(a) {
            let b = this.cd;
            this.cd = a;
            if (b != this.cd) {
                this.kd("IconFocusElevation", b, a);
            }
        }
        get bs() {
            return this.ba;
        }
        set bs(a) {
            let b = this.ba;
            this.ba = a;
            if (b != this.ba) {
                this.kd("IconBorderWidth", b, a);
            }
        }
        get k1() {
            return this.ko;
        }
        set k1(a) {
            let b = this.ko;
            this.ko = a;
            {
                this.kd("IconCornerRadius", b, a);
            }
        }
        get qi() {
            return this.mo;
        }
        set qi(a) {
            let b = this.mo;
            this.mo = a;
            if (b != this.mo) {
                this.kd("IconRippleColor", b, a);
            }
        }
        get qj() {
            return this.mp;
        }
        set qj(a) {
            let b = this.mp;
            this.mp = a;
            if (b != this.mp) {
                this.kd("IconTextColor", b, a);
            }
        }
        get qh() {
            return this.mn;
        }
        set qh(a) {
            let b = this.mn;
            this.mn = a;
            if (b != this.mn) {
                this.kd("IconHoverTextColor", b, a);
            }
        }
        get qe() {
            return this.mk;
        }
        set qe(a) {
            let b = this.mk;
            this.mk = a;
            if (b != this.mk) {
                this.kd("IconFocusBackgroundColor", b, a);
            }
        }
        get qf() {
            return this.ml;
        }
        set qf(a) {
            let b = this.ml;
            this.ml = a;
            if (b != this.ml) {
                this.kd("IconFocusTextColor", b, a);
            }
        }
        get hu() {
            return this.ei;
        }
        set hu(a) {
            let b = this.ei;
            this.ei = a;
            if (b != this.ei) {
                this.kd("InputId", b, a);
            }
        }
        get hs() {
            return this.eh;
        }
        set hs(a) {
            let b = this.eh;
            this.eh = a;
            if (b != this.eh) {
                this.kd("Id", b, a);
            }
        }
        get fw() {
            return this.ee;
        }
        set fw(a) {
            let b = this.ee;
            this.ee = a;
            if (b != this.ee) {
                this.kd("Display", b, a);
            }
        }
        get ff() {
            return this.ed;
        }
        set ff(a) {
            let b = this.ed;
            this.ed = a;
            if (b != this.ed) {
                this.kd("ChildContentDisplay", b, this.ed);
            }
        }
        get g0() {
            return this.ef;
        }
        set g0(a) {
            let b = this.ef;
            this.ef = a;
            if (b != this.ef) {
                this.kd("FlexDirection", b, a);
            }
        }
        get g2() {
            return this.eg;
        }
        set g2(a) {
            let b = this.eg;
            this.eg = a;
            if (b != this.eg) {
                this.kd("FlexGrow", b, a);
            }
        }
        get e7() {
            return this.eb;
        }
        set e7(a) {
            let b = this.eb;
            this.eb = a;
            if (b != this.eb) {
                this.kd("AlignItems", b, a);
            }
        }
        get ea() {
            return this.d6;
        }
        set ea(a) {
            let b = this.d6;
            this.d6 = a;
            if (b != this.d6) {
                this.kd("Value", b, a);
            }
        }
        get h2() {
            return this.ej;
        }
        set h2(a) {
            let b = this.ej;
            this.ej = a;
            if (b != this.ej) {
                this.kd("Name", b, a);
            }
        }
        get aw() {
            return this.ak;
        }
        get d3() {
            return this.cp;
        }
        set d3(a) {
            let b = this.cp;
            this.cp = a;
            this.ak = true;
            if (b != this.cp) {
                this.kd("TabIndex", b, a);
            }
        }
        get e9() {
            return this.ec;
        }
        set e9(a) {
            let b = this.ec;
            this.ec = a;
            if (b != this.ec) {
                this.kd("AriaLabel", b, a);
            }
        }
        get av() {
            return this.aj;
        }
        set av(a) {
            let b = this.aj;
            this.aj = a;
            if (b != this.aj) {
                this.kd("FillAvailableSpace", b, this.aj);
            }
        }
        get focused() {
            return this.am;
        }
        set focused(a) {
            let b = this.am;
            this.am = a;
            if (b != this.am) {
                this.kd("IsFocused", b, a);
            }
        }
        get az() {
            return this.an;
        }
        set az(a) {
            let b = this.an;
            this.an = a;
            if (b != this.an) {
                this.kd("IsFocusStyleEnabled", b, a);
            }
        }
        get at() {
            return this.ah;
        }
        set at(a) {
            let b = this.ah;
            this.ah = a;
            if (b != this.ah) {
                this.kd("DisableRipple", b, a);
            }
        }
        get ap() {
            return this.ad;
        }
        set ap(a) {
            let b = this.ad;
            this.ad = a;
            if (b != this.ad) {
                this.kd("ActualDisableRipple", b, a);
            }
        }
        get ar() {
            return this.af;
        }
        set ar(a) {
            let b = this.af;
            this.af = a;
            if (b != this.af) {
                this.kd("DisableHover", b, this.af);
            }
        }
        get a0() {
            return this.ao;
        }
        set a0(a) {
            let b = this.ao;
            this.ao = a;
            if (b != this.ao) {
                this.kd("IsHover", b, a);
            }
        }
        get disabled() {
            return this.al;
        }
        set disabled(a) {
            let b = this.al;
            this.al = a;
            if (b != this.al) {
                this.kd("IsDisabled", b, a);
            }
        }
        get au() {
            return this.ai;
        }
        set au(a) {
            let b = this.ai;
            this.ai = a;
            if (b != this.ai) {
                this.kd("DisableTransitions", b, a);
            }
        }
        get as() {
            return this.ag;
        }
        set as(a) {
            let b = this.ag;
            this.ag = a;
            if (b != this.ag) {
                this.kd("DisablePointer", b, this.ag);
            }
        }
        get bi() {
            return this.a5;
        }
        set bi(a) {
            let b = this.a5;
            this.a5 = a;
            if (b != this.a5) {
                this.kd("ContentPaddingLeft", b, this.a5);
            }
        }
        get bk() {
            return this.a7;
        }
        set bk(a) {
            let b = this.a7;
            this.a7 = a;
            if (b != this.a7) {
                this.kd("ContentPaddingTop", b, this.a7);
            }
        }
        get bj() {
            return this.a6;
        }
        set bj(a) {
            let b = this.a6;
            this.a6 = a;
            if (b != this.a6) {
                this.kd("ContentPaddingRight", b, this.a6);
            }
        }
        get bh() {
            return this.a4;
        }
        set bh(a) {
            let b = this.a4;
            this.a4 = a;
            if (b != this.a4) {
                this.kd("ContentPaddingBottom", b, this.a4);
            }
        }
        get k5() {
            return this.k4;
        }
        set k5(a) {
            let b = this.k4;
            this.k4 = a;
            if (b != this.k4) {
                this.kd("HorizontalContentAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.k4));
            }
        }
        get q9() {
            return this.q8;
        }
        set q9(a) {
            let b = this.q8;
            this.q8 = a;
            if (b != this.q8) {
                this.kd("VerticalContentAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.q8));
            }
        }
        get aq() {
            return this.ae;
        }
        set aq(a) {
            let b = this.ae;
            this.ae = a;
            if (b != this.ae) {
                this.kd("ClickTunneling", b, this.ae);
            }
        }
        ke() {
            this.j3();
            this.view.aw(this.np, BrushUtil.h(0, 0, 0, 0));
            this.kh();
        }
        get a() {
            let a = new AnimationKeyFrameEffectTiming();
            a.g = 300;
            a.b = 0;
            return a;
        }
        j3() {
            this.view.ae();
        }
        onDetachedFromUI() {
            this.view.aj();
        }
        onAttachedToUI() {
            this.view.ag();
        }
        appendButtonContent(a) {
            this.view.ac(a);
        }
        clearButtonContent() {
            this.view.ad();
        }
        getButtonContent() {
            return this.view.r();
        }
        a1() {
            return this.view.g();
        }
        d7() {
            return this.b();
        }
        f0() {
            let a = this.b();
            return a.ab();
        }
        b() {
            let a = this.view.q;
            let b = this.view.s;
            let c = new ButtonVisualModelExport();
            let d = UIElementPropertyAccessorFactory.c.a(12, 0);
            let e = d.b(a);
            let f = this.view.a();
            c.s = f[0];
            c.q = f[1];
            c.p = NativeUI.d(a);
            c.t = NativeUI.k(a);
            c.h = this.n;
            c.i = this.q;
            c.c = AppearanceHelper.a(NativeUI.ak(a));
            c.g = AppearanceHelper.a(this.nr);
            c.d = AppearanceHelper.a(this.no);
            c.a = AppearanceHelper.a(this.ne);
            c.u = this.ct;
            c.e = AppearanceHelper.a(this.np);
            c.ah = this.kr;
            c.b = AppearanceHelper.a(NativeUI.aj(a));
            c.j = this.u;
            c.f = AppearanceHelper.a(NativeUI.al(b));
            c.o = this.bf;
            c.x = this.fw;
            c.y = this.g0;
            c.z = this.g2;
            c.w = this.e7;
            c.v = this.view.s.getNativeElement().innerText;
            c.aa = this.h2;
            c.m = this.focused;
            c.k = this.ap;
            c.n = this.a0;
            c.l = this.disabled;
            if (this.aa != null) {
                let g = this.aa;
                if (this.view != null && g.q == null) {
                    let h = this.view.k;
                    let i = FontUtil.getFontInfoFromString(h, g.fontString);
                    g.q = i.q;
                    g.f = i.f;
                    g.r = i.r;
                    g.t = i.t;
                    g.u = i.u;
                    g.v = i.v;
                }
                if (g.q != null) {
                    c.ac = g.q;
                }
                if (!isNaN_(g.f)) {
                    c.r = g.f;
                }
                if (g.v != null) {
                    c.ag = g.v;
                }
                if (g.t != null) {
                    c.ae = g.t;
                }
                if (g.r != null) {
                    c.ad = g.t;
                }
            }
            return c;
        }
        provideContainer(a) {
            this.view.ai(a);
        }
    }
    XButton.$t = /*@__PURE__*/ markType(XButton, 'XButton', Base.$, [INotifyPropertyChanged_$type]);
    XButton.m = 2;
    XButton.d5 = 0;
    XButton.d4 = 0;
    XButton.i = /*@__PURE__*/ new Theme(1, /*@__PURE__*/ ((() => {
        let $ret = new Dictionary$2(String_$type, Base.$, 0);
        $ret.addItem("UmbraShadowColor", BrushUtil.h(66, 0, 0, 0));
        $ret.addItem("PenumbraShadowColor", BrushUtil.h(30, 0, 0, 0));
        $ret.addItem("AmbientShadowColor", BrushUtil.h(20, 0, 0, 0));
        $ret.addItem("ElevationMode", enumGetBox(ElevationMode_$type, 1));
        return $ret;
    })()), /*@__PURE__*/ ((() => {
        let $ret = new Dictionary$2(Base.$, Theme.$, 0);
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 0), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 2);
            $ret.addItem("HoverElevation", 4);
            $ret.addItem("FocusElevation", 8);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("CornerRadius", new CornerRadius(0, 4));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(255, 228, 28, 119));
            $ret.addItem("TextColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(255, 220, 83, 145));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(255, 220, 83, 145));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 0, 0, 0));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 1), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 0);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("CornerRadius", new CornerRadius(0, 4));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 228, 28, 119));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 228, 28, 119));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(13, 228, 28, 119));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(30, 228, 28, 119));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 228, 28, 119));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 2), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(30, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 0);
            $ret.addItem("BorderColor", BrushUtil.h(255, 228, 28, 119));
            $ret.addItem("RippleColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("CornerRadius", new CornerRadius(0, 4));
            $ret.addItem("BorderWidth", 1);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 228, 28, 119));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 228, 28, 119));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(13, 228, 28, 119));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(30, 228, 28, 119));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 228, 28, 119));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 4), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 0);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("CornerRadius", new CornerRadius(0, 28));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(30, 0, 0, 0));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 0, 0, 0));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 3), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 6);
            $ret.addItem("HoverElevation", 12);
            $ret.addItem("FocusElevation", 12);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("CornerRadius", new CornerRadius(0, 28));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(255, 228, 28, 119));
            $ret.addItem("TextColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(255, 220, 83, 145));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(255, 220, 83, 145));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 0, 0, 0));
            return $ret;
        })())));
        return $ret;
    })()));
    XButton.h = /*@__PURE__*/ new Theme(1, /*@__PURE__*/ ((() => {
        let $ret = new Dictionary$2(String_$type, Base.$, 0);
        $ret.addItem("UmbraShadowColor", BrushUtil.h(100, 33, 150, 243));
        $ret.addItem("PenumbraShadowColor", BrushUtil.h(70, 33, 150, 243));
        $ret.addItem("AmbientShadowColor", BrushUtil.h(40, 33, 150, 243));
        $ret.addItem("ElevationMode", enumGetBox(ElevationMode_$type, 2));
        return $ret;
    })()), /*@__PURE__*/ ((() => {
        let $ret = new Dictionary$2(Base.$, Theme.$, 0);
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 0), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("CornerRadius", new CornerRadius(0, 3));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("TextColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(255, 27, 135, 220));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(255, 21, 112, 184));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 255, 255, 255));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 1), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(100, 33, 150, 243));
            $ret.addItem("CornerRadius", new CornerRadius(0, 3));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 119, 119, 119));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 119, 119, 119));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(26, 33, 150, 243));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 33, 150, 243));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 2), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(30, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("RippleColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("CornerRadius", new CornerRadius(0, 3));
            $ret.addItem("BorderWidth", 1);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(26, 33, 150, 243));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 255, 255, 255));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 4), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", null);
            $ret.addItem("CornerRadius", new CornerRadius(0, 28));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 119, 119, 119));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 119, 119, 119));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(30, 0, 0, 0));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 33, 150, 243));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 3), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("CornerRadius", new CornerRadius(0, 28));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("TextColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(255, 27, 135, 220));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(255, 21, 112, 184));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 255, 255, 255));
            return $ret;
        })())));
        return $ret;
    })()));
    XButton.j = /*@__PURE__*/ new Theme(1, /*@__PURE__*/ ((() => {
        let $ret = new Dictionary$2(String_$type, Base.$, 0);
        $ret.addItem("UmbraShadowColor", BrushUtil.h(100, 33, 150, 243));
        $ret.addItem("PenumbraShadowColor", BrushUtil.h(70, 33, 150, 243));
        $ret.addItem("AmbientShadowColor", BrushUtil.h(40, 33, 150, 243));
        $ret.addItem("ElevationMode", enumGetBox(ElevationMode_$type, 2));
        return $ret;
    })()), /*@__PURE__*/ ((() => {
        let $ret = new Dictionary$2(Base.$, Theme.$, 0);
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 0), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("CornerRadius", new CornerRadius(0, 3));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("TextColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(255, 27, 135, 220));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(255, 21, 112, 184));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 255, 255, 255));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 1), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(100, 33, 150, 243));
            $ret.addItem("CornerRadius", new CornerRadius(0, 3));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 119, 119, 119));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 119, 119, 119));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(26, 33, 150, 243));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 33, 150, 243));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 2), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(30, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("RippleColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("CornerRadius", new CornerRadius(0, 3));
            $ret.addItem("BorderWidth", 1);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(26, 33, 150, 243));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 255, 255, 255));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 4), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", null);
            $ret.addItem("CornerRadius", new CornerRadius(0, 28));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(51, 178, 191, 220));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(51, 178, 191, 220));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 0, 0, 0));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 3), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("CornerRadius", new CornerRadius(0, 28));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("TextColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(255, 27, 135, 220));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(255, 21, 112, 184));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 255, 255, 255));
            return $ret;
        })())));
        return $ret;
    })()));
    XButton.k = /*@__PURE__*/ new ThemeResolver(1, /*@__PURE__*/ ((() => {
        let $ret = new Dictionary$2(BaseControlTheme_$type, Theme.$, 0);
        $ret.addItem(2, XButton.i);
        $ret.addItem(1, XButton.h);
        $ret.addItem(3, XButton.j);
        return $ret;
    })()), 2);
    return XButton;
})();
