/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { EventArgs, markType } from "igniteui-react-core";
/**
 * @hidden
 */
export let SelectedValueChangedEventArgs = /*@__PURE__*/ (() => {
    class SelectedValueChangedEventArgs extends EventArgs {
        constructor() {
            super(...arguments);
            this._oldValue = new Date();
            this._newValue = new Date();
        }
        get oldValue() {
            return this._oldValue;
        }
        set oldValue(a) {
            this._oldValue = a;
        }
        get newValue() {
            return this._newValue;
        }
        set newValue(a) {
            this._newValue = a;
        }
    }
    SelectedValueChangedEventArgs.$t = /*@__PURE__*/ markType(SelectedValueChangedEventArgs, 'SelectedValueChangedEventArgs', EventArgs.$);
    return SelectedValueChangedEventArgs;
})();
