import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { XButton as XButton_internal } from './XButton';
import { IgrXButton as IgrXButton } from './igr-x-button';
export class IgrXButtonGroupButtonCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgrXButton.$type) {
            IgrXButton.$type = markType(IgrXButton, "IgrXButton");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgrXButton.$type) {
            IgrXButton.$type = markType(IgrXButton, "IgrXButton");
        }
        let coll = new SyncableObservableCollection$2(IgrXButton.$type, XButton_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = IgrXButton._createFromInternal(int);
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    }
}
