import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { XInputGroupItem as XInputGroupItem_internal } from './XInputGroupItem';
import { IgrXInputGroupItem as IgrXInputGroupItem } from './igr-x-input-group-item';
export class IgrXInputGroupInputCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgrXInputGroupItem.$type) {
            IgrXInputGroupItem.$type = markType(IgrXInputGroupItem, "IgrXInputGroupItem");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgrXInputGroupItem.$type) {
            IgrXInputGroupItem.$type = markType(IgrXInputGroupItem, "IgrXInputGroupItem");
        }
        let coll = new SyncableObservableCollection$2(IgrXInputGroupItem.$type, XInputGroupItem_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = IgrXInputGroupItem._createFromInternal(int);
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    }
}
