/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { Base, Delegate_$type, fromEnum, runOn, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, delegateCombine, enumGetBox, delegateRemove, fromEn } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { ButtonGroupOrientation_$type } from "./ButtonGroupOrientation";
import { ButtonGroupDisplayStyle_$type } from "./ButtonGroupDisplayStyle";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { XButtonGroupButtonCollection } from "./XButtonGroupButtonCollection";
import { ThemeResolver } from "./ThemeResolver";
import { ButtonGroupSelectionChangedEventArgs } from "./ButtonGroupSelectionChangedEventArgs";
import { CornerRadius } from "igniteui-react-core";
import { ButtonGroupVisualModelExport } from "./ButtonGroupVisualModelExport";
import { AppearanceHelper } from "igniteui-react-core";
import { ButtonVisualModelExport } from "./ButtonVisualModelExport";
import { BrushUtil } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
var ButtonGroupView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ButtonGroupView, _super);
    function ButtonGroupView() {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.g = null;
        _this.b = null;
        _this.f = new List$1(Delegate_$type, 0);
        _this.m = null;
        _this.c = true;
        _this.h = null;
        _this.i = null;
        _this.j = null;
        _this.k = null;
        return _this;
    }
    ButtonGroupView.prototype.v = function () {
    };
    ButtonGroupView.prototype.d = function () {
        return true;
    };
    ButtonGroupView.prototype.p = function (a) {
    };
    ButtonGroupView.prototype.r = function (a) {
    };
    ButtonGroupView.prototype.q = function () {
    };
    Object.defineProperty(ButtonGroupView.prototype, "l", {
        get: function () {
            return this.h;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ButtonGroupView.prototype, "ab", {
        get: function () {
            return null;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ButtonGroupView.prototype, "e", {
        get: function () {
            return true;
        },
        enumerable: false,
        configurable: true
    });
    ButtonGroupView.prototype.t = function (a) {
        var e_1, _a;
        var _this = this;
        if (a == null) {
            try {
                for (var _b = __values(fromEnum(this.f)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    b();
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            this.f.clear();
        }
        this.g = a;
        a.rootWrapper.setStyleProperty("position", "relative");
        var c = this.g.createElement("div");
        c.addClass("ig-button-content");
        c.setStyleProperty("position", "relative");
        c.setStyleProperty("display", "flex");
        c.setStyleProperty("flex-direction", "row");
        c.setStyleProperty("flex-wrap", "no-wrap");
        c.setStyleProperty("align-items", "center");
        this.j = c;
        this.f.add(c.listen("click", runOn(this, this.n)));
        this.g.append(c);
        this.g.getPortal(c, "ChildContent", function (d) {
            var comp_ = d.componentRef;
            _this.k = comp_;
            if (_this.a.k == 0) {
                _this.j.setStyleProperty("flex-direction", "row");
                comp_.display = 'flex';
                comp_.flexDirection = 'row';
            }
            else {
                _this.j.setStyleProperty("flex-direction", "column");
                comp_.display = 'flex';
                comp_.flexDirection = 'column';
            }
        }, true);
        this.a.db();
    };
    ButtonGroupView.prototype.z = function (a) {
        if (this.m != a) {
            this.m = a;
            if (this.i != null) {
                this.i.setAttribute("d", this.m);
            }
        }
    };
    ButtonGroupView.prototype.y = function () {
        var comp_ = this.k;
        if (comp_ != null) {
            if (this.a.k == 0) {
                this.j.setStyleProperty("flex-direction", "row");
                comp_.display = 'flex';
                comp_.flexDirection = 'row';
            }
            else {
                this.j.setStyleProperty("flex-direction", "column");
                comp_.display = 'flex';
                comp_.flexDirection = 'column';
            }
        }
    };
    ButtonGroupView.prototype.n = function (a) {
    };
    ButtonGroupView.prototype.w = function () {
        if (this.d()) {
        }
    };
    ButtonGroupView.prototype.s = function () {
        this.c = true;
    };
    ButtonGroupView.prototype.u = function () {
        var e_2, _a;
        this.c = false;
        try {
            for (var _b = __values(fromEnum(this.f)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var a = _c.value;
                a();
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        this.f.clear();
    };
    ButtonGroupView.prototype.aa = function (a) {
        if (a != null) {
            this.g.rootWrapper.setStyleProperty("font", a.fontString);
        }
    };
    ButtonGroupView.prototype.x = function (a) {
        if (this.a.k == 0) {
            a.fw = "flex";
            a.g0 = "row";
            a.e7 = "center";
        }
        else {
            a.fw = "flex";
            a.g0 = "column";
            a.e7 = "stretch";
        }
    };
    ButtonGroupView.prototype.o = function (a) {
        this.j.append(a);
    };
    ButtonGroupView.$t = markType(ButtonGroupView, 'ButtonGroupView');
    return ButtonGroupView;
}(Base));
export { ButtonGroupView };
/**
 * @hidden
 */
var XButtonGroup = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(XButtonGroup, _super);
    function XButtonGroup() {
        var _this = _super.call(this) || this;
        _this.h = 1;
        _this.n = 0;
        _this.r = 1;
        _this.q = 1;
        _this.a = new Array(0);
        _this.u = false;
        _this._view = null;
        _this.ax = ThemeResolver.m(XButtonGroup.o, XButtonGroup.av, XButtonGroup.ap);
        _this.gz = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gn, XButtonGroup.fn);
        _this.g1 = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gp, XButtonGroup.fp);
        _this.g0 = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.go, XButtonGroup.fo);
        _this.g2 = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gq, XButtonGroup.fq);
        _this.aw = ThemeResolver.m(XButtonGroup.o, XButtonGroup.au, XButtonGroup.ao);
        _this.g6 = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gu, XButtonGroup.fu);
        _this.g3 = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gr, XButtonGroup.fr);
        _this.g7 = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gv, XButtonGroup.fv);
        _this.ha = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gy, XButtonGroup.fy);
        _this.g4 = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gs, XButtonGroup.fs);
        _this.g5 = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gt, XButtonGroup.ft);
        _this.g8 = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gw, XButtonGroup.fw);
        _this.g9 = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gx, XButtonGroup.fx);
        _this.ar = ThemeResolver.m(XButtonGroup.o, XButtonGroup.at, XButtonGroup.an);
        _this.fz = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gb, XButtonGroup.fb);
        _this.f1 = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gd, XButtonGroup.fd);
        _this.f0 = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gc, XButtonGroup.fc);
        _this.f2 = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.ge, XButtonGroup.fe);
        _this.aq = ThemeResolver.m(XButtonGroup.o, XButtonGroup.as, XButtonGroup.am);
        _this.f6 = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gi, XButtonGroup.fi);
        _this.f3 = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gf, XButtonGroup.ff);
        _this.f7 = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gj, XButtonGroup.fj);
        _this.ga = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gm, XButtonGroup.fm);
        _this.f4 = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gg, XButtonGroup.fg);
        _this.f5 = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gh, XButtonGroup.fh);
        _this.f8 = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gk, XButtonGroup.fk);
        _this.f9 = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gl, XButtonGroup.fl);
        _this.ad = ThemeResolver.m(XButtonGroup.o, XButtonGroup.av, XButtonGroup.ap);
        _this.dm = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gn, XButtonGroup.fn);
        _this.dp = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gp, XButtonGroup.fp);
        _this.du = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gu, XButtonGroup.fu);
        _this.dr = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gr, XButtonGroup.fr);
        _this.dn = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.go, XButtonGroup.fo);
        _this.dq = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gq, XButtonGroup.fq);
        _this.ac = ThemeResolver.m(XButtonGroup.o, XButtonGroup.au, XButtonGroup.ao);
        _this.dv = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gv, XButtonGroup.fv);
        _this.dy = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gy, XButtonGroup.fy);
        _this.ds = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gs, XButtonGroup.fs);
        _this.dt = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gt, XButtonGroup.ft);
        _this.dw = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gw, XButtonGroup.fw);
        _this.dx = ThemeResolver.ah(XButtonGroup.o, XButtonGroup.gx, XButtonGroup.fx);
        _this.ah = NaN;
        _this.d7 = null;
        _this.d9 = null;
        _this.ee = null;
        _this.eb = null;
        _this.ec = null;
        _this.d8 = null;
        _this.ea = null;
        _this.ag = NaN;
        _this.ed = null;
        _this.ev = null;
        _this.ey = null;
        _this.ew = null;
        _this.ex = null;
        _this.aj = NaN;
        _this.ef = null;
        _this.eh = null;
        _this.em = null;
        _this.ej = null;
        _this.ek = null;
        _this.eg = null;
        _this.ei = null;
        _this.ai = NaN;
        _this.el = null;
        _this.er = null;
        _this.eu = null;
        _this.es = null;
        _this.et = null;
        _this.af = NaN;
        _this.dz = null;
        _this.d1 = null;
        _this.d6 = null;
        _this.d3 = null;
        _this.d4 = null;
        _this.d0 = null;
        _this.d2 = null;
        _this.ae = NaN;
        _this.d5 = null;
        _this.en = null;
        _this.eq = null;
        _this.eo = null;
        _this.ep = null;
        _this.j = 0;
        _this.a6 = "ig-buttongroup-" + XButtonGroup.a4++;
        _this.w = false;
        _this.v = false;
        _this.x = false;
        _this.propertyChanged = null;
        _this.f = new XButtonGroupButtonCollection();
        _this.selectionChanged = null;
        var a = new ButtonGroupView();
        a.a = _this;
        _this.view = a;
        _this.view.v();
        var b = _this.f;
        b.collectionChanged = delegateCombine(b.collectionChanged, runOn(_this, _this.c3));
        var c = _this.f;
        c.collectionResetting = delegateCombine(c.collectionResetting, runOn(_this, _this.c4));
        return _this;
    }
    Object.defineProperty(XButtonGroup.prototype, "i", {
        get: function () {
            return this.h;
        },
        set: function (a) {
            var b = this.h;
            this.h = a;
            if (b != this.h) {
                this.da("DisplayType", enumGetBox(ButtonGroupDisplayStyle_$type, b), enumGetBox(ButtonGroupDisplayStyle_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "p", {
        get: function () {
            return this.n;
        },
        set: function (a) {
            var b = this.n;
            this.n = a;
            if (b != this.n) {
                this.da("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    XButtonGroup.prototype.c4 = function (a, b) {
        var e_3, _a;
        try {
            for (var _b = __values(fromEnum(this.buttons)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                c.clicked = delegateRemove(c.clicked, runOn(this, this.c6));
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        this.df();
        this.view.q();
    };
    XButtonGroup.prototype.appendContentChild = function (a) {
        this.view.o(a);
    };
    XButtonGroup.prototype.c3 = function (a, b) {
        var e_4, _a, e_5, _b;
        if (b.oldItems != null) {
            try {
                for (var _c = __values(fromEn(b.oldItems)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var c = _d.value;
                    var d = c;
                    if (d != null) {
                        d.clicked = delegateRemove(d.clicked, runOn(this, this.c6));
                    }
                    this.view.r(d);
                }
            }
            catch (e_4_1) {
                e_4 = { error: e_4_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_4)
                        throw e_4.error;
                }
            }
        }
        if (b.newItems != null) {
            try {
                for (var _e = __values(fromEn(b.newItems)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var e = _f.value;
                    var f = e;
                    if (f != null) {
                        f.clicked = delegateCombine(f.clicked, runOn(this, this.c6));
                    }
                    this.view.p(f);
                }
            }
            catch (e_5_1) {
                e_5 = { error: e_5_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_5)
                        throw e_5.error;
                }
            }
        }
        this.df();
    };
    XButtonGroup.prototype.c6 = function (a, b) {
        var c = a;
        var d = this.buttons.indexOf(c);
        this.de(c, d);
    };
    Object.defineProperty(XButtonGroup.prototype, "t", {
        get: function () {
            return this.r;
        },
        set: function (a) {
            var b = this.r;
            this.r = a;
            if (b != this.r) {
                this.da("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "s", {
        get: function () {
            return this.q;
        },
        set: function (a) {
            var b = this.q;
            this.q = a;
            if (b != this.q) {
                this.da("ActualDensity", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "d", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            var b = this.a;
            this.a = a;
            if (b != this.a) {
                this.da("SelectedIndices", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    XButtonGroup.prototype.de = function (a, b) {
        this.u = true;
        if (this.aa(a)) {
            this.d = this.b(this.d, a, b);
        }
        else {
            if (!this.z) {
                this.d = new Array(0);
            }
            this.d = this.c(this.d, a, b);
        }
        this.df();
        if (this.selectionChanged != null) {
            this.selectionChanged(this, new ButtonGroupSelectionChangedEventArgs());
        }
        this.u = false;
    };
    XButtonGroup.prototype.c = function (a, b, c) {
        var d = new Array(Math.max(0, this.a.length + 1));
        var e = 0;
        for (var f = 0; f < this.a.length; f++) {
            if (this.a[f] != c) {
                d[e] = this.a[f];
                e++;
            }
        }
        d[e] = c;
        return d;
    };
    XButtonGroup.prototype.b = function (a, b, c) {
        var d = new Array(Math.max(0, this.a.length - 1));
        var e = 0;
        for (var f = 0; f < this.a.length; f++) {
            if (this.a[f] != c) {
                d[e] = this.a[f];
                e++;
            }
        }
        return d;
    };
    Object.defineProperty(XButtonGroup.prototype, "view", {
        get: function () {
            return this._view;
        },
        set: function (a) {
            this._view = a;
        },
        enumerable: false,
        configurable: true
    });
    XButtonGroup.prototype.destroy = function () {
        this.provideContainer(null);
    };
    XButtonGroup.prototype.da = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        this.dc(a, b, c);
    };
    XButtonGroup.prototype.dc = function (a, b, c) {
        switch (a) {
            case "BaseTheme":
                this.dh(this.p);
                this.dg();
                break;
            case "DisplayType":
            case "ItemBorderColor":
            case "ItemDisabledBorderColor":
            case "ItemBackgroundColor":
            case "ItemDisabledBackgroundColor":
            case "SelectedItemBackgroundColor":
            case "ItemTextColor":
            case "ItemDisabledTextColor":
            case "SelectedItemTextColor":
            case "ItemHoverBackgroundColor":
            case "SelectedItemHoverBackgroundColor":
            case "ItemHoverTextColor":
            case "SelectedItemHoverTextColor":
            case "OutlinedItemBorderColor":
            case "OutlinedItemDisabledBorderColor":
            case "OutlinedItemBackgroundColor":
            case "OutlinedItemDisabledBackgroundColor":
            case "OutlinedSelectedItemBackgroundColor":
            case "OutlinedItemTextColor":
            case "OutlinedItemDisabledTextColor":
            case "OutlinedSelectedItemTextColor":
            case "OutlinedItemHoverBackgroundColor":
            case XButtonGroup.cv:
            case "OutlinedItemHoverTextColor":
            case "OutlinedSelectedItemHoverTextColor":
            case "FlatItemBorderColor":
            case "FlatItemDisabledBorderColor":
            case "FlatItemBackgroundColor":
            case "FlatItemDisabledBackgroundColor":
            case "FlatSelectedItemBackgroundColor":
            case "FlatItemTextColor":
            case "FlatItemDisabledTextColor":
            case "FlatSelectedItemTextColor":
            case "FlatItemHoverBackgroundColor":
            case "FlatSelectedItemHoverBackgroundColor":
            case "FlatItemHoverTextColor":
            case "FlatSelectedItemHoverTextColor":
                this.dg();
                break;
            case "ActualItemBorderColor":
            case "ActualItemDisabledBorderColor":
            case "ActualItemDisabledBackgroundColor":
            case "ActualItemBackgroundColor":
            case "ActualItemTextColor":
            case "ActualItemDisabledTextColor":
            case "ActualSelectedItemTextColor":
            case "ActualSelectedItemBackgroundColor":
                this.df();
                break;
            case "Orientation":
                this.view.y();
                this.df();
                break;
            case "Density":
                this.s = this.t == 0 ? 1 : this.t;
                break;
            case "ActualDensity":
                for (var d = 0; d < this.buttons.count; d++) {
                    this.buttons._inner[d].r = this.s;
                }
                break;
            case "IsDisabled":
                for (var e = 0; e < this.buttons.count; e++) {
                    this.buttons._inner[e].disabled = this.disabled;
                }
                break;
            case "SelectedIndices":
                if (!this.u) {
                    this.df();
                }
                break;
        }
    };
    XButtonGroup.prototype.dl = function (a, b) {
        return new CornerRadius(1, !isNaN_(a.c) ? a.c : b.c, !isNaN_(a.d) ? a.d : b.d, !isNaN_(a.b) ? a.b : b.b, !isNaN_(a.a) ? a.a : b.a);
    };
    XButtonGroup.prototype.dg = function () {
        switch (this.i) {
            case 1:
                this.al = !isNaN_(this.a1) ? this.a1 : this.ax;
                this.ez = this.hn != null ? this.hn : this.gz;
                this.e1 = this.hp != null ? this.hp : this.g1;
                this.e6 = this.hu != null ? this.hu : this.g6;
                this.e3 = this.hr != null ? this.hr : this.g3;
                this.e0 = this.ho != null ? this.ho : this.g0;
                this.e2 = this.hq != null ? this.hq : this.g2;
                this.ak = !isNaN_(this.a0) ? this.a0 : this.aw;
                this.e7 = this.h7 != null ? this.h7 : this.g7;
                this.fa = this.ia != null ? this.ia : this.ha;
                this.e4 = this.hs != null ? this.hs : this.g4;
                this.e5 = this.ht != null ? this.ht : this.g5;
                this.e8 = this.h8 != null ? this.h8 : this.g8;
                this.e9 = this.h9 != null ? this.h9 : this.g9;
                break;
            case 0:
                this.al = !isNaN_(this.a1) ? this.a1 : this.ar;
                this.ez = this.hn != null ? this.hn : this.fz;
                this.e1 = this.hp != null ? this.hp : this.f1;
                this.e6 = this.hu != null ? this.hu : this.f6;
                this.e3 = this.hr != null ? this.hr : this.f3;
                this.e0 = this.ho != null ? this.ho : this.f0;
                this.e2 = this.hq != null ? this.hq : this.f2;
                this.ak = !isNaN_(this.a0) ? this.a0 : this.aq;
                this.e7 = this.h7 != null ? this.h7 : this.f7;
                this.fa = this.ia != null ? this.ia : this.ga;
                this.e4 = this.hs != null ? this.hs : this.f4;
                this.e5 = this.ht != null ? this.ht : this.f5;
                this.e8 = this.h8 != null ? this.h8 : this.f8;
                this.e9 = this.h9 != null ? this.h9 : this.f9;
                break;
        }
    };
    XButtonGroup.prototype.df = function () {
        for (var a = 0; a < this.buttons.count; a++) {
            var b = this.buttons._inner[a];
            b.r = this.s;
            if (a == 0) {
                this.di(b);
            }
            else if (a == this.buttons.count - 1) {
                this.dj(b);
            }
            else {
                this.dk(b);
            }
            b.e = 1;
            b.az = false;
            if (this.v) {
                b.disabled = this.disabled;
            }
            b.nt = this.e0;
            b.bg = this.ak;
            b.ph = this.e2;
            b.pg = this.e1;
            b.pi = this.e3;
            this.view.x(b);
            if (this.aa(b)) {
                b.ns = this.e7;
                b.q7 = this.fa;
                b.p7 = this.e8;
                b.p8 = this.e9;
            }
            else {
                b.ns = this.ez;
                b.q7 = this.e6;
                b.p7 = this.e4;
                b.p8 = this.e5;
            }
        }
    };
    XButtonGroup.prototype.aa = function (a) {
        var b = this.buttons.indexOf(a);
        for (var c = 0; c < this.d.length; c++) {
            if (this.d[c] == b) {
                return true;
            }
        }
        return false;
    };
    XButtonGroup.prototype.dk = function (a) {
        a.kt = new CornerRadius(1, 0, 0, 0, 0);
    };
    XButtonGroup.prototype.dj = function (a) {
        if (this.k == 1) {
            a.kt = new CornerRadius(1, 0, 0, this.al, this.al);
        }
        else {
            a.kt = new CornerRadius(1, 0, this.al, this.al, 0);
        }
    };
    XButtonGroup.prototype.di = function (a) {
        if (this.k == 1) {
            a.kt = new CornerRadius(1, this.al, this.al, 0, 0);
        }
        else {
            a.kt = new CornerRadius(1, this.al, 0, 0, this.al);
        }
    };
    XButtonGroup.prototype.dh = function (a) {
        this.ax = ThemeResolver.m(a, XButtonGroup.av, XButtonGroup.ap);
        this.gz = ThemeResolver.ah(a, XButtonGroup.gn, XButtonGroup.fn);
        this.g1 = ThemeResolver.ah(a, XButtonGroup.gp, XButtonGroup.fp);
        this.g0 = ThemeResolver.ah(a, XButtonGroup.go, XButtonGroup.fo);
        this.g2 = ThemeResolver.ah(a, XButtonGroup.gq, XButtonGroup.fq);
        this.aw = ThemeResolver.m(a, XButtonGroup.au, XButtonGroup.ao);
        this.g6 = ThemeResolver.ah(a, XButtonGroup.gu, XButtonGroup.fu);
        this.g3 = ThemeResolver.ah(a, XButtonGroup.gr, XButtonGroup.fr);
        this.g7 = ThemeResolver.ah(a, XButtonGroup.gv, XButtonGroup.fv);
        this.ha = ThemeResolver.ah(a, XButtonGroup.gy, XButtonGroup.fy);
        this.g4 = ThemeResolver.ah(a, XButtonGroup.gs, XButtonGroup.fs);
        this.g5 = ThemeResolver.ah(a, XButtonGroup.gt, XButtonGroup.ft);
        this.g8 = ThemeResolver.ah(a, XButtonGroup.gw, XButtonGroup.fw);
        this.g9 = ThemeResolver.ah(a, XButtonGroup.gx, XButtonGroup.fx);
        this.ar = ThemeResolver.m(a, XButtonGroup.at, XButtonGroup.an);
        this.fz = ThemeResolver.ah(a, XButtonGroup.gb, XButtonGroup.fb);
        this.f1 = ThemeResolver.ah(a, XButtonGroup.gd, XButtonGroup.fd);
        this.f0 = ThemeResolver.ah(a, XButtonGroup.gc, XButtonGroup.fc);
        this.f2 = ThemeResolver.ah(a, XButtonGroup.ge, XButtonGroup.fe);
        this.aq = ThemeResolver.m(a, XButtonGroup.as, XButtonGroup.am);
        this.f6 = ThemeResolver.ah(a, XButtonGroup.gi, XButtonGroup.fi);
        this.f3 = ThemeResolver.ah(a, XButtonGroup.gf, XButtonGroup.ff);
        this.f7 = ThemeResolver.ah(a, XButtonGroup.gj, XButtonGroup.fj);
        this.ga = ThemeResolver.ah(a, XButtonGroup.gm, XButtonGroup.fm);
        this.f4 = ThemeResolver.ah(a, XButtonGroup.gg, XButtonGroup.fg);
        this.f5 = ThemeResolver.ah(a, XButtonGroup.gh, XButtonGroup.fh);
        this.f8 = ThemeResolver.ah(a, XButtonGroup.gk, XButtonGroup.fk);
        this.f9 = ThemeResolver.ah(a, XButtonGroup.gl, XButtonGroup.fl);
    };
    Object.defineProperty(XButtonGroup.prototype, "al", {
        get: function () {
            return this.ad;
        },
        set: function (a) {
            var b = this.ad;
            this.ad = a;
            if (b != this.ad) {
                this.da("ActualItemCornerRadius", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "ez", {
        get: function () {
            return this.dm;
        },
        set: function (a) {
            var b = this.dm;
            this.dm = a;
            if (b != this.dm) {
                this.da("ActualItemBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "e1", {
        get: function () {
            return this.dp;
        },
        set: function (a) {
            var b = this.dp;
            this.dp = a;
            if (b != this.dp) {
                this.da("ActualItemDisabledBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "e6", {
        get: function () {
            return this.du;
        },
        set: function (a) {
            var b = this.du;
            this.du = a;
            if (b != this.du) {
                this.da("ActualItemTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "e3", {
        get: function () {
            return this.dr;
        },
        set: function (a) {
            var b = this.dr;
            this.dr = a;
            if (b != this.dr) {
                this.da("ActualItemDisabledTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "e0", {
        get: function () {
            return this.dn;
        },
        set: function (a) {
            var b = this.dn;
            this.dn = a;
            if (b != this.dn) {
                this.da("ActualItemBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "e2", {
        get: function () {
            return this.dq;
        },
        set: function (a) {
            var b = this.dq;
            this.dq = a;
            if (b != this.dq) {
                this.da("ActualItemDisabledBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "ak", {
        get: function () {
            return this.ac;
        },
        set: function (a) {
            var b = this.ac;
            this.ac = a;
            if (b != this.ac) {
                this.da("ActualItemBorderWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "e7", {
        get: function () {
            return this.dv;
        },
        set: function (a) {
            var b = this.dv;
            this.dv = a;
            if (b != this.dv) {
                this.da("ActualSelectedItemBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "fa", {
        get: function () {
            return this.dy;
        },
        set: function (a) {
            var b = this.dy;
            this.dy = a;
            if (b != this.dy) {
                this.da("ActualSelectedItemTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "e4", {
        get: function () {
            return this.ds;
        },
        set: function (a) {
            var b = this.ds;
            this.ds = a;
            if (b != this.ds) {
                this.da("ActualItemHoverBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "e5", {
        get: function () {
            return this.dt;
        },
        set: function (a) {
            var b = this.dt;
            this.dt = a;
            if (b != this.dt) {
                this.da("ActualItemHoverTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "e8", {
        get: function () {
            return this.dw;
        },
        set: function (a) {
            var b = this.dw;
            this.dw = a;
            if (b != this.dw) {
                this.da("ActualSelectedItemHoverBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "e9", {
        get: function () {
            return this.dx;
        },
        set: function (a) {
            var b = this.dx;
            this.dx = a;
            if (b != this.dx) {
                this.da("ActualSelectedItemHoverTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "a1", {
        get: function () {
            return this.ah;
        },
        set: function (a) {
            var b = this.ah;
            this.ah = a;
            if (b != this.ah) {
                this.da("ItemCornerRadius", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "hn", {
        get: function () {
            return this.d7;
        },
        set: function (a) {
            var b = this.d7;
            this.d7 = a;
            if (b != this.d7) {
                this.da("ItemBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "hp", {
        get: function () {
            return this.d9;
        },
        set: function (a) {
            var b = this.d9;
            this.d9 = a;
            if (b != this.d9) {
                this.da("ItemDisabledBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "hu", {
        get: function () {
            return this.ee;
        },
        set: function (a) {
            var b = this.ee;
            this.ee = a;
            if (b != this.ee) {
                this.da("ItemTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "hr", {
        get: function () {
            return this.eb;
        },
        set: function (a) {
            var b = this.eb;
            this.eb = a;
            if (b != this.eb) {
                this.da("ItemDisabledTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "hs", {
        get: function () {
            return this.ec;
        },
        set: function (a) {
            var b = this.ec;
            this.ec = a;
            if (b != this.ec) {
                this.da("ItemHoverBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "ho", {
        get: function () {
            return this.d8;
        },
        set: function (a) {
            var b = this.d8;
            this.d8 = a;
            if (b != this.d8) {
                this.da("ItemBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "hq", {
        get: function () {
            return this.ea;
        },
        set: function (a) {
            var b = this.ea;
            this.ea = a;
            if (b != this.ea) {
                this.da("ItemDisabledBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "a0", {
        get: function () {
            return this.ag;
        },
        set: function (a) {
            var b = this.ag;
            this.ag = a;
            if (b != this.ag) {
                this.da("ItemBorderWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "ht", {
        get: function () {
            return this.ed;
        },
        set: function (a) {
            var b = this.ed;
            this.ed = a;
            if (b != this.ed) {
                this.da("ItemHoverTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "h7", {
        get: function () {
            return this.ev;
        },
        set: function (a) {
            var b = this.ev;
            this.ev = a;
            if (b != this.ev) {
                this.da("SelectedItemBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "ia", {
        get: function () {
            return this.ey;
        },
        set: function (a) {
            var b = this.ey;
            this.ey = a;
            if (b != this.ey) {
                this.da("SelectedItemTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "h8", {
        get: function () {
            return this.ew;
        },
        set: function (a) {
            var b = this.ew;
            this.ew = a;
            if (b != this.ew) {
                this.da("SelectedItemHoverBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "h9", {
        get: function () {
            return this.ex;
        },
        set: function (a) {
            var b = this.ex;
            this.ex = a;
            if (b != this.ex) {
                this.da("SelectedItemHoverTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "a3", {
        get: function () {
            return this.aj;
        },
        set: function (a) {
            var b = this.aj;
            this.aj = a;
            if (b != this.aj) {
                this.da("OutlinedItemCornerRadius", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "hv", {
        get: function () {
            return this.ef;
        },
        set: function (a) {
            var b = this.ef;
            this.ef = a;
            if (b != this.ef) {
                this.da("OutlinedItemBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "hx", {
        get: function () {
            return this.eh;
        },
        set: function (a) {
            var b = this.eh;
            this.eh = a;
            if (b != this.eh) {
                this.da("OutlinedItemDisabledBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "h2", {
        get: function () {
            return this.em;
        },
        set: function (a) {
            var b = this.em;
            this.em = a;
            if (b != this.em) {
                this.da("OutlinedItemTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "hz", {
        get: function () {
            return this.ej;
        },
        set: function (a) {
            var b = this.ej;
            this.ej = a;
            if (b != this.ej) {
                this.da("OutlinedItemDisabledTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "h0", {
        get: function () {
            return this.ek;
        },
        set: function (a) {
            var b = this.ek;
            this.ek = a;
            if (b != this.ek) {
                this.da("OutlinedItemHoverBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "hw", {
        get: function () {
            return this.eg;
        },
        set: function (a) {
            var b = this.eg;
            this.eg = a;
            if (b != this.eg) {
                this.da("OutlinedItemBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "hy", {
        get: function () {
            return this.ei;
        },
        set: function (a) {
            var b = this.ei;
            this.ei = a;
            if (b != this.ei) {
                this.da("OutlinedItemDisabledBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "a2", {
        get: function () {
            return this.ai;
        },
        set: function (a) {
            var b = this.ai;
            this.ai = a;
            if (b != this.ai) {
                this.da("OutlinedItemBorderWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "h1", {
        get: function () {
            return this.el;
        },
        set: function (a) {
            var b = this.el;
            this.el = a;
            if (b != this.el) {
                this.da("OutlinedItemHoverTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "h3", {
        get: function () {
            return this.er;
        },
        set: function (a) {
            var b = this.er;
            this.er = a;
            if (b != this.er) {
                this.da("OutlinedSelectedItemBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "h6", {
        get: function () {
            return this.eu;
        },
        set: function (a) {
            var b = this.eu;
            this.eu = a;
            if (b != this.eu) {
                this.da("OutlinedSelectedItemTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "h4", {
        get: function () {
            return this.es;
        },
        set: function (a) {
            var b = this.es;
            this.es = a;
            if (b != this.es) {
                this.da(XButtonGroup.cv, b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "h5", {
        get: function () {
            return this.et;
        },
        set: function (a) {
            var b = this.et;
            this.et = a;
            if (b != this.et) {
                this.da("OutlinedSelectedItemHoverTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "az", {
        get: function () {
            return this.af;
        },
        set: function (a) {
            var b = this.af;
            this.af = a;
            if (b != this.af) {
                this.da("FlatItemCornerRadius", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "hb", {
        get: function () {
            return this.dz;
        },
        set: function (a) {
            var b = this.dz;
            this.dz = a;
            if (b != this.dz) {
                this.da("FlatItemBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "hd", {
        get: function () {
            return this.d1;
        },
        set: function (a) {
            var b = this.d1;
            this.d1 = a;
            if (b != this.d1) {
                this.da("FlatItemDisabledBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "hi", {
        get: function () {
            return this.d6;
        },
        set: function (a) {
            var b = this.d6;
            this.d6 = a;
            if (b != this.d6) {
                this.da("FlatItemTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "hf", {
        get: function () {
            return this.d3;
        },
        set: function (a) {
            var b = this.d3;
            this.d3 = a;
            if (b != this.d3) {
                this.da("FlatItemDisabledTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "hg", {
        get: function () {
            return this.d4;
        },
        set: function (a) {
            var b = this.d4;
            this.d4 = a;
            if (b != this.d4) {
                this.da("FlatItemHoverBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "hc", {
        get: function () {
            return this.d0;
        },
        set: function (a) {
            var b = this.d0;
            this.d0 = a;
            if (b != this.d0) {
                this.da("FlatItemBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "he", {
        get: function () {
            return this.d2;
        },
        set: function (a) {
            var b = this.d2;
            this.d2 = a;
            if (b != this.d2) {
                this.da("FlatItemDisabledBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "ay", {
        get: function () {
            return this.ae;
        },
        set: function (a) {
            var b = this.ae;
            this.ae = a;
            if (b != this.ae) {
                this.da("FlatItemBorderWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "hh", {
        get: function () {
            return this.d5;
        },
        set: function (a) {
            var b = this.d5;
            this.d5 = a;
            if (b != this.d5) {
                this.da("FlatItemHoverTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "hj", {
        get: function () {
            return this.en;
        },
        set: function (a) {
            var b = this.en;
            this.en = a;
            if (b != this.en) {
                this.da("FlatSelectedItemBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "hm", {
        get: function () {
            return this.eq;
        },
        set: function (a) {
            var b = this.eq;
            this.eq = a;
            if (b != this.eq) {
                this.da("FlatSelectedItemTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "hk", {
        get: function () {
            return this.eo;
        },
        set: function (a) {
            var b = this.eo;
            this.eo = a;
            if (b != this.eo) {
                this.da("FlatSelectedItemHoverBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "hl", {
        get: function () {
            return this.ep;
        },
        set: function (a) {
            var b = this.ep;
            this.ep = a;
            if (b != this.ep) {
                this.da("FlatSelectedItemHoverTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "k", {
        get: function () {
            return this.j;
        },
        set: function (a) {
            var b = this.j;
            this.j = a;
            if (b != this.j) {
                this.da("Orientation", enumGetBox(ButtonGroupOrientation_$type, b), enumGetBox(ButtonGroupOrientation_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "b5", {
        get: function () {
            return this.a6;
        },
        set: function (a) {
            var b = this.a6;
            this.a6 = a;
            if (b != this.a6) {
                this.da("Id", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "disabled", {
        get: function () {
            return this.w;
        },
        set: function (a) {
            var b = this.w;
            this.w = a;
            this.v = true;
            if (b != this.w) {
                this.da("IsDisabled", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButtonGroup.prototype, "z", {
        get: function () {
            return this.x;
        },
        set: function (a) {
            var b = this.x;
            this.x = a;
            if (b != this.x) {
                this.da("IsMultiSelect", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    XButtonGroup.prototype.db = function () {
    };
    XButtonGroup.prototype.onDetachedFromUI = function () {
        this.view.u();
    };
    XButtonGroup.prototype.onAttachedToUI = function () {
        this.view.s();
    };
    XButtonGroup.prototype.ab = function () {
        return this.view.d();
    };
    XButtonGroup.prototype.a5 = function () {
        return this.e();
    };
    XButtonGroup.prototype.bq = function () {
        var a = this.e();
        return a.l();
    };
    XButtonGroup.prototype.e = function () {
        var a = new ButtonGroupVisualModelExport();
        a.e = this.p;
        a.f = this.s;
        a.a = this.d;
        a.k = this.al;
        a.b = AppearanceHelper.a(this.ez);
        a.d = AppearanceHelper.a(this.e6);
        a.c = AppearanceHelper.a(this.e0);
        a.j = this.ak;
        a.g = this.disabled;
        a.h = this.z;
        a.i = new List$1(ButtonVisualModelExport.$, 0);
        for (var b = 0; b < this.buttons.count; b++) {
            a.i.add1(this.buttons._inner[b].d7());
        }
        return a;
    };
    XButtonGroup.prototype.provideContainer = function (a) {
        this.view.t(a);
    };
    Object.defineProperty(XButtonGroup.prototype, "buttons", {
        get: function () {
            return this.f;
        },
        enumerable: false,
        configurable: true
    });
    XButtonGroup.$t = markType(XButtonGroup, 'XButtonGroup', Base.$, [INotifyPropertyChanged_$type]);
    XButtonGroup.o = 2;
    XButtonGroup.av = 4;
    XButtonGroup.gn = BrushUtil.h(255, 255, 255, 255);
    XButtonGroup.gp = BrushUtil.h(10, 0, 0, 0);
    XButtonGroup.go = BrushUtil.h(255, 199, 199, 199);
    XButtonGroup.gq = BrushUtil.h(255, 199, 199, 199);
    XButtonGroup.au = 1;
    XButtonGroup.gu = BrushUtil.h(255, 0, 0, 0);
    XButtonGroup.gr = BrushUtil.h(66, 0, 0, 0);
    XButtonGroup.gv = BrushUtil.h(60, 0, 0, 0);
    XButtonGroup.gy = BrushUtil.h(255, 0, 0, 0);
    XButtonGroup.gs = BrushUtil.h(30, 0, 0, 0);
    XButtonGroup.gt = BrushUtil.h(255, 0, 0, 0);
    XButtonGroup.gw = BrushUtil.h(96, 0, 0, 0);
    XButtonGroup.gx = BrushUtil.h(255, 0, 0, 0);
    XButtonGroup.ap = 3;
    XButtonGroup.fn = BrushUtil.h(0, 255, 255, 255);
    XButtonGroup.fp = BrushUtil.h(10, 0, 0, 0);
    XButtonGroup.fo = BrushUtil.h(255, 33, 150, 243);
    XButtonGroup.fq = BrushUtil.h(255, 199, 199, 199);
    XButtonGroup.ao = 1;
    XButtonGroup.fu = BrushUtil.h(255, 33, 150, 243);
    XButtonGroup.fr = BrushUtil.h(66, 0, 0, 0);
    XButtonGroup.fv = BrushUtil.h(255, 33, 150, 243);
    XButtonGroup.fy = BrushUtil.h(255, 255, 255, 255);
    XButtonGroup.fs = BrushUtil.h(26, 33, 150, 243);
    XButtonGroup.ft = BrushUtil.h(255, 33, 150, 243);
    XButtonGroup.fw = BrushUtil.h(255, 33, 150, 243);
    XButtonGroup.fx = BrushUtil.h(255, 255, 255, 255);
    XButtonGroup.at = 4;
    XButtonGroup.gb = BrushUtil.h(0, 255, 255, 255);
    XButtonGroup.gd = BrushUtil.h(10, 0, 0, 0);
    XButtonGroup.gc = BrushUtil.h(0, 0, 0, 0);
    XButtonGroup.ge = BrushUtil.h(255, 199, 199, 199);
    XButtonGroup.as = 0;
    XButtonGroup.gi = BrushUtil.h(255, 228, 28, 119);
    XButtonGroup.gf = BrushUtil.h(66, 0, 0, 0);
    XButtonGroup.gj = BrushUtil.h(30, 228, 28, 119);
    XButtonGroup.gm = BrushUtil.h(255, 228, 28, 119);
    XButtonGroup.gg = BrushUtil.h(13, 228, 28, 119);
    XButtonGroup.gh = BrushUtil.h(255, 228, 28, 119);
    XButtonGroup.gk = BrushUtil.h(30, 228, 28, 119);
    XButtonGroup.gl = BrushUtil.h(255, 228, 28, 119);
    XButtonGroup.an = 0;
    XButtonGroup.fb = BrushUtil.h(0, 255, 255, 255);
    XButtonGroup.fd = BrushUtil.h(10, 0, 0, 0);
    XButtonGroup.fc = BrushUtil.h(0, 0, 0, 0);
    XButtonGroup.fe = BrushUtil.h(0, 0, 0, 0);
    XButtonGroup.am = 0;
    XButtonGroup.fi = BrushUtil.h(255, 119, 119, 119);
    XButtonGroup.ff = BrushUtil.h(66, 0, 0, 0);
    XButtonGroup.fj = BrushUtil.h(26, 33, 150, 243);
    XButtonGroup.fm = BrushUtil.h(255, 33, 150, 243);
    XButtonGroup.fg = BrushUtil.h(10, 33, 150, 243);
    XButtonGroup.fh = BrushUtil.h(255, 119, 119, 119);
    XButtonGroup.fk = BrushUtil.h(26, 33, 150, 243);
    XButtonGroup.fl = BrushUtil.h(255, 33, 150, 243);
    XButtonGroup.cv = "OutlinedSelectedItemHoverBackgroundColor";
    XButtonGroup.a4 = 0;
    return XButtonGroup;
}(Base));
export { XButtonGroup };
