/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { Base, Delegate_$type, fromEnum, runOn, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, enumGetBox, String_$type } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { XRipple } from "./XRipple";
import { NativeUI } from "igniteui-react-core";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { HorizontalAlignment_$type } from "igniteui-react-core";
import { KeyFrameAnimationFactory } from "igniteui-react-core";
import { ElevationMode_$type } from "igniteui-react-core";
import { ElevationHelper } from "./ElevationHelper";
import { ButtonDisplayStyle_$type } from "./ButtonDisplayStyle";
import { isNaN_ } from "igniteui-react-core";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { CornerRadius } from "igniteui-react-core";
import { VerticalAlignment_$type } from "igniteui-react-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-react-core";
import { ThemeResolver } from "./ThemeResolver";
import { ButtonClickEventArgs } from "./ButtonClickEventArgs";
import { MouseEventArgs } from "igniteui-react-core";
import { FocusEventArgs } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
import { ButtonVisualModelExport } from "./ButtonVisualModelExport";
import { UIElementPropertyAccessorFactory } from "igniteui-react-core";
import { AppearanceHelper } from "igniteui-react-core";
import { FontUtil } from "igniteui-react-core";
import { Dictionary$2 } from "igniteui-react-core";
import { Theme } from "./Theme";
/**
 * @hidden
 */
var ButtonView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ButtonView, _super);
    function ButtonView() {
        var _this = _super.call(this) || this;
        _this.b = null;
        _this.k = null;
        _this.d = null;
        _this.h = new List$1(Delegate_$type, 0);
        _this.e = true;
        _this.n = null;
        _this.j = NaN;
        _this.i = NaN;
        _this.l = null;
        _this.c = null;
        _this.m = null;
        _this.p = null;
        _this.o = null;
        return _this;
    }
    ButtonView.prototype.ao = function () {
    };
    ButtonView.prototype.g = function () {
        return true;
    };
    Object.defineProperty(ButtonView.prototype, "q", {
        get: function () {
            return this.n;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ButtonView.prototype, "s", {
        get: function () {
            return this.m;
        },
        enumerable: false,
        configurable: true
    });
    ButtonView.prototype.ai = function (a) {
        var e_1, _a;
        var _this = this;
        if (a == null) {
            try {
                for (var _b = __values(fromEnum(this.h)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    b();
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            this.h.clear();
            return;
        }
        this.k = a;
        this.k.rootWrapper.setStyleProperty("display", "flex");
        this.k.rootWrapper.setStyleProperty("flex-direction", "row");
        this.k.rootWrapper.setStyleProperty("flex-wrap", "no-wrap");
        this.k.rootWrapper.setStyleProperty("align-items", "center");
        var c = this.k.createElement("button");
        this.n = c;
        this.n.setStyleProperty("position", "relative");
        this.n.setStyleProperty("display", "inline-flex");
        this.n.setStyleProperty("align-items", "center");
        this.n.setStyleProperty("justify-content", "center");
        this.ay();
        this.n.setStyleProperty("border", "none");
        this.n.setStyleProperty("cursor", "pointer");
        this.n.setStyleProperty("user-select", "none");
        this.n.setStyleProperty("outline-style", "none");
        this.n.setStyleProperty("-webkit-tap-highlight-color", "transparent");
        this.n.setStyleProperty("overflow", "hidden");
        this.n.setStyleProperty("white-space", "no-wrap");
        this.n.setStyleProperty("color", "#000");
        this.n.setStyleProperty("background", this.b.nf._fill);
        NativeUI.o(this.n, this.b.kr);
        this.n.setAttribute("id", this.b.hu);
        this.av();
        this.h.add(c.listen("change", runOn(this, this.x)));
        this.h.add(c.listen("click", runOn(this, this.y)));
        this.h.add(c.listen("focus", runOn(this, this.z)));
        this.h.add(c.listen("blur", runOn(this, this.w)));
        this.h.add(this.k.rootWrapper.listen("mouseenter", runOn(this, this.u)));
        this.h.add(this.k.rootWrapper.listen("mouseleave", runOn(this, this.v)));
        this.h.add(this.k.rootWrapper.listen("focusin", runOn(this, this.aa)));
        this.h.add(this.k.rootWrapper.listen("focusout", runOn(this, this.ab)));
        this.k.append(c);
        var d = this.k.createElement("div");
        var e = this.k.getSubRenderer(d);
        d.setStyleProperty("position", "absolute");
        d.setStyleProperty("width", "100%");
        d.setStyleProperty("height", "100%");
        d.setStyleProperty("left", "0px");
        d.setStyleProperty("top", "0px");
        d.setStyleProperty("overflow", "hidden");
        var f = new XRipple();
        f.provideContainer(e);
        f.q = c;
        var g = this.k.getExternal(f, this.k.rootWrapper, this.k.getExternal(this.b, null, null));
        f.h = false;
        f.k = true;
        this.c = f;
        this.n.append(d);
        var h = this.k.createElement("div");
        h.addClass("ig-button-content");
        h.setStyleProperty("font-family", "Verdana");
        h.setStyleProperty("font-weight", "400");
        h.setStyleProperty("font-size", ".875rem");
        this.m = h;
        this.h.add(h.listen("click", runOn(this, this.t)));
        this.n.append(h);
        this.o = h;
        this.k.getPortal(h, "ChildContent", function (i) {
            var comp_ = i.componentRef;
            _this.p = comp_;
            {
                _this.o.setStyleProperty("flex-direction", _this.b.g0);
                _this.o.setStyleProperty("align-items", _this.b.e7);
                var direction_ = _this.b.g0;
                var display_ = _this.b.ff != null ? _this.b.ff : _this.b.fw;
                var alignItems_ = _this.b.e7;
                comp_.display = display_;
                comp_.flexDirection = direction_;
                comp_.alignItems = alignItems_;
            }
        }, true);
        this.b.ke();
    };
    ButtonView.prototype.ak = function () {
        this.c.i = this.b.ap;
    };
    ButtonView.prototype.ay = function () {
        var a = "2.25rem";
        var b = "2.25rem";
        var c = "2.25rem";
        var d = "2.25rem";
        var e = "3.5rem";
        var f = "3.5rem";
        var g = "3.5rem";
        var h = "3.5rem";
        var i = "5.5rem";
        var j = "2.25rem";
        var k = "0px";
        var l = ".9375rem";
        var m = ".5625rem 1rem";
        switch (this.b.q) {
            case 2:
                m = ".375rem .75rem";
                j = "1.875rem";
                e = "3rem";
                f = "3rem";
                g = "3rem";
                h = "3rem";
                l = ".6875rem";
                break;
            case 3:
                m = ".1875rem 1rem";
                j = "1.5rem";
                f = "2.5rem";
                e = "2.5rem";
                h = "2.5rem";
                g = "2.5rem";
                l = ".4375rem";
                break;
        }
        if (!isNaN_(this.b.bi) && !isNaN_(this.b.bk) && !isNaN_(this.b.bj) && !isNaN_(this.b.bh)) {
            m = this.b.bk + "px " + this.b.bj + "px " + this.b.bh + "px " + this.b.bi + "px";
        }
        if (this.b.e == 4) {
            this.n.setStyleProperty("min-width", a);
            this.n.setStyleProperty("min-height", b);
            this.n.setStyleProperty("padding", k);
            this.n.setStyleProperty("width", c);
            this.n.setStyleProperty("height", d);
        }
        else if (this.b.e == 3) {
            this.n.setStyleProperty("min-width", e);
            this.n.setStyleProperty("min-height", f);
            this.n.setStyleProperty("padding", l);
            this.n.setStyleProperty("width", g);
            this.n.setStyleProperty("height", h);
        }
        else {
            this.n.setStyleProperty("min-width", i);
            this.n.setStyleProperty("min-height", j);
            this.n.setStyleProperty("padding", m);
        }
        if (!isNaN_(this.b.bf) && this.b.bf > 0) {
            this.n.setStyleProperty("border-style", "solid");
        }
        else {
            this.n.setStyleProperty("border-style", "none");
        }
        if (!isNaN_(this.j)) {
            this.n.setStyleProperty("min-width", this.j.toString() + "px");
        }
        if (!isNaN_(this.i)) {
            this.n.setStyleProperty("min-height", this.i.toString() + "px");
        }
        if (this.b.av) {
            this.n.setStyleProperty("width", "100%");
            this.n.setStyleProperty("height", "100%");
            this.k.rootWrapper.setStyleProperty("height", "100%");
        }
        else {
            this.n.setStyleProperty("width", "auto");
            this.n.setStyleProperty("height", "auto");
            this.k.rootWrapper.setStyleProperty("height", "auto");
        }
    };
    ButtonView.prototype.as = function () {
        switch (this.b.k5) {
            case 1:
                this.n.setStyleProperty("justify-content", "center");
                this.o.setStyleProperty("flex-grow", "unset");
                break;
            case 3:
                this.n.setStyleProperty("justify-content", "stretch");
                this.o.setStyleProperty("flex-grow", "1");
                break;
            case 0:
                this.n.setStyleProperty("justify-content", "left");
                this.o.setStyleProperty("flex-grow", "unset");
                break;
            case 2:
                this.n.setStyleProperty("justify-content", "right");
                this.o.setStyleProperty("flex-grow", "unset");
                break;
        }
    };
    ButtonView.prototype.au = function (a) {
        this.j = a;
    };
    ButtonView.prototype.at = function (a) {
        this.i = a;
    };
    ButtonView.prototype.aq = function () {
        this.n.setAttribute("disabled", this.b.disabled ? "true" : "false");
        this.n.setProperty("disabled", this.b.disabled);
    };
    ButtonView.prototype.al = function () {
        if (this.k != null) {
            this.k.rootWrapper.setStyleProperty("display", this.b.fw);
            var comp_ = this.p;
            if (this.p != null) {
                this.o.setStyleProperty("display", this.b.fw);
                var display_ = this.b.ff != null ? this.b.fw : this.b.ff;
                comp_.display = display_;
            }
            var ext_ = this.k.getExternal(this.b, null, null);
            if (ext_ && ext_._onDisplayChanged) {
                ext_._onDisplayChanged();
            }
            ;
        }
    };
    ButtonView.prototype.ah = function () {
        if (this.k != null) {
            var comp_ = this.p;
            if (this.p != null) {
                var display_ = this.b.ff != null ? this.b.ff : this.b.fw;
                comp_.display = display_;
            }
        }
    };
    ButtonView.prototype.af = function () {
        if (this.k != null) {
            this.k.rootWrapper.setStyleProperty("align-items", this.b.e7);
            this.n.setStyleProperty("align-items", this.b.e7);
            var comp_ = this.p;
            if (this.p != null) {
                this.o.setStyleProperty("align-items", this.b.e7);
                var alignItems_ = this.b.e7;
                comp_.alignItems = alignItems_;
            }
            var ext_ = this.k.getExternal(this.b, null, null);
            if (ext_ && ext_._onAlignItemsChanged) {
                ext_._onAlignItemsChanged();
            }
            ;
        }
    };
    ButtonView.prototype.am = function () {
        if (this.k != null) {
            this.k.rootWrapper.setStyleProperty("flex-direction", this.b.g0);
            this.n.setStyleProperty("flex-direction", this.b.g0);
            var ext_ = this.k.getExternal(this.b, null, null);
            var comp_ = this.p;
            if (this.p != null) {
                this.o.setStyleProperty("flex-direction", this.b.g0);
                var direction_ = this.b.g0;
                comp_.flexDirection = direction_;
            }
            if (ext_ && ext_._onFlexDirectionChanged) {
                ext_._onFlexDirectionChanged();
            }
            ;
        }
    };
    ButtonView.prototype.an = function () {
        if (this.k != null) {
            this.k.rootWrapper.setStyleProperty("flex-grow", this.b.g2);
            this.n.setStyleProperty("flex-grow", this.b.g2);
            var ext_ = this.k.getExternal(this.b, null, null);
            if (ext_ && ext_._onFlexGrowChanged) {
                ext_._onFlexGrowChanged();
            }
            ;
        }
    };
    ButtonView.prototype.t = function (a) {
    };
    ButtonView.prototype.av = function () {
        if (this.g()) {
            var a = this.b.hu;
            this.n.setAttribute("name", this.b.h2);
            this.n.setProperty("value", this.b.ea);
            if (this.b.aw) {
                this.n.setAttribute("tabindex", this.b.d3.toString());
            }
            this.n.setProperty("disabled", this.b.disabled);
            {
            }
            this.n.setAttribute("aria-label", this.b.e9);
            this.n.setStyleProperty("cursor", !this.b.as ? "pointer" : "unset");
        }
    };
    ButtonView.prototype.ap = function () {
        if (this.g()) {
            var a = this.b.hu;
            this.n.setAttribute("id", a);
        }
    };
    ButtonView.prototype.u = function (a) {
        this.b.kb();
    };
    ButtonView.prototype.v = function (a) {
        this.b.kc();
    };
    ButtonView.prototype.w = function (a) {
        this.b.j5();
    };
    ButtonView.prototype.z = function (a) {
        this.b.j8();
    };
    ButtonView.prototype.y = function (a) {
        if (!this.b.aq) {
            a.preventDefault();
        }
        this.b.j6();
    };
    ButtonView.prototype.aa = function (a) {
        this.b.j9();
    };
    ButtonView.prototype.ab = function (a) {
        this.b.ka(a.originalEvent.relatedTarget);
    };
    ButtonView.prototype.f = function () {
        return false;
    };
    ButtonView.prototype.x = function (a) {
    };
    ButtonView.prototype.ae = function () {
        if (KeyFrameAnimationFactory.h == null) {
            KeyFrameAnimationFactory.h = this.k;
        }
    };
    ButtonView.prototype.ag = function () {
        this.e = true;
        this.h.add(this.n.listen("change", runOn(this, this.x)));
        this.h.add(this.n.listen("click", runOn(this, this.y)));
        this.h.add(this.n.listen("focus", runOn(this, this.z)));
        this.h.add(this.n.listen("blur", runOn(this, this.w)));
        this.h.add(this.m.listen("click", runOn(this, this.t)));
        this.h.add(this.n.listen("mouseenter", runOn(this, this.u)));
        this.h.add(this.n.listen("mouseleave", runOn(this, this.v)));
        this.h.add(this.n.listen("focusin", runOn(this, this.aa)));
        this.h.add(this.n.listen("focusout", runOn(this, this.ab)));
    };
    ButtonView.prototype.aj = function () {
        var e_2, _a;
        this.e = false;
        try {
            for (var _b = __values(fromEnum(this.h)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var a = _c.value;
                a();
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        this.h.clear();
    };
    ButtonView.prototype.ar = function () {
        var model_ = this.b;
        if (model_.externalObject && model_.externalObject.refreshDefaults) {
            model_.externalObject.refreshDefaults();
        }
        ;
    };
    ButtonView.prototype.aw = function (a, b) {
        this.c.ax = a;
        this.c.aw = b;
    };
    ButtonView.prototype.ax = function (a, b) {
        var c = ElevationHelper.e(a, this.b.nr, this.b.no, this.b.ne, b);
        this.n.setStyleProperty("box-shadow", c);
    };
    ButtonView.prototype.az = function (a) {
        if (a != null) {
            this.m.setStyleProperty("font", a.fontString);
        }
    };
    ButtonView.prototype.ac = function (a) {
        this.m.append(a);
    };
    ButtonView.prototype.ad = function () {
        this.m.removeChildren();
    };
    ButtonView.prototype.r = function () {
        return this.m.getChildCount() > 0 ? this.m.getChildAt(0) : null;
    };
    ButtonView.prototype.a = function () {
        var rect_ = this.k.rootWrapper.getNativeElement().getBoundingClientRect();
        var a = (rect_.top);
        var b = (rect_.left);
        var c = new Array(2);
        c[0] = a;
        c[1] = b;
        return c;
    };
    ButtonView.$t = markType(ButtonView, 'ButtonView');
    return ButtonView;
}(Base));
export { ButtonView };
/**
 * @hidden
 */
var XButton = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(XButton, _super);
    function XButton() {
        var _this = _super.call(this) || this;
        _this._view = null;
        _this.d9 = null;
        _this.pf = XButton.k.ae(XButton.m, "UmbraShadowColor");
        _this.o3 = XButton.k.ae(XButton.m, "PenumbraShadowColor");
        _this.nu = XButton.k.ae(XButton.m, "AmbientShadowColor");
        _this.v = XButton.k.d(XButton.m, "ElevationMode");
        _this.o6 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledBackgroundColor");
        _this.o7 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledBorderColor");
        _this.o8 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledTextColor");
        _this.da = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledElevation");
        _this.dd = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "RestingElevation");
        _this.dc = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverElevation");
        _this.db = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusElevation");
        _this.o5 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "BorderColor");
        _this.pd = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "RippleColor");
        _this.ky = XButton.k.y(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "CornerRadius");
        _this.bp = XButton.k.i(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "BorderWidth");
        _this.o4 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "BackgroundColor");
        _this.pe = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "TextColor");
        _this.pc = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverTextColor");
        _this.pb = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverBackgroundColor");
        _this.o9 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusBackgroundColor");
        _this.pa = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusTextColor");
        _this.n8 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "DisabledBackgroundColor");
        _this.n9 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "DisabledBorderColor");
        _this.oa = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "DisabledTextColor");
        _this.cy = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "DisabledElevation");
        _this.c1 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "RestingElevation");
        _this.c0 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "HoverElevation");
        _this.cz = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "FocusElevation");
        _this.n7 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "BorderColor");
        _this.of = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "RippleColor");
        _this.kv = XButton.k.y(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "CornerRadius");
        _this.bm = XButton.k.i(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "BorderWidth");
        _this.n6 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "BackgroundColor");
        _this.og = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "TextColor");
        _this.oe = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "HoverTextColor");
        _this.od = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "HoverBackgroundColor");
        _this.ob = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "FocusBackgroundColor");
        _this.oc = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "FocusTextColor");
        _this.ou = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "DisabledBackgroundColor");
        _this.ov = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "DisabledBorderColor");
        _this.ow = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "DisabledTextColor");
        _this.c6 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "DisabledElevation");
        _this.c9 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "RestingElevation");
        _this.c8 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "HoverElevation");
        _this.c7 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "FocusElevation");
        _this.ot = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "BorderColor");
        _this.o1 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "RippleColor");
        _this.kx = XButton.k.y(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "CornerRadius");
        _this.bo = XButton.k.i(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "BorderWidth");
        _this.os = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "BackgroundColor");
        _this.o2 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "TextColor");
        _this.o0 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "HoverTextColor");
        _this.oz = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "HoverBackgroundColor");
        _this.ox = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "FocusBackgroundColor");
        _this.oy = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "FocusTextColor");
        _this.oj = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "DisabledBackgroundColor");
        _this.ok = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "DisabledBorderColor");
        _this.ol = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "DisabledTextColor");
        _this.c2 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "DisabledElevation");
        _this.c5 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "RestingElevation");
        _this.c4 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "HoverElevation");
        _this.c3 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "FocusElevation");
        _this.oi = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "BorderColor");
        _this.oq = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "RippleColor");
        _this.kw = XButton.k.y(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "CornerRadius");
        _this.bn = XButton.k.i(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "BorderWidth");
        _this.oh = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "BackgroundColor");
        _this.or = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "TextColor");
        _this.op = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "HoverTextColor");
        _this.oo = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "HoverBackgroundColor");
        _this.om = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "FocusBackgroundColor");
        _this.on = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "FocusTextColor");
        _this.nx = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "DisabledBackgroundColor");
        _this.ny = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "DisabledBorderColor");
        _this.nz = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "DisabledTextColor");
        _this.cu = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "DisabledElevation");
        _this.cx = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "RestingElevation");
        _this.cw = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "HoverElevation");
        _this.cv = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "FocusElevation");
        _this.nw = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "BorderColor");
        _this.n4 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "RippleColor");
        _this.ku = XButton.k.y(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "CornerRadius");
        _this.bl = XButton.k.i(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "BorderWidth");
        _this.nv = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "BackgroundColor");
        _this.n5 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "TextColor");
        _this.n3 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "HoverTextColor");
        _this.n2 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "HoverBackgroundColor");
        _this.n0 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "FocusBackgroundColor");
        _this.n1 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "FocusTextColor");
        _this.bc = NaN;
        _this.bb = NaN;
        _this.d = 0;
        _this.p = 0;
        _this.l = 0;
        _this.o = 1;
        _this.k8 = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "BorderColor");
        _this.lj = ThemeResolver.ag(XButton.m, XButton.k, "UmbraShadowColor");
        _this.lg = ThemeResolver.ag(XButton.m, XButton.k, "PenumbraShadowColor");
        _this.k6 = ThemeResolver.ag(XButton.m, XButton.k, "AmbientShadowColor");
        _this.b0 = ThemeResolver.p(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "RestingElevation");
        _this.by = ThemeResolver.p(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusElevation");
        _this.bz = ThemeResolver.p(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverElevation");
        _this.lh = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "RippleColor");
        _this.kk = ThemeResolver.aa(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "CornerRadius");
        _this.k7 = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "BackgroundColor");
        _this.k9 = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledBackgroundColor");
        _this.la = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledBorderColor");
        _this.lb = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledTextColor");
        _this.bx = ThemeResolver.p(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledElevation");
        _this.s = ThemeResolver.f(XButton.m, XButton.k, "ElevationMode");
        _this.li = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "TextColor");
        _this.lf = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverTextColor");
        _this.lc = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusBackgroundColor");
        _this.ld = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusTextColor");
        _this.le = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverBackgroundColor");
        _this.a2 = ThemeResolver.k(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "BorderWidth");
        _this.m1 = null;
        _this.m3 = null;
        _this.m4 = null;
        _this.m5 = null;
        _this.ck = -1;
        _this.m8 = null;
        _this.m2 = null;
        _this.cn = -1;
        _this.cm = -1;
        _this.cl = -1;
        _this.be = NaN;
        _this.kq = new CornerRadius(1, NaN, NaN, NaN, NaN);
        _this.na = null;
        _this.lz = null;
        _this.l1 = null;
        _this.l2 = null;
        _this.l3 = null;
        _this.b6 = -1;
        _this.l6 = null;
        _this.l0 = null;
        _this.b9 = -1;
        _this.b8 = -1;
        _this.b7 = -1;
        _this.l8 = null;
        _this.l9 = null;
        _this.l7 = null;
        _this.l4 = null;
        _this.l5 = null;
        _this.a9 = NaN;
        _this.kn = new CornerRadius(1, NaN, NaN, NaN, NaN);
        _this.lk = null;
        _this.lm = null;
        _this.ln = null;
        _this.lo = null;
        _this.b1 = -1;
        _this.t = 0;
        _this.mc = null;
        _this.ll = null;
        _this.co = -1;
        _this.cb = -1;
        _this.ca = -1;
        _this.z = null;
        _this.nd = null;
        _this.me = null;
        _this.nc = null;
        _this.nb = null;
        _this.m9 = null;
        _this.m6 = null;
        _this.m7 = null;
        _this.ma = null;
        _this.mb = null;
        _this.a3 = NaN;
        _this.kl = new CornerRadius(1, NaN, NaN, NaN, NaN);
        _this.mq = null;
        _this.ms = null;
        _this.mt = null;
        _this.mu = null;
        _this.cg = -1;
        _this.mx = null;
        _this.mr = null;
        _this.cj = -1;
        _this.ci = -1;
        _this.ch = -1;
        _this.bd = NaN;
        _this.kp = new CornerRadius(1, NaN, NaN, NaN, NaN);
        _this.mz = null;
        _this.m0 = null;
        _this.my = null;
        _this.mv = null;
        _this.mw = null;
        _this.lp = null;
        _this.lr = null;
        _this.ls = null;
        _this.lt = null;
        _this.b2 = -1;
        _this.md = null;
        _this.lq = null;
        _this.b5 = -1;
        _this.b4 = -1;
        _this.b3 = -1;
        _this.a8 = NaN;
        _this.km = new CornerRadius(1, NaN, NaN, NaN, NaN);
        _this.lx = null;
        _this.ly = null;
        _this.lw = null;
        _this.lu = null;
        _this.lv = null;
        _this.mf = null;
        _this.mh = null;
        _this.mi = null;
        _this.mj = null;
        _this.cc = -1;
        _this.mm = null;
        _this.mg = null;
        _this.cf = -1;
        _this.ce = -1;
        _this.cd = -1;
        _this.ba = NaN;
        _this.ko = new CornerRadius(1, NaN, NaN, NaN, NaN);
        _this.mo = null;
        _this.mp = null;
        _this.mn = null;
        _this.mk = null;
        _this.ml = null;
        _this.ei = "ig-native-button-" + XButton.d5++;
        _this.eh = "ig-button-" + XButton.d4++;
        _this.ee = "inline-block";
        _this.ed = null;
        _this.ef = "inline-block";
        _this.eg = null;
        _this.eb = "center";
        _this.d6 = null;
        _this.ej = null;
        _this.cp = 0;
        _this.ak = false;
        _this.ec = null;
        _this.aj = false;
        _this.am = false;
        _this.an = true;
        _this.ah = false;
        _this.ad = false;
        _this.af = false;
        _this.ao = false;
        _this.al = false;
        _this.ai = false;
        _this.ag = false;
        _this.a5 = NaN;
        _this.a7 = NaN;
        _this.a6 = NaN;
        _this.a4 = NaN;
        _this.k4 = 1;
        _this.q8 = 1;
        _this.ae = true;
        _this.propertyChanged = null;
        _this.clicked = null;
        _this.mouseEnter = null;
        _this.mouseLeave = null;
        _this.gotFocus = null;
        _this.lostFocus = null;
        var a = new ButtonView();
        a.b = _this;
        _this.view = a;
        _this.view.ao();
        return _this;
    }
    Object.defineProperty(XButton.prototype, "view", {
        get: function () {
            return this._view;
        },
        set: function (a) {
            this._view = a;
        },
        enumerable: false,
        configurable: true
    });
    XButton.prototype.destroy = function () {
        this.provideContainer(null);
    };
    XButton.prototype.kd = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        this.kf(a, b, c);
    };
    XButton.prototype.kf = function (a, b, c) {
        switch (a) {
            case "CornerRadius":
            case "BorderColor":
            case "RestingElevation":
            case "HoverElevation":
            case "FocusElevation":
            case "RippleColor":
            case "BorderWidth":
            case "BackgroundColor":
            case "DisabledBackgroundColor":
            case "DisabledBorderColor":
            case "DisabledTextColor":
            case "DisabledElevation":
            case "HoverBackgroundColor":
            case "FocusTextColor":
            case "TextColor":
            case "HoverTextColor":
            case "FocusBackgroundColor":
            case "RaisedBorderColor":
            case "RaisedRestingElevation":
            case "RaisedFocusElevation":
            case "RaisedHoverElevation":
            case "RaisedRippleColor":
            case "RaisedBorderWidth":
            case "RaisedBackgroundColor":
            case "RaisedDisabledBackgroundColor":
            case "RaisedDisabledBorderColor":
            case "RaisedDisabledTextColor":
            case "RaisedDisabledElevation":
            case "RaisedHoverBackgroundColor":
            case "RaisedCornerRadius":
            case "RaisedFocusBackgroundColor":
            case "RaisedFocusTextColor":
            case "RaisedTextColor":
            case "RaisedHoverTextColor":
            case "FlatBorderColor":
            case "FlatRestingElevation":
            case "FlatFocusElevation":
            case "FlatHoverElevation":
            case "FlatRippleColor":
            case "FlatBorderWidth":
            case "FlatBackgroundColor":
            case "FlatDisabledBackgroundColor":
            case "FlatDisabledBorderColor":
            case "FlatDisabledTextColor":
            case "FlatDisabledElevation":
            case "FlatHoverBackgroundColor":
            case "FlatCornerRadius":
            case "FlatFocusBackgroundColor":
            case "FlatFocusTextColor":
            case "FlatTextColor":
            case "FlatHoverTextColor":
            case "OutlinedRippleColor":
            case "OutlinedRestingElevation":
            case "OutlinedFocusElevation":
            case "OutlinedHoverElevation":
            case "OutlinedBorderColor":
            case "OutlinedBorderWidth":
            case "OutlinedBackgroundColor":
            case "OutlinedDisabledBackgroundColor":
            case "OutlinedDisabledBorderColor":
            case "OutlinedDisabledTextColor":
            case "OutlinedDisabledElevation":
            case "OutlinedHoverBackgroundColor":
            case "OutlinedCornerRadius":
            case "OutlinedFocusBackgroundColor":
            case "OutlinedFocusTextColor":
            case "OutlinedTextColor":
            case "OutlinedHoverTextColor":
            case "FabBorderColor":
            case "FabRippleColor":
            case "FabRestingElevation":
            case "FabFocusElevation":
            case "FabHoverElevation":
            case "FabBorderWidth":
            case "FabBackgroundColor":
            case "FabDisabledBackgroundColor":
            case "FabDisabledBorderColor":
            case "FabDisabledTextColor":
            case "FabDisabledElevation":
            case "FabHoverBackgroundColor":
            case "FabCornerRadius":
            case "FabFocusBackgroundColor":
            case "FabFocusTextColor":
            case "FabTextColor":
            case "FabHoverTextColor":
            case "IconRestingElevation":
            case "IconFocusElevation":
            case "IconHoverElevation":
            case "IconBorderColor":
            case "IconRippleColor":
            case "IconBorderWidth":
            case "IconBackgroundColor":
            case "IconDisabledBackgroundColor":
            case "IconDisabledBorderColor":
            case "IconDisabledTextColor":
            case "IconDisabledElevation":
            case "IconHoverBackgroundColor":
            case "IconCornerRadius":
            case "IconFocusBackgroundColor":
            case "IconFocusTextColor":
            case "IconTextColor":
            case "IconHoverTextColor":
            case "ElevationMode":
                this.ki();
                break;
            case "BaseTheme":
                this.kj(this.n == 0 ? 2 : this.n);
                this.ki();
                break;
            case "IsDisabled":
                this.ap = this.disabled || this.at;
                this.ki();
                this.view.aq();
                break;
            case "DisableRipple":
                this.ap = this.disabled || this.at;
                this.ki();
                break;
            case "TextStyle":
            case "DisableHover":
                this.kh();
                break;
            case "ActualDisableRipple":
                this.view.ak();
                break;
            case "ActualBackgroundColor":
            case "ActualDisabledBackgroundColor":
            case "ActualDisabledBorderColor":
            case "ActualDisabledTextColor":
            case "ActualDisabledElevation":
            case "ActualHoverBackgroundColor":
            case "ActualBorderColor":
            case "ActualFocusTextColor":
            case "ActualHoverTextColor":
            case "ActualElevationMode":
                this.kh();
                break;
            case "Density":
                this.q = this.r == 0 ? 1 : this.r;
                break;
            case "ActualDensity":
            case "ActualBorderWidth":
            case "ActualCornerRadius":
                this.view.ay();
                this.kh();
                break;
            case "DisplayType":
                this.view.ay();
                this.ki();
                this.kh();
                break;
            case "ContentPaddingLeft":
            case "ContentPaddingTop":
            case "ContentPaddingRight":
            case "ContentPaddingBottom":
            case "FillAvailableSpace":
                this.view.ay();
                break;
            case "HorizontalContentAlignment":
            case "VerticalContentAlignment":
                this.view.as();
                break;
            case "InputId":
                this.view.ap();
                break;
            case "Display":
                this.view.al();
                break;
            case "ChildContentDisplay":
                this.view.ah();
                break;
            case "FlexDirection":
                this.view.am();
                break;
            case "FlexGrow":
                this.view.an();
                break;
            case "AlignItems":
                this.view.af();
                break;
            case "TabIndex":
            case "DisablePointer":
                this.view.av();
                break;
            case "MinWidth":
                this.view.au(this.bu);
                this.view.ay();
                break;
            case "MinHeight":
                this.view.at(this.bt);
                this.view.ay();
                break;
        }
    };
    XButton.prototype.ks = function (a, b) {
        return new CornerRadius(1, !isNaN_(a.c) ? a.c : b.c, !isNaN_(a.d) ? a.d : b.d, !isNaN_(a.b) ? a.b : b.b, !isNaN_(a.a) ? a.a : b.a);
    };
    XButton.prototype.ki = function () {
        this.u = this.w != 0 ? this.w : this.v;
        this.nr = this.pf;
        this.no = this.o3;
        this.ne = this.nu;
        switch (this.e) {
            case 0:
                this.nh = this.pg != null ? this.pg : this.qx != null ? this.qx : this.o6;
                this.ni = this.ph != null ? this.ph : this.qy != null ? this.qy : this.o7;
                this.nj = this.pi != null ? this.pi : this.qz != null ? this.qz : this.o8;
                this.cq = this.de >= 0 ? this.de : this.dy >= 0 ? this.dy : this.da;
                this.ct = this.d2 >= 0 ? this.d2 : this.d1 >= 0 ? this.d1 : this.dd;
                this.cs = this.dp >= 0 ? this.dp : this.d0 >= 0 ? this.d0 : this.dc;
                this.cr = this.dn >= 0 ? this.dn : this.dz >= 0 ? this.dz : this.db;
                this.ng = this.nt != null ? this.nt : this.qw != null ? this.qw : this.o5;
                this.nf = this.ns != null ? this.ns : this.qv != null ? this.qv : this.o4;
                this.nm = this.p7 != null ? this.p7 : this.q2 != null ? this.q2 : this.pb;
                this.kr = this.ks(this.kt, this.ks(this.k3, this.ky));
                this.bf = !isNaN_(this.bg) ? this.bg : !isNaN_(this.bw) ? this.bw : this.bp;
                this.np = this.q6 != null ? this.q6 : this.q4 != null ? this.q4 : this.pd;
                this.nk = this.p5 != null ? this.p5 : this.q0 != null ? this.q0 : this.o9;
                this.nl = this.p6 != null ? this.p6 : this.q1 != null ? this.q1 : this.pa;
                this.nq = this.q7 != null ? this.q7 : this.q5 != null ? this.q5 : this.pe;
                this.nn = this.p8 != null ? this.p8 : this.q3 != null ? this.q3 : this.pc;
                break;
            case 2:
                this.nh = this.pg != null ? this.pg : this.qm != null ? this.qm : this.ou;
                this.ni = this.ph != null ? this.ph : this.qn != null ? this.qn : this.ov;
                this.nj = this.pi != null ? this.pi : this.qo != null ? this.qo : this.ow;
                this.cq = this.de >= 0 ? this.de : this.du >= 0 ? this.du : this.c6;
                this.ct = this.d2 >= 0 ? this.d2 : this.dx >= 0 ? this.dx : this.c9;
                this.cs = this.dp >= 0 ? this.dp : this.dw >= 0 ? this.dw : this.c8;
                this.cr = this.dn >= 0 ? this.dn : this.dv >= 0 ? this.dv : this.c7;
                this.ng = this.nt != null ? this.nt : this.ql != null ? this.ql : this.ot;
                this.nf = this.p7 != null ? this.p7 : this.ns != null ? this.ns : this.qk != null ? this.qk : this.os;
                this.nm = this.qr != null ? this.qr : this.oz;
                this.kr = this.ks(this.kt, this.ks(this.k2, this.kx));
                this.bf = !isNaN_(this.bg) ? this.bg : !isNaN_(this.bv) ? this.bv : this.bo;
                this.np = this.q6 != null ? this.q6 : this.qt != null ? this.qt : this.o1;
                this.nk = this.p5 != null ? this.p5 : this.qp != null ? this.qp : this.ox;
                this.nl = this.p6 != null ? this.p6 : this.qq != null ? this.qq : this.oy;
                this.nq = this.q7 != null ? this.q7 : this.qu != null ? this.qu : this.o2;
                this.nn = this.p8 != null ? this.p8 : this.qs != null ? this.qs : this.o0;
                break;
            case 1:
                this.nh = this.pg != null ? this.pg : this.pw != null ? this.pw : this.n8;
                this.ni = this.ph != null ? this.ph : this.px != null ? this.px : this.n9;
                this.nj = this.pi != null ? this.pi : this.py != null ? this.py : this.oa;
                this.cq = this.de >= 0 ? this.de : this.dj >= 0 ? this.dj : this.cy;
                this.ct = this.d2 >= 0 ? this.d2 : this.dm >= 0 ? this.dm : this.c1;
                this.cs = this.dp >= 0 ? this.dp : this.dl >= 0 ? this.dl : this.c0;
                this.cr = this.dn >= 0 ? this.dn : this.dk >= 0 ? this.dk : this.cz;
                this.ng = this.nt != null ? this.nt : this.pv != null ? this.pv : this.n7;
                this.nf = this.ns != null ? this.ns : this.pu != null ? this.pu : this.n6;
                this.nm = this.p7 != null ? this.p7 : this.p1 != null ? this.p1 : this.od;
                this.kr = this.ks(this.kt, this.ks(this.k0, this.kv));
                this.bf = !isNaN_(this.bg) ? this.bg : !isNaN_(this.br) ? this.br : this.bm;
                this.np = this.q6 != null ? this.q6 : this.p3 != null ? this.p3 : this.of;
                this.nk = this.p5 != null ? this.p5 : this.pz != null ? this.pz : this.ob;
                this.nl = this.p6 != null ? this.p6 : this.p0 != null ? this.p0 : this.oc;
                this.nq = this.q7 != null ? this.q7 : this.p4 != null ? this.p4 : this.og;
                this.nn = this.p8 != null ? this.p8 : this.p2 != null ? this.p2 : this.oe;
                break;
            case 4:
                this.nh = this.pg != null ? this.pg : this.qb != null ? this.qb : this.oj;
                this.ni = this.ph != null ? this.ph : this.qc != null ? this.qc : this.ok;
                this.nj = this.pi != null ? this.pi : this.qd != null ? this.qd : this.ol;
                this.cq = this.de >= 0 ? this.de : this.dq >= 0 ? this.dq : this.c2;
                this.ct = this.d2 >= 0 ? this.d2 : this.dt >= 0 ? this.dt : this.c5;
                this.cs = this.dp >= 0 ? this.dp : this.ds >= 0 ? this.ds : this.c4;
                this.cr = this.dn >= 0 ? this.dn : this.dr >= 0 ? this.dr : this.c3;
                this.ng = this.nt != null ? this.nt : this.qa != null ? this.qa : this.oi;
                this.nf = this.ns != null ? this.ns : this.p9 != null ? this.p9 : this.oh;
                this.nm = this.p7 != null ? this.p7 : this.qg != null ? this.qg : this.oo;
                this.kr = this.ks(this.kt, this.ks(this.k1, this.kw));
                this.bf = !isNaN_(this.bg) ? this.bg : !isNaN_(this.bs) ? this.bs : this.bn;
                this.np = this.q6 != null ? this.q6 : this.qi != null ? this.qi : this.oq;
                this.nk = this.p5 != null ? this.p5 : this.qe != null ? this.qe : this.om;
                this.nl = this.p6 != null ? this.p6 : this.qf != null ? this.qf : this.on;
                this.nq = this.q7 != null ? this.q7 : this.qj != null ? this.qj : this.or;
                this.nn = this.p8 != null ? this.p8 : this.qh != null ? this.qh : this.op;
                break;
            case 3:
                this.nh = this.pg != null ? this.pg : this.pl != null ? this.pl : this.nx;
                this.ni = this.ph != null ? this.ph : this.pm != null ? this.pm : this.ny;
                this.nj = this.pi != null ? this.pi : this.pn != null ? this.pn : this.nz;
                this.cq = this.de >= 0 ? this.de : this.df >= 0 ? this.df : this.cu;
                this.ct = this.d2 >= 0 ? this.d2 : this.di >= 0 ? this.di : this.cx;
                this.cs = this.dp >= 0 ? this.dp : this.dh >= 0 ? this.dh : this.cw;
                this.cr = this.dn >= 0 ? this.dn : this.dg >= 0 ? this.dg : this.cv;
                this.ng = this.nt != null ? this.nt : this.pk != null ? this.pk : this.nw;
                this.nf = this.ns != null ? this.ns : this.pj != null ? this.pj : this.nv;
                this.nm = this.p7 != null ? this.p7 : this.pq != null ? this.pq : this.n2;
                this.kr = this.ks(this.kt, this.ks(this.kz, this.ku));
                this.bf = !isNaN_(this.bg) ? this.bg : !isNaN_(this.bq) ? this.bq : this.bl;
                this.np = this.q6 != null ? this.q6 : this.ps != null ? this.ps : this.pd;
                this.nk = this.p5 != null ? this.p5 : this.po != null ? this.po : this.n0;
                this.nl = this.p6 != null ? this.p6 : this.pp != null ? this.pp : this.n1;
                this.nq = this.q7 != null ? this.q7 : this.pt != null ? this.pt : this.n5;
                this.nn = this.p8 != null ? this.p8 : this.pr != null ? this.pr : this.n3;
                break;
        }
    };
    XButton.prototype.j6 = function () {
        if (this.disabled) {
            return;
        }
        if (this.clicked != null) {
            this.clicked(this, new ButtonClickEventArgs());
        }
    };
    XButton.prototype.j5 = function () {
        this.focused = false;
        this.kh();
    };
    XButton.prototype.j8 = function () {
        this.focused = true;
        this.kh();
    };
    XButton.prototype.kc = function () {
        this.a0 = false;
        this.kh();
        if (this.mouseLeave != null) {
            this.mouseLeave(this, new MouseEventArgs());
        }
    };
    XButton.prototype.kb = function () {
        this.a0 = true;
        this.kh();
        if (this.mouseEnter != null) {
            this.mouseEnter(this, new MouseEventArgs());
        }
    };
    XButton.prototype.j9 = function () {
        if (this.gotFocus != null) {
            this.gotFocus(this, new FocusEventArgs());
        }
    };
    XButton.prototype.ka = function (a) {
        if (this.lostFocus != null) {
            this.lostFocus(this, ((function () {
                var $ret = new FocusEventArgs();
                $ret.a = a;
                return $ret;
            })()));
        }
    };
    XButton.prototype.kh = function () {
        var a = this.view.q;
        if (a == null) {
            return;
        }
        NativeUI.o(a, this.kr);
        NativeUI.n(a, this.ng);
        if (!isNaN_(this.bf)) {
            NativeUI.p(a, new Thickness(0, this.bf));
        }
        if (this.disabled) {
            this.view.ax(this.cq, this.u);
        }
        else if (this.focused && this.az) {
            this.view.ax(this.cr, this.u);
        }
        else {
            if (this.a0 && !this.ar) {
                this.view.ax(this.cs, this.u);
            }
            else {
                this.view.ax(this.ct, this.u);
            }
        }
        if (this.disabled) {
            NativeUI.m(a, this.nh);
        }
        else if (this.focused && this.az) {
            NativeUI.m(a, this.nk);
        }
        else {
            if (this.a0 && !this.ar) {
                NativeUI.m(a, this.nm);
            }
            else {
                NativeUI.m(a, this.nf);
            }
        }
        this.view.aw(this.np, BrushUtil.h(0, 0, 0, 0));
        if (this.aa != null) {
            this.view.az(this.aa);
        }
        if (this.disabled) {
            NativeUI.q(this.view.s, this.nj);
            NativeUI.r(this.view.s, this.nj);
        }
        else if (this.focused && this.az) {
            NativeUI.q(this.view.s, this.nl);
            NativeUI.r(this.view.s, this.nl);
        }
        else {
            if (this.a0 && !this.ar) {
                NativeUI.q(this.view.s, this.nn);
                NativeUI.r(this.view.s, this.nn);
            }
            else {
                NativeUI.q(this.view.s, this.nq);
                NativeUI.r(this.view.s, this.nq);
            }
        }
    };
    XButton.prototype.kj = function (a) {
        this.pf = XButton.k.ae(a, "UmbraShadowColor");
        this.o3 = XButton.k.ae(a, "PenumbraShadowColor");
        this.nu = XButton.k.ae(a, "AmbientShadowColor");
        this.v = XButton.k.d(a, "ElevationMode");
        this.o6 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledBackgroundColor");
        this.o7 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledBorderColor");
        this.o8 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledTextColor");
        this.da = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledElevation");
        this.dd = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 0), "RestingElevation");
        this.dc = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverElevation");
        this.db = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusElevation");
        this.o5 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "BorderColor");
        this.pd = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "RippleColor");
        this.ky = XButton.k.y(a, enumGetBox(ButtonDisplayStyle_$type, 0), "CornerRadius");
        this.bp = XButton.k.i(a, enumGetBox(ButtonDisplayStyle_$type, 0), "BorderWidth");
        this.o4 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "BackgroundColor");
        this.pe = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "TextColor");
        this.pc = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverTextColor");
        this.pb = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverBackgroundColor");
        this.o9 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusBackgroundColor");
        this.pa = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusTextColor");
        this.n8 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "DisabledBackgroundColor");
        this.n9 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "DisabledBorderColor");
        this.oa = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "DisabledTextColor");
        this.cy = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 1), "DisabledElevation");
        this.c1 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 1), "RestingElevation");
        this.c0 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 1), "HoverElevation");
        this.cz = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 1), "FocusElevation");
        this.n7 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "BorderColor");
        this.of = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "RippleColor");
        this.kv = XButton.k.y(a, enumGetBox(ButtonDisplayStyle_$type, 1), "CornerRadius");
        this.bm = XButton.k.i(a, enumGetBox(ButtonDisplayStyle_$type, 1), "BorderWidth");
        this.n6 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "BackgroundColor");
        this.og = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "TextColor");
        this.oe = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "HoverTextColor");
        this.od = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "HoverBackgroundColor");
        this.ob = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "FocusBackgroundColor");
        this.oc = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "FocusTextColor");
        this.ou = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "DisabledBackgroundColor");
        this.ov = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "DisabledBorderColor");
        this.ow = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "DisabledTextColor");
        this.c6 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 2), "DisabledElevation");
        this.c9 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 2), "RestingElevation");
        this.c8 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 2), "HoverElevation");
        this.c7 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 2), "FocusElevation");
        this.ot = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "BorderColor");
        this.o1 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "RippleColor");
        this.kx = XButton.k.y(a, enumGetBox(ButtonDisplayStyle_$type, 2), "CornerRadius");
        this.bo = XButton.k.i(a, enumGetBox(ButtonDisplayStyle_$type, 2), "BorderWidth");
        this.os = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "BackgroundColor");
        this.o2 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "TextColor");
        this.o0 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "HoverTextColor");
        this.oz = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "HoverBackgroundColor");
        this.ox = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "FocusBackgroundColor");
        this.oy = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "FocusTextColor");
        this.oj = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "DisabledBackgroundColor");
        this.ok = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "DisabledBorderColor");
        this.ol = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "DisabledTextColor");
        this.c2 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 4), "DisabledElevation");
        this.c5 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 4), "RestingElevation");
        this.c4 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 4), "HoverElevation");
        this.c3 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 4), "FocusElevation");
        this.oi = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "BorderColor");
        this.oq = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "RippleColor");
        this.kw = XButton.k.y(a, enumGetBox(ButtonDisplayStyle_$type, 4), "CornerRadius");
        this.bn = XButton.k.i(a, enumGetBox(ButtonDisplayStyle_$type, 4), "BorderWidth");
        this.oh = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "BackgroundColor");
        this.or = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "TextColor");
        this.op = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "HoverTextColor");
        this.oo = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "HoverBackgroundColor");
        this.om = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "FocusBackgroundColor");
        this.on = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "FocusTextColor");
        this.nx = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "DisabledBackgroundColor");
        this.ny = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "DisabledBorderColor");
        this.nz = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "DisabledTextColor");
        this.cu = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 3), "DisabledElevation");
        this.cx = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 3), "RestingElevation");
        this.cw = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 3), "HoverElevation");
        this.cv = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 3), "FocusElevation");
        this.nw = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "BorderColor");
        this.n4 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "RippleColor");
        this.ku = XButton.k.y(a, enumGetBox(ButtonDisplayStyle_$type, 3), "CornerRadius");
        this.bl = XButton.k.i(a, enumGetBox(ButtonDisplayStyle_$type, 3), "BorderWidth");
        this.nv = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "BackgroundColor");
        this.n5 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "TextColor");
        this.n3 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "HoverTextColor");
        this.n2 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "HoverBackgroundColor");
        this.n0 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "FocusBackgroundColor");
        this.n1 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "FocusTextColor");
    };
    Object.defineProperty(XButton.prototype, "bu", {
        get: function () {
            return this.bc;
        },
        set: function (a) {
            var b = this.bc;
            this.bc = a;
            if (b != this.bc) {
                this.kd("MinWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "bt", {
        get: function () {
            return this.bb;
        },
        set: function (a) {
            var b = this.bb;
            this.bb = a;
            if (b != this.bb) {
                this.kd("MinHeight", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "e", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            var b = this.d;
            this.d = a;
            if (b != this.d) {
                this.kd("DisplayType", enumGetBox(ButtonDisplayStyle_$type, b), enumGetBox(ButtonDisplayStyle_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "r", {
        get: function () {
            return this.p;
        },
        set: function (a) {
            var b = this.p;
            this.p = a;
            if (b != this.p) {
                this.kd("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "n", {
        get: function () {
            return this.l;
        },
        set: function (a) {
            var b = this.l;
            this.l = a;
            if (b != this.l) {
                this.kd("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "q", {
        get: function () {
            return this.o;
        },
        set: function (a) {
            var b = this.o;
            this.o = a;
            if (b != this.o) {
                this.kd("ActualDensity", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "ng", {
        get: function () {
            return this.k8;
        },
        set: function (a) {
            var b = this.k8;
            this.k8 = a;
            if (b != this.k8) {
                this.kd("ActualBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "nr", {
        get: function () {
            return this.lj;
        },
        set: function (a) {
            var b = this.lj;
            this.lj = a;
            if (b != this.lj) {
                this.kd("ActualUmbraShadowColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "no", {
        get: function () {
            return this.lg;
        },
        set: function (a) {
            var b = this.lg;
            this.lg = a;
            if (b != this.lg) {
                this.kd("ActualPenumbraShadowColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "ne", {
        get: function () {
            return this.k6;
        },
        set: function (a) {
            var b = this.k6;
            this.k6 = a;
            if (b != this.k6) {
                this.kd("ActualAmbientShadowColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "ct", {
        get: function () {
            return this.b0;
        },
        set: function (a) {
            var b = this.b0;
            this.b0 = a;
            if (b != this.b0) {
                this.kd("ActualRestingElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "cr", {
        get: function () {
            return this.by;
        },
        set: function (a) {
            var b = this.by;
            this.by = a;
            if (b != this.by) {
                this.kd("ActualFocusElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "cs", {
        get: function () {
            return this.bz;
        },
        set: function (a) {
            var b = this.bz;
            this.bz = a;
            if (b != this.bz) {
                this.kd("ActualHoverElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "np", {
        get: function () {
            return this.lh;
        },
        set: function (a) {
            var b = this.lh;
            this.lh = a;
            if (b != this.lh) {
                this.kd("ActualRippleColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "kr", {
        get: function () {
            return this.kk;
        },
        set: function (a) {
            var b = this.kk;
            this.kk = a;
            if (b != this.kk) {
                this.kd("ActualCornerRadius", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "nf", {
        get: function () {
            return this.k7;
        },
        set: function (a) {
            var b = this.k7;
            this.k7 = a;
            if (b != this.k7) {
                this.kd("ActualBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "nh", {
        get: function () {
            return this.k9;
        },
        set: function (a) {
            var b = this.k9;
            this.k9 = a;
            if (b != this.k9) {
                this.kd("ActualDisabledBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "ni", {
        get: function () {
            return this.la;
        },
        set: function (a) {
            var b = this.la;
            this.la = a;
            if (b != this.la) {
                this.kd("ActualDisabledBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "nj", {
        get: function () {
            return this.lb;
        },
        set: function (a) {
            var b = this.lb;
            this.lb = a;
            if (b != this.lb) {
                this.kd("ActualDisabledTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "cq", {
        get: function () {
            return this.bx;
        },
        set: function (a) {
            var b = this.bx;
            this.bx = a;
            if (b != this.bx) {
                this.kd("ActualDisabledElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "u", {
        get: function () {
            return this.s;
        },
        set: function (a) {
            var b = this.s;
            this.s = a;
            if (b != this.s) {
                this.kd("ActualElevationMode", enumGetBox(ElevationMode_$type, b), enumGetBox(ElevationMode_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "nq", {
        get: function () {
            return this.li;
        },
        set: function (a) {
            var b = this.li;
            this.li = a;
            if (b != this.li) {
                this.kd("ActualTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "nn", {
        get: function () {
            return this.lf;
        },
        set: function (a) {
            var b = this.lf;
            this.lf = a;
            if (b != this.lf) {
                this.kd("ActualHoverTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "nk", {
        get: function () {
            return this.lc;
        },
        set: function (a) {
            var b = this.lc;
            this.lc = a;
            if (b != this.lc) {
                this.kd("ActualFocusBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "nl", {
        get: function () {
            return this.ld;
        },
        set: function (a) {
            var b = this.ld;
            this.ld = a;
            if (b != this.ld) {
                this.kd("ActualFocusTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "nm", {
        get: function () {
            return this.le;
        },
        set: function (a) {
            var b = this.le;
            this.le = a;
            if (b != this.le) {
                this.kd("ActualHoverBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "bf", {
        get: function () {
            return this.a2;
        },
        set: function (a) {
            var b = this.a2;
            this.a2 = a;
            if (b != this.a2) {
                this.kd("ActualBorderWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qv", {
        get: function () {
            return this.m1;
        },
        set: function (a) {
            var b = this.m1;
            this.m1 = a;
            if (b != this.m1) {
                this.kd("RaisedBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qx", {
        get: function () {
            return this.m3;
        },
        set: function (a) {
            var b = this.m3;
            this.m3 = a;
            if (b != this.m3) {
                this.kd("RaisedDisabledBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qy", {
        get: function () {
            return this.m4;
        },
        set: function (a) {
            var b = this.m4;
            this.m4 = a;
            if (b != this.m4) {
                this.kd("RaisedDisabledBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qz", {
        get: function () {
            return this.m5;
        },
        set: function (a) {
            var b = this.m5;
            this.m5 = a;
            if (b != this.m5) {
                this.kd("RaisedDisabledTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "dy", {
        get: function () {
            return this.ck;
        },
        set: function (a) {
            var b = this.ck;
            this.ck = a;
            if (b != this.ck) {
                this.kd("RaisedDisabledElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "q2", {
        get: function () {
            return this.m8;
        },
        set: function (a) {
            var b = this.m8;
            this.m8 = a;
            if (b != this.m8) {
                this.kd("RaisedHoverBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qw", {
        get: function () {
            return this.m2;
        },
        set: function (a) {
            var b = this.m2;
            this.m2 = a;
            if (b != this.m2) {
                this.kd("RaisedBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "d1", {
        get: function () {
            return this.cn;
        },
        set: function (a) {
            var b = this.cn;
            this.cn = a;
            if (b != this.cn) {
                this.kd("RaisedRestingElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "d0", {
        get: function () {
            return this.cm;
        },
        set: function (a) {
            var b = this.cm;
            this.cm = a;
            if (b != this.cm) {
                this.kd("RaisedHoverElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "dz", {
        get: function () {
            return this.cl;
        },
        set: function (a) {
            var b = this.cl;
            this.cl = a;
            if (b != this.cl) {
                this.kd("RaisedFocusElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "bw", {
        get: function () {
            return this.be;
        },
        set: function (a) {
            var b = this.be;
            this.be = a;
            if (b != this.be) {
                this.kd("RaisedBorderWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "k3", {
        get: function () {
            return this.kq;
        },
        set: function (a) {
            var b = this.kq;
            this.kq = a;
            {
                this.kd("RaisedCornerRadius", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "q4", {
        get: function () {
            return this.na;
        },
        set: function (a) {
            var b = this.na;
            this.na = a;
            if (b != this.na) {
                this.kd("RaisedRippleColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "pu", {
        get: function () {
            return this.lz;
        },
        set: function (a) {
            var b = this.lz;
            this.lz = a;
            if (b != this.lz) {
                this.kd("FlatBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "pw", {
        get: function () {
            return this.l1;
        },
        set: function (a) {
            var b = this.l1;
            this.l1 = a;
            if (b != this.l1) {
                this.kd("FlatDisabledBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "px", {
        get: function () {
            return this.l2;
        },
        set: function (a) {
            var b = this.l2;
            this.l2 = a;
            if (b != this.l2) {
                this.kd("FlatDisabledBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "py", {
        get: function () {
            return this.l3;
        },
        set: function (a) {
            var b = this.l3;
            this.l3 = a;
            if (b != this.l3) {
                this.kd("FlatDisabledTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "dj", {
        get: function () {
            return this.b6;
        },
        set: function (a) {
            var b = this.b6;
            this.b6 = a;
            if (b != this.b6) {
                this.kd("FlatDisabledElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "p1", {
        get: function () {
            return this.l6;
        },
        set: function (a) {
            var b = this.l6;
            this.l6 = a;
            if (b != this.l6) {
                this.kd("FlatHoverBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "pv", {
        get: function () {
            return this.l0;
        },
        set: function (a) {
            var b = this.l0;
            this.l0 = a;
            if (b != this.l0) {
                this.kd("FlatBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "dm", {
        get: function () {
            return this.b9;
        },
        set: function (a) {
            var b = this.b9;
            this.b9 = a;
            if (b != this.b9) {
                this.kd("FlatRestingElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "dl", {
        get: function () {
            return this.b8;
        },
        set: function (a) {
            var b = this.b8;
            this.b8 = a;
            if (b != this.b8) {
                this.kd("FlatHoverElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "dk", {
        get: function () {
            return this.b7;
        },
        set: function (a) {
            var b = this.b7;
            this.b7 = a;
            if (b != this.b7) {
                this.kd("FlatFocusElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "p3", {
        get: function () {
            return this.l8;
        },
        set: function (a) {
            var b = this.l8;
            this.l8 = a;
            if (b != this.l8) {
                this.kd("FlatRippleColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "p4", {
        get: function () {
            return this.l9;
        },
        set: function (a) {
            var b = this.l9;
            this.l9 = a;
            if (b != this.l9) {
                this.kd("FlatTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "p2", {
        get: function () {
            return this.l7;
        },
        set: function (a) {
            var b = this.l7;
            this.l7 = a;
            if (b != this.l7) {
                this.kd("FlatHoverTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "pz", {
        get: function () {
            return this.l4;
        },
        set: function (a) {
            var b = this.l4;
            this.l4 = a;
            if (b != this.l4) {
                this.kd("FlatFocusBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "p0", {
        get: function () {
            return this.l5;
        },
        set: function (a) {
            var b = this.l5;
            this.l5 = a;
            if (b != this.l5) {
                this.kd("FlatFocusTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "br", {
        get: function () {
            return this.a9;
        },
        set: function (a) {
            var b = this.a9;
            this.a9 = a;
            if (b != this.a9) {
                this.kd("FlatBorderWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "k0", {
        get: function () {
            return this.kn;
        },
        set: function (a) {
            var b = this.kn;
            this.kn = a;
            {
                this.kd("FlatCornerRadius", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "ns", {
        get: function () {
            return this.lk;
        },
        set: function (a) {
            var b = this.lk;
            this.lk = a;
            if (b != this.lk) {
                this.kd("BackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "pg", {
        get: function () {
            return this.lm;
        },
        set: function (a) {
            var b = this.lm;
            this.lm = a;
            if (b != this.lm) {
                this.kd("DisabledBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "ph", {
        get: function () {
            return this.ln;
        },
        set: function (a) {
            var b = this.ln;
            this.ln = a;
            if (b != this.ln) {
                this.kd("DisabledBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "pi", {
        get: function () {
            return this.lo;
        },
        set: function (a) {
            var b = this.lo;
            this.lo = a;
            if (b != this.lo) {
                this.kd("DisabledTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "de", {
        get: function () {
            return this.b1;
        },
        set: function (a) {
            var b = this.b1;
            this.b1 = a;
            if (b != this.b1) {
                this.kd("DisabledElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "w", {
        get: function () {
            return this.t;
        },
        set: function (a) {
            var b = this.t;
            this.t = a;
            if (b != this.t) {
                this.kd("ElevationMode", enumGetBox(ElevationMode_$type, b), enumGetBox(ElevationMode_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "p7", {
        get: function () {
            return this.mc;
        },
        set: function (a) {
            var b = this.mc;
            this.mc = a;
            if (b != this.mc) {
                this.kd("HoverBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "nt", {
        get: function () {
            return this.ll;
        },
        set: function (a) {
            var b = this.ll;
            this.ll = a;
            if (b != this.ll) {
                this.kd("BorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "d2", {
        get: function () {
            return this.co;
        },
        set: function (a) {
            var b = this.co;
            this.co = a;
            if (b != this.co) {
                this.kd("RestingElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "dp", {
        get: function () {
            return this.cb;
        },
        set: function (a) {
            var b = this.cb;
            this.cb = a;
            if (b != this.cb) {
                this.kd("HoverElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "dn", {
        get: function () {
            return this.ca;
        },
        set: function (a) {
            var b = this.ca;
            this.ca = a;
            if (b != this.ca) {
                this.kd("FocusElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "aa", {
        get: function () {
            return this.z;
        },
        set: function (a) {
            var b = this.z;
            this.z = a;
            if (b != this.z) {
                this.kd("TextStyle", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "q7", {
        get: function () {
            return this.nd;
        },
        set: function (a) {
            var b = this.nd;
            this.nd = a;
            if (b != this.nd) {
                this.kd("TextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "p8", {
        get: function () {
            return this.me;
        },
        set: function (a) {
            var b = this.me;
            this.me = a;
            if (b != this.me) {
                this.kd("HoverTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "q6", {
        get: function () {
            return this.nc;
        },
        set: function (a) {
            var b = this.nc;
            this.nc = a;
            if (b != this.nc) {
                this.kd("RippleColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "q5", {
        get: function () {
            return this.nb;
        },
        set: function (a) {
            var b = this.nb;
            this.nb = a;
            if (b != this.nb) {
                this.kd("RaisedTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "q3", {
        get: function () {
            return this.m9;
        },
        set: function (a) {
            var b = this.m9;
            this.m9 = a;
            if (b != this.m9) {
                this.kd("RaisedHoverTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "q0", {
        get: function () {
            return this.m6;
        },
        set: function (a) {
            var b = this.m6;
            this.m6 = a;
            if (b != this.m6) {
                this.kd("RaisedFocusBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "q1", {
        get: function () {
            return this.m7;
        },
        set: function (a) {
            var b = this.m7;
            this.m7 = a;
            if (b != this.m7) {
                this.kd("RaisedFocusTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "p5", {
        get: function () {
            return this.ma;
        },
        set: function (a) {
            var b = this.ma;
            this.ma = a;
            if (b != this.ma) {
                this.kd("FocusBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "p6", {
        get: function () {
            return this.mb;
        },
        set: function (a) {
            var b = this.mb;
            this.mb = a;
            if (b != this.mb) {
                this.kd("FocusTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "bg", {
        get: function () {
            return this.a3;
        },
        set: function (a) {
            var b = this.a3;
            this.a3 = a;
            if (b != this.a3) {
                this.kd("BorderWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "kt", {
        get: function () {
            return this.kl;
        },
        set: function (a) {
            var b = this.kl;
            this.kl = a;
            {
                this.kd("CornerRadius", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qk", {
        get: function () {
            return this.mq;
        },
        set: function (a) {
            var b = this.mq;
            this.mq = a;
            if (b != this.mq) {
                this.kd("OutlinedBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qm", {
        get: function () {
            return this.ms;
        },
        set: function (a) {
            var b = this.ms;
            this.ms = a;
            if (b != this.ms) {
                this.kd("OutlinedDisabledBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qn", {
        get: function () {
            return this.mt;
        },
        set: function (a) {
            var b = this.mt;
            this.mt = a;
            if (b != this.mt) {
                this.kd("OutlinedDisabledBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qo", {
        get: function () {
            return this.mu;
        },
        set: function (a) {
            var b = this.mu;
            this.mu = a;
            if (b != this.mu) {
                this.kd("OutlinedDisabledTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "du", {
        get: function () {
            return this.cg;
        },
        set: function (a) {
            var b = this.cg;
            this.cg = a;
            if (b != this.cg) {
                this.kd("OutlinedDisabledElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qr", {
        get: function () {
            return this.mx;
        },
        set: function (a) {
            var b = this.mx;
            this.mx = a;
            if (b != this.mx) {
                this.kd("OutlinedHoverBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "ql", {
        get: function () {
            return this.mr;
        },
        set: function (a) {
            var b = this.mr;
            this.mr = a;
            if (b != this.mr) {
                this.kd("OutlinedBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "dx", {
        get: function () {
            return this.cj;
        },
        set: function (a) {
            var b = this.cj;
            this.cj = a;
            if (b != this.cj) {
                this.kd("OutlinedRestingElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "dw", {
        get: function () {
            return this.ci;
        },
        set: function (a) {
            var b = this.ci;
            this.ci = a;
            if (b != this.ci) {
                this.kd("OutlinedHoverElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "dv", {
        get: function () {
            return this.ch;
        },
        set: function (a) {
            var b = this.ch;
            this.ch = a;
            if (b != this.ch) {
                this.kd("OutlinedFocusElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "bv", {
        get: function () {
            return this.bd;
        },
        set: function (a) {
            var b = this.bd;
            this.bd = a;
            if (b != this.bd) {
                this.kd("OutlinedBorderWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "k2", {
        get: function () {
            return this.kp;
        },
        set: function (a) {
            var b = this.kp;
            this.kp = a;
            {
                this.kd("OutlinedCornerRadius", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qt", {
        get: function () {
            return this.mz;
        },
        set: function (a) {
            var b = this.mz;
            this.mz = a;
            if (b != this.mz) {
                this.kd("OutlinedRippleColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qu", {
        get: function () {
            return this.m0;
        },
        set: function (a) {
            var b = this.m0;
            this.m0 = a;
            if (b != this.m0) {
                this.kd("OutlinedTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qs", {
        get: function () {
            return this.my;
        },
        set: function (a) {
            var b = this.my;
            this.my = a;
            if (b != this.my) {
                this.kd("OutlinedHoverTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qp", {
        get: function () {
            return this.mv;
        },
        set: function (a) {
            var b = this.mv;
            this.mv = a;
            if (b != this.mv) {
                this.kd("OutlinedFocusBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qq", {
        get: function () {
            return this.mw;
        },
        set: function (a) {
            var b = this.mw;
            this.mw = a;
            if (b != this.mw) {
                this.kd("OutlinedFocusTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "pj", {
        get: function () {
            return this.lp;
        },
        set: function (a) {
            var b = this.lp;
            this.lp = a;
            if (b != this.lp) {
                this.kd("FabBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "pl", {
        get: function () {
            return this.lr;
        },
        set: function (a) {
            var b = this.lr;
            this.lr = a;
            if (b != this.lr) {
                this.kd("FabDisabledBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "pm", {
        get: function () {
            return this.ls;
        },
        set: function (a) {
            var b = this.ls;
            this.ls = a;
            if (b != this.ls) {
                this.kd("FabDisabledBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "pn", {
        get: function () {
            return this.lt;
        },
        set: function (a) {
            var b = this.lt;
            this.lt = a;
            if (b != this.lt) {
                this.kd("FabDisabledTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "df", {
        get: function () {
            return this.b2;
        },
        set: function (a) {
            var b = this.b2;
            this.b2 = a;
            if (b != this.b2) {
                this.kd("FabDisabledElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "pq", {
        get: function () {
            return this.md;
        },
        set: function (a) {
            var b = this.md;
            this.md = a;
            if (b != this.md) {
                this.kd("FabHoverBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "pk", {
        get: function () {
            return this.lq;
        },
        set: function (a) {
            var b = this.lq;
            this.lq = a;
            if (b != this.lq) {
                this.kd("FabBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "di", {
        get: function () {
            return this.b5;
        },
        set: function (a) {
            var b = this.b5;
            this.b5 = a;
            if (b != this.b5) {
                this.kd("FabRestingElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "dh", {
        get: function () {
            return this.b4;
        },
        set: function (a) {
            var b = this.b4;
            this.b4 = a;
            if (b != this.b4) {
                this.kd("FabHoverElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "dg", {
        get: function () {
            return this.b3;
        },
        set: function (a) {
            var b = this.b3;
            this.b3 = a;
            if (b != this.b3) {
                this.kd("FabFocusElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "bq", {
        get: function () {
            return this.a8;
        },
        set: function (a) {
            var b = this.a8;
            this.a8 = a;
            if (b != this.a8) {
                this.kd("FabBorderWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "kz", {
        get: function () {
            return this.km;
        },
        set: function (a) {
            var b = this.km;
            this.km = a;
            {
                this.kd("FabCornerRadius", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "ps", {
        get: function () {
            return this.lx;
        },
        set: function (a) {
            var b = this.lx;
            this.lx = a;
            if (b != this.lx) {
                this.kd("FabRippleColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "pt", {
        get: function () {
            return this.ly;
        },
        set: function (a) {
            var b = this.ly;
            this.ly = a;
            if (b != this.ly) {
                this.kd("FabTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "pr", {
        get: function () {
            return this.lw;
        },
        set: function (a) {
            var b = this.lw;
            this.lw = a;
            if (b != this.lw) {
                this.kd("FabHoverTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "po", {
        get: function () {
            return this.lu;
        },
        set: function (a) {
            var b = this.lu;
            this.lu = a;
            if (b != this.lu) {
                this.kd("FabFocusBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "pp", {
        get: function () {
            return this.lv;
        },
        set: function (a) {
            var b = this.lv;
            this.lv = a;
            if (b != this.lv) {
                this.kd("FabFocusTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "p9", {
        get: function () {
            return this.mf;
        },
        set: function (a) {
            var b = this.mf;
            this.mf = a;
            if (b != this.mf) {
                this.kd("IconBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qb", {
        get: function () {
            return this.mh;
        },
        set: function (a) {
            var b = this.mh;
            this.mh = a;
            if (b != this.mh) {
                this.kd("IconDisabledBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qc", {
        get: function () {
            return this.mi;
        },
        set: function (a) {
            var b = this.mi;
            this.mi = a;
            if (b != this.mi) {
                this.kd("IconDisabledBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qd", {
        get: function () {
            return this.mj;
        },
        set: function (a) {
            var b = this.mj;
            this.mj = a;
            if (b != this.mj) {
                this.kd("IconDisabledTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "dq", {
        get: function () {
            return this.cc;
        },
        set: function (a) {
            var b = this.cc;
            this.cc = a;
            if (b != this.cc) {
                this.kd("IconDisabledElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qg", {
        get: function () {
            return this.mm;
        },
        set: function (a) {
            var b = this.mm;
            this.mm = a;
            if (b != this.mm) {
                this.kd("IconHoverBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qa", {
        get: function () {
            return this.mg;
        },
        set: function (a) {
            var b = this.mg;
            this.mg = a;
            if (b != this.mg) {
                this.kd("IconBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "dt", {
        get: function () {
            return this.cf;
        },
        set: function (a) {
            var b = this.cf;
            this.cf = a;
            if (b != this.cf) {
                this.kd("IconRestingElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "ds", {
        get: function () {
            return this.ce;
        },
        set: function (a) {
            var b = this.ce;
            this.ce = a;
            if (b != this.ce) {
                this.kd("IconHoverElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "dr", {
        get: function () {
            return this.cd;
        },
        set: function (a) {
            var b = this.cd;
            this.cd = a;
            if (b != this.cd) {
                this.kd("IconFocusElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "bs", {
        get: function () {
            return this.ba;
        },
        set: function (a) {
            var b = this.ba;
            this.ba = a;
            if (b != this.ba) {
                this.kd("IconBorderWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "k1", {
        get: function () {
            return this.ko;
        },
        set: function (a) {
            var b = this.ko;
            this.ko = a;
            {
                this.kd("IconCornerRadius", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qi", {
        get: function () {
            return this.mo;
        },
        set: function (a) {
            var b = this.mo;
            this.mo = a;
            if (b != this.mo) {
                this.kd("IconRippleColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qj", {
        get: function () {
            return this.mp;
        },
        set: function (a) {
            var b = this.mp;
            this.mp = a;
            if (b != this.mp) {
                this.kd("IconTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qh", {
        get: function () {
            return this.mn;
        },
        set: function (a) {
            var b = this.mn;
            this.mn = a;
            if (b != this.mn) {
                this.kd("IconHoverTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qe", {
        get: function () {
            return this.mk;
        },
        set: function (a) {
            var b = this.mk;
            this.mk = a;
            if (b != this.mk) {
                this.kd("IconFocusBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qf", {
        get: function () {
            return this.ml;
        },
        set: function (a) {
            var b = this.ml;
            this.ml = a;
            if (b != this.ml) {
                this.kd("IconFocusTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "hu", {
        get: function () {
            return this.ei;
        },
        set: function (a) {
            var b = this.ei;
            this.ei = a;
            if (b != this.ei) {
                this.kd("InputId", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "hs", {
        get: function () {
            return this.eh;
        },
        set: function (a) {
            var b = this.eh;
            this.eh = a;
            if (b != this.eh) {
                this.kd("Id", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "fw", {
        get: function () {
            return this.ee;
        },
        set: function (a) {
            var b = this.ee;
            this.ee = a;
            if (b != this.ee) {
                this.kd("Display", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "ff", {
        get: function () {
            return this.ed;
        },
        set: function (a) {
            var b = this.ed;
            this.ed = a;
            if (b != this.ed) {
                this.kd("ChildContentDisplay", b, this.ed);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "g0", {
        get: function () {
            return this.ef;
        },
        set: function (a) {
            var b = this.ef;
            this.ef = a;
            if (b != this.ef) {
                this.kd("FlexDirection", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "g2", {
        get: function () {
            return this.eg;
        },
        set: function (a) {
            var b = this.eg;
            this.eg = a;
            if (b != this.eg) {
                this.kd("FlexGrow", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "e7", {
        get: function () {
            return this.eb;
        },
        set: function (a) {
            var b = this.eb;
            this.eb = a;
            if (b != this.eb) {
                this.kd("AlignItems", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "ea", {
        get: function () {
            return this.d6;
        },
        set: function (a) {
            var b = this.d6;
            this.d6 = a;
            if (b != this.d6) {
                this.kd("Value", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "h2", {
        get: function () {
            return this.ej;
        },
        set: function (a) {
            var b = this.ej;
            this.ej = a;
            if (b != this.ej) {
                this.kd("Name", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "aw", {
        get: function () {
            return this.ak;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "d3", {
        get: function () {
            return this.cp;
        },
        set: function (a) {
            var b = this.cp;
            this.cp = a;
            this.ak = true;
            if (b != this.cp) {
                this.kd("TabIndex", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "e9", {
        get: function () {
            return this.ec;
        },
        set: function (a) {
            var b = this.ec;
            this.ec = a;
            if (b != this.ec) {
                this.kd("AriaLabel", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "av", {
        get: function () {
            return this.aj;
        },
        set: function (a) {
            var b = this.aj;
            this.aj = a;
            if (b != this.aj) {
                this.kd("FillAvailableSpace", b, this.aj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "focused", {
        get: function () {
            return this.am;
        },
        set: function (a) {
            var b = this.am;
            this.am = a;
            if (b != this.am) {
                this.kd("IsFocused", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "az", {
        get: function () {
            return this.an;
        },
        set: function (a) {
            var b = this.an;
            this.an = a;
            if (b != this.an) {
                this.kd("IsFocusStyleEnabled", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "at", {
        get: function () {
            return this.ah;
        },
        set: function (a) {
            var b = this.ah;
            this.ah = a;
            if (b != this.ah) {
                this.kd("DisableRipple", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "ap", {
        get: function () {
            return this.ad;
        },
        set: function (a) {
            var b = this.ad;
            this.ad = a;
            if (b != this.ad) {
                this.kd("ActualDisableRipple", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "ar", {
        get: function () {
            return this.af;
        },
        set: function (a) {
            var b = this.af;
            this.af = a;
            if (b != this.af) {
                this.kd("DisableHover", b, this.af);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "a0", {
        get: function () {
            return this.ao;
        },
        set: function (a) {
            var b = this.ao;
            this.ao = a;
            if (b != this.ao) {
                this.kd("IsHover", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "disabled", {
        get: function () {
            return this.al;
        },
        set: function (a) {
            var b = this.al;
            this.al = a;
            if (b != this.al) {
                this.kd("IsDisabled", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "au", {
        get: function () {
            return this.ai;
        },
        set: function (a) {
            var b = this.ai;
            this.ai = a;
            if (b != this.ai) {
                this.kd("DisableTransitions", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "as", {
        get: function () {
            return this.ag;
        },
        set: function (a) {
            var b = this.ag;
            this.ag = a;
            if (b != this.ag) {
                this.kd("DisablePointer", b, this.ag);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "bi", {
        get: function () {
            return this.a5;
        },
        set: function (a) {
            var b = this.a5;
            this.a5 = a;
            if (b != this.a5) {
                this.kd("ContentPaddingLeft", b, this.a5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "bk", {
        get: function () {
            return this.a7;
        },
        set: function (a) {
            var b = this.a7;
            this.a7 = a;
            if (b != this.a7) {
                this.kd("ContentPaddingTop", b, this.a7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "bj", {
        get: function () {
            return this.a6;
        },
        set: function (a) {
            var b = this.a6;
            this.a6 = a;
            if (b != this.a6) {
                this.kd("ContentPaddingRight", b, this.a6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "bh", {
        get: function () {
            return this.a4;
        },
        set: function (a) {
            var b = this.a4;
            this.a4 = a;
            if (b != this.a4) {
                this.kd("ContentPaddingBottom", b, this.a4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "k5", {
        get: function () {
            return this.k4;
        },
        set: function (a) {
            var b = this.k4;
            this.k4 = a;
            if (b != this.k4) {
                this.kd("HorizontalContentAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.k4));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "q9", {
        get: function () {
            return this.q8;
        },
        set: function (a) {
            var b = this.q8;
            this.q8 = a;
            if (b != this.q8) {
                this.kd("VerticalContentAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.q8));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "aq", {
        get: function () {
            return this.ae;
        },
        set: function (a) {
            var b = this.ae;
            this.ae = a;
            if (b != this.ae) {
                this.kd("ClickTunneling", b, this.ae);
            }
        },
        enumerable: false,
        configurable: true
    });
    XButton.prototype.ke = function () {
        this.j3();
        this.view.aw(this.np, BrushUtil.h(0, 0, 0, 0));
        this.kh();
    };
    Object.defineProperty(XButton.prototype, "a", {
        get: function () {
            var a = new AnimationKeyFrameEffectTiming();
            a.g = 300;
            a.b = 0;
            return a;
        },
        enumerable: false,
        configurable: true
    });
    XButton.prototype.j3 = function () {
        this.view.ae();
    };
    XButton.prototype.onDetachedFromUI = function () {
        this.view.aj();
    };
    XButton.prototype.onAttachedToUI = function () {
        this.view.ag();
    };
    XButton.prototype.appendButtonContent = function (a) {
        this.view.ac(a);
    };
    XButton.prototype.clearButtonContent = function () {
        this.view.ad();
    };
    XButton.prototype.getButtonContent = function () {
        return this.view.r();
    };
    XButton.prototype.a1 = function () {
        return this.view.g();
    };
    XButton.prototype.d7 = function () {
        return this.b();
    };
    XButton.prototype.f0 = function () {
        var a = this.b();
        return a.ab();
    };
    XButton.prototype.b = function () {
        var a = this.view.q;
        var b = this.view.s;
        var c = new ButtonVisualModelExport();
        var d = UIElementPropertyAccessorFactory.c.a(12, 0);
        var e = d.b(a);
        var f = this.view.a();
        c.s = f[0];
        c.q = f[1];
        c.p = NativeUI.d(a);
        c.t = NativeUI.k(a);
        c.h = this.n;
        c.i = this.q;
        c.c = AppearanceHelper.a(NativeUI.ak(a));
        c.g = AppearanceHelper.a(this.nr);
        c.d = AppearanceHelper.a(this.no);
        c.a = AppearanceHelper.a(this.ne);
        c.u = this.ct;
        c.e = AppearanceHelper.a(this.np);
        c.ah = this.kr;
        c.b = AppearanceHelper.a(NativeUI.aj(a));
        c.j = this.u;
        c.f = AppearanceHelper.a(NativeUI.al(b));
        c.o = this.bf;
        c.x = this.fw;
        c.y = this.g0;
        c.z = this.g2;
        c.w = this.e7;
        c.v = this.view.s.getNativeElement().innerText;
        c.aa = this.h2;
        c.m = this.focused;
        c.k = this.ap;
        c.n = this.a0;
        c.l = this.disabled;
        if (this.aa != null) {
            var g = this.aa;
            if (this.view != null && g.q == null) {
                var h = this.view.k;
                var i = FontUtil.getFontInfoFromString(h, g.fontString);
                g.q = i.q;
                g.f = i.f;
                g.r = i.r;
                g.t = i.t;
                g.u = i.u;
                g.v = i.v;
            }
            if (g.q != null) {
                c.ac = g.q;
            }
            if (!isNaN_(g.f)) {
                c.r = g.f;
            }
            if (g.v != null) {
                c.ag = g.v;
            }
            if (g.t != null) {
                c.ae = g.t;
            }
            if (g.r != null) {
                c.ad = g.t;
            }
        }
        return c;
    };
    XButton.prototype.provideContainer = function (a) {
        this.view.ai(a);
    };
    XButton.$t = markType(XButton, 'XButton', Base.$, [INotifyPropertyChanged_$type]);
    XButton.m = 2;
    XButton.d5 = 0;
    XButton.d4 = 0;
    XButton.i = new Theme(1, ((function () {
        var $ret = new Dictionary$2(String_$type, Base.$, 0);
        $ret.addItem("UmbraShadowColor", BrushUtil.h(66, 0, 0, 0));
        $ret.addItem("PenumbraShadowColor", BrushUtil.h(30, 0, 0, 0));
        $ret.addItem("AmbientShadowColor", BrushUtil.h(20, 0, 0, 0));
        $ret.addItem("ElevationMode", enumGetBox(ElevationMode_$type, 1));
        return $ret;
    })()), ((function () {
        var $ret = new Dictionary$2(Base.$, Theme.$, 0);
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 0), new Theme(0, ((function () {
            var $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 2);
            $ret.addItem("HoverElevation", 4);
            $ret.addItem("FocusElevation", 8);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("CornerRadius", new CornerRadius(0, 4));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(255, 228, 28, 119));
            $ret.addItem("TextColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(255, 220, 83, 145));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(255, 220, 83, 145));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 0, 0, 0));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 1), new Theme(0, ((function () {
            var $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 0);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("CornerRadius", new CornerRadius(0, 4));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 228, 28, 119));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 228, 28, 119));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(13, 228, 28, 119));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(30, 228, 28, 119));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 228, 28, 119));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 2), new Theme(0, ((function () {
            var $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(30, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 0);
            $ret.addItem("BorderColor", BrushUtil.h(255, 228, 28, 119));
            $ret.addItem("RippleColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("CornerRadius", new CornerRadius(0, 4));
            $ret.addItem("BorderWidth", 1);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 228, 28, 119));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 228, 28, 119));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(13, 228, 28, 119));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(30, 228, 28, 119));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 228, 28, 119));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 4), new Theme(0, ((function () {
            var $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 0);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("CornerRadius", new CornerRadius(0, 28));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(30, 0, 0, 0));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 0, 0, 0));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 3), new Theme(0, ((function () {
            var $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 6);
            $ret.addItem("HoverElevation", 12);
            $ret.addItem("FocusElevation", 12);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("CornerRadius", new CornerRadius(0, 28));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(255, 228, 28, 119));
            $ret.addItem("TextColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(255, 220, 83, 145));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(255, 220, 83, 145));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 0, 0, 0));
            return $ret;
        })())));
        return $ret;
    })()));
    XButton.h = new Theme(1, ((function () {
        var $ret = new Dictionary$2(String_$type, Base.$, 0);
        $ret.addItem("UmbraShadowColor", BrushUtil.h(100, 33, 150, 243));
        $ret.addItem("PenumbraShadowColor", BrushUtil.h(70, 33, 150, 243));
        $ret.addItem("AmbientShadowColor", BrushUtil.h(40, 33, 150, 243));
        $ret.addItem("ElevationMode", enumGetBox(ElevationMode_$type, 2));
        return $ret;
    })()), ((function () {
        var $ret = new Dictionary$2(Base.$, Theme.$, 0);
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 0), new Theme(0, ((function () {
            var $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("CornerRadius", new CornerRadius(0, 3));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("TextColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(255, 27, 135, 220));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(255, 21, 112, 184));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 255, 255, 255));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 1), new Theme(0, ((function () {
            var $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(100, 33, 150, 243));
            $ret.addItem("CornerRadius", new CornerRadius(0, 3));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 119, 119, 119));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 119, 119, 119));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(26, 33, 150, 243));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 33, 150, 243));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 2), new Theme(0, ((function () {
            var $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(30, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("RippleColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("CornerRadius", new CornerRadius(0, 3));
            $ret.addItem("BorderWidth", 1);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(26, 33, 150, 243));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 255, 255, 255));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 4), new Theme(0, ((function () {
            var $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", null);
            $ret.addItem("CornerRadius", new CornerRadius(0, 28));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 119, 119, 119));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 119, 119, 119));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(30, 0, 0, 0));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 33, 150, 243));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 3), new Theme(0, ((function () {
            var $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("CornerRadius", new CornerRadius(0, 28));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("TextColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(255, 27, 135, 220));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(255, 21, 112, 184));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 255, 255, 255));
            return $ret;
        })())));
        return $ret;
    })()));
    XButton.j = new Theme(1, ((function () {
        var $ret = new Dictionary$2(String_$type, Base.$, 0);
        $ret.addItem("UmbraShadowColor", BrushUtil.h(100, 33, 150, 243));
        $ret.addItem("PenumbraShadowColor", BrushUtil.h(70, 33, 150, 243));
        $ret.addItem("AmbientShadowColor", BrushUtil.h(40, 33, 150, 243));
        $ret.addItem("ElevationMode", enumGetBox(ElevationMode_$type, 2));
        return $ret;
    })()), ((function () {
        var $ret = new Dictionary$2(Base.$, Theme.$, 0);
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 0), new Theme(0, ((function () {
            var $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("CornerRadius", new CornerRadius(0, 3));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("TextColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(255, 27, 135, 220));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(255, 21, 112, 184));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 255, 255, 255));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 1), new Theme(0, ((function () {
            var $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(100, 33, 150, 243));
            $ret.addItem("CornerRadius", new CornerRadius(0, 3));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 119, 119, 119));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 119, 119, 119));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(26, 33, 150, 243));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 33, 150, 243));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 2), new Theme(0, ((function () {
            var $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(30, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("RippleColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("CornerRadius", new CornerRadius(0, 3));
            $ret.addItem("BorderWidth", 1);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(26, 33, 150, 243));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 255, 255, 255));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 4), new Theme(0, ((function () {
            var $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", null);
            $ret.addItem("CornerRadius", new CornerRadius(0, 28));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(51, 178, 191, 220));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(51, 178, 191, 220));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 0, 0, 0));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 3), new Theme(0, ((function () {
            var $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("CornerRadius", new CornerRadius(0, 28));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("TextColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(255, 27, 135, 220));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(255, 21, 112, 184));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 255, 255, 255));
            return $ret;
        })())));
        return $ret;
    })()));
    XButton.k = new ThemeResolver(1, ((function () {
        var $ret = new Dictionary$2(BaseControlTheme_$type, Theme.$, 0);
        $ret.addItem(2, XButton.i);
        $ret.addItem(1, XButton.h);
        $ret.addItem(3, XButton.j);
        return $ret;
    })()), 2);
    return XButton;
}(Base));
export { XButton };
