/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, runOn, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, delegateRemove, enumGetBox, delegateCombine, Number_$type } from "igniteui-react-core";
import { DomWrapper_$type } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { DayOfWeek_$type } from "./DayOfWeek";
import { DayInfo } from "./DayInfo";
import { XButton } from "./XButton";
import { XIcon } from "./XIcon";
import { dateMinValue, dateGetMonth, dateNow, dateAddYears, dateFromValues, dateMaxValue, dateGetDate, dateAddDays, dateAddMonths } from "igniteui-react-core";
import { parseBool } from "igniteui-react-core";
import { SRProvider } from "igniteui-react-core";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { FirstWeek_$type } from "./FirstWeek";
import { BrushUtil } from "igniteui-react-core";
import { ObservableCollection$1 } from "igniteui-react-core";
import { SelectedValueChangedEventArgs } from "./SelectedValueChangedEventArgs";
import { CornerRadius } from "igniteui-react-core";
import { CalendarVisualModelExport } from "./CalendarVisualModelExport";
import { ButtonVisualModelExport } from "./ButtonVisualModelExport";
import { TextElementsVisualModelExport } from "./TextElementsVisualModelExport";
import { AppearanceHelper } from "igniteui-react-core";
import { NativeUI } from "igniteui-react-core";
import { FontUtil } from "igniteui-react-core";
import { truncate, intDivide, isNaN_ } from "igniteui-react-core";
import { stringIsNullOrWhiteSpace } from "igniteui-react-core";
import { timeSpanTotalDays } from "igniteui-react-core";
/**
 * @hidden
 */
var CalendarView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CalendarView, _super);
    function CalendarView() {
        var _this = _super.call(this) || this;
        _this.n = null;
        _this.o = null;
        _this.t = null;
        _this.q = null;
        _this.u = null;
        _this.s = null;
        _this.r = null;
        _this.g = new List$1(DomWrapper_$type, 0);
        _this.f = new List$1(DomWrapper_$type, 0);
        _this.h = new List$1(DomWrapper_$type, 0);
        _this.j = new List$1(DomWrapper_$type, 0);
        _this.i = new List$1(DomWrapper_$type, 0);
        _this.e = new List$1(DomWrapper_$type, 0);
        _this.p = null;
        _this.w = null;
        _this.c = null;
        _this.m = null;
        _this.w = "day";
        _this.p = null;
        return _this;
    }
    CalendarView.prototype.k = function () {
        return this.e;
    };
    CalendarView.prototype.l = function () {
        return this.i;
    };
    CalendarView.prototype.ao = function () {
    };
    CalendarView.prototype.an = function (a) {
        if (a == null) {
            this.m = null;
            return;
        }
        this.m = a;
        this.m.rootWrapper.setStyleProperty("background-color", "rgb(255, 255, 255)");
        var b = Math.round(a.rootWrapper.width());
        var c = Math.round(a.rootWrapper.height());
        this.aa();
        this.a2();
        this.a3();
        this.a0();
        var d = this.m.rootWrapper;
        d.listen("keydown", runOn(this, this.z));
        d.listen("focus", runOn(this, this.y));
    };
    CalendarView.prototype.x = function () {
        return this.w;
    };
    CalendarView.prototype.aa = function () {
        if (this.m != null) {
            this.n = this.m.createElement("div");
            this.n.setStyleProperty("display", "flex");
            this.n.setStyleProperty("width", "100%");
            this.n.setStyleProperty("height", "100%");
            this.o = this.m.createElement("div");
            this.o.setStyleProperty("height", "100%");
            this.o.setStyleProperty("width", "100%");
            this.t = this.m.createElement("div");
            this.ad();
            this.n.append(this.o);
            this.m.append(this.n);
            for (var a = 0; a < 42; a++) {
                var b = this.m.createElement("div");
                this.f.add(b);
            }
            this.ab();
            this.a8();
            this.q = this.m.createElement("div");
            this.q.setStyleProperty("height", "100%");
            this.m.append(this.q);
            for (var c = 0; c < 12; c++) {
                var d = this.m.createElement("div");
                this.h.add(d);
            }
            this.ac();
            for (var e = 0; e < 12; e++) {
                var f = this.q.getChildAt(e);
                f.listen("click", runOn(this, this.ai));
            }
            this.q.hide();
            this.u = this.m.createElement("div");
            this.u.setStyleProperty("height", "100%");
            this.m.append(this.u);
            for (var g = 0; g < 7; g++) {
                var h = this.m.createElement("div");
                this.j.add(h);
            }
            this.ae();
            for (var i = 0; i < 7; i++) {
                var j = this.u.getChildAt(i);
                j.listen("click", runOn(this, this.bd));
            }
            this.u.listen("wheel", runOn(this, this.be));
            this.u.hide();
        }
    };
    CalendarView.prototype.ad = function () {
        if (this.m != null) {
            this.t.setStyleProperty("display", "flex");
            this.t.setStyleProperty("flex-direction", "column");
            this.t.setStyleProperty("padding-top", "26px");
            this.t.setStyleProperty("width", "12%");
            var a = this.c.ag();
            for (var b = 0; b < 6; b++) {
                var c = this.m.createElement("div");
                c.setAttribute("aria-hidden", "true");
                c.setStyleProperty("text-align", "center");
                c.setStyleProperty("vertical-align", "middle");
                c.setStyleProperty("height", "30px");
                c.setStyleProperty("width", "25px");
                c.setStyleProperty("border-width", "0px 1px 0px 0px");
                c.setStyleProperty("border-style", "solid");
                c.setStyleProperty("border-color", "rgb(163, 172, 184)");
                var d = this.m.createElement("span");
                d.setAttribute("aria-hidden", "true");
                d.setStyleProperty("font", "14px Verdana");
                d.setStyleProperty("color", "rgb(24, 29, 31)");
                c.append(d);
                this.i.add(d);
                d.setText(a._inner[b].toString());
                this.t.append(c);
            }
        }
    };
    CalendarView.prototype.a4 = function () {
        if (this.t != null) {
            var a = this.c.ag();
            this.i.clear();
            for (var b = 0; b < 6; b++) {
                var c = this.t.getChildAt(b);
                var d = c.getChildAt(0);
                d.setText(a._inner[b].toString());
                this.i.add(d);
            }
        }
    };
    CalendarView.prototype.a8 = function () {
        if (this.t != null) {
            if (this.c.af == true) {
                this.t.show();
                this.t.setStyleProperty("width", "12%");
                this.t.parent().setStyleProperty("max-width", "245px");
                this.t.parent().getChildAt(1).setStyleProperty("width", "88%");
            }
            else {
                this.t.hide();
                this.t.parent().setStyleProperty("max-width", "231px");
                this.t.parent().getChildAt(1).setStyleProperty("width", "100%");
            }
        }
    };
    CalendarView.prototype.ab = function () {
        if (this.m != null) {
            this.o.setStyleProperty("display", "flex");
            this.o.setStyleProperty("flex-direction", "column");
            this.o.setStyleProperty("justify-content", "space-evenly");
            var a = this.m.createElement("div");
            a.setStyleProperty("display", "flex");
            a.setStyleProperty("justify-content", "space-evenly");
            a.setStyleProperty("width", "100%");
            a.setAttribute("role", "row");
            var b = this.m.createElement("div");
            b.setStyleProperty("width", "15%");
            var c = this.m.createElement("div");
            c.setStyleProperty("width", "20%");
            var d = this.m.createElement("div");
            d.setStyleProperty("width", "20%");
            var e = this.m.createElement("div");
            e.setStyleProperty("width", "15%");
            a.append(b);
            a.append(c);
            a.append(d);
            a.append(e);
            this.o.append(a);
            var f = this.m.createElement("div");
            f.setStyleProperty("width", "100%");
            f.setStyleProperty("height", "100%");
            f.setStyleProperty("display", "flex");
            f.setStyleProperty("flex-direction", "row");
            f.setStyleProperty("justify-content", "space-evenly");
            this.t.setStyleProperty("padding-bottom", "6px");
            f.append(this.t);
            var g = this.m.createElement("div");
            g.setStyleProperty("display", "flex");
            g.setStyleProperty("flex-direction", "column");
            g.setStyleProperty("width", "88%");
            g.setAttribute("role", "grid");
            g.setAttribute("aria-readonly", "true");
            f.append(g);
            this.o.append(f);
            var h = 0;
            for (var i = 0; i < 7; i++) {
                var j = this.m.createElement("div");
                j.setAttribute("role", "row");
                j.setStyleProperty("display", "flex");
                j.setStyleProperty("justify-content", "space-evenly");
                if (i == 0) {
                    for (var k = 0; k < 7; k++) {
                        var l = this.m.createElement("div");
                        l.setAttribute("role", "columnheader");
                        l.setAttribute("scope", "col");
                        l.setStyleProperty("text-align", "center");
                        l.setStyleProperty("vertical-align", "middle");
                        l.setStyleProperty("width", "12%");
                        var m = this.m.createElement("span");
                        m.setStyleProperty("font", "16px Verdana");
                        m.setStyleProperty("color", "rgb(24, 29, 31)");
                        l.append(m);
                        this.e.add(m);
                        j.append(l);
                    }
                    g.append(j);
                }
                else {
                    for (var n = 0; n < 7; n++) {
                        var o = this.m.createElement("div");
                        o.setAttribute("role", "gridcell");
                        o.setStyleProperty("justify-content", "center");
                        var p = this.f._inner[h];
                        var q = this.m.createElement("span");
                        q.setAttribute("aria-hidden", "true");
                        p.append(q);
                        this.af(o, p, h);
                        p.parent().setStyleProperty("max-height", "30px");
                        p.parent().setStyleProperty("display", "flex");
                        o.setStyleProperty("width", "12%");
                        o.setStyleProperty("height", "100%");
                        j.append(o);
                        h++;
                    }
                    g.append(j);
                }
            }
            this.s = this.m.createElement("div");
            this.s.setStyleProperty("display", "flex");
            this.s.setStyleProperty("padding-bottom", "4px");
            var r = this.m.createElement("div");
            r.setStyleProperty("width", "100%");
            r.setStyleProperty("justify-content", "center");
            this.r = this.m.createElement("div");
            this.r.setAttribute("aria-hidden", "true");
            var s = this.m.createElement("span");
            s.setAttribute("aria-hidden", "true");
            this.r.append(s);
            this.c.cm(r, this.r);
            this.r.parent().setAttribute("aria-hidden", "true");
            this.r.parent().parent().setAttribute("tabindex", "-1");
            this.r.parent().parent().setAttribute("aria-readonly", "true");
            this.r.parent().parent().setAttribute("aria-selected", "false");
            this.r.parent().parent().setAttribute("aria-disabled", "false");
            this.r.parent().parent().setAttribute("data-is-focusable", "true");
            this.s.append(r);
            this.o.append(this.s);
            this.a7();
            this.c.cf();
        }
    };
    CalendarView.prototype.ac = function () {
        if (this.m != null) {
            this.q.setStyleProperty("display", "flex");
            this.q.setStyleProperty("flex-direction", "row");
            this.q.setStyleProperty("flex-wrap", "wrap");
            this.q.setStyleProperty("margin", "2px");
            this.q.setStyleProperty("justify-content", "center");
            this.q.setStyleProperty("width", "100%");
            this.q.setStyleProperty("height", "100%");
            this.q.setAttribute("role", "grid");
            this.q.setAttribute("aria-readonly", "true");
            for (var a = 0; a < 12; a++) {
                var b = this.m.createElement("div");
                b.setStyleProperty("margin", "5px");
                b.setAttribute("data-month", (a + 1).toString());
                var c = this.h._inner[a];
                c.setAttribute("aria-hidden", "true");
                this.c.cl(b, c);
                b.setStyleProperty("width", "28%");
                var d = b.getChildAt(0);
                d.setStyleProperty("width", "100%");
                var e = this.m.createElement("span");
                e.setAttribute("aria-hidden", "true");
                var f = void 0;
                var g = a + 1;
                f = this.c.e(g, a);
                c.parent().parent().setAttribute("aria-label", f[0]);
                e.setText(f[1]);
                c.append(e);
                c.parent().setAttribute("aria-hidden", "true");
                c.parent().parent().setAttribute("tabindex", "-1");
                c.parent().parent().setAttribute("aria-readonly", "true");
                c.parent().parent().setAttribute("aria-selected", "false");
                c.parent().parent().setAttribute("aria-disabled", "false");
                c.parent().parent().setAttribute("data-is-focusable", "true");
                c.setAttribute("data-index", a.toString());
                this.q.append(b);
            }
        }
    };
    CalendarView.prototype.bc = function () {
        for (var a = 0; a < 12; a++) {
            var b = this.h._inner[a];
            var c = void 0;
            var d = a + 1;
            c = this.c.e(d, a);
            b.parent().parent().setAttribute("aria-label", c[0]);
            var e = b.getChildAt(0);
            e.setText(c[1]);
        }
    };
    CalendarView.prototype.ae = function () {
        if (this.m != null) {
            this.u.setStyleProperty("width", "100%");
            this.u.setStyleProperty("height", "100%");
            var a = this.c.aq.getFullYear() - 3;
            this.u.setStyleProperty("padding", "5px");
            this.u.setAttribute("role", "grid");
            this.u.setAttribute("aria-readonly", "true");
            for (var b = 0; b < 7; b++) {
                var c = this.m.createElement("div");
                var d = this.j._inner[b];
                d.setAttribute("aria-hidden", "true");
                this.c.cn(c, d, b);
                d.parent().setAttribute("aria-hidden", "true");
                d.parent().parent().setAttribute("tabindex", "-1");
                d.parent().parent().setAttribute("aria-readonly", "true");
                d.parent().parent().setAttribute("aria-selected", "false");
                d.parent().parent().setAttribute("aria-disabled", "false");
                d.parent().parent().setAttribute("data-is-focusable", "true");
                c.setStyleProperty("width", "100%");
                c.setStyleProperty("height", "14%");
                c.setStyleProperty("justify-content", "center");
                var e = c.getChildAt(0);
                e.setStyleProperty("width", "98%");
                var f = this.m.createElement("span");
                f.setAttribute("aria-hidden", "true");
                f.setText(a.toString());
                a++;
                d.setAttribute("data-index", b.toString());
                d.append(f);
                this.u.append(c);
            }
        }
    };
    CalendarView.prototype.a7 = function () {
        if (this.m != null) {
            if (this.c.ae == true) {
                this.s.setStyleProperty("display", "flex");
            }
            else {
                this.s.setStyleProperty("display", "none");
            }
        }
    };
    CalendarView.prototype.a2 = function () {
        if (this.m != null) {
            var a = this.o.getChildAt(0);
            for (var b = 0; b < 4; b++) {
                var c = this.m.createElement("div");
                this.g.add(c);
            }
            var d = a.getChildAt(0);
            var e = this.g._inner[0];
            var f = this.m.createElement("div");
            f.setAttribute("aria-hidden", "true");
            e.append(f);
            this.c.ck(d, f, e, "prev");
            e.parent().parent().setAttribute("aria-label", "Previous Month");
            e.parent().setStyleProperty("max-height", "30px");
            e.parent().setStyleProperty("display", "flex");
            e.setAttribute("data-index", "0");
            this.av(e);
            var g = a.getChildAt(1);
            var h = this.g._inner[1];
            var i = this.m.createElement("span");
            i.setAttribute("aria-hidden", "true");
            h.append(i);
            this.c.cj(g, h, "month");
            i = h.getChildAt(0);
            var j = this.c.bx();
            i.setText(j);
            h.parent().parent().setAttribute("aria-label", "Select Month");
            h.parent().setStyleProperty("min-width", "40px");
            h.parent().setStyleProperty("max-height", "30px");
            h.parent().setStyleProperty("display", "flex");
            h.setAttribute("data-index", "1");
            this.av(h);
            var k = a.getChildAt(2);
            var l = this.g._inner[2];
            var m = this.m.createElement("span");
            m.setAttribute("aria-hidden", "true");
            l.append(m);
            this.c.cj(k, l, "year");
            m = this.g._inner[2].getChildAt(0);
            var n = this.c.by();
            m.setText(n);
            l.parent().parent().setAttribute("aria-label", "Select Year");
            l.parent().setStyleProperty("min-width", "40px");
            l.parent().setStyleProperty("max-height", "30px");
            l.parent().setStyleProperty("display", "flex");
            l.setAttribute("data-index", "2");
            this.av(l);
            var o = a.getChildAt(3);
            var p = this.g._inner[3];
            var q = this.m.createElement("div");
            q.setAttribute("aria-hidden", "true");
            p.append(q);
            this.c.ck(o, q, p, "next");
            p.parent().parent().setAttribute("aria-label", "Next Month");
            p.parent().setStyleProperty("max-height", "30px");
            p.parent().setStyleProperty("display", "flex");
            p.setAttribute("data-index", "3");
            this.av(p);
            var r = this.c.a();
            for (var s = 0; s < this.g.count; s++) {
                if (r[s] == true) {
                    this.g._inner[s].setAttribute("data-disabled", "true");
                }
                else {
                    this.g._inner[s].setAttribute("data-disabled", "false");
                }
            }
            d.listen("click", runOn(this, this.ap));
            o.listen("click", runOn(this, this.ak));
            g.listen("click", runOn(this, this.aj));
            k.listen("click", runOn(this, this.bf));
        }
    };
    CalendarView.prototype.bb = function () {
        var a = this.g._inner[1];
        var b = a.getChildAt(0);
        var c = this.c.bx();
        b.setText(c);
    };
    CalendarView.prototype.av = function (a) {
        a.setAttribute("aria-hidden", "true");
        a.parent().setAttribute("aria-hidden", "true");
        a.parent().parent().setAttribute("tabindex", "-1");
        a.parent().parent().setAttribute("aria-readonly", "true");
        a.parent().parent().setAttribute("aria-selected", "false");
        a.parent().parent().setAttribute("aria-disabled", "false");
        a.parent().parent().setAttribute("data-is-focusable", "true");
        a.setAttribute("data-section", "header");
        a.setAttribute("data-disabled", "false");
    };
    CalendarView.prototype.a3 = function () {
        if (this.m != null) {
            var a = this.o.getChildAt(1).getChildAt(1).getChildAt(0);
            var b = new List$1(DayOfWeek_$type, 0);
            switch (this.c.l) {
                case 0:
                    b.add(0);
                    b.add(1);
                    b.add(2);
                    b.add(3);
                    b.add(4);
                    b.add(5);
                    b.add(6);
                    break;
                case 1:
                    b.add(1);
                    b.add(2);
                    b.add(3);
                    b.add(4);
                    b.add(5);
                    b.add(6);
                    b.add(0);
                    break;
                case 2:
                    b.add(2);
                    b.add(3);
                    b.add(4);
                    b.add(5);
                    b.add(6);
                    b.add(0);
                    b.add(1);
                    break;
                case 3:
                    b.add(3);
                    b.add(4);
                    b.add(5);
                    b.add(6);
                    b.add(0);
                    b.add(1);
                    b.add(2);
                    break;
                case 4:
                    b.add(4);
                    b.add(5);
                    b.add(6);
                    b.add(0);
                    b.add(1);
                    b.add(2);
                    b.add(3);
                    break;
                case 5:
                    b.add(5);
                    b.add(6);
                    b.add(0);
                    b.add(1);
                    b.add(2);
                    b.add(3);
                    b.add(4);
                    break;
                case 6:
                    b.add(6);
                    b.add(0);
                    b.add(1);
                    b.add(2);
                    b.add(3);
                    b.add(4);
                    b.add(5);
                    break;
            }
            this.e.clear();
            for (var c = 0; c < b.count; c++) {
                var d = a.getChildAt(c);
                var e = d.getChildAt(0);
                var f = this.c.d(b._inner[c]);
                d.setAttribute("title", f[0]);
                d.setAttribute("aria-label", f[0]);
                e.setText(f[1]);
                this.e.add(e);
            }
        }
    };
    CalendarView.prototype.a0 = function () {
        if (this.m != null) {
            this.a1();
            this.a4();
            var a = this.o.getChildAt(1);
            var b = a.getChildAt(1);
            for (var c = 1; c < 7; c++) {
                var d = b.getChildAt(c);
                for (var e = 0; e < 7; e++) {
                    var f = d.getChildAt(e);
                    f.listen("click", runOn(this, this.ag));
                }
            }
        }
    };
    CalendarView.prototype.a1 = function (a, b) {
        if (a === void 0) {
            a = false;
        }
        if (b === void 0) {
            b = false;
        }
        if (this.m != null) {
            var c = null;
            var d = null;
            var e = null;
            var f = this.c.value;
            var g = this.c.aq;
            var h = this.c.av;
            for (var i = 0; i < 42; i++) {
                var j = this.f._inner[i];
                var k = j.getChildAt(0);
                var l = this.c.j(i);
                if (l != null) {
                    j.parent().parent().setAttribute("aria-label", l.c.toString() + "/" + l.b.toString() + "/" + l.d.toString());
                    j.setAttribute("data-section", "days");
                    j.setAttribute("data-index", i.toString());
                    j.setAttribute("data-date", l.b.toString() + "/" + l.c.toString() + "/" + l.d.toString());
                    j.setAttribute("data-selected", "false");
                    j.setAttribute("data-disabled", "false");
                    j.setAttribute("data-today", "false");
                    k.setText(l.b.toString());
                    if (+f != +(dateMinValue()) && l.b == f.getDate() && l.c == dateGetMonth(f) && l.d == f.getFullYear()) {
                        c = j;
                        j.parent().parent().setAttribute("aria-selected", "true");
                        j.setAttribute("data-selected", "true");
                    }
                    else if (l.b == h.getDate() && l.c == dateGetMonth(h) && l.d == h.getFullYear()) {
                        d = j;
                        j.setAttribute("data-today", "true");
                    }
                    var m = this.c.ad(i);
                    if (m) {
                        j.setAttribute("data-disabled", "true");
                    }
                    if (l.b == 1 && l.c == dateGetMonth(g)) {
                        e = j;
                    }
                }
            }
            if (a == true) {
                if (c != null && +f != +(dateMinValue()) && f.getFullYear() == g.getFullYear() && dateGetMonth(f) == dateGetMonth(g)) {
                    this.d(c);
                }
                else if (d != null && h.getFullYear() == g.getFullYear() && dateGetMonth(h) == dateGetMonth(g)) {
                    this.d(d);
                }
                else if (e != null) {
                    if (b == true) {
                        for (var n = 41; n >= 0; n--) {
                            var o = this.c.j(n);
                            if (o.c == dateGetMonth(g)) {
                                var p = this.f._inner[n];
                                var q = p.getAttribute("data-disabled");
                                if (q == "false") {
                                    e = this.f._inner[n];
                                    break;
                                }
                            }
                        }
                    }
                    else {
                        for (var r = 0; r < 42; r++) {
                            var s = this.c.j(r);
                            if (s.c == dateGetMonth(g)) {
                                var t = this.f._inner[r];
                                var u = t.getAttribute("data-disabled");
                                if (u == "false") {
                                    e = this.f._inner[r];
                                    break;
                                }
                            }
                        }
                    }
                    this.d(e);
                }
            }
        }
    };
    CalendarView.prototype.af = function (a, b, c) {
        if (this.m != null) {
            b.setAttribute("aria-hidden", "true");
            var d = this.m.createElement("span");
            d.setAttribute("aria-hidden", "true");
            b.append(d);
            this.c.ci(a, b, c);
            b.parent().setAttribute("aria-hidden", "true");
            b.parent().parent().setAttribute("tabindex", "-1");
            b.parent().parent().setAttribute("aria-readonly", "true");
            b.parent().parent().setAttribute("aria-selected", "false");
            b.parent().parent().setAttribute("aria-disabled", "false");
            b.parent().parent().setAttribute("data-is-focusable", "true");
        }
    };
    CalendarView.prototype.as = function (a, b) {
        if (this.m != null) {
            var c = this.m.getSubRenderer(a);
            b.provideContainer(c);
            var d = c.getExternal(b, c.rootWrapper, c.getExternal(this.c, null, null));
        }
    };
    CalendarView.prototype.az = function (a) {
        var b = this.r.getChildAt(0);
        b.setText(a);
        this.r.parent().parent().setAttribute("aria-label", a);
    };
    CalendarView.prototype.aw = function (a, b) {
        if (this.m != null) {
            var c = this.m.getSubRenderer(a);
            b.provideContainer(c);
            var d = c.getExternal(b, c.rootWrapper, c.getExternal(this.c, null, null));
        }
    };
    CalendarView.prototype.ay = function () {
        if (this.m != null) {
            var a = this.g._inner[1].getChildAt(0);
            var b = this.c.bx();
            a.setText(b);
            var c = this.g._inner[2].getChildAt(0);
            var d = this.c.by();
            c.setText(d);
        }
    };
    CalendarView.prototype.at = function (a, b) {
        if (a === void 0) {
            a = false;
        }
        if (b === void 0) {
            b = false;
        }
        if (this.m != null) {
            this.a1(a, b);
            this.a4();
            var c = this.c.a();
            for (var d = 0; d < this.g.count; d++) {
                if (c[d] == true) {
                    this.g._inner[d].setAttribute("data-disabled", "true");
                }
                else {
                    this.g._inner[d].setAttribute("data-disabled", "false");
                }
            }
        }
    };
    CalendarView.prototype.ax = function () {
        if (this.m != null) {
            if (this.h.count != 0) {
                var a = null;
                var b = null;
                var c = 0;
                var d = 0;
                var e = 0;
                for (var f = 0; f < 12; f++) {
                    var g = this.h._inner[f];
                    g.setAttribute("data-section", "months");
                    g.setAttribute("data-disabled", "false");
                    g.parent().parent().setAttribute("aria-selected", "false");
                    var h = f + 1;
                    var i = this.c.value;
                    var j = this.c.av;
                    if (+i != +(dateMinValue()) && dateGetMonth(i) == h) {
                        b = g;
                        c = f;
                        g.parent().parent().setAttribute("aria-selected", "true");
                    }
                    if (dateGetMonth(j) == h) {
                        a = g;
                        d = f;
                    }
                    var k = this.c.aa(f, h);
                    if (k) {
                        g.setAttribute("data-disabled", "true");
                    }
                }
                for (var l = 0; l < this.h.count; l++) {
                    var m = this.h._inner[l];
                    var n = m.getAttribute("data-disabled");
                    if (n == "false") {
                        e = l;
                        break;
                    }
                }
                var o = this.h._inner[c].getAttribute("data-disabled");
                var p = this.h._inner[d].getAttribute("data-disabled");
                var q = this.h._inner[e].getAttribute("data-disabled");
                if (b != null && o == "false") {
                    this.d(b);
                }
                else if (a != null && p == "false") {
                    this.d(a);
                }
                else if (q == "false") {
                    this.d(this.h._inner[e]);
                }
                else {
                    this.ar();
                }
            }
        }
    };
    CalendarView.prototype.a6 = function () {
        if (this.m != null) {
            if (this.j.count != 0) {
                var a = this.c.aq.getFullYear();
                var b = true;
                this.a5(a, b);
            }
        }
    };
    CalendarView.prototype.a5 = function (a, b) {
        if (b === void 0) {
            b = false;
        }
        if (a < this.c.au.getFullYear()) {
            a = this.c.au.getFullYear();
        }
        if (a > this.c.at.getFullYear()) {
            a = this.c.at.getFullYear();
        }
        var c = a - 3;
        var d = false;
        for (var e = 0; e < 7; e++) {
            var f = this.j._inner[e];
            f.setAttribute("data-section", "years");
            f.setAttribute("data-disabled", "false");
            f.parent().parent().setAttribute("aria-selected", "false");
            var g = this.c.ab(e, c);
            f.setAttribute("data-disabled", g.toString());
            var h = f.getChildAt(0);
            h.setText(c.toString());
            f.parent().parent().setAttribute("aria-label", c.toString());
            if (c == a && b) {
                if (g == false) {
                    f.parent().parent().setAttribute("aria-selected", "true");
                    d = true;
                    this.d(f);
                }
            }
            c++;
        }
        if (d == false) {
            var i = this.j._inner[3].getAttribute("data-disabled");
            if (i == "false") {
                var j = this.j._inner[3];
                this.d(j);
            }
        }
    };
    CalendarView.prototype.ar = function (a) {
        if (a === void 0) {
            a = false;
        }
        this.at();
        this.ay();
        this.w = "day";
        this.n.show();
        this.n.setStyleProperty("display", "flex");
        this.q.hide();
        this.u.hide();
        this.au(a);
        this.ah();
    };
    CalendarView.prototype.au = function (a) {
        if (a === void 0) {
            a = false;
        }
        var b = null;
        var c = null;
        var d = null;
        for (var e = 0; e < this.f.count; e++) {
            var f = this.f._inner[e];
            var g = parseBool(f.getAttribute("data-disabled").toString());
            var h = f.getAttribute("data-date").toString().split('/');
            var i = h[1];
            var j = parseBool(f.getAttribute("data-selected").toString());
            var k = parseBool(f.getAttribute("data-today").toString());
            if (j == true) {
                c = f;
            }
            if (k == true) {
                d = f;
            }
            var l = dateGetMonth(this.c.aq).toString();
            if (g == false && l == i && b == null) {
                b = f;
            }
        }
        if (d != null) {
            b = d;
        }
        if (c != null && a == false) {
            b = c;
        }
        if (b == null) {
            for (var m = 0; m < this.g.count; m++) {
                var n = parseBool(this.g._inner[m].getAttribute("data-disabled").toString());
                if (n == false) {
                    b = this.g._inner[m];
                    break;
                }
            }
        }
        if (b != null) {
            this.d(b);
        }
    };
    CalendarView.prototype.d = function (a) {
        if (a == null) {
            return false;
        }
        var b = parseBool(a.getAttribute("data-disabled").toString());
        if (b) {
            return false;
        }
        this.p = a;
        return true;
    };
    CalendarView.prototype.ah = function () {
        if (this.p != null) {
            this.p.parent().parent().focus(true);
        }
    };
    CalendarView.prototype.aq = function (a, b) {
        if (a === void 0) {
            a = true;
        }
        if (b === void 0) {
            b = false;
        }
        var c = parseBool(this.g._inner[0].getAttribute("data-disabled").toString());
        if (c) {
            return;
        }
        this.c.cc(-1);
        this.at(a, b);
        this.ay();
    };
    CalendarView.prototype.al = function (a, b) {
        if (a === void 0) {
            a = true;
        }
        if (b === void 0) {
            b = false;
        }
        var c = parseBool(this.g._inner[3].getAttribute("data-disabled").toString());
        if (c) {
            return;
        }
        this.c.cc(1);
        this.at(a, b);
        this.ay();
    };
    CalendarView.prototype.a9 = function () {
        this.n.hide();
        this.q.show();
        this.q.setStyleProperty("display", "flex");
        this.u.hide();
        this.w = "month";
        this.ax();
        this.ah();
    };
    CalendarView.prototype.ba = function () {
        this.n.hide();
        this.q.hide();
        this.u.show();
        this.w = "year";
        this.a6();
        this.ah();
    };
    CalendarView.prototype.y = function (a) {
    };
    CalendarView.prototype.z = function (a) {
        var b = a.which;
        if (this.w == "day") {
            var c = this.p.getAttribute("data-section").toString();
            var d = parseInt(this.p.getAttribute("data-index").toString());
            if (c == "header") {
                if (b == 37) {
                    if (d > 0) {
                        var e = this.g._inner[d - 1];
                        var f = this.d(e);
                        if (f == false && d > 1) {
                            e = this.g._inner[d - 2];
                            this.d(e);
                        }
                        this.ah();
                    }
                    else {
                        this.aq(false);
                        var g = parseBool(this.p.getAttribute("data-disabled").toString());
                        if (g == true) {
                            this.au();
                            this.ah();
                        }
                    }
                }
                else if (b == 39) {
                    if (d < 3) {
                        var h = this.g._inner[d + 1];
                        var i = this.d(h);
                        if (i == false && d < 2) {
                            h = this.g._inner[d + 2];
                            this.d(h);
                        }
                        this.ah();
                    }
                    else {
                        this.al(false);
                        var j = parseBool(this.p.getAttribute("data-disabled").toString());
                        if (j == true) {
                            this.au();
                            this.ah();
                        }
                    }
                }
                else if (b == 9) {
                    if (a.shiftKey) {
                        this.c.cs();
                    }
                    else {
                        a.preventDefault();
                        this.at(true);
                        this.ah();
                    }
                }
                else if (b == 13) {
                    a.preventDefault();
                    if (d == 0) {
                        this.aq(false);
                    }
                    else if (d == 1) {
                        this.a9();
                    }
                    else if (d == 2) {
                        this.ba();
                    }
                    else if (d == 3) {
                        this.al(false);
                    }
                }
            }
            else if (c == "days") {
                var k = this.p.getAttribute("data-date").toString().split('/');
                var l = k[0];
                var m = k[1];
                if (b == 37) {
                    if (d == 0) {
                        this.aq(true, true);
                        this.ah();
                    }
                    else {
                        var n = this.f._inner[d - 1];
                        var o = n.getAttribute("data-date").toString().split('/');
                        var p = o[0];
                        var q = o[1];
                        if (m == q) {
                            this.d(n);
                            this.ah();
                        }
                        else {
                            this.aq();
                            var r = this.v(p, q);
                            this.d(r);
                            this.ah();
                        }
                    }
                }
                else if (b == 39) {
                    if (d == 41) {
                        this.al(true, false);
                        this.ah();
                    }
                    else {
                        var s = this.f._inner[d + 1];
                        var t = s.getAttribute("data-date").toString().split('/');
                        var u = t[0];
                        var v = t[1];
                        if (m == v) {
                            this.d(s);
                            this.ah();
                        }
                        else {
                            this.al();
                            var w = this.v(u, v);
                            this.d(w);
                            this.ah();
                        }
                    }
                }
                else if (b == 40) {
                    if (d >= 35) {
                        this.al();
                        var x = this.v(l, m);
                        var y = parseInt(x.getAttribute("data-index").toString());
                        var z = this.f._inner[y + 7];
                        var aa = z.getAttribute("data-date").toString().split('/');
                        var ab = aa[0];
                        var ac = aa[1];
                        var ad = this.v(ab, ac);
                        this.d(ad);
                        this.ah();
                    }
                    else {
                        var ae = this.f._inner[d + 7];
                        var af = ae.getAttribute("data-date").toString().split('/');
                        var ag = af[0];
                        var ah = af[1];
                        if (m == ah) {
                            this.d(ae);
                            this.ah();
                        }
                        else {
                            this.al();
                            var ai = this.v(ag, ah);
                            this.d(ai);
                            this.ah();
                        }
                    }
                }
                else if (b == 38) {
                    if (d <= 6) {
                        this.aq();
                        var aj = this.v(l, m);
                        var ak = parseInt(aj.getAttribute("data-index").toString());
                        var al = this.f._inner[ak - 7];
                        var am = al.getAttribute("data-date").toString().split('/');
                        var an = am[0];
                        var ao = am[1];
                        var ap = this.v(an, ao);
                        this.d(ap);
                        this.ah();
                    }
                    else {
                        var aq = this.f._inner[d - 7];
                        var ar = aq.getAttribute("data-date").toString().split('/');
                        var as = ar[0];
                        var at = ar[1];
                        if (m == at) {
                            this.d(aq);
                            this.ah();
                        }
                        else {
                            this.aq();
                            var au = this.v(as, at);
                            this.d(au);
                            this.ah();
                        }
                    }
                }
                else if (b == 34) {
                    this.al();
                    this.ah();
                }
                else if (b == 33) {
                    this.aq();
                    this.ah();
                }
                else if (b == 9) {
                    if (a.shiftKey) {
                        a.preventDefault();
                        var av = this.g._inner[1];
                        this.d(av);
                        this.ah();
                    }
                    else {
                        this.c.cs();
                    }
                }
            }
        }
        else if (this.w == "month") {
            var aw = parseInt(this.p.getAttribute("data-index").toString());
            if (b == 37) {
                if (aw == 0) {
                    var ax = this.h._inner[11];
                    this.d(ax);
                    this.ah();
                }
                else {
                    var ay = this.h._inner[aw - 1];
                    this.d(ay);
                    this.ah();
                }
            }
            else if (b == 39) {
                if (aw == 11) {
                    var az = this.h._inner[0];
                    this.d(az);
                    this.ah();
                }
                else {
                    var a0 = this.h._inner[aw + 1];
                    this.d(a0);
                    this.ah();
                }
            }
            else if (b == 40) {
                if (aw >= 9) {
                    var a1 = this.h._inner[aw - 9];
                    this.d(a1);
                    this.ah();
                }
                else {
                    var a2 = this.h._inner[aw + 3];
                    this.d(a2);
                    this.ah();
                }
            }
            else if (b == 38) {
                if (aw <= 2) {
                    var a3 = this.h._inner[aw + 9];
                    this.d(a3);
                    this.ah();
                }
                else {
                    var a4 = this.h._inner[aw - 3];
                    this.d(a4);
                    this.ah();
                }
            }
            else if (b == 13) {
                this.d(this.g._inner[1]);
                this.ah();
            }
        }
        else if (this.w == "year") {
            var a5 = parseInt(this.p.getAttribute("data-index").toString());
            var a6 = parseInt(this.j._inner[3].getChildAt(0).getText());
            if (b == 40) {
                this.c.cz(a6, 1);
                this.ah();
            }
            else if (b == 38) {
                this.c.cz(a6, -1);
                this.ah();
            }
            else if (b == 13) {
                this.d(this.g._inner[2]);
                this.ah();
            }
        }
        if (b == 27) {
            this.ar();
            this.c.cs();
        }
        if (a.altKey == true) {
            if (b == 38) {
                this.ar();
                this.c.cs();
            }
        }
    };
    CalendarView.prototype.v = function (a, b) {
        var c = null;
        var d = null;
        for (var e = 0; e < 42; e++) {
            var f = this.f._inner[e];
            var g = f.getAttribute("data-date").toString().split('/');
            var h = g[0];
            var i = g[1];
            if (b == i && d == null) {
                d = f;
            }
            if (b == i && a == h) {
                c = f;
                break;
            }
        }
        if (c == null) {
            c = d;
        }
        return c;
    };
    CalendarView.prototype.ap = function (a) {
        var b = this.g._inner[0];
        var c = parseBool(b.getAttribute("data-disabled").toString());
        if (c == true) {
            return;
        }
        this.aq();
    };
    CalendarView.prototype.ak = function (a) {
        var b = this.g._inner[3];
        var c = parseBool(b.getAttribute("data-disabled").toString());
        if (c == true) {
            return;
        }
        this.al();
    };
    CalendarView.prototype.aj = function (a) {
        var b = this.g._inner[1];
        var c = parseBool(b.getAttribute("data-disabled").toString());
        if (c == true) {
            return;
        }
        this.a9();
    };
    CalendarView.prototype.bf = function (a) {
        var b = this.g._inner[2];
        var c = parseBool(b.getAttribute("data-disabled").toString());
        if (c == true) {
            return;
        }
        this.ba();
    };
    CalendarView.prototype.ag = function (e_) {
        var a = (e_.originalEvent.currentTarget);
        var b = a.innerText;
        if (b != "") {
            var c = a.lastChild.lastChild.lastChild;
            var d = parseBool(c.getAttribute("data-disabled").toString());
            if (d == false) {
                var e = c.getAttribute("data-date").toString().split('/');
                var f = e[1];
                var g = e[2];
                this.c.co(b, f, g);
            }
        }
    };
    CalendarView.prototype.ai = function (e_) {
        var a = (e_.originalEvent.currentTarget);
        var b = a.getAttribute("data-month").toString();
        if (b != "") {
            var c = parseInt(b);
            var d = a.lastChild.lastChild.lastChild;
            var e = parseBool(d.getAttribute("data-disabled").toString());
            if (e == false) {
                this.c.cd(c);
                this.ar();
            }
        }
    };
    CalendarView.prototype.bd = function (e_) {
        var a = (e_.originalEvent.currentTarget);
        var b = a.innerText;
        if (b != "") {
            var c = parseInt(b);
            var d = a.lastChild.lastChild.lastChild;
            var e = parseBool(d.getAttribute("data-disabled").toString());
            if (e == false) {
                this.c.ce(c);
                this.ar();
            }
        }
    };
    CalendarView.prototype.be = function (e_) {
        e_.preventDefault();
        var a = (e_.originalEvent.deltaY);
        var b = parseInt(this.j._inner[3].getChildAt(0).getText());
        this.c.cz(b, a);
    };
    CalendarView.prototype.a = function () {
        var rect_ = this.m.rootWrapper.getNativeElement().getBoundingClientRect();
        var a = (rect_.top);
        var b = (rect_.left);
        var c = new Array(2);
        c[0] = a;
        c[1] = b;
        return c;
    };
    CalendarView.prototype.b = function (a) {
        var rect_ = a.getNativeElement().getBoundingClientRect();
        var b = (rect_.top);
        var c = (rect_.left);
        var d = new Array(2);
        d[0] = b;
        d[1] = c;
        return d;
    };
    CalendarView.prototype.am = function () {
    };
    CalendarView.$t = markType(CalendarView, 'CalendarView');
    return CalendarView;
}(Base));
export { CalendarView };
/**
 * @hidden
 */
var XCalendar = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(XCalendar, _super);
    function XCalendar() {
        var _this = _super.call(this) || this;
        _this.h = null;
        _this.aq = dateNow();
        _this.am = new Date();
        _this.ai = null;
        _this.aj = null;
        _this.ah = null;
        _this.ak = null;
        _this.al = null;
        _this.g = null;
        _this.ap = dateMinValue();
        _this.propertyChanged = null;
        _this.close = null;
        _this.selectedValueChanged = null;
        _this.w = null;
        _this.as = dateMinValue();
        _this.ar = dateNow();
        _this.ao = dateMinValue();
        _this.an = dateMaxValue();
        _this.s = 3;
        _this.q = 1;
        _this.c6 = BrushUtil.h(0, 255, 255, 255);
        _this.dc = BrushUtil.h(255, 33, 150, 243);
        _this.de = BrushUtil.h(255, 21, 112, 184);
        _this.c9 = BrushUtil.h(76, 33, 150, 243);
        _this.db = BrushUtil.h(50, 186, 191, 199);
        _this.df = BrushUtil.h(255, 24, 29, 31);
        _this.dd = BrushUtil.h(255, 255, 255, 255);
        _this.da = BrushUtil.h(255, 24, 29, 31);
        _this.c8 = BrushUtil.h(255, 33, 150, 243);
        _this.c7 = BrushUtil.h(255, 33, 150, 243);
        _this.y = false;
        _this.u = null;
        _this.k = 0;
        _this.n = 0;
        _this.z = false;
        _this.am = dateAddYears(_this.am, -200);
        _this.ai = new ObservableCollection$1(DayInfo.$, 0);
        _this.aj = new ObservableCollection$1(XButton.$, 0);
        _this.ah = new ObservableCollection$1(XButton.$, 0);
        _this.ak = new ObservableCollection$1(XButton.$, 0);
        _this.al = new ObservableCollection$1(XButton.$, 0);
        var a = new CalendarView();
        a.c = _this;
        _this.h = a;
        _this.h.ao();
        return _this;
    }
    XCalendar.prototype.cs = function () {
        if (this.close != null) {
            this.close(this);
        }
    };
    XCalendar.prototype.cu = function (a) {
        var b = this.as;
        this.as = a;
        if (this.selectedValueChanged != null) {
            this.selectedValueChanged(this, ((function () {
                var $ret = new SelectedValueChangedEventArgs();
                $ret.oldValue = b;
                $ret.newValue = a;
                return $ret;
            })()));
        }
        if (+(this.value) != +(dateMinValue())) {
            this.aq = this.value;
        }
        this.cx();
    };
    XCalendar.prototype.co = function (a, b, c) {
        var d = dateFromValues(parseInt(c), parseInt(b), parseInt(a), 0, 0, 0, 0);
        this.cu(d);
    };
    XCalendar.prototype.notifySizeChanged = function () {
        this.h.am();
    };
    XCalendar.prototype.destroy = function () {
        if (this.g != null) {
            var a = this.g;
            a.clicked = delegateRemove(a.clicked, runOn(this, this.c2));
        }
        this.provideContainer(null);
    };
    XCalendar.prototype.provideContainer = function (a) {
        this.h.an(a);
    };
    Object.defineProperty(XCalendar.prototype, "x", {
        get: function () {
            if (this.w == null) {
                this.w = new SRProvider(this.h.m);
                this.w.cb("Calendar");
            }
            return this.w;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XCalendar.prototype, "value", {
        get: function () {
            return this.as;
        },
        set: function (a) {
            var b = this.as;
            this.ap = b;
            this.as = a;
            if (+b != +(this.as)) {
                this.ct("Value", b, this.as);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XCalendar.prototype, "av", {
        get: function () {
            return this.ar;
        },
        set: function (a) {
            var b = this.ar;
            this.ar = a;
            if (+b != +(this.ar)) {
                this.ct("Today", b, this.ar);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XCalendar.prototype, "au", {
        get: function () {
            return this.ao;
        },
        set: function (a) {
            var b = this.ao;
            this.ao = a;
            if (+b != +(this.ao)) {
                this.ct("MinDate", b, this.ao);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XCalendar.prototype, "at", {
        get: function () {
            return this.an;
        },
        set: function (a) {
            var b = this.an;
            this.an = a;
            if (+b != +(this.an)) {
                this.ct("MaxDate", b, this.an);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XCalendar.prototype, "t", {
        get: function () {
            return this.s;
        },
        set: function (a) {
            var b = this.s;
            this.s = a;
            if (b != this.s) {
                this.ct("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, this.s));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XCalendar.prototype, "r", {
        get: function () {
            return this.q;
        },
        set: function (a) {
            var b = this.q;
            this.q = a;
            if (b != this.q) {
                this.ct("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, this.q));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XCalendar.prototype, "dg", {
        get: function () {
            return this.c6;
        },
        set: function (a) {
            var b = this.c6;
            this.c6 = a;
            if (b != this.c6) {
                this.ct("BackgroundColor", b, this.c6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XCalendar.prototype, "dm", {
        get: function () {
            return this.dc;
        },
        set: function (a) {
            var b = this.dc;
            this.dc = a;
            if (b != this.dc) {
                this.ct("SelectedDateBackgroundColor", b, this.dc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XCalendar.prototype, "dp", {
        get: function () {
            return this.de;
        },
        set: function (a) {
            var b = this.de;
            this.de = a;
            if (b != this.de) {
                this.ct("SelectedFocusDateBackgroundColor", b, this.de);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XCalendar.prototype, "dj", {
        get: function () {
            return this.c9;
        },
        set: function (a) {
            var b = this.c9;
            this.c9 = a;
            if (b != this.c9) {
                this.ct("FocusDateBackgroundColor", b, this.c9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XCalendar.prototype, "dl", {
        get: function () {
            return this.db;
        },
        set: function (a) {
            var b = this.db;
            this.db = a;
            if (b != this.db) {
                this.ct("HoverBackgroundColor", b, this.db);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XCalendar.prototype, "dq", {
        get: function () {
            return this.df;
        },
        set: function (a) {
            var b = this.df;
            this.df = a;
            if (b != this.df) {
                this.ct("TextColor", b, this.df);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XCalendar.prototype, "dn", {
        get: function () {
            return this.dd;
        },
        set: function (a) {
            var b = this.dd;
            this.dd = a;
            if (b != this.dd) {
                this.ct("SelectedDateTextColor", b, this.dd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XCalendar.prototype, "dk", {
        get: function () {
            return this.da;
        },
        set: function (a) {
            var b = this.da;
            this.da = a;
            if (b != this.da) {
                this.ct("FocusDateTextColor", b, this.da);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XCalendar.prototype, "di", {
        get: function () {
            return this.c8;
        },
        set: function (a) {
            var b = this.c8;
            this.c8 = a;
            if (b != this.c8) {
                this.ct("CurrentDateTextColor", b, this.c8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XCalendar.prototype, "dh", {
        get: function () {
            return this.c7;
        },
        set: function (a) {
            var b = this.c7;
            this.c7 = a;
            if (b != this.c7) {
                this.ct("CurrentDateBorderColor", b, this.c7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XCalendar.prototype, "ae", {
        get: function () {
            return this.y;
        },
        set: function (a) {
            var b = this.y;
            this.y = a;
            if (b != this.y) {
                this.ct("ShowTodayButton", b, this.y);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XCalendar.prototype, "v", {
        get: function () {
            return this.u;
        },
        set: function (a) {
            var b = this.u;
            this.u = a;
            if (b != this.u) {
                this.ct("TextStyle", b, this.u);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XCalendar.prototype, "l", {
        get: function () {
            return this.k;
        },
        set: function (a) {
            var b = this.k;
            this.k = a;
            if (b != this.k) {
                this.ct("FirstDayOfWeek", enumGetBox(DayOfWeek_$type, b), enumGetBox(DayOfWeek_$type, this.k));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XCalendar.prototype, "o", {
        get: function () {
            return this.n;
        },
        set: function (a) {
            var b = this.n;
            this.n = a;
            if (b != this.n) {
                this.ct("FirstWeekOfYear", enumGetBox(FirstWeek_$type, b), enumGetBox(FirstWeek_$type, this.n));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XCalendar.prototype, "af", {
        get: function () {
            return this.z;
        },
        set: function (a) {
            var b = this.z;
            this.z = a;
            if (b != this.z) {
                this.ct("ShowWeekNumbers", b, this.z);
            }
        },
        enumerable: false,
        configurable: true
    });
    XCalendar.prototype.ct = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        this.cv(a, b, c);
    };
    XCalendar.prototype.cv = function (a, b, c) {
        switch (a) {
            case "Density":
                this.c0();
                break;
            case "BaseTheme":
                this.c1();
                break;
            case "Value":
                if (+(this.value) != +(dateMinValue())) {
                    if (dateGetDate(this.value) < dateGetDate(this.au) || dateGetDate(this.value) > dateGetDate(this.at)) {
                        this.value = this.ap;
                    }
                }
                this.ap = this.value;
                if (+(this.value) != +(dateMinValue())) {
                    this.aq = this.value;
                }
                this.cx();
                break;
            case "Today":
                var d = Base.compareSimple(this.av, this.au);
                var e = Base.compareSimple(this.av, this.at);
                if (d < 0) {
                    this.ar = this.au;
                }
                else if (e > 0) {
                    this.ar = this.at;
                }
                if (+(this.value) == +(dateMinValue())) {
                    this.aq = this.av;
                }
                this.cx();
                break;
            case "MaxDate":
            case "MinDate":
                var f = Base.compareSimple(this.au, this.at);
                if (f >= 0) {
                    this.at = dateMaxValue();
                }
                var g = Base.compareSimple(this.aq, this.au);
                var h = Base.compareSimple(this.aq, this.at);
                if (g < 0) {
                    this.aq = this.au;
                }
                else if (h > 0) {
                    this.aq = this.at;
                }
                this.cx();
                break;
            case "TextColor":
            case "SelectedDateTextColor":
            case "FocusDateTextColor":
            case "CurrentDateTextColor":
            case "CurrentDateBorderColor":
            case "BackgroundColor":
            case "FocusDateBackgroundColor":
            case "SelectedFocusDateBackgroundColor":
            case "SelectedDateBackgroundColor":
            case "HoverBackgroundColor":
                this.c3();
                break;
            case "TextStyle":
                this.c4();
                break;
            case "ShowTodayButton":
                this.h.a7();
                break;
            case "FirstDayOfWeek":
                this.cx();
                break;
            case "FirstWeekOfYear":
            case "ShowWeekNumbers":
                this.h.a8();
                this.cx();
                break;
        }
    };
    XCalendar.prototype.c3 = function () {
        for (var a = 0; a < this.aj.count; a++) {
            if (this.dq != null) {
                this.aj._inner[a].p4 = this.dq;
            }
            if (this.dk != null) {
                this.aj._inner[a].p0 = this.dk;
            }
            if (this.dg != null) {
                this.aj._inner[a].pu = this.dg;
            }
            if (this.dj != null) {
                this.aj._inner[a].pz = this.dj;
            }
            if (this.dl != null) {
                this.aj._inner[a].p1 = this.dl;
            }
        }
        for (var b = 0; b < this.ah.count; b++) {
            if (this.dq != null) {
                this.ah._inner[b].p4 = this.dq;
            }
            if (this.dk != null) {
                this.ah._inner[b].p0 = this.dk;
            }
            if (this.dg != null) {
                this.ah._inner[b].pu = this.dg;
            }
            if (this.dj != null) {
                this.ah._inner[b].pz = this.dj;
            }
            if (this.dl != null) {
                this.ah._inner[b].p1 = this.dl;
            }
        }
        for (var c = 0; c < this.ak.count; c++) {
            if (this.dq != null) {
                this.ak._inner[c].p4 = this.dq;
            }
            if (this.dk != null) {
                this.ak._inner[c].p0 = this.dk;
            }
            if (this.dg != null) {
                this.ak._inner[c].pu = this.dg;
            }
            if (this.dj != null) {
                this.ak._inner[c].pz = this.dj;
            }
            if (this.dl != null) {
                this.ak._inner[c].p1 = this.dl;
            }
        }
        for (var d = 0; d < this.al.count; d++) {
            if (this.dq != null) {
                this.al._inner[d].p4 = this.dq;
            }
            if (this.dk != null) {
                this.al._inner[d].p0 = this.dk;
            }
            if (this.dg != null) {
                this.al._inner[d].pu = this.dg;
            }
            if (this.dj != null) {
                this.al._inner[d].pz = this.dj;
            }
            if (this.dl != null) {
                this.al._inner[d].p1 = this.dl;
            }
        }
    };
    XCalendar.prototype.c4 = function () {
        for (var a = 0; a < this.aj.count; a++) {
            if (this.u != null) {
                this.aj._inner[a].aa = this.u;
            }
        }
        for (var b = 0; b < this.ah.count; b++) {
            if (this.u != null) {
                this.ah._inner[b].aa = this.u;
            }
        }
        for (var c = 0; c < this.ak.count; c++) {
            if (this.u != null) {
                this.ak._inner[c].aa = this.u;
            }
        }
        for (var d = 0; d < this.al.count; d++) {
            if (this.u != null) {
                this.al._inner[d].aa = this.u;
            }
        }
    };
    XCalendar.prototype.cq = function () {
        this.cx();
        this.h.au();
        this.h.ah();
    };
    XCalendar.prototype.c1 = function () {
    };
    XCalendar.prototype.c0 = function () {
    };
    XCalendar.prototype.ch = function () {
        this.value = dateMinValue();
        this.h.at();
    };
    XCalendar.prototype.cx = function () {
        this.c5();
        this.h.a3();
        this.cg();
        this.h.ay();
        this.h.a6();
        this.h.at();
    };
    XCalendar.prototype.c5 = function () {
        var a = !stringIsNullOrWhiteSpace(this.x.b1("Today")) ? this.x.b1("Today") : "Today";
        this.h.az(a);
        this.h.bc();
        this.h.bb();
    };
    XCalendar.prototype.cf = function () {
        this.cg();
    };
    XCalendar.prototype.ci = function (a, b, c) {
        var d = new XButton();
        this.h.as(a, d);
        d.n = this.r;
        d.r = this.t;
        d.aa = this.u;
        d.d3 = -1;
        d.e = 1;
        if (this.u != null) {
            d.aa = this.u;
        }
        var e = new CornerRadius(0, 2);
        d.kt = e;
        d.k0 = e;
        d.dk = 0;
        d.appendButtonContent(b);
        d.p4 = this.dq;
        d.p0 = this.dk;
        d.pu = this.dg;
        d.pz = this.dj;
        d.p1 = this.dl;
        d.bu = 30;
        d.bt = 30;
        this.ah.add(d);
        d.h2 = "btnDays" + c.toString();
    };
    XCalendar.prototype.cm = function (a, b) {
        var c = new XButton();
        this.h.as(a, c);
        c.n = this.r;
        c.r = this.t;
        c.aa = this.u;
        c.d3 = -1;
        c.e = 1;
        if (this.u != null) {
            c.aa = this.u;
        }
        var d = new CornerRadius(0, 2);
        c.kt = d;
        c.k0 = d;
        c.dk = 0;
        c.appendButtonContent(b);
        var e = !stringIsNullOrWhiteSpace(this.x.b1("Today")) ? this.x.b1("Today") : "Today";
        this.h.az(e);
        c.p4 = this.dq;
        c.p0 = this.dk;
        c.pu = this.dg;
        c.pz = this.dj;
        c.p1 = this.dl;
        this.g = c;
        var f = this.g;
        f.clicked = delegateCombine(f.clicked, runOn(this, this.c2));
    };
    XCalendar.prototype.c2 = function (a, b) {
        this.aq = this.av;
        this.cg();
        this.h.ar(true);
    };
    XCalendar.prototype.cl = function (a, b) {
        var c = new XButton();
        this.h.as(a, c);
        c.n = this.r;
        c.r = this.t;
        c.aa = this.u;
        c.d3 = -1;
        c.e = 1;
        if (this.u != null) {
            c.aa = this.u;
        }
        var d = new CornerRadius(0, 2);
        c.kt = d;
        c.k0 = d;
        c.dk = 0;
        c.appendButtonContent(b);
        c.p4 = this.dq;
        c.p0 = this.dk;
        c.pu = this.dg;
        c.pz = this.dj;
        c.p1 = this.dl;
        c.bu = 40;
        this.ak.add(c);
    };
    XCalendar.prototype.e = function (a, b) {
        var c = new Array(2);
        c[0] = "";
        c[1] = "";
        switch (a) {
            case 1:
                c[0] = !stringIsNullOrWhiteSpace(this.x.b1("January_Full")) ? this.x.b1("January_Full") : "January";
                c[1] = !stringIsNullOrWhiteSpace(this.x.b1("January_Short")) ? this.x.b1("January_Short") : "Jan";
                break;
            case 2:
                c[0] = !stringIsNullOrWhiteSpace(this.x.b1("February_Full")) ? this.x.b1("February_Full") : "February";
                c[1] = !stringIsNullOrWhiteSpace(this.x.b1("February_Short")) ? this.x.b1("February_Short") : "Feb";
                break;
            case 3:
                c[0] = !stringIsNullOrWhiteSpace(this.x.b1("March_Full")) ? this.x.b1("March_Full") : "March";
                c[1] = !stringIsNullOrWhiteSpace(this.x.b1("March_Short")) ? this.x.b1("March_Short") : "Mar";
                break;
            case 4:
                c[0] = !stringIsNullOrWhiteSpace(this.x.b1("April_Full")) ? this.x.b1("April_Full") : "April";
                c[1] = !stringIsNullOrWhiteSpace(this.x.b1("April_Short")) ? this.x.b1("April_Short") : "Apr";
                break;
            case 5:
                c[0] = !stringIsNullOrWhiteSpace(this.x.b1("May_Full")) ? this.x.b1("May_Full") : "May";
                c[1] = !stringIsNullOrWhiteSpace(this.x.b1("May_Short")) ? this.x.b1("May_Short") : "May";
                break;
            case 6:
                c[0] = !stringIsNullOrWhiteSpace(this.x.b1("June_Full")) ? this.x.b1("June_Full") : "June";
                c[1] = !stringIsNullOrWhiteSpace(this.x.b1("June_Short")) ? this.x.b1("June_Short") : "Jun";
                break;
            case 7:
                c[0] = !stringIsNullOrWhiteSpace(this.x.b1("July_Full")) ? this.x.b1("July_Full") : "July";
                c[1] = !stringIsNullOrWhiteSpace(this.x.b1("July_Short")) ? this.x.b1("July_Short") : "Jul";
                break;
            case 8:
                c[0] = !stringIsNullOrWhiteSpace(this.x.b1("August_Full")) ? this.x.b1("August_Full") : "August";
                c[1] = !stringIsNullOrWhiteSpace(this.x.b1("August_Short")) ? this.x.b1("August_Short") : "Aug";
                break;
            case 9:
                c[0] = !stringIsNullOrWhiteSpace(this.x.b1("September_Full")) ? this.x.b1("September_Full") : "September";
                c[1] = !stringIsNullOrWhiteSpace(this.x.b1("September_Short")) ? this.x.b1("September_Short") : "Sep";
                break;
            case 10:
                c[0] = !stringIsNullOrWhiteSpace(this.x.b1("October_Full")) ? this.x.b1("October_Full") : "October";
                c[1] = !stringIsNullOrWhiteSpace(this.x.b1("October_Short")) ? this.x.b1("October_Short") : "Oct";
                break;
            case 11:
                c[0] = !stringIsNullOrWhiteSpace(this.x.b1("November_Full")) ? this.x.b1("November_Full") : "November";
                c[1] = !stringIsNullOrWhiteSpace(this.x.b1("November_Short")) ? this.x.b1("November_Short") : "Nov";
                break;
            case 12:
                c[0] = !stringIsNullOrWhiteSpace(this.x.b1("December_Full")) ? this.x.b1("December_Full") : "December";
                c[1] = !stringIsNullOrWhiteSpace(this.x.b1("December_Short")) ? this.x.b1("December_Short") : "Dec";
                break;
        }
        this.ak._inner[b].h2 = "btnMonth" + c[1];
        return c;
    };
    XCalendar.prototype.cn = function (a, b, c) {
        var d = new XButton();
        this.h.as(a, d);
        d.n = this.r;
        d.r = this.t;
        d.aa = this.u;
        d.d3 = -1;
        d.e = 1;
        if (this.u != null) {
            d.aa = this.u;
        }
        var e = new CornerRadius(0, 2);
        d.kt = e;
        d.k0 = e;
        d.dk = 0;
        d.appendButtonContent(b);
        d.p4 = this.dq;
        d.p0 = this.dk;
        d.pu = this.dg;
        d.pz = this.dj;
        d.p1 = this.dl;
        d.h2 = "btnYear" + c.toString();
        this.al.add(d);
    };
    XCalendar.prototype.cg = function () {
        if (+(this.aq) == +(dateMinValue())) {
            this.aq = dateNow();
        }
        this.ai.clear();
        var a = dateAddDays(this.aq, -(this.aq.getDate() - 1));
        var b = this.l;
        var c = a.getDay();
        while (c != b) {
            a = dateAddDays(a, -1);
            c = a.getDay();
        }
        while (this.ai.count < 42) {
            var d = new DayInfo();
            d.b = a.getDate();
            d.c = dateGetMonth(a);
            d.d = a.getFullYear();
            d.a = a.getDay();
            this.ai.add(d);
            a = dateAddDays(a, 1);
        }
    };
    XCalendar.prototype.ag = function () {
        var a = new List$1(Number_$type, 0);
        if (this.af == false) {
            for (var b = 0; b < 6; b++) {
                a.add(b);
            }
            return a;
        }
        var c = dateFromValues(this.aq.getFullYear(), dateGetMonth(this.aq), 1, 0, 0, 0, 0);
        for (var d = 0; d < 6; d++) {
            var e = 0;
            if (this.o == 2) {
                e = this.ba(c, this.o, this.l);
            }
            else {
                e = this.ba(c, this.o, this.l);
            }
            if (this.o == 0 || this.o == 2) {
                if (e == 2 && a._inner[d - 1] == 53) {
                    var f = c;
                    for (var g = 0; g < 6; g++) {
                        if (f.getDay() == this.l) {
                            if (f.getDate() > 1) {
                                a._inner[d - 1] = 1;
                            }
                            else {
                                e = 1;
                            }
                        }
                        else if (f.getDay() < this.l) {
                            f = dateAddDays(f, 1);
                        }
                        else if (f.getDay() > this.l) {
                            f = dateAddDays(f, -1);
                        }
                    }
                }
            }
            a.add(e);
            c = dateAddDays(c, 7);
        }
        return a;
    };
    XCalendar.prototype.a9 = function (a) {
        var b = dateAddMonths(dateAddDays(a, -a.getDate() + 1), -dateGetMonth(a) + 1);
        var c = dateAddDays(dateAddYears(b, 1), -1);
        var d = [6, 7, 8, 9, 10, 4, 5];
        var e = truncate(timeSpanTotalDays((+a - +b)));
        var f = e + d[b.getDay()];
        var g = intDivide(f, 7);
        switch (g) {
            case 0: return this.a9(dateAddDays(b, -1));
            case 53: if (c.getDay() < 4) {
                return 1;
            }
            else {
                return g;
            }
            default: return g;
        }
    };
    XCalendar.prototype.ba = function (a, b, c) {
        if (c < 0 || c > 6) {
            return -1;
        }
        switch (b) {
            case 0: return (this.a8(a, c));
            case 1: return (this.bb(a, c, 7));
            case 2: return (this.bb(a, c, 4));
        }
        return -1;
    };
    XCalendar.prototype.a8 = function (a, b) {
        var c = this.a7(a) - 1;
        var d = a.getDay();
        var e = d - (c % 7);
        var f = (e - b + 14) % 7;
        return (intDivide((c + f), 7) + 1);
    };
    XCalendar.prototype.bb = function (a, b, c) {
        var d;
        var e;
        var f;
        var g = this.a7(a) - 1;
        var h = a.getDay();
        d = h - (g % 7);
        e = (b - d + 14) % 7;
        if (e != 0 && e >= c) {
            e -= 7;
        }
        f = g - e;
        if (f >= 0) {
            return (intDivide(f, 7) + 1);
        }
        if (a <= dateAddDays(this.au, g)) {
            return this.bc(b, c);
        }
        return (this.bb(dateAddDays(a, -(g + 1)), b, c));
    };
    XCalendar.prototype.bc = function (a, b) {
        var c = this.a7(this.au) - 1;
        var d = this.m(this.au) - c % 7;
        var e = (a + 7 - d) % 7;
        if (e == 0 || e >= b) {
            return 1;
        }
        var f = 365 - 1;
        var g = d - 1 - (f % 7);
        var h = (a - g + 14) % 7;
        var i = f - h;
        if (h >= b) {
            i += 7;
        }
        return (intDivide(i, 7) + 1);
    };
    XCalendar.prototype.a7 = function (a) {
        return this.a6(a, 1);
    };
    XCalendar.prototype.m = function (a) {
        return ((intDivide(a.getTime(), 0xC92A69C000) + 1) % 7);
    };
    XCalendar.prototype.a6 = function (a, b) {
        var c = this.bd(a.getFullYear(), dateGetMonth(a), a.getDate());
        var d = (intDivide(c, 0xC92A69C000));
        var e = intDivide(d, 146097);
        d -= e * 146097;
        var f = intDivide(d, 36524);
        if (f == 4) {
            f = 3;
        }
        d -= f * 36524;
        var g = intDivide(d, 1461);
        d -= g * 1461;
        var h = intDivide(d, 365);
        if (h == 4) {
            h = 3;
        }
        if (b == 0) {
            return e * 400 + f * 100 + g * 4 + h + 1;
        }
        d -= h * 365;
        if (b == 1) {
            return d + 1;
        }
        var i = h == 3 && (g != 24 || f == 3);
        var j = i ? XCalendar.c : XCalendar.b;
        var k = d >> 5 + 1;
        while (d >= j[k]) {
            k++;
        }
        if (b == 2) {
            return k;
        }
        return d - j[k - 1] + 1;
    };
    XCalendar.prototype.bd = function (a, b, c) {
        if (a >= 1 && a <= 9999 && b >= 1 && b <= 12) {
            var d = XCalendar.ac(a) ? XCalendar.c : XCalendar.b;
            if (c >= 1 && c <= d[b] - d[b - 1]) {
                var e = a - 1;
                var f = e * 365 + intDivide(e, 4) - intDivide(e, 100) + intDivide(e, 400) + d[b - 1] + c - 1;
                return f * 0xC92A69C000;
            }
        }
        return -1;
    };
    XCalendar.ac = function (a) {
        return a % 4 == 0 && (a % 100 != 0 || a % 400 == 0);
    };
    XCalendar.prototype.ck = function (a, b, c, d) {
        var e = new XButton();
        this.h.as(a, e);
        e.n = this.r;
        e.r = this.t;
        e.aa = this.u;
        e.d3 = -1;
        e.e = 1;
        var f = new CornerRadius(0, 2);
        e.kt = f;
        e.k0 = f;
        e.dk = 0;
        var g = new XIcon();
        this.h.aw(b, g);
        if (d == "prev") {
            g.svgPath = XCalendar.bk;
            e.h2 = "btnPrev";
        }
        else if (d == "next") {
            g.svgPath = XCalendar.bl;
            e.h2 = "btnNext";
        }
        e.appendButtonContent(c);
        e.p4 = this.dq;
        e.p0 = this.dk;
        e.pu = this.dg;
        e.pz = this.dj;
        e.p1 = this.dl;
        e.bu = 28;
        e.bt = 28;
        this.aj.add(e);
    };
    XCalendar.prototype.cj = function (a, b, c) {
        var d = new XButton();
        this.h.as(a, d);
        d.n = this.r;
        d.r = this.t;
        d.aa = this.u;
        d.d3 = -1;
        d.e = 1;
        if (this.u != null) {
            d.aa = this.u;
        }
        var e = new CornerRadius(0, 2);
        d.kt = e;
        d.k0 = e;
        d.dk = 0;
        d.appendButtonContent(b);
        d.p4 = this.dq;
        d.p0 = this.dk;
        d.pu = this.dg;
        d.pz = this.dj;
        d.p1 = this.dl;
        d.bu = 40;
        if (c == "month") {
            d.h2 = "btnMonth";
        }
        else if (c == "year") {
            d.h2 = "btnYear";
        }
        this.aj.add(d);
    };
    XCalendar.prototype.a = function () {
        var a = new Array(4);
        a[0] = false;
        a[1] = false;
        a[2] = false;
        a[3] = false;
        var b = this.aq.getFullYear();
        var c = dateGetMonth(this.aq);
        if (b == this.au.getFullYear() && b == this.at.getFullYear()) {
            this.aj._inner[2].disabled = true;
            if (c == dateGetMonth(this.au) && c == dateGetMonth(this.at)) {
                this.aj._inner[0].disabled = true;
                this.aj._inner[1].disabled = true;
                this.aj._inner[3].disabled = true;
            }
            else if (c == dateGetMonth(this.au)) {
                this.aj._inner[0].disabled = true;
                this.aj._inner[1].disabled = false;
                this.aj._inner[3].disabled = false;
            }
            else if (c == dateGetMonth(this.at)) {
                this.aj._inner[0].disabled = false;
                this.aj._inner[1].disabled = false;
                this.aj._inner[3].disabled = true;
            }
            else {
                this.aj._inner[0].disabled = false;
                this.aj._inner[1].disabled = false;
                this.aj._inner[3].disabled = false;
            }
        }
        else {
            this.aj._inner[0].disabled = false;
            this.aj._inner[2].disabled = false;
            this.aj._inner[3].disabled = false;
            if (b == this.au.getFullYear()) {
                if (c == dateGetMonth(this.au)) {
                    this.aj._inner[0].disabled = true;
                    this.aj._inner[1].disabled = false;
                    this.aj._inner[3].disabled = false;
                }
                else {
                    this.aj._inner[0].disabled = false;
                    this.aj._inner[1].disabled = false;
                    this.aj._inner[3].disabled = false;
                }
            }
            else if (b == this.at.getFullYear()) {
                if (c == dateGetMonth(this.at)) {
                    this.aj._inner[0].disabled = false;
                    this.aj._inner[1].disabled = false;
                    this.aj._inner[3].disabled = true;
                }
                else {
                    this.aj._inner[0].disabled = false;
                    this.aj._inner[1].disabled = false;
                    this.aj._inner[3].disabled = false;
                }
            }
            else if (b > this.at.getFullYear() || b < this.au.getFullYear()) {
                this.aj._inner[0].disabled = true;
                this.aj._inner[1].disabled = true;
                this.aj._inner[3].disabled = true;
            }
        }
        for (var d = 0; d < this.aj.count; d++) {
            a[d] = this.aj._inner[d].disabled;
        }
        return a;
    };
    XCalendar.prototype.bx = function () {
        var a = dateGetMonth(this.aq);
        var b = "";
        switch (a) {
            case 1:
                b = !stringIsNullOrWhiteSpace(this.x.b1("January_Short")) ? this.x.b1("January_Short") : "Jan";
                break;
            case 2:
                b = !stringIsNullOrWhiteSpace(this.x.b1("February_Short")) ? this.x.b1("February_Short") : "Feb";
                break;
            case 3:
                b = !stringIsNullOrWhiteSpace(this.x.b1("March_Short")) ? this.x.b1("March_Short") : "Mar";
                break;
            case 4:
                b = !stringIsNullOrWhiteSpace(this.x.b1("April_Short")) ? this.x.b1("April_Short") : "Apr";
                break;
            case 5:
                b = !stringIsNullOrWhiteSpace(this.x.b1("May_Short")) ? this.x.b1("May_Short") : "May";
                break;
            case 6:
                b = !stringIsNullOrWhiteSpace(this.x.b1("June_Short")) ? this.x.b1("June_Short") : "Jun";
                break;
            case 7:
                b = !stringIsNullOrWhiteSpace(this.x.b1("July_Short")) ? this.x.b1("July_Short") : "Jul";
                break;
            case 8:
                b = !stringIsNullOrWhiteSpace(this.x.b1("August_Short")) ? this.x.b1("August_Short") : "Aug";
                break;
            case 9:
                b = !stringIsNullOrWhiteSpace(this.x.b1("September_Short")) ? this.x.b1("September_Short") : "Sep";
                break;
            case 10:
                b = !stringIsNullOrWhiteSpace(this.x.b1("October_Short")) ? this.x.b1("October_Short") : "Oct";
                break;
            case 11:
                b = !stringIsNullOrWhiteSpace(this.x.b1("November_Short")) ? this.x.b1("November_Short") : "Nov";
                break;
            case 12:
                b = !stringIsNullOrWhiteSpace(this.x.b1("December_Short")) ? this.x.b1("December_Short") : "Dec";
                break;
        }
        return b;
    };
    XCalendar.prototype.by = function () {
        var a = this.aq.getFullYear().toString();
        return a;
    };
    XCalendar.prototype.d = function (a) {
        var b = new Array(2);
        b[0] = "";
        b[1] = "";
        if (a == 0) {
            b[0] = !stringIsNullOrWhiteSpace(this.x.b1("Sunday_Full")) ? this.x.b1("Sunday_Full") : "Sunday";
            b[1] = !stringIsNullOrWhiteSpace(this.x.b1("Sunday_Single")) ? this.x.b1("Sunday_Single") : "S";
        }
        else if (a == 1) {
            b[0] = !stringIsNullOrWhiteSpace(this.x.b1("Monday_Full")) ? this.x.b1("Monday_Full") : "Monday";
            b[1] = !stringIsNullOrWhiteSpace(this.x.b1("Monday_Single")) ? this.x.b1("Monday_Single") : "M";
        }
        else if (a == 2) {
            b[0] = !stringIsNullOrWhiteSpace(this.x.b1("Tuesday_Full")) ? this.x.b1("Tuesday_Full") : "Tuesday";
            b[1] = !stringIsNullOrWhiteSpace(this.x.b1("Tuesday_Single")) ? this.x.b1("Tuesday_Single") : "T";
        }
        else if (a == 3) {
            b[0] = !stringIsNullOrWhiteSpace(this.x.b1("Wednesday_Full")) ? this.x.b1("Wednesday_Full") : "Wednesday";
            b[1] = !stringIsNullOrWhiteSpace(this.x.b1("Wednesday_Single")) ? this.x.b1("Wednesday_Single") : "W";
        }
        else if (a == 4) {
            b[0] = !stringIsNullOrWhiteSpace(this.x.b1("Thursday_Full")) ? this.x.b1("Thursday_Full") : "Thursday";
            b[1] = !stringIsNullOrWhiteSpace(this.x.b1("Thursday_Single")) ? this.x.b1("Thursday_Single") : "T";
        }
        else if (a == 5) {
            b[0] = !stringIsNullOrWhiteSpace(this.x.b1("Friday_Full")) ? this.x.b1("Friday_Full") : "Friday";
            b[1] = !stringIsNullOrWhiteSpace(this.x.b1("Friday_Single")) ? this.x.b1("Friday_Single") : "F";
        }
        else if (a == 6) {
            b[0] = !stringIsNullOrWhiteSpace(this.x.b1("Saturday_Full")) ? this.x.b1("Saturday_Full") : "Saturday";
            b[1] = !stringIsNullOrWhiteSpace(this.x.b1("Saturday_Single")) ? this.x.b1("Saturday_Single") : "S";
        }
        return b;
    };
    XCalendar.prototype.j = function (a) {
        return this.ai._inner[a];
    };
    XCalendar.prototype.ad = function (a) {
        var b = this.ai._inner[a];
        var c = this.ah._inner[a];
        if (+(this.value) != +(dateMinValue()) && b.b == this.value.getDate() && b.c == dateGetMonth(this.value) && b.d == this.value.getFullYear()) {
            c.p4 = this.dn;
            c.p0 = this.dn;
            c.pu = this.dm;
            c.pz = this.dp;
            c.pv = this.dg;
        }
        else if (b.b == this.av.getDate() && b.c == dateGetMonth(this.av) && b.d == this.av.getFullYear()) {
            c.p4 = this.di;
            ;
            c.p0 = this.dk;
            c.pu = this.dg;
            c.pz = this.dj;
            c.pv = this.dh;
            c.br = 1;
        }
        else if (b.a != 0 && b.a != 6 && b.c == dateGetMonth(this.aq)) {
            c.p4 = this.dq;
            c.p0 = this.dk;
            c.pu = this.dg;
            c.pz = this.dj;
            c.pv = this.dg;
        }
        else {
            c.p4 = this.dq;
            c.p0 = this.dk;
            c.pu = this.dg;
            c.pz = this.dj;
            c.pv = this.dg;
        }
        if (b.d >= this.au.getFullYear() && b.d <= this.at.getFullYear()) {
            if (b.d == this.au.getFullYear() && b.d == this.at.getFullYear()) {
                if (b.c == dateGetMonth(this.au) && b.c == dateGetMonth(this.at)) {
                    if (b.b >= this.au.getDate() && b.b <= this.at.getDate()) {
                        c.disabled = false;
                    }
                    else {
                        c.disabled = true;
                    }
                }
                else if (b.c >= dateGetMonth(this.au) && b.c <= dateGetMonth(this.at)) {
                    if (b.c == dateGetMonth(this.au)) {
                        if (b.b >= this.au.getDate()) {
                            c.disabled = false;
                        }
                        else {
                            c.disabled = true;
                        }
                    }
                    else if (b.c == dateGetMonth(this.at)) {
                        if (b.b <= this.at.getDate()) {
                            c.disabled = false;
                        }
                        else {
                            c.disabled = true;
                        }
                    }
                    else {
                        c.disabled = false;
                    }
                }
                else {
                    c.disabled = true;
                }
            }
            else {
                if (b.d == this.au.getFullYear()) {
                    if (b.c >= dateGetMonth(this.au)) {
                        if (b.c == dateGetMonth(this.au)) {
                            if (b.b >= this.au.getDate()) {
                                c.disabled = false;
                            }
                            else {
                                c.disabled = true;
                            }
                        }
                        else {
                            c.disabled = false;
                        }
                    }
                    else {
                        c.disabled = true;
                    }
                }
                else if (b.d == this.at.getFullYear()) {
                    if (b.c <= dateGetMonth(this.at)) {
                        if (b.c == dateGetMonth(this.at)) {
                            if (b.b <= this.at.getDate()) {
                                c.disabled = false;
                            }
                            else {
                                c.disabled = true;
                            }
                        }
                        else {
                            c.disabled = false;
                        }
                    }
                    else {
                        c.disabled = true;
                    }
                }
                else {
                    c.disabled = false;
                }
            }
        }
        else {
            c.disabled = true;
        }
        return c.disabled;
    };
    XCalendar.prototype.aa = function (a, b) {
        if (this.aq.getFullYear() >= this.au.getFullYear() && this.aq.getFullYear() <= this.at.getFullYear()) {
            if (this.aq.getFullYear() == this.au.getFullYear() && this.aq.getFullYear() == this.at.getFullYear()) {
                if (b < dateGetMonth(this.au) || b > dateGetMonth(this.at)) {
                    this.ak._inner[a].disabled = true;
                }
                else {
                    this.ak._inner[a].disabled = false;
                }
            }
            else if (this.aq.getFullYear() == this.au.getFullYear()) {
                if (b < dateGetMonth(this.au)) {
                    this.ak._inner[a].disabled = true;
                }
                else {
                    this.ak._inner[a].disabled = false;
                }
            }
            else if (this.aq.getFullYear() == this.at.getFullYear()) {
                if (b > dateGetMonth(this.at)) {
                    this.ak._inner[a].disabled = true;
                }
                else {
                    this.ak._inner[a].disabled = false;
                }
            }
            else {
                this.ak._inner[a].disabled = false;
            }
        }
        else {
            this.ak._inner[a].disabled = true;
        }
        return this.ak._inner[a].disabled;
    };
    XCalendar.prototype.ab = function (a, b) {
        if (b < this.au.getFullYear() || b > this.at.getFullYear()) {
            this.al._inner[a].disabled = true;
        }
        else {
            this.al._inner[a].disabled = false;
        }
        return this.al._inner[a].disabled;
    };
    XCalendar.prototype.cc = function (a) {
        this.aq = dateAddMonths(this.aq, a);
        this.cg();
    };
    XCalendar.prototype.cd = function (a) {
        this.aq = dateFromValues(this.aq.getFullYear(), a, this.aq.getDate(), 0, 0, 0, 0);
        this.cg();
    };
    XCalendar.prototype.ce = function (a) {
        var b = dateGetMonth(this.aq);
        var c = this.aq.getDate();
        if (a == this.au.getFullYear() && a == this.at.getFullYear()) {
            if (b < dateGetMonth(this.au)) {
                b = dateGetMonth(this.au);
                if (c < this.au.getDate()) {
                    c = this.au.getDate();
                }
            }
            else if (b > dateGetMonth(this.at)) {
                b = dateGetMonth(this.at);
                if (c > this.at.getDate()) {
                    c = this.at.getDate();
                }
            }
            else if (b == dateGetMonth(this.au) && b == dateGetMonth(this.at)) {
                if (c < this.au.getDate()) {
                    c = this.au.getDate();
                }
                else if (c > this.at.getDate()) {
                    c = this.at.getDate();
                }
            }
            else if (b == dateGetMonth(this.au)) {
                if (c < this.au.getDate()) {
                    c = this.au.getDate();
                }
            }
            else if (b == dateGetMonth(this.at)) {
                if (c > this.at.getDate()) {
                    c = this.at.getDate();
                }
            }
        }
        else if (a == this.au.getFullYear()) {
            if (b < dateGetMonth(this.au)) {
                b = dateGetMonth(this.au);
                if (c < this.au.getDate()) {
                    c = this.au.getDate();
                }
            }
            else if (b == dateGetMonth(this.au)) {
                if (c < this.au.getDate()) {
                    c = this.au.getDate();
                }
            }
        }
        else if (a == this.at.getFullYear()) {
            if (b > dateGetMonth(this.at)) {
                b = dateGetMonth(this.at);
                if (c > this.at.getDate()) {
                    c = this.at.getDate();
                }
            }
            else if (b == dateGetMonth(this.at)) {
                if (c > this.at.getDate()) {
                    c = this.at.getDate();
                }
            }
        }
        this.aq = dateFromValues(a, b, c, 0, 0, 0, 0);
        this.cg();
    };
    XCalendar.prototype.cz = function (a, b) {
        if (b < 0) {
            a--;
        }
        else {
            a++;
        }
        this.h.a5(a);
    };
    XCalendar.prototype.cy = function () {
        this.h.ar();
    };
    XCalendar.prototype.bj = function () {
        return this.f();
    };
    XCalendar.prototype.bs = function () {
        var a = this.f();
        return a.o();
    };
    XCalendar.prototype.f = function () {
        var a = new CalendarVisualModelExport();
        a.i = this.t;
        a.h = this.r;
        a.e = AppearanceHelper.a(this.dm);
        a.g = AppearanceHelper.a(this.dp);
        a.c = AppearanceHelper.a(this.dj);
        a.f = AppearanceHelper.a(this.dn);
        a.d = AppearanceHelper.a(this.dk);
        a.b = AppearanceHelper.a(this.di);
        a.a = AppearanceHelper.a(this.dh);
        a.j = new List$1(ButtonVisualModelExport.$, 0);
        a.k = new List$1(TextElementsVisualModelExport.$, 0);
        a.l = new List$1(TextElementsVisualModelExport.$, 0);
        var b = this.h.x();
        a.n = b;
        var c = this.h.a();
        var d = c[0];
        var e = c[1];
        if (b == "day") {
            for (var f = 0; f < this.aj.count; f++) {
                if (this.aj._inner[f].h2 == null) {
                    this.aj._inner[f].h2 = "header" + f.toString();
                }
                var g = this.aj._inner[f].d7();
                g.s = g.s - d;
                g.q = g.q - e;
                a.j.add(g);
            }
            for (var h = 0; h < this.ah.count; h++) {
                if (this.ah._inner[h].h2 == null) {
                    this.ah._inner[h].h2 = "days" + h.toString();
                }
                var i = this.ah._inner[h].d7();
                i.s = i.s - d;
                i.q = i.q - e;
                a.j.add(i);
            }
            if (this.ae == true) {
                this.g.h2 = "todayButton";
                var j = this.g.d7();
                j.s = j.s - d;
                j.q = j.q - e;
                a.j.add(j);
            }
            var k = this.h.k();
            for (var l = 0; l < k.count; l++) {
                var m = new TextElementsVisualModelExport();
                var n = this.h.b(k._inner[l]);
                m.e = n[0] - d;
                m.d = n[1] - e;
                m.c = NativeUI.d(k._inner[l].parent());
                m.f = NativeUI.k(k._inner[l].parent());
                m.b = AppearanceHelper.a(NativeUI.al(k._inner[l]));
                m.g = k._inner[l].getText();
                a.k.add(m);
            }
            if (this.af == true) {
                var o = this.h.l();
                for (var p = 0; p < o.count; p++) {
                    var q = new TextElementsVisualModelExport();
                    var r = this.h.b(o._inner[p]);
                    q.e = r[0] - d;
                    q.d = r[1] - e;
                    q.c = NativeUI.d(o._inner[p].parent());
                    q.f = NativeUI.k(o._inner[p].parent());
                    q.b = AppearanceHelper.a(NativeUI.al(o._inner[p]));
                    q.a = AppearanceHelper.a(NativeUI.ak(o._inner[p]));
                    q.g = o._inner[p].getText();
                    a.l.add(q);
                }
            }
        }
        else if (b == "month") {
            for (var s = 0; s < this.ak.count; s++) {
                if (this.ak._inner[s].h2 == null) {
                    this.ak._inner[s].h2 = "months" + s.toString();
                }
                var t = this.ak._inner[s].d7();
                t.s = t.s - d;
                t.q = t.q - e;
                a.j.add(t);
            }
        }
        else if (b == "year") {
            for (var u = 0; u < this.al.count; u++) {
                if (this.al._inner[u].h2 == null) {
                    this.al._inner[u].h2 = "years" + u.toString();
                }
                var v = this.al._inner[u].d7();
                v.s = v.s - d;
                v.q = v.q - e;
                a.j.add(v);
            }
        }
        if (this.v != null) {
            var w = this.v;
            if (this.h != null && w.q == null) {
                var x = this.h.m;
                var y = FontUtil.getFontInfoFromString(x, w.fontString);
                w.q = y.q;
                w.f = y.f;
                w.r = y.r;
                w.t = y.t;
                w.u = y.u;
                w.v = y.v;
            }
            if (w.q != null) {
                a.p = w.q;
            }
            if (!isNaN_(w.f)) {
                a.m = w.f;
            }
            if (w.v != null) {
                a.t = w.v;
            }
            if (w.t != null) {
                a.r = w.t;
            }
            if (w.r != null) {
                a.q = w.t;
            }
        }
        return a;
    };
    XCalendar.$t = markType(XCalendar, 'XCalendar', Base.$, [INotifyPropertyChanged_$type]);
    XCalendar.bk = "M15.41 16.59L10.83 12l4.58-4.59L14 6l-6 6 6 6 1.41-1.41z";
    XCalendar.bl = "M8.59 16.59L13.17 12 8.59 7.41 10 6l6 6-6 6-1.41-1.41z";
    XCalendar.b = [0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334, 365];
    XCalendar.c = [0, 31, 60, 91, 121, 152, 182, 213, 244, 274, 305, 335, 366];
    return XCalendar;
}(Base));
export { XCalendar };
