/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, runOn, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, delegateRemove, enumGetBox, delegateCombine } from "igniteui-react-core";
import { XInputGroup } from "./XInputGroup";
import { XLabel } from "./XLabel";
import { XInput } from "./XInput";
import { XSuffix } from "./XSuffix";
import { XIcon } from "./XIcon";
import { Popup } from "igniteui-react-core";
import { XCalendar } from "./XCalendar";
import { Rect } from "igniteui-react-core";
import { SRProvider } from "igniteui-react-core";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { DayOfWeek_$type } from "./DayOfWeek";
import { FirstWeek_$type } from "./FirstWeek";
import { DateFormats_$type } from "./DateFormats";
import { BrushUtil } from "igniteui-react-core";
import { DateTimeValueFormatter } from "./DateTimeValueFormatter";
import { SelectedValueChangedEventArgs } from "./SelectedValueChangedEventArgs";
import { GotFocusEventArgs } from "./GotFocusEventArgs";
import { LostFocusEventArgs } from "./LostFocusEventArgs";
import { DatePickerVisualModelExport } from "./DatePickerVisualModelExport";
import { FontUtil } from "igniteui-react-core";
import { dateMinValue, dateMaxValue, dateGetDate, dateFromValues, dateGetMonth } from "igniteui-react-core";
import { stringContains, stringIsNullOrWhiteSpace, stringIsNullOrEmpty } from "igniteui-react-core";
import { stringSplit } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
var DatePickerView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DatePickerView, _super);
    function DatePickerView() {
        var _this = _super.call(this) || this;
        _this.b = null;
        _this.d = null;
        _this.k = null;
        _this.e = null;
        _this.m = null;
        _this.l = null;
        _this.j = null;
        _this.g = null;
        _this.f = null;
        _this.i = null;
        _this.h = null;
        _this.o = null;
        _this.document_Click = _this.document_Click.bind(_this);
        _this.window_Resize = _this.window_Resize.bind(_this);
        return _this;
    }
    DatePickerView.prototype.am = function () {
    };
    Object.defineProperty(DatePickerView.prototype, "n", {
        get: function () {
            return this.e;
        },
        enumerable: false,
        configurable: true
    });
    DatePickerView.prototype.ak = function (a) {
        if (a == null) {
            this.b.cq();
            if (this.d != null) {
                var b = this.d.rootWrapper.getChildAt(0);
                b.unlistenAll();
                document.removeEventListener("click", this.document_Click, false);
                window.removeEventListener("resize", this.window_Resize, false);
            }
            this.d = null;
            return;
        }
        this.d = a;
        var c = Math.round(a.rootWrapper.width());
        var d = Math.round(a.rootWrapper.height());
        this.ad();
        this.ae();
        var e = this.d.rootWrapper.getChildAt(0);
        e.listen("keydown", runOn(this, this.y));
        e.listen("focusin", runOn(this, this.w));
        e.listen("focusout", runOn(this, this.x));
        document.addEventListener("click", this.document_Click, false);
        window.addEventListener("resize", this.window_Resize, false);
        this.o = new MutationObserver(runOn(this, this.al));
    };
    DatePickerView.prototype.ad = function () {
        if (this.d != null) {
            this.k = this.d.rootWrapper.getChildAt(0);
            this.k.setAttribute("tabIndex", this.b.be.toString());
            this.k.setStyleProperty("display", "flex");
            this.k.setStyleProperty("height", "100%");
            this.l = this.d.createElement("div");
            this.j = this.d.createElement("div");
            this.j.setRawStyleProperty("flex-grow", "1");
            this.g = this.d.createElement("div");
            this.g.setAttribute("aria-hidden", "true");
            this.f = this.d.createElement("div");
            this.g.setStyleProperty("padding-right", "2px");
            this.i = this.d.createElement("div");
            this.i.setAttribute("aria-hidden", "true");
            this.h = this.d.createElement("div");
            this.b.cr();
            this.j.getChildAt(0).setAttribute("aria-expanded", "fasle");
            this.j.getChildAt(0).setAttribute("aria-invalid", "false");
            this.f.setStyleProperty("height", "16px");
            this.f.setStyleProperty("width", "16px");
            this.h.setStyleProperty("height", "16px");
            this.h.setStyleProperty("width", "16px");
            this.f.listen("click", runOn(this, this.ac));
            this.f.listen("mousedown", runOn(this, this.aa));
            this.f.listen("mouseleave", runOn(this, this.ab));
            this.h.listen("click", runOn(this, this.ag));
        }
    };
    DatePickerView.prototype.aq = function (a) {
        if (this.d != null) {
            var b = this.d.getSubRenderer(this.k);
            a.provideContainer(b);
            var c = b.getExternal(a, b.rootWrapper, this.d.getExternal(this.b, null, null));
        }
    };
    DatePickerView.prototype.as = function (a) {
        if (this.d != null) {
            var b = this.d.getSubRenderer(this.l);
            a.provideContainer(b);
            var c = b.getExternal(a, b.rootWrapper, this.d.getExternal(this.b, null, null));
        }
    };
    DatePickerView.prototype.ar = function (a) {
        if (this.d != null) {
            var b = this.d.getSubRenderer(this.j);
            a.provideContainer(b);
            var c = b.getExternal(a, b.rootWrapper, this.d.getExternal(this.b, null, null));
        }
    };
    DatePickerView.prototype.au = function (a, b) {
        if (this.d != null) {
            var c = this.d.getSubRenderer(b);
            a.provideContainer(c);
            var d = c.getExternal(a, c.rootWrapper, this.d.getExternal(this.b, null, null));
        }
    };
    DatePickerView.prototype.ap = function (a, b) {
        if (this.d != null) {
            var c = this.d.getSubRenderer(b);
            a.provideContainer(c);
            var d = c.getExternal(a, c.rootWrapper, this.d.getExternal(this.b, null, null));
        }
    };
    DatePickerView.prototype.v = function () {
        return this.l;
    };
    DatePickerView.prototype.u = function () {
        return this.j;
    };
    DatePickerView.prototype.r = function () {
        return this.g;
    };
    DatePickerView.prototype.q = function () {
        return this.f;
    };
    DatePickerView.prototype.t = function () {
        return this.i;
    };
    DatePickerView.prototype.s = function () {
        return this.h;
    };
    DatePickerView.prototype.aw = function (a) {
        if (this.j != null) {
            if (a) {
                this.j.getChildAt(0).setAttribute("aria-expanded", "true");
            }
            else {
                this.j.getChildAt(0).setAttribute("aria-expanded", "false");
            }
        }
    };
    DatePickerView.prototype.ay = function (a) {
        if (a != null && a != "") {
            this.j.getChildAt(0).setAttribute("aria-label", a);
        }
        else {
            this.j.getChildAt(0).setAttribute("aria-label", "Select a date");
        }
    };
    DatePickerView.prototype.av = function () {
        if (this.f != null) {
            if (this.b.az == true) {
                this.f.show();
            }
            else {
                this.f.hide();
            }
        }
    };
    DatePickerView.prototype.ah = function () {
        if (this.f != null) {
            this.f.hide();
        }
    };
    DatePickerView.prototype.ax = function () {
        this.k.setAttribute("tabIndex", this.b.be.toString());
    };
    DatePickerView.prototype.an = function () {
        this.o.observe(document, { childList: true, subtree: true });
    };
    DatePickerView.prototype.aj = function () {
        this.o.disconnect();
    };
    DatePickerView.prototype.ae = function () {
        if (this.d != null) {
            this.m = this.d.rootWrapper.getChildAt(1);
            this.e = this.d.createElement("div");
            this.e.setStyleProperty("width", "100%");
            this.e.setStyleProperty("height", "100%");
            this.e.setStyleProperty("display", "flex");
            this.b.cs();
            this.e.parent().setStyleProperty("height", "100%");
            if (this.b.a1 == true) {
                this.e.parent().parent().setStyleProperty("max-width", "245px");
            }
            else {
                this.e.parent().parent().setStyleProperty("max-width", "232px");
            }
        }
    };
    DatePickerView.prototype.z = function () {
        if (this.d != null) {
            if (this.b.a1 == true) {
                this.e.parent().parent().setStyleProperty("max-width", "245px");
            }
            else {
                this.e.parent().parent().setStyleProperty("max-width", "232px");
            }
        }
    };
    DatePickerView.prototype.at = function (a) {
        if (this.d != null) {
            var b = this.d.getSubRenderer(this.m);
            a.provideRenderer(b);
            var c = b.getExternal(a, b.rootWrapper, this.d.getExternal(this.b, null, null));
        }
    };
    DatePickerView.prototype.ao = function (a) {
        if (this.d != null) {
            var b = this.d.getSubRenderer(this.e);
            a.provideContainer(b);
            var c = b.getExternal(a, b.rootWrapper, this.d.getExternal(this.b, null, null));
        }
    };
    DatePickerView.prototype.p = function () {
        return this.e;
    };
    DatePickerView.prototype.ac = function (a) {
        if (this.b.av == true) {
            return;
        }
        this.b.cp();
        if (this.f != null) {
            this.f.hide();
        }
    };
    DatePickerView.prototype.aa = function (a) {
        this.b.c8();
    };
    DatePickerView.prototype.ab = function (a) {
        this.b.c9();
    };
    DatePickerView.prototype.ag = function (a) {
        a.stopPropagation();
        this.b.cx();
    };
    DatePickerView.prototype.y = function (a) {
        var b = a.which;
        if (b == 27) {
            this.b.cq();
        }
    };
    DatePickerView.prototype.w = function (a) {
        this.b.focus();
        var b = (a.originalEvent.relatedTarget);
        if (!this.c(b)) {
            this.b.c3();
        }
    };
    DatePickerView.prototype.x = function (a) {
        var b = (a.originalEvent.relatedTarget);
        if (!this.c(b)) {
            this.b.cw();
            this.b.c4();
        }
    };
    DatePickerView.prototype.al = function (a, b) {
        if (this.d != null) {
            var c = this.d.rootWrapper.getNativeElement();
            if (!document.documentElement.contains(c)) {
                this.b.cq();
            }
        }
        else {
            this.b.cq();
        }
    };
    DatePickerView.prototype.document_Click = function (a) {
        var b = a.target;
        if (!this.c(b)) {
            this.b.cq();
        }
    };
    DatePickerView.prototype.window_Resize = function (a) {
        this.b.dm();
    };
    DatePickerView.prototype.a0 = function (a) {
        if (this.d != null) {
            var b = this.d.rootWrapper.getNativeElement();
            var c = (b.getBoundingClientRect());
            if (a) {
                c = new Rect(0, c.left + window.pageXOffset, c.top + window.pageYOffset, c.width, c.height);
            }
            return c;
        }
        return null;
    };
    DatePickerView.prototype.a = function () {
        var a = (window.innerWidth);
        var b = (window.innerHeight);
        var c = new Array(2);
        c[0] = a;
        c[1] = b;
        return c;
    };
    DatePickerView.prototype.c = function (a) {
        if (null == a) {
            return false;
        }
        var b = this.d.rootWrapper.getNativeElement();
        var c = this.e.getNativeElement();
        return b.contains(a) || c.contains(a);
    };
    DatePickerView.prototype.ai = function () {
    };
    DatePickerView.$t = markType(DatePickerView, 'DatePickerView');
    return DatePickerView;
}(Base));
export { DatePickerView };
/**
 * @hidden
 */
var DatePicker = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DatePicker, _super);
    function DatePicker() {
        var _this = _super.call(this) || this;
        _this.h = null;
        _this.u = null;
        _this.q = null;
        _this.o = null;
        _this.r = null;
        _this.m = null;
        _this.n = null;
        _this.c = null;
        _this.bg = "dd";
        _this.bk = "mm";
        _this.bn = "yyyy";
        _this.bh = "mdy";
        _this.bm = "/";
        _this.ah = false;
        _this.at = false;
        _this.ar = false;
        _this.a5 = dateMinValue();
        _this.ai = false;
        _this.propertyChanged = null;
        _this.selectedValueChanged = null;
        _this.ae = null;
        _this.a7 = dateMinValue();
        _this.a6 = dateMinValue();
        _this.bj = "";
        _this.dt = BrushUtil.h(255, 24, 29, 31);
        _this.z = null;
        _this.bl = "";
        _this.a4 = dateMinValue();
        _this.a3 = dateMaxValue();
        _this.x = 2;
        _this.v = 1;
        _this.aa = null;
        _this.du = BrushUtil.h(255, 24, 29, 31);
        _this.ds = BrushUtil.h(255, 163, 172, 184);
        _this.ao = true;
        _this.ap = false;
        _this.ag = true;
        _this.an = true;
        _this.i = 0;
        _this.k = 0;
        _this.aq = false;
        _this.a = new DateTimeValueFormatter();
        _this.d = 0;
        _this.bi = null;
        _this.aj = false;
        _this.bd = 0;
        _this.ak = false;
        _this.am = false;
        _this.as = false;
        _this.al = false;
        _this.gotFocus = null;
        _this.lostFocus = null;
        _this.keyDown = null;
        _this.changing = null;
        var a = new DatePickerView();
        a.b = _this;
        _this.h = a;
        _this.h.am();
        _this.co();
        return _this;
    }
    DatePicker.prototype.db = function (a, b) {
        if (this.u != null) {
            this.ah = true;
            this.cq();
        }
        this.dl();
        if (this.selectedValueChanged != null) {
            this.selectedValueChanged(this, ((function () {
                var $ret = new SelectedValueChangedEventArgs();
                $ret.oldValue = a;
                $ret.newValue = b;
                return $ret;
            })()));
        }
        if (this.ai) {
            this.df();
        }
    };
    DatePicker.prototype.notifySizeChanged = function () {
        this.h.ai();
    };
    DatePicker.prototype.destroy = function () {
        if (this.c != null) {
            var a = this.c;
            a.selectedValueChanged = delegateRemove(a.selectedValueChanged, runOn(this, this.cn));
            var b = this.c;
            b.close = delegateRemove(b.close, runOn(this, this.cm));
        }
        this.provideContainer(null);
    };
    DatePicker.prototype.provideContainer = function (a) {
        this.h.ak(a);
    };
    DatePicker.prototype.setName = function (a) {
        this.o.e = a;
    };
    Object.defineProperty(DatePicker.prototype, "af", {
        get: function () {
            if (this.ae == null) {
                this.ae = new SRProvider(this.h.d);
                this.ae.cb("Calendar");
            }
            return this.ae;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "value", {
        get: function () {
            return this.a7;
        },
        set: function (a) {
            var b = this.a7;
            this.a5 = b;
            this.a7 = a;
            if (+b != +(this.a7)) {
                this.da("Value", b, this.a7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "ba", {
        get: function () {
            return this.a6;
        },
        set: function (a) {
            var b = this.a6;
            this.a6 = a;
            if (+b != +(this.a6)) {
                this.da("Today", b, this.a6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "b3", {
        get: function () {
            return this.bj;
        },
        set: function (a) {
            var b = this.bj;
            this.bj = a;
            if (b != this.bj) {
                this.da("Label", b, this.bj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "dw", {
        get: function () {
            return this.dt;
        },
        set: function (a) {
            var b = this.dt;
            this.dt = a;
            if (b != this.dt) {
                this.da("LabelTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "ac", {
        get: function () {
            return this.z;
        },
        set: function (a) {
            var b = this.z;
            this.z = a;
            if (b != this.z) {
                this.da("LabelTextStyle", b, this.z);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "cb", {
        get: function () {
            return this.bl;
        },
        set: function (a) {
            var b = this.bl;
            this.bl = a;
            if (b != this.bl) {
                this.da("Placeholder", b, this.bl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "a9", {
        get: function () {
            return this.a4;
        },
        set: function (a) {
            var b = this.a4;
            this.a4 = a;
            if (+b != +(this.a4)) {
                this.da("MinDate", b, this.a4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "a8", {
        get: function () {
            return this.a3;
        },
        set: function (a) {
            var b = this.a3;
            this.a3 = a;
            if (+b != +(this.a3)) {
                this.da("MaxDate", b, this.a3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "y", {
        get: function () {
            return this.x;
        },
        set: function (a) {
            var b = this.x;
            this.x = a;
            if (b != this.x) {
                this.da("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, this.x));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "w", {
        get: function () {
            return this.v;
        },
        set: function (a) {
            var b = this.v;
            this.v = a;
            if (b != this.v) {
                this.da("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, this.v));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "ad", {
        get: function () {
            return this.aa;
        },
        set: function (a) {
            var b = this.aa;
            this.aa = a;
            if (b != this.aa) {
                this.da("TextStyle", b, this.aa);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "dx", {
        get: function () {
            return this.du;
        },
        set: function (a) {
            var b = this.du;
            this.du = a;
            if (b != this.du) {
                this.da("TextColor", b, this.du);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "dv", {
        get: function () {
            return this.ds;
        },
        set: function (a) {
            var b = this.ds;
            this.ds = a;
            if (b != this.ds) {
                this.da("IconColor", b, this.ds);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "az", {
        get: function () {
            return this.ao;
        },
        set: function (a) {
            var b = this.ao;
            this.ao = a;
            if (b != this.ao) {
                this.da("ShowClearButton", b, this.ao);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "a0", {
        get: function () {
            return this.ap;
        },
        set: function (a) {
            var b = this.ap;
            this.ap = a;
            if (b != this.ap) {
                this.da("ShowTodayButton", b, this.ap);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "au", {
        get: function () {
            return this.ag;
        },
        set: function (a) {
            var b = this.ag;
            this.ag = a;
            if (b != this.ag) {
                this.da("AllowTextInput", b, this.ag);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "ay", {
        get: function () {
            return this.an;
        },
        set: function (a) {
            var b = this.an;
            this.an = a;
            if (b != this.an) {
                this.da("OpenOnFocus", b, this.an);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "j", {
        get: function () {
            return this.i;
        },
        set: function (a) {
            var b = this.i;
            this.i = a;
            if (b != this.i) {
                this.da("FirstDayOfWeek", enumGetBox(DayOfWeek_$type, b), enumGetBox(DayOfWeek_$type, this.i));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "l", {
        get: function () {
            return this.k;
        },
        set: function (a) {
            var b = this.k;
            this.k = a;
            if (b != this.k) {
                this.da("FirstWeekOfYear", enumGetBox(FirstWeek_$type, b), enumGetBox(FirstWeek_$type, this.k));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "a1", {
        get: function () {
            return this.aq;
        },
        set: function (a) {
            var b = this.aq;
            this.aq = a;
            if (b != this.aq) {
                this.da("ShowWeekNumbers", b, this.aq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "e", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            var b = this.d;
            this.d = a;
            if (this.d != b) {
                this.da("DateFormat", enumGetBox(DateFormats_$type, b), enumGetBox(DateFormats_$type, this.d));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "by", {
        get: function () {
            return this.bi;
        },
        set: function (a) {
            var b = this.bi;
            this.bi = a;
            if (b != this.bi) {
                this.da("FormatString", b, this.bi);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "av", {
        get: function () {
            return this.aj;
        },
        set: function (a) {
            var b = this.aj;
            this.aj = a;
            if (b != this.aj) {
                this.da("IsDisabled", b, this.aj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "be", {
        get: function () {
            return this.bd;
        },
        set: function (a) {
            var b = this.bd;
            this.bd = a;
            if (b != this.bd) {
                this.da("TabIndex", b, this.bd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "aw", {
        get: function () {
            return this.ak;
        },
        set: function (a) {
            var b = this.ak;
            this.ak = a;
            if (b != this.ak) {
                this.da("IsFixed", b, this.ak);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "ax", {
        get: function () {
            return this.am;
        },
        set: function (a) {
            var b = this.am;
            this.am = a;
            if (b != this.am) {
                this.da("OpenAsChild", b, this.am);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "a2", {
        get: function () {
            return this.as;
        },
        set: function (a) {
            var b = this.as;
            this.as = a;
            if (b != this.as) {
                this.da("UseTopLayer", b, this.as);
            }
        },
        enumerable: false,
        configurable: true
    });
    DatePicker.prototype.da = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        this.dd(a, b, c);
    };
    DatePicker.prototype.dd = function (a, b, c) {
        switch (a) {
            case "Density":
                this.dg();
                break;
            case "BaseTheme":
                this.di();
                break;
            case "Value":
                if (+(dateGetDate(this.value)) != +(dateGetDate(dateMinValue()))) {
                    if (dateGetDate(this.value) < dateGetDate(this.a9) || dateGetDate(this.value) > dateGetDate(this.a8)) {
                        this.ai = true;
                        this.value = this.a5;
                        this.ai = false;
                    }
                }
                this.db(this.a5, this.value);
                this.a5 = this.value;
                if (this.c != null) {
                    if (+(dateGetDate(this.value)) == +(dateGetDate(dateMinValue()))) {
                        this.c.value = dateMinValue();
                    }
                    else {
                        this.c.value = this.value;
                    }
                }
                break;
            case "Label":
                if (this.r != null) {
                    this.r.text = this.b3;
                    if (this.b3 != null && this.b3 != "") {
                        if (!this.q.inputs.contains(this.r)) {
                            this.q.inputs.insert(0, this.r);
                        }
                    }
                    else {
                        if (this.q.inputs.contains(this.r)) {
                            this.q.inputs.remove(this.r);
                        }
                    }
                }
                break;
            case "Placeholder":
                if (this.o != null) {
                    this.o.cg = this.cb;
                    this.h.ay(this.cb);
                }
                break;
            case "Today":
                if (this.c != null) {
                    this.c.av = this.ba;
                }
                break;
            case "MaxDate":
                if (this.c != null) {
                    var d = Base.compareSimple(this.a9, this.a8);
                    if (d >= 0) {
                        this.a8 = dateMaxValue();
                    }
                    this.c.at = this.a3;
                }
                if (dateGetDate(this.value) > dateGetDate(this.a8)) {
                    this.a5 = dateMinValue();
                    this.ai = true;
                    this.value = dateMinValue();
                    this.ai = false;
                }
                break;
            case "MinDate":
                if (this.c != null) {
                    this.c.au = this.a4;
                    var e = Base.compareSimple(this.a9, this.a8);
                    if (e >= 0) {
                        this.a5 = dateMaxValue();
                        this.c.at = this.a8;
                    }
                }
                if (dateGetDate(this.value) < dateGetDate(this.a9)) {
                    this.a5 = dateMinValue();
                    this.ai = true;
                    this.value = dateMinValue();
                    this.ai = false;
                }
                break;
            case "TextStyle":
                this.dn();
                break;
            case "ShowClearButton":
                if (this.o != null) {
                    if (this.o.cq != "") {
                        this.h.av();
                    }
                }
                break;
            case "LabelTextColor":
            case "LabelTextStyle":
            case "TextColor":
            case "IconColor":
                this.dp();
                break;
            case "ShowTodayButton":
                if (this.c != null) {
                    this.c.ae = this.a0;
                    this.h.z();
                }
                break;
            case "AllowTextInput":
                if (this.o != null) {
                    this.o.disabled = !this.au;
                }
                break;
            case "OpenOnFocus": break;
            case "DateFormat":
                this.a.k(this.e);
                this.dl();
                break;
            case "FormatString":
                this.co();
                this.dl();
                break;
            case "FirstDayOfWeek":
                if (this.c != null) {
                    this.c.l = this.j;
                }
                break;
            case "ShowWeekNumbers":
                if (this.c != null) {
                    this.c.af = this.a1;
                    this.h.z();
                }
                break;
            case "FirstWeekOfYear":
                if (this.c != null) {
                    this.c.o = this.l;
                }
                break;
            case "IsDisabled":
                {
                    if (this.q != null) {
                        this.q.disabled = this.av;
                    }
                    if (this.o != null) {
                        this.o.disabled = this.av;
                    }
                }
                break;
            case "TabIndex":
                this.h.ax();
                break;
            case "IsFixed":
                if (this.u != null) {
                    this.u.aq = this.aw;
                }
                break;
            case "UseTopLayer":
                if (this.u != null) {
                    this.u.ax = this.a2;
                }
                break;
        }
    };
    DatePicker.prototype.co = function () {
        var a = '/';
        var b = this.by != null ? this.by.toLowerCase() : this.a.j();
        if (stringContains(b, "/")) {
            a = '/';
        }
        else if (stringContains(b, "-")) {
            a = '-';
        }
        else if (stringContains(b, " ")) {
            a = ' ';
        }
        else if (stringContains(b, ".")) {
            a = '.';
        }
        else if (stringContains(b, ",")) {
            a = ',';
        }
        this.bm = a.toString();
        var c = b.split(a);
        if (c.length == 3) {
            var d = "";
            for (var e = 0; e < 3; e++) {
                if (stringContains(c[e], "d")) {
                    d += "d";
                    switch (c[e]) {
                        case "d":
                            this.bg = c[e];
                            break;
                        case "dd":
                            this.bg = c[e];
                            break;
                        case "ddd":
                            this.bg = c[e];
                            break;
                        case "dddd":
                            this.bg = c[e];
                            break;
                        default:
                            this.bg = "dd";
                            break;
                    }
                }
                else if (stringContains(c[e], "m")) {
                    d += "m";
                    switch (c[e]) {
                        case "m":
                            this.bk = c[e];
                            break;
                        case "mm":
                            this.bk = c[e];
                            break;
                        case "mmm":
                            this.bk = c[e];
                            break;
                        case "mmmm":
                            this.bk = c[e];
                            break;
                        default:
                            this.bk = "mm";
                            break;
                    }
                    this.bk = c[e];
                }
                else if (stringContains(c[e], "y")) {
                    d += "y";
                    switch (c[e]) {
                        case "yy":
                            this.bn = c[e];
                            break;
                        case "yyyy":
                            this.bn = c[e];
                            break;
                        default:
                            this.bn = "yyyy";
                            break;
                    }
                }
            }
            if (d == "dmy" || d == "mdy" || d == "ymd") {
                this.bh = d;
            }
            else {
                this.bh = "mdy";
            }
        }
    };
    DatePicker.prototype.dp = function () {
        if (this.o != null) {
            this.o.d8 = this.dx;
        }
        if (this.m != null) {
            this.m.fill = this.dv;
        }
        if (this.n != null) {
            this.n.fill = this.dv;
        }
        if (this.r != null) {
            this.r.df = this.dw;
            this.r.y = this.ac;
        }
    };
    DatePicker.prototype.dk = function () {
        if (this.q != null) {
        }
    };
    DatePicker.prototype.dn = function () {
        if (this.aa != null) {
            this.o.af = this.aa;
        }
    };
    DatePicker.prototype.cr = function () {
        this.q = new XInputGroup();
        this.h.aq(this.q);
        this.q.d = 0;
        this.q.p = this.w;
        this.q.t = this.y;
        this.r = new XLabel();
        this.h.as(this.r);
        this.r.df = this.dw;
        this.r.y = this.ac;
        this.q.appendContentChild(this.h.v());
        if (this.b3 != null && this.b3 != "") {
            this.r.text = this.b3;
            this.q.inputs.add(this.r);
        }
        this.o = new XInput();
        this.h.ar(this.o);
        this.o.b8 = "text";
        if (this.aa != null) {
            this.o.af = this.aa;
        }
        this.o.disabled = !this.au;
        this.o.d8 = this.dx;
        this.q.appendContentChild(this.h.u());
        this.q.inputs.add(this.o);
        this.o.cg = this.cb;
        this.h.ay(this.cb);
        var a = this.o;
        a.change = delegateCombine(a.change, runOn(this, this.cy));
        var b = this.o;
        b.changing = delegateCombine(b.changing, runOn(this, this.cz));
        var c = this.o;
        c.keyDown = delegateCombine(c.keyDown, runOn(this, this.c0));
        var d = new XSuffix();
        this.h.au(d, this.h.r());
        this.m = new XIcon();
        this.h.ap(this.m, this.h.q());
        this.m.svgPath = DatePicker.br;
        this.m.fill = this.dv;
        d.appendContentChild(this.h.q());
        this.q.appendContentChild(this.h.r());
        this.q.inputs.add(d);
        this.dl();
        var e = new XSuffix();
        this.h.au(e, this.h.t());
        this.n = new XIcon();
        this.h.ap(this.n, this.h.s());
        this.n.svgPath = DatePicker.bq;
        this.n.fill = this.dv;
        e.appendContentChild(this.h.s());
        this.q.appendContentChild(this.h.t());
        this.q.inputs.add(e);
    };
    DatePicker.prototype.c0 = function (a, b) {
        this.c6(b);
        if (b.defaultPrevented) {
            return;
        }
        var c = b.keyCode;
        var d = b.modifiers;
        switch (c) {
            case 9:
                this.ar = true;
                if (!this.at) {
                    this.dr(this.o.cq);
                }
                this.ah = true;
                this.cq();
                this.ar = false;
                break;
            case 13:
                this.ar = true;
                if (!this.at) {
                    this.dr(this.o.cq);
                }
                this.ah = true;
                this.cq();
                this.ar = false;
                break;
            case 40:
                if (d == 1) {
                    this.dc();
                    this.cv();
                }
                break;
            case 38:
                if (d == 1) {
                    this.cq();
                }
                break;
        }
    };
    DatePicker.prototype.cz = function (a, b) {
        this.c2(b);
        if (b.value.length > 0) {
            this.h.av();
        }
        else {
            this.h.ah();
        }
    };
    DatePicker.prototype.cy = function (a, b) {
        this.at = true;
        this.dr(b.value);
        this.at = false;
    };
    DatePicker.prototype.dr = function (a) {
        var b = ['/', '-', ' ', '.', ','];
        var c = stringSplit(a, b, 1);
        var d = 0;
        var e = 0;
        var f = 0;
        var g = true;
        if (c.length == 3) {
            if (c[0].length == 0 || c[1].length == 0 || c[2].length == 0) {
                g = false;
            }
            if (this.bh == "dmy") {
                d = parseInt(c[0]);
                e = parseInt(c[1]);
                f = parseInt(c[2]);
            }
            else if (this.bh == "mdy") {
                e = parseInt(c[0]);
                d = parseInt(c[1]);
                f = parseInt(c[2]);
            }
            else if (this.bh == "ymd") {
                f = parseInt(c[0]);
                e = parseInt(c[1]);
                d = parseInt(c[2]);
            }
            if (isNaN_(d) || isNaN_(f)) {
                g = false;
            }
            if (f < 50) {
                f = f + 2000;
            }
            if (isNaN_(e)) {
                var h = "";
                if (this.bh == "dmy") {
                    h = c[1].toLowerCase();
                }
                else if (this.bh == "mdy") {
                    h = c[0].toLowerCase();
                }
                else if (this.bh == "ymd") {
                    h = c[1].toLowerCase();
                }
                var i = !stringIsNullOrWhiteSpace(this.af.b1("January_Full")) ? this.af.b1("January_Full").toLowerCase() : "january";
                var j = !stringIsNullOrWhiteSpace(this.af.b1("January_Short")) ? this.af.b1("January_Short").toLowerCase() : "jan";
                var k = !stringIsNullOrWhiteSpace(this.af.b1("February_Full")) ? this.af.b1("February_Full").toLowerCase() : "february";
                var l = !stringIsNullOrWhiteSpace(this.af.b1("February_Short")) ? this.af.b1("February_Short").toLowerCase() : "feb";
                var m = !stringIsNullOrWhiteSpace(this.af.b1("March_Full")) ? this.af.b1("March_Full").toLowerCase() : "march";
                var n = !stringIsNullOrWhiteSpace(this.af.b1("March_Short")) ? this.af.b1("March_Short").toLowerCase() : "mar";
                var o = !stringIsNullOrWhiteSpace(this.af.b1("April_Full")) ? this.af.b1("April_Full").toLowerCase() : "april";
                var p = !stringIsNullOrWhiteSpace(this.af.b1("April_Short")) ? this.af.b1("April_Short").toLowerCase() : "apr";
                var q = !stringIsNullOrWhiteSpace(this.af.b1("May_Full")) ? this.af.b1("May_Full").toLowerCase() : "may";
                var r = !stringIsNullOrWhiteSpace(this.af.b1("May_Short")) ? this.af.b1("May_Short").toLowerCase() : "may";
                var s = !stringIsNullOrWhiteSpace(this.af.b1("June_Full")) ? this.af.b1("June_Full").toLowerCase() : "june";
                var t = !stringIsNullOrWhiteSpace(this.af.b1("June_Short")) ? this.af.b1("June_Short").toLowerCase() : "jun";
                var u = !stringIsNullOrWhiteSpace(this.af.b1("July_Full")) ? this.af.b1("July_Full").toLowerCase() : "july";
                var v = !stringIsNullOrWhiteSpace(this.af.b1("July_Short")) ? this.af.b1("July_Short").toLowerCase() : "jul";
                var w = !stringIsNullOrWhiteSpace(this.af.b1("August_Full")) ? this.af.b1("August_Full").toLowerCase() : "august";
                var x = !stringIsNullOrWhiteSpace(this.af.b1("August_Short")) ? this.af.b1("August_Short").toLowerCase() : "aug";
                var y = !stringIsNullOrWhiteSpace(this.af.b1("September_Full")) ? this.af.b1("September_Full").toLowerCase() : "september";
                var z = !stringIsNullOrWhiteSpace(this.af.b1("September_Short")) ? this.af.b1("September_Short").toLowerCase() : "sep";
                var aa = !stringIsNullOrWhiteSpace(this.af.b1("October_Full")) ? this.af.b1("October_Full").toLowerCase() : "october";
                var ab = !stringIsNullOrWhiteSpace(this.af.b1("October_Short")) ? this.af.b1("October_Short").toLowerCase() : "oct";
                var ac = !stringIsNullOrWhiteSpace(this.af.b1("November_Full")) ? this.af.b1("November_Full").toLowerCase() : "november";
                var ad = !stringIsNullOrWhiteSpace(this.af.b1("November_Short")) ? this.af.b1("November_Short").toLowerCase() : "nov";
                var ae = !stringIsNullOrWhiteSpace(this.af.b1("December_Full")) ? this.af.b1("December_Full").toLowerCase() : "december";
                var af = !stringIsNullOrWhiteSpace(this.af.b1("December_Short")) ? this.af.b1("December_Short").toLowerCase() : "dec";
                if (h == i || h == j) {
                    e = 1;
                }
                else if (h == k || h == l) {
                    e = 2;
                }
                else if (h == m || h == n) {
                    e = 3;
                }
                else if (h == o || h == p) {
                    e = 4;
                }
                else if (h == q || h == r) {
                    e = 5;
                }
                else if (h == s || h == t) {
                    e = 6;
                }
                else if (h == u || h == v) {
                    e = 7;
                }
                else if (h == w || h == x) {
                    e = 8;
                }
                else if (h == y || h == z) {
                    e = 9;
                }
                else if (h == aa || h == ab) {
                    e = 10;
                }
                else if (h == ac || h == ad) {
                    e = 11;
                }
                else if (h == ae || h == af) {
                    e = 12;
                }
                else {
                    g = false;
                }
            }
            if (e > 12 || e < 1) {
                g = false;
            }
        }
        else {
            g = false;
        }
        if (g) {
            var ag = dateFromValues(f, e, d, 0, 0, 0, 0);
            var ah = Base.compareSimple(ag, this.a9);
            var ai = Base.compareSimple(ag, this.a8);
            if (ah < 0 || ai > 0) {
                this.dl();
            }
            else {
                this.dq(ag);
                this.h.av();
            }
        }
        else {
            if (stringIsNullOrEmpty(a)) {
                this.cp();
            }
            else {
                this.dl();
            }
        }
    };
    DatePicker.prototype.dq = function (a) {
        var b = this.value;
        this.value = a;
    };
    DatePicker.prototype.dl = function () {
        if (this.o != null) {
            if (+(dateGetDate(this.a7)) != +(dateGetDate(dateMinValue()))) {
                var a = "";
                if (this.by == null) {
                    a = this.a.i(this.value);
                }
                else {
                    var b = this.value.getDate().toString();
                    var c = b;
                    if (this.bg == "dd") {
                        if (this.value.getDate() < 10) {
                            b = "0" + b;
                        }
                    }
                    else if (this.bg == "ddd") {
                        switch (this.value.getDay()) {
                            case 0:
                                b = !stringIsNullOrWhiteSpace(this.af.b1("Sunday_Short")) ? this.af.b1("Sunday_Short") : "Sun";
                                break;
                            case 1:
                                b = !stringIsNullOrWhiteSpace(this.af.b1("Monday_Short")) ? this.af.b1("Monday_Short") : "Mon";
                                break;
                            case 2:
                                b = !stringIsNullOrWhiteSpace(this.af.b1("Tuesday_Short")) ? this.af.b1("Tuesday_Short") : "Tue";
                                break;
                            case 3:
                                b = !stringIsNullOrWhiteSpace(this.af.b1("Wednesday_Short")) ? this.af.b1("Wednesday_Short") : "Wed";
                                break;
                            case 4:
                                b = !stringIsNullOrWhiteSpace(this.af.b1("Thursday_Short")) ? this.af.b1("Thursday_Short") : "Thu";
                                break;
                            case 5:
                                b = !stringIsNullOrWhiteSpace(this.af.b1("Friday_Short")) ? this.af.b1("Friday_Short") : "Fri";
                                break;
                            case 6:
                                b = !stringIsNullOrWhiteSpace(this.af.b1("Saturday_Short")) ? this.af.b1("Saturday_Short") : "Sat";
                                break;
                        }
                    }
                    else if (this.bg == "dddd") {
                        switch (this.value.getDay()) {
                            case 0:
                                b = !stringIsNullOrWhiteSpace(this.af.b1("Sunday_Full")) ? this.af.b1("Sunday_Full") : "Sunday";
                                break;
                            case 1:
                                b = !stringIsNullOrWhiteSpace(this.af.b1("Monday_Full")) ? this.af.b1("Monday_Full") : "Monday";
                                break;
                            case 2:
                                b = !stringIsNullOrWhiteSpace(this.af.b1("Tuesday_Full")) ? this.af.b1("Tuesday_Full") : "Tuesday";
                                break;
                            case 3:
                                b = !stringIsNullOrWhiteSpace(this.af.b1("Wednesday_Full")) ? this.af.b1("Wednesday_Full") : "Wednesday";
                                break;
                            case 4:
                                b = !stringIsNullOrWhiteSpace(this.af.b1("Thursday_Full")) ? this.af.b1("Thursday_Full") : "Thursday";
                                break;
                            case 5:
                                b = !stringIsNullOrWhiteSpace(this.af.b1("Friday_Full")) ? this.af.b1("Friday_Full") : "Friday";
                                break;
                            case 6:
                                b = !stringIsNullOrWhiteSpace(this.af.b1("Saturday_Full")) ? this.af.b1("Saturday_Full") : "Saturday";
                                break;
                        }
                    }
                    var d = dateGetMonth(this.value).toString();
                    if (this.bk == "mm") {
                        if (dateGetMonth(this.value) < 10) {
                            d = "0" + d;
                        }
                    }
                    else if (this.bk == "mmm") {
                        switch (dateGetMonth(this.value)) {
                            case 1:
                                d = !stringIsNullOrWhiteSpace(this.af.b1("January_Short")) ? this.af.b1("January_Short") : "Jan";
                                break;
                            case 2:
                                d = !stringIsNullOrWhiteSpace(this.af.b1("February_Short")) ? this.af.b1("February_Short") : "Feb";
                                break;
                            case 3:
                                d = !stringIsNullOrWhiteSpace(this.af.b1("March_Short")) ? this.af.b1("March_Short") : "Mar";
                                break;
                            case 4:
                                d = !stringIsNullOrWhiteSpace(this.af.b1("April_Short")) ? this.af.b1("April_Short") : "Apr";
                                break;
                            case 5:
                                d = !stringIsNullOrWhiteSpace(this.af.b1("May_Short")) ? this.af.b1("May_Short") : "May";
                                break;
                            case 6:
                                d = !stringIsNullOrWhiteSpace(this.af.b1("June_Short")) ? this.af.b1("June_Short") : "Jun";
                                break;
                            case 7:
                                d = !stringIsNullOrWhiteSpace(this.af.b1("July_Short")) ? this.af.b1("July_Short") : "Jul";
                                break;
                            case 8:
                                d = !stringIsNullOrWhiteSpace(this.af.b1("August_Short")) ? this.af.b1("August_Short") : "Aug";
                                break;
                            case 9:
                                d = !stringIsNullOrWhiteSpace(this.af.b1("September_Short")) ? this.af.b1("September_Short") : "Sep";
                                break;
                            case 10:
                                d = !stringIsNullOrWhiteSpace(this.af.b1("October_Short")) ? this.af.b1("October_Short") : "Oct";
                                break;
                            case 11:
                                d = !stringIsNullOrWhiteSpace(this.af.b1("November_Short")) ? this.af.b1("November_Short") : "Nov";
                                break;
                            case 12:
                                d = !stringIsNullOrWhiteSpace(this.af.b1("December_Short")) ? this.af.b1("December_Short") : "Dec";
                                break;
                        }
                    }
                    else if (this.bk == "mmmm") {
                        switch (dateGetMonth(this.value)) {
                            case 1:
                                d = !stringIsNullOrWhiteSpace(this.af.b1("January_Full")) ? this.af.b1("January_Full") : "January";
                                break;
                            case 2:
                                d = !stringIsNullOrWhiteSpace(this.af.b1("February_Full")) ? this.af.b1("February_Full") : "February";
                                break;
                            case 3:
                                d = !stringIsNullOrWhiteSpace(this.af.b1("March_Full")) ? this.af.b1("March_Full") : "March";
                                break;
                            case 4:
                                d = !stringIsNullOrWhiteSpace(this.af.b1("April_Full")) ? this.af.b1("April_Full") : "April";
                                break;
                            case 5:
                                d = !stringIsNullOrWhiteSpace(this.af.b1("May_Full")) ? this.af.b1("May_Full") : "May";
                                break;
                            case 6:
                                d = !stringIsNullOrWhiteSpace(this.af.b1("June_Full")) ? this.af.b1("June_Full") : "June";
                                break;
                            case 7:
                                d = !stringIsNullOrWhiteSpace(this.af.b1("July_Full")) ? this.af.b1("July_Full") : "July";
                                break;
                            case 8:
                                d = !stringIsNullOrWhiteSpace(this.af.b1("August_Full")) ? this.af.b1("August_Full") : "August";
                                break;
                            case 9:
                                d = !stringIsNullOrWhiteSpace(this.af.b1("September_Full")) ? this.af.b1("September_Full") : "September";
                                break;
                            case 10:
                                d = !stringIsNullOrWhiteSpace(this.af.b1("October_Full")) ? this.af.b1("October_Full") : "October";
                                break;
                            case 11:
                                d = !stringIsNullOrWhiteSpace(this.af.b1("November_Full")) ? this.af.b1("November_Full") : "November";
                                break;
                            case 12:
                                d = !stringIsNullOrWhiteSpace(this.af.b1("December_Full")) ? this.af.b1("December_Full") : "December";
                                break;
                        }
                    }
                    var e = this.value.getFullYear().toString();
                    if (this.bn == "yy") {
                        e = e.substr(2);
                    }
                    if (this.bh == "dmy") {
                        if (this.bg == "ddd" || this.bg == "dddd") {
                            a = b + this.bm + d + " " + c + this.bm + e;
                        }
                        else {
                            a = b + this.bm + d + this.bm + e;
                        }
                    }
                    else if (this.bh == "mdy") {
                        if (this.bg == "ddd" || this.bg == "dddd") {
                            a = d + " " + c + this.bm + b + this.bm + e;
                        }
                        else {
                            a = d + this.bm + b + this.bm + e;
                        }
                    }
                    else if (this.bh == "ymd") {
                        if (this.bg == "ddd" || this.bg == "dddd") {
                            a = e + this.bm + d + " " + c + this.bm + b;
                        }
                        else {
                            a = e + this.bm + d + this.bm + b;
                        }
                    }
                }
                this.o.cq = a;
                this.h.av();
            }
            else {
                this.o.cq = "";
                this.h.ah();
            }
        }
    };
    DatePicker.prototype.cp = function () {
        if (this.av == true) {
            return;
        }
        if (this.o != null) {
            this.o.cq = "";
        }
        this.value = dateMinValue();
        this.c.ch();
        this.al = false;
    };
    DatePicker.prototype.c8 = function () {
        this.al = true;
    };
    DatePicker.prototype.c9 = function () {
        this.al = false;
    };
    DatePicker.prototype.cs = function () {
        this.u = new Popup();
        this.u.aq = this.aw;
        this.u.ax = this.a2;
        this.u.cy = BrushUtil.h(255, 255, 255, 255);
        this.u.a8 = 150;
        this.h.at(this.u);
        this.c = new XCalendar();
        this.h.ao(this.c);
        if (+(this.a9) != +(dateMinValue())) {
            this.c.au = this.a9;
        }
        if (+(this.a8) != +(dateMaxValue())) {
            this.c.at = this.a8;
        }
        if (+(this.ba) != +(dateMinValue())) {
            this.c.av = this.ba;
        }
        this.c.ae = this.a0;
        this.c.l = this.j;
        this.c.af = this.a1;
        this.c.o = this.l;
        var a = this.c;
        a.selectedValueChanged = delegateCombine(a.selectedValueChanged, runOn(this, this.cn));
        var b = this.c;
        b.close = delegateCombine(b.close, runOn(this, this.cm));
        this.u.appendPopupContent(this.h.p());
    };
    DatePicker.prototype.cn = function (a, b) {
        this.ai = true;
        this.value = b.newValue;
        this.ai = false;
    };
    DatePicker.prototype.cm = function (a) {
        if (this.u.aw) {
            this.ah = true;
            this.cq();
        }
    };
    DatePicker.prototype.cx = function () {
        if (this.ah == false) {
            if (this.u.aw) {
                this.cq();
            }
            else {
                this.dc();
            }
        }
        else {
            this.ah = false;
        }
    };
    DatePicker.prototype.dc = function () {
        if (this.av) {
            return;
        }
        if (this.u != null) {
            var a = this.h.a0(false);
            var b = this.h.a()[1];
            var c = 240;
            if (this.a0 == true) {
                c = 270;
            }
            var d = a.bottom + c;
            if (b < d) {
                var e = a.top - c;
                if (e < 0) {
                    this.dj(1, 0);
                }
                else {
                    this.dj(2, 0);
                }
            }
            else {
                this.dj(1, 0);
            }
            this.h.an();
            this.h.aw(true);
        }
    };
    DatePicker.prototype.dj = function (a, b) {
        if (this.ax) {
            this.u.cp(this.h.d.rootWrapper.getNativeElement(), a, b);
        }
        else {
            var c = this.h.a0(true);
            this.u.showRelativeToExclusionRect(c, a, b);
        }
    };
    DatePicker.prototype.dm = function () {
        if (this.u.aw) {
            var a = this.h.a0(false);
            var b = new Rect(0, a.left + window.pageXOffset, a.top + window.pageYOffset, a.width, a.height);
            var c = this.h.a()[1];
            var d = 240;
            if (this.a0 == true) {
                d = 270;
            }
            var e = a.bottom + d;
            if (c < e) {
                var f = a.top - d;
                if (f < 0) {
                    if (this.u.r != 1) {
                        this.u.r = 1;
                        this.u.b9(b);
                    }
                }
                else {
                    if (this.u.r != 2) {
                        this.u.r = 2;
                        this.u.b9(b);
                    }
                }
            }
            else {
                if (this.u.r != 1) {
                    this.u.r = 1;
                    this.u.b9(b);
                }
            }
        }
    };
    DatePicker.prototype.cq = function () {
        var _this = this;
        if (this.u != null) {
            window.setTimeout(function () { return _this.u.b5(); }, 0);
        }
        if (this.c != null) {
            this.c.cy();
        }
        this.h.aw(false);
        this.ah = false;
        this.h.aj();
    };
    DatePicker.prototype.focus = function (a) {
        var _this = this;
        if (a === void 0) {
            a = false;
        }
        if (this.o != null) {
            this.o.focus(a);
        }
        if (!this.u.aw && this.ay == true) {
            if (this.ah == false) {
                if (this.al) {
                    return;
                }
                if (this.au == false) {
                    this.dc();
                    this.ah = true;
                    window.setTimeout(function () { return _this.cv(); }, 0);
                }
                else {
                    if (this.ay == true && this.ar == false) {
                        this.dc();
                        this.ah = true;
                        window.setTimeout(function () { return _this.cv(); }, 0);
                    }
                }
            }
            else {
                this.ah = false;
            }
        }
    };
    DatePicker.prototype.cw = function () {
        this.ah = false;
    };
    DatePicker.prototype.df = function () {
        if (this.o != null) {
            this.o.dp();
        }
    };
    DatePicker.prototype.cv = function () {
        this.c.cq();
    };
    DatePicker.prototype.c3 = function () {
        var a = new GotFocusEventArgs();
        this.c5(a);
    };
    DatePicker.prototype.c4 = function () {
        var a = new LostFocusEventArgs();
        this.c7(a);
    };
    DatePicker.prototype.di = function () {
    };
    DatePicker.prototype.dg = function () {
    };
    DatePicker.prototype.bf = function () {
        return this.b();
    };
    DatePicker.prototype.bv = function () {
        var a = this.b();
        return a.g();
    };
    DatePicker.prototype.b = function () {
        var a = new DatePickerVisualModelExport();
        a.e = this.y;
        a.d = this.w;
        a.c = this.u.bc();
        a.b = this.q.fe();
        a.a = this.c.bj();
        if (this.ad != null) {
            var b = this.ad;
            if (this.h != null && b.q == null) {
                var c = this.h.d;
                var d = FontUtil.getFontInfoFromString(c, b.fontString);
                b.q = d.q;
                b.f = d.f;
                b.r = d.r;
                b.t = d.t;
                b.u = d.u;
                b.v = d.v;
            }
            if (b.q != null) {
                a.h = b.q;
            }
            if (!isNaN_(b.f)) {
                a.f = b.f;
            }
            if (b.v != null) {
                a.l = b.v;
            }
            if (b.t != null) {
                a.j = b.t;
            }
            if (b.r != null) {
                a.i = b.t;
            }
        }
        return a;
    };
    DatePicker.prototype.c5 = function (a) {
        if (null != this.gotFocus) {
            this.gotFocus(this, a);
        }
    };
    DatePicker.prototype.c7 = function (a) {
        if (null != this.lostFocus) {
            this.lostFocus(this, a);
        }
    };
    DatePicker.prototype.c6 = function (a) {
        if (null != this.keyDown) {
            this.keyDown(this, a);
        }
    };
    DatePicker.prototype.c2 = function (a) {
        if (null != this.changing) {
            this.changing(this, a);
        }
    };
    DatePicker.$t = markType(DatePicker, 'DatePicker', Base.$, [INotifyPropertyChanged_$type]);
    DatePicker.bq = "M20 3h-1V1h-2v2H7V1H5v2H4c-1.1 0-2 .9-2 2v16c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm0 18H4V8h16v13z";
    DatePicker.br = "M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z";
    DatePicker.ab = null;
    return DatePicker;
}(Base));
export { DatePicker };
