import { CheckboxChangeEventArgs as CheckboxChangeEventArgs_internal } from "./CheckboxChangeEventArgs";
import { ensureBool } from "igniteui-react-core";
var IgrCheckboxChangeEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrCheckboxChangeEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrCheckboxChangeEventArgs.prototype.createImplementation = function () {
        return new CheckboxChangeEventArgs_internal();
    };
    Object.defineProperty(IgrCheckboxChangeEventArgs.prototype, "nativeElement", {
        get: function () {
            return this._implementation.nativeElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrCheckboxChangeEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrCheckboxChangeEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrCheckboxChangeEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrCheckboxChangeEventArgs.prototype, "isChecked", {
        get: function () {
            return this.i.isChecked;
        },
        set: function (v) {
            this.i.isChecked = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrCheckboxChangeEventArgs.prototype, "isIndeterminate", {
        get: function () {
            return this.i.isIndeterminate;
        },
        set: function (v) {
            this.i.isIndeterminate = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    return IgrCheckboxChangeEventArgs;
}());
export { IgrCheckboxChangeEventArgs };
