import { GotFocusEventArgs as GotFocusEventArgs_internal } from "./GotFocusEventArgs";
var IgrGotFocusEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrGotFocusEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGotFocusEventArgs.prototype.createImplementation = function () {
        return new GotFocusEventArgs_internal();
    };
    Object.defineProperty(IgrGotFocusEventArgs.prototype, "nativeElement", {
        get: function () {
            return this._implementation.nativeElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGotFocusEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGotFocusEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrGotFocusEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    return IgrGotFocusEventArgs;
}());
export { IgrGotFocusEventArgs };
