import { LostFocusEventArgs as LostFocusEventArgs_internal } from "./LostFocusEventArgs";
var IgrLostFocusEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrLostFocusEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrLostFocusEventArgs.prototype.createImplementation = function () {
        return new LostFocusEventArgs_internal();
    };
    Object.defineProperty(IgrLostFocusEventArgs.prototype, "nativeElement", {
        get: function () {
            return this._implementation.nativeElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrLostFocusEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrLostFocusEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrLostFocusEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    return IgrLostFocusEventArgs;
}());
export { IgrLostFocusEventArgs };
