import { SelectedValueChangedEventArgs as SelectedValueChangedEventArgs_internal } from "./SelectedValueChangedEventArgs";
var IgrSelectedValueChangedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrSelectedValueChangedEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrSelectedValueChangedEventArgs.prototype.createImplementation = function () {
        return new SelectedValueChangedEventArgs_internal();
    };
    Object.defineProperty(IgrSelectedValueChangedEventArgs.prototype, "nativeElement", {
        get: function () {
            return this._implementation.nativeElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrSelectedValueChangedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrSelectedValueChangedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrSelectedValueChangedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrSelectedValueChangedEventArgs.prototype, "oldValue", {
        get: function () {
            return this.i.oldValue;
        },
        set: function (v) {
            this.i.oldValue = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrSelectedValueChangedEventArgs.prototype, "newValue", {
        get: function () {
            return this.i.newValue;
        },
        set: function (v) {
            this.i.newValue = v;
        },
        enumerable: false,
        configurable: true
    });
    return IgrSelectedValueChangedEventArgs;
}());
export { IgrSelectedValueChangedEventArgs };
