import { __extends } from "tslib";
import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { XButton as XButton_internal } from './XButton';
import { IgrXButton as IgrXButton } from './igr-x-button';
var IgrXButtonGroupButtonCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrXButtonGroupButtonCollection, _super);
    function IgrXButtonGroupButtonCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgrXButton.$type) {
            IgrXButton.$type = markType(IgrXButton, "IgrXButton");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrXButtonGroupButtonCollection.prototype._createInnerColl = function () {
        if (!IgrXButton.$type) {
            IgrXButton.$type = markType(IgrXButton, "IgrXButton");
        }
        var coll = new SyncableObservableCollection$2(IgrXButton.$type, XButton_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = IgrXButton._createFromInternal(int);
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    };
    return IgrXButtonGroupButtonCollection;
}(IgCollection));
export { IgrXButtonGroupButtonCollection };
