import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { XButton } from "./XButton";
import { FontInfo } from "igniteui-react-core";
import { ButtonGroupOrientation } from "./ButtonGroupOrientation";
import { ButtonGroupDisplayStyle } from "./ButtonGroupDisplayStyle";
import { BaseControlTheme } from "igniteui-react-core";
import { ControlDisplayDensity } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { XButtonGroupButtonCollection } from "./XButtonGroupButtonCollection";
import { ButtonGroupSelectionChangedEventArgs } from "./ButtonGroupSelectionChangedEventArgs";
import { ButtonGroupVisualModelExport } from "./ButtonGroupVisualModelExport";
/**
 * @hidden
 */
export declare class ButtonGroupView extends Base {
    static $t: Type;
    constructor();
    a: XButtonGroup;
    v(): void;
    d(): boolean;
    p(a: XButton): void;
    r(a: XButton): void;
    q(): void;
    private g;
    private b;
    private f;
    get l(): any;
    get ab(): Path;
    get e(): boolean;
    t(a: DomRenderer): void;
    private m;
    z(a: string): void;
    y(): void;
    private n;
    w(): void;
    private c;
    private h;
    private i;
    private j;
    private k;
    s(): void;
    u(): void;
    aa(a: FontInfo): void;
    x(a: XButton): void;
    o(a: any): void;
}
/**
 * @hidden
 */
export declare class XButtonGroup extends Base implements INotifyPropertyChanged {
    static $t: Type;
    constructor();
    private h;
    get i(): ButtonGroupDisplayStyle;
    set i(a: ButtonGroupDisplayStyle);
    private n;
    get p(): BaseControlTheme;
    set p(a: BaseControlTheme);
    private c4;
    appendContentChild(a: any): void;
    private c3;
    private c6;
    private r;
    get t(): ControlDisplayDensity;
    set t(a: ControlDisplayDensity);
    private q;
    get s(): ControlDisplayDensity;
    set s(a: ControlDisplayDensity);
    private a;
    get d(): number[];
    set d(a: number[]);
    private u;
    private de;
    private c;
    private b;
    private _view;
    get view(): ButtonGroupView;
    set view(a: ButtonGroupView);
    destroy(): void;
    protected da(a: string, b: any, c: any): void;
    protected dc(a: string, b: any, c: any): void;
    private dl;
    private dg;
    private df;
    private aa;
    private dk;
    private dj;
    private di;
    static o: BaseControlTheme;
    ax: number;
    gz: Brush;
    g1: Brush;
    g0: Brush;
    g2: Brush;
    aw: number;
    g6: Brush;
    g3: Brush;
    g7: Brush;
    ha: Brush;
    g4: Brush;
    g5: Brush;
    g8: Brush;
    g9: Brush;
    static av: number;
    static gn: Brush;
    static gp: Brush;
    static go: Brush;
    static gq: Brush;
    static au: number;
    static gu: Brush;
    static gr: Brush;
    static gv: Brush;
    static gy: Brush;
    static gs: Brush;
    static gt: Brush;
    static gw: Brush;
    static gx: Brush;
    static ap: number;
    static fn: Brush;
    static fp: Brush;
    static fo: Brush;
    static fq: Brush;
    static ao: number;
    static fu: Brush;
    static fr: Brush;
    static fv: Brush;
    static fy: Brush;
    static fs: Brush;
    static ft: Brush;
    static fw: Brush;
    static fx: Brush;
    ar: number;
    fz: Brush;
    f1: Brush;
    f0: Brush;
    f2: Brush;
    aq: number;
    f6: Brush;
    f3: Brush;
    f7: Brush;
    ga: Brush;
    f4: Brush;
    f5: Brush;
    f8: Brush;
    f9: Brush;
    static at: number;
    static gb: Brush;
    static gd: Brush;
    static gc: Brush;
    static ge: Brush;
    static as: number;
    static gi: Brush;
    static gf: Brush;
    static gj: Brush;
    static gm: Brush;
    static gg: Brush;
    static gh: Brush;
    static gk: Brush;
    static gl: Brush;
    static an: number;
    static fb: Brush;
    static fd: Brush;
    static fc: Brush;
    static fe: Brush;
    static am: number;
    static fi: Brush;
    static ff: Brush;
    static fj: Brush;
    static fm: Brush;
    static fg: Brush;
    static fh: Brush;
    static fk: Brush;
    static fl: Brush;
    private dh;
    private ad;
    get al(): number;
    set al(a: number);
    private dm;
    get ez(): Brush;
    set ez(a: Brush);
    private dp;
    get e1(): Brush;
    set e1(a: Brush);
    private du;
    get e6(): Brush;
    set e6(a: Brush);
    private dr;
    get e3(): Brush;
    set e3(a: Brush);
    private dn;
    get e0(): Brush;
    set e0(a: Brush);
    private dq;
    get e2(): Brush;
    set e2(a: Brush);
    private ac;
    get ak(): number;
    set ak(a: number);
    private dv;
    get e7(): Brush;
    set e7(a: Brush);
    private dy;
    get fa(): Brush;
    set fa(a: Brush);
    private ds;
    get e4(): Brush;
    set e4(a: Brush);
    private dt;
    get e5(): Brush;
    set e5(a: Brush);
    private dw;
    get e8(): Brush;
    set e8(a: Brush);
    private dx;
    get e9(): Brush;
    set e9(a: Brush);
    private ah;
    get a1(): number;
    set a1(a: number);
    private d7;
    get hn(): Brush;
    set hn(a: Brush);
    private d9;
    get hp(): Brush;
    set hp(a: Brush);
    private ee;
    get hu(): Brush;
    set hu(a: Brush);
    private eb;
    get hr(): Brush;
    set hr(a: Brush);
    private ec;
    get hs(): Brush;
    set hs(a: Brush);
    private d8;
    get ho(): Brush;
    set ho(a: Brush);
    private ea;
    get hq(): Brush;
    set hq(a: Brush);
    private ag;
    get a0(): number;
    set a0(a: number);
    private ed;
    get ht(): Brush;
    set ht(a: Brush);
    private ev;
    get h7(): Brush;
    set h7(a: Brush);
    private ey;
    get ia(): Brush;
    set ia(a: Brush);
    private ew;
    get h8(): Brush;
    set h8(a: Brush);
    private ex;
    get h9(): Brush;
    set h9(a: Brush);
    private aj;
    get a3(): number;
    set a3(a: number);
    private ef;
    get hv(): Brush;
    set hv(a: Brush);
    private eh;
    get hx(): Brush;
    set hx(a: Brush);
    private em;
    get h2(): Brush;
    set h2(a: Brush);
    private ej;
    get hz(): Brush;
    set hz(a: Brush);
    private ek;
    get h0(): Brush;
    set h0(a: Brush);
    private eg;
    get hw(): Brush;
    set hw(a: Brush);
    private ei;
    get hy(): Brush;
    set hy(a: Brush);
    private ai;
    get a2(): number;
    set a2(a: number);
    private el;
    get h1(): Brush;
    set h1(a: Brush);
    private er;
    get h3(): Brush;
    set h3(a: Brush);
    private eu;
    get h6(): Brush;
    set h6(a: Brush);
    static readonly cv: string;
    private es;
    get h4(): Brush;
    set h4(a: Brush);
    private et;
    get h5(): Brush;
    set h5(a: Brush);
    private af;
    get az(): number;
    set az(a: number);
    private dz;
    get hb(): Brush;
    set hb(a: Brush);
    private d1;
    get hd(): Brush;
    set hd(a: Brush);
    private d6;
    get hi(): Brush;
    set hi(a: Brush);
    private d3;
    get hf(): Brush;
    set hf(a: Brush);
    private d4;
    get hg(): Brush;
    set hg(a: Brush);
    private d0;
    get hc(): Brush;
    set hc(a: Brush);
    private d2;
    get he(): Brush;
    set he(a: Brush);
    private ae;
    get ay(): number;
    set ay(a: number);
    private d5;
    get hh(): Brush;
    set hh(a: Brush);
    private en;
    get hj(): Brush;
    set hj(a: Brush);
    private eq;
    get hm(): Brush;
    set hm(a: Brush);
    private eo;
    get hk(): Brush;
    set hk(a: Brush);
    private ep;
    get hl(): Brush;
    set hl(a: Brush);
    private j;
    get k(): ButtonGroupOrientation;
    set k(a: ButtonGroupOrientation);
    private static a4;
    private a6;
    get b5(): string;
    set b5(a: string);
    private w;
    private v;
    get disabled(): boolean;
    set disabled(a: boolean);
    private x;
    get z(): boolean;
    set z(a: boolean);
    db(): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    protected ab(): boolean;
    a5(): any;
    bq(): string;
    e(): ButtonGroupVisualModelExport;
    provideContainer(a: DomRenderer): void;
    private f;
    get buttons(): XButtonGroupButtonCollection;
    selectionChanged: (sender: any, args: ButtonGroupSelectionChangedEventArgs) => void;
}
