import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { ControlDisplayDensity } from "igniteui-react-core";
import { HorizontalAlignment } from "igniteui-react-core";
import { ElevationMode } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { ButtonDisplayStyle } from "./ButtonDisplayStyle";
import { BaseControlTheme } from "igniteui-react-core";
import { CornerRadius } from "igniteui-react-core";
import { VerticalAlignment } from "igniteui-react-core";
import { ThemeResolver } from "./ThemeResolver";
import { ButtonClickEventArgs } from "./ButtonClickEventArgs";
import { MouseEventArgs } from "igniteui-react-core";
import { FocusEventArgs } from "igniteui-react-core";
import { ButtonVisualModelExport } from "./ButtonVisualModelExport";
import { Theme } from "./Theme";
/**
 * @hidden
 */
export declare class ButtonView extends Base {
    static $t: Type;
    constructor();
    b: XButton;
    ao(): void;
    g(): boolean;
    k: DomRenderer;
    private d;
    private h;
    get q(): any;
    get s(): any;
    ai(a: DomRenderer): void;
    ak(): void;
    ay(): void;
    as(): void;
    au(a: number): void;
    at(a: number): void;
    aq(): void;
    al(): void;
    ah(): void;
    af(): void;
    am(): void;
    an(): void;
    private t;
    av(): void;
    ap(): void;
    private u;
    private v;
    private w;
    private z;
    private y;
    private aa;
    private ab;
    private f;
    private x;
    ae(): void;
    private e;
    private n;
    private j;
    private i;
    private l;
    private c;
    private m;
    private p;
    private o;
    ag(): void;
    aj(): void;
    ar(): void;
    aw(a: Brush, b: Brush): void;
    ax(a: number, b: ElevationMode): void;
    az(a: FontInfo): void;
    ac(a: any): void;
    ad(): void;
    r(): any;
    a(): number[];
}
/**
 * @hidden
 */
export declare class XButton extends Base implements INotifyPropertyChanged {
    static $t: Type;
    constructor();
    private _view;
    get view(): ButtonView;
    set view(a: ButtonView);
    d9: any;
    destroy(): void;
    protected kd(a: string, b: any, c: any): void;
    protected kf(a: string, b: any, c: any): void;
    private ks;
    private ki;
    j6(): void;
    j5(): void;
    j8(): void;
    kc(): void;
    kb(): void;
    j9(): void;
    ka(a: any): void;
    private kh;
    static m: BaseControlTheme;
    pf: Brush;
    o3: Brush;
    nu: Brush;
    v: ElevationMode;
    o6: Brush;
    o7: Brush;
    o8: Brush;
    da: number;
    dd: number;
    dc: number;
    db: number;
    o5: Brush;
    pd: Brush;
    ky: CornerRadius;
    bp: number;
    o4: Brush;
    pe: Brush;
    pc: Brush;
    pb: Brush;
    o9: Brush;
    pa: Brush;
    n8: Brush;
    n9: Brush;
    oa: Brush;
    cy: number;
    c1: number;
    c0: number;
    cz: number;
    n7: Brush;
    of: Brush;
    kv: CornerRadius;
    bm: number;
    n6: Brush;
    og: Brush;
    oe: Brush;
    od: Brush;
    ob: Brush;
    oc: Brush;
    ou: Brush;
    ov: Brush;
    ow: Brush;
    c6: number;
    c9: number;
    c8: number;
    c7: number;
    ot: Brush;
    o1: Brush;
    kx: CornerRadius;
    bo: number;
    os: Brush;
    o2: Brush;
    o0: Brush;
    oz: Brush;
    ox: Brush;
    oy: Brush;
    oj: Brush;
    ok: Brush;
    ol: Brush;
    c2: number;
    c5: number;
    c4: number;
    c3: number;
    oi: Brush;
    oq: Brush;
    kw: CornerRadius;
    bn: number;
    oh: Brush;
    or: Brush;
    op: Brush;
    oo: Brush;
    om: Brush;
    on: Brush;
    nx: Brush;
    ny: Brush;
    nz: Brush;
    cu: number;
    cx: number;
    cw: number;
    cv: number;
    nw: Brush;
    n4: Brush;
    ku: CornerRadius;
    bl: number;
    nv: Brush;
    n5: Brush;
    n3: Brush;
    n2: Brush;
    n0: Brush;
    n1: Brush;
    private kj;
    private bc;
    get bu(): number;
    set bu(a: number);
    private bb;
    get bt(): number;
    set bt(a: number);
    private d;
    get e(): ButtonDisplayStyle;
    set e(a: ButtonDisplayStyle);
    private p;
    get r(): ControlDisplayDensity;
    set r(a: ControlDisplayDensity);
    private l;
    get n(): BaseControlTheme;
    set n(a: BaseControlTheme);
    private o;
    get q(): ControlDisplayDensity;
    set q(a: ControlDisplayDensity);
    private k8;
    get ng(): Brush;
    set ng(a: Brush);
    private lj;
    get nr(): Brush;
    set nr(a: Brush);
    private lg;
    get no(): Brush;
    set no(a: Brush);
    private k6;
    get ne(): Brush;
    set ne(a: Brush);
    private b0;
    get ct(): number;
    set ct(a: number);
    private by;
    get cr(): number;
    set cr(a: number);
    private bz;
    get cs(): number;
    set cs(a: number);
    private lh;
    get np(): Brush;
    set np(a: Brush);
    private kk;
    get kr(): CornerRadius;
    set kr(a: CornerRadius);
    private k7;
    get nf(): Brush;
    set nf(a: Brush);
    private k9;
    get nh(): Brush;
    set nh(a: Brush);
    private la;
    get ni(): Brush;
    set ni(a: Brush);
    private lb;
    get nj(): Brush;
    set nj(a: Brush);
    private bx;
    get cq(): number;
    set cq(a: number);
    private s;
    get u(): ElevationMode;
    set u(a: ElevationMode);
    private li;
    get nq(): Brush;
    set nq(a: Brush);
    private lf;
    get nn(): Brush;
    set nn(a: Brush);
    private lc;
    get nk(): Brush;
    set nk(a: Brush);
    private ld;
    get nl(): Brush;
    set nl(a: Brush);
    private le;
    get nm(): Brush;
    set nm(a: Brush);
    private a2;
    get bf(): number;
    set bf(a: number);
    private m1;
    get qv(): Brush;
    set qv(a: Brush);
    private m3;
    get qx(): Brush;
    set qx(a: Brush);
    private m4;
    get qy(): Brush;
    set qy(a: Brush);
    private m5;
    get qz(): Brush;
    set qz(a: Brush);
    private ck;
    get dy(): number;
    set dy(a: number);
    private m8;
    get q2(): Brush;
    set q2(a: Brush);
    private m2;
    get qw(): Brush;
    set qw(a: Brush);
    private cn;
    get d1(): number;
    set d1(a: number);
    private cm;
    get d0(): number;
    set d0(a: number);
    private cl;
    get dz(): number;
    set dz(a: number);
    private be;
    get bw(): number;
    set bw(a: number);
    private kq;
    get k3(): CornerRadius;
    set k3(a: CornerRadius);
    private na;
    get q4(): Brush;
    set q4(a: Brush);
    private lz;
    get pu(): Brush;
    set pu(a: Brush);
    private l1;
    get pw(): Brush;
    set pw(a: Brush);
    private l2;
    get px(): Brush;
    set px(a: Brush);
    private l3;
    get py(): Brush;
    set py(a: Brush);
    private b6;
    get dj(): number;
    set dj(a: number);
    private l6;
    get p1(): Brush;
    set p1(a: Brush);
    private l0;
    get pv(): Brush;
    set pv(a: Brush);
    private b9;
    get dm(): number;
    set dm(a: number);
    private b8;
    get dl(): number;
    set dl(a: number);
    private b7;
    get dk(): number;
    set dk(a: number);
    private l8;
    get p3(): Brush;
    set p3(a: Brush);
    private l9;
    get p4(): Brush;
    set p4(a: Brush);
    private l7;
    get p2(): Brush;
    set p2(a: Brush);
    private l4;
    get pz(): Brush;
    set pz(a: Brush);
    private l5;
    get p0(): Brush;
    set p0(a: Brush);
    private a9;
    get br(): number;
    set br(a: number);
    private kn;
    get k0(): CornerRadius;
    set k0(a: CornerRadius);
    private lk;
    get ns(): Brush;
    set ns(a: Brush);
    private lm;
    get pg(): Brush;
    set pg(a: Brush);
    private ln;
    get ph(): Brush;
    set ph(a: Brush);
    private lo;
    get pi(): Brush;
    set pi(a: Brush);
    private b1;
    get de(): number;
    set de(a: number);
    private t;
    get w(): ElevationMode;
    set w(a: ElevationMode);
    private mc;
    get p7(): Brush;
    set p7(a: Brush);
    private ll;
    get nt(): Brush;
    set nt(a: Brush);
    private co;
    get d2(): number;
    set d2(a: number);
    private cb;
    get dp(): number;
    set dp(a: number);
    private ca;
    get dn(): number;
    set dn(a: number);
    private z;
    get aa(): FontInfo;
    set aa(a: FontInfo);
    private nd;
    get q7(): Brush;
    set q7(a: Brush);
    private me;
    get p8(): Brush;
    set p8(a: Brush);
    private nc;
    get q6(): Brush;
    set q6(a: Brush);
    private nb;
    get q5(): Brush;
    set q5(a: Brush);
    private m9;
    get q3(): Brush;
    set q3(a: Brush);
    private m6;
    get q0(): Brush;
    set q0(a: Brush);
    private m7;
    get q1(): Brush;
    set q1(a: Brush);
    private ma;
    get p5(): Brush;
    set p5(a: Brush);
    private mb;
    get p6(): Brush;
    set p6(a: Brush);
    private a3;
    get bg(): number;
    set bg(a: number);
    private kl;
    get kt(): CornerRadius;
    set kt(a: CornerRadius);
    private mq;
    get qk(): Brush;
    set qk(a: Brush);
    private ms;
    get qm(): Brush;
    set qm(a: Brush);
    private mt;
    get qn(): Brush;
    set qn(a: Brush);
    private mu;
    get qo(): Brush;
    set qo(a: Brush);
    private cg;
    get du(): number;
    set du(a: number);
    private mx;
    get qr(): Brush;
    set qr(a: Brush);
    private mr;
    get ql(): Brush;
    set ql(a: Brush);
    private cj;
    get dx(): number;
    set dx(a: number);
    private ci;
    get dw(): number;
    set dw(a: number);
    private ch;
    get dv(): number;
    set dv(a: number);
    private bd;
    get bv(): number;
    set bv(a: number);
    private kp;
    get k2(): CornerRadius;
    set k2(a: CornerRadius);
    private mz;
    get qt(): Brush;
    set qt(a: Brush);
    private m0;
    get qu(): Brush;
    set qu(a: Brush);
    private my;
    get qs(): Brush;
    set qs(a: Brush);
    private mv;
    get qp(): Brush;
    set qp(a: Brush);
    private mw;
    get qq(): Brush;
    set qq(a: Brush);
    private lp;
    get pj(): Brush;
    set pj(a: Brush);
    private lr;
    get pl(): Brush;
    set pl(a: Brush);
    private ls;
    get pm(): Brush;
    set pm(a: Brush);
    private lt;
    get pn(): Brush;
    set pn(a: Brush);
    private b2;
    get df(): number;
    set df(a: number);
    private md;
    get pq(): Brush;
    set pq(a: Brush);
    private lq;
    get pk(): Brush;
    set pk(a: Brush);
    private b5;
    get di(): number;
    set di(a: number);
    private b4;
    get dh(): number;
    set dh(a: number);
    private b3;
    get dg(): number;
    set dg(a: number);
    private a8;
    get bq(): number;
    set bq(a: number);
    private km;
    get kz(): CornerRadius;
    set kz(a: CornerRadius);
    private lx;
    get ps(): Brush;
    set ps(a: Brush);
    private ly;
    get pt(): Brush;
    set pt(a: Brush);
    private lw;
    get pr(): Brush;
    set pr(a: Brush);
    private lu;
    get po(): Brush;
    set po(a: Brush);
    private lv;
    get pp(): Brush;
    set pp(a: Brush);
    private mf;
    get p9(): Brush;
    set p9(a: Brush);
    private mh;
    get qb(): Brush;
    set qb(a: Brush);
    private mi;
    get qc(): Brush;
    set qc(a: Brush);
    private mj;
    get qd(): Brush;
    set qd(a: Brush);
    private cc;
    get dq(): number;
    set dq(a: number);
    private mm;
    get qg(): Brush;
    set qg(a: Brush);
    private mg;
    get qa(): Brush;
    set qa(a: Brush);
    private cf;
    get dt(): number;
    set dt(a: number);
    private ce;
    get ds(): number;
    set ds(a: number);
    private cd;
    get dr(): number;
    set dr(a: number);
    private ba;
    get bs(): number;
    set bs(a: number);
    private ko;
    get k1(): CornerRadius;
    set k1(a: CornerRadius);
    private mo;
    get qi(): Brush;
    set qi(a: Brush);
    private mp;
    get qj(): Brush;
    set qj(a: Brush);
    private mn;
    get qh(): Brush;
    set qh(a: Brush);
    private mk;
    get qe(): Brush;
    set qe(a: Brush);
    private ml;
    get qf(): Brush;
    set qf(a: Brush);
    private static d5;
    private ei;
    get hu(): string;
    set hu(a: string);
    private static d4;
    private eh;
    get hs(): string;
    set hs(a: string);
    private ee;
    get fw(): string;
    set fw(a: string);
    private ed;
    get ff(): string;
    set ff(a: string);
    private ef;
    get g0(): string;
    set g0(a: string);
    private eg;
    get g2(): string;
    set g2(a: string);
    private eb;
    get e7(): string;
    set e7(a: string);
    private d6;
    get ea(): any;
    set ea(a: any);
    private ej;
    get h2(): string;
    set h2(a: string);
    private cp;
    private ak;
    get aw(): boolean;
    get d3(): number;
    set d3(a: number);
    private ec;
    get e9(): string;
    set e9(a: string);
    private aj;
    get av(): boolean;
    set av(a: boolean);
    private am;
    get focused(): boolean;
    set focused(a: boolean);
    private an;
    get az(): boolean;
    set az(a: boolean);
    private ah;
    get at(): boolean;
    set at(a: boolean);
    private ad;
    get ap(): boolean;
    set ap(a: boolean);
    private af;
    get ar(): boolean;
    set ar(a: boolean);
    private ao;
    get a0(): boolean;
    set a0(a: boolean);
    private al;
    get disabled(): boolean;
    set disabled(a: boolean);
    private ai;
    get au(): boolean;
    set au(a: boolean);
    private ag;
    get as(): boolean;
    set as(a: boolean);
    private a5;
    get bi(): number;
    set bi(a: number);
    private a7;
    get bk(): number;
    set bk(a: number);
    private a6;
    get bj(): number;
    set bj(a: number);
    private a4;
    get bh(): number;
    set bh(a: number);
    private k4;
    get k5(): HorizontalAlignment;
    set k5(a: HorizontalAlignment);
    private q8;
    get q9(): VerticalAlignment;
    set q9(a: VerticalAlignment);
    private ae;
    get aq(): boolean;
    set aq(a: boolean);
    ke(): void;
    private get a();
    private j3;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    appendButtonContent(a: any): void;
    clearButtonContent(): void;
    getButtonContent(): any;
    protected a1(): boolean;
    d7(): any;
    f0(): string;
    b(): ButtonVisualModelExport;
    provideContainer(a: DomRenderer): void;
    clicked: (sender: any, args: ButtonClickEventArgs) => void;
    mouseEnter: (sender: any, args: MouseEventArgs) => void;
    mouseLeave: (sender: any, args: MouseEventArgs) => void;
    gotFocus: (sender: any, args: FocusEventArgs) => void;
    lostFocus: (sender: any, args: FocusEventArgs) => void;
    static i: Theme;
    static h: Theme;
    static j: Theme;
    static k: ThemeResolver;
}
