import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { Tuple$2 } from "igniteui-react-core";
import { SVGNode } from "igniteui-react-core";
import { FastIterationDictionary$2 } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { IIcon } from "igniteui-react-core";
import { BaseControlTheme } from "igniteui-react-core";
import { BrushCollection } from "igniteui-react-core";
import { IconClickedEventArgs } from "./IconClickedEventArgs";
import { IconVisualModelExport } from "./IconVisualModelExport";
/**
 * @hidden
 */
export declare class IconView extends Base {
    static $t: Type;
    constructor();
    c: XIcon;
    ag(): void;
    i(): boolean;
    s: DomRenderer;
    private f;
    private l;
    get w(): any;
    get x(): any;
    get b(): any[];
    get j(): boolean;
    n: List$1<Tuple$2<SVGNode, any>>;
    o: List$1<Tuple$2<SVGNode, any>>;
    p: List$1<Tuple$2<SVGNode, any>>;
    q: List$1<Tuple$2<SVGNode, any>>;
    r: List$1<Tuple$2<SVGNode, any>>;
    d: FastIterationDictionary$2<string, List$1<Tuple$2<SVGNode, any>>>;
    e: FastIterationDictionary$2<string, List$1<Tuple$2<SVGNode, any>>>;
    ae(a: DomRenderer): void;
    ao(a: string): void;
    ap(a: string[]): void;
    an(a: string): void;
    private y;
    al(a: string): void;
    private h;
    am(): void;
    ar(): void;
    private k;
    ai(a: Brush, b: string): void;
    aj(a: any, b: Brush): void;
    ak(a: any, b: Brush): void;
    private z;
    ah(): void;
    private aa;
    private ab;
    private g;
    private v;
    private u;
    private t;
    private m;
    ac(): void;
    af(): void;
    aq(a: FontInfo): void;
    a(): number[];
    private ad;
}
/**
 * @hidden
 */
export declare class XIcon extends Base implements INotifyPropertyChanged, IIcon {
    static $t: Type;
    constructor();
    private _view;
    get view(): IconView;
    set view(a: IconView);
    destroy(): void;
    protected cb(a: string, b: any, c: any): void;
    protected ce(a: string, b: any, c: any): void;
    private ci;
    protected get r(): boolean;
    private ch;
    private cg;
    private cd;
    static cz: Brush;
    static c4: Brush;
    static c3: Brush;
    static c0: Brush;
    static c1: Brush;
    static c2: Brush;
    static ah: number;
    static ag: number;
    private j;
    get k(): BaseControlTheme;
    set k(a: BaseControlTheme);
    private cj;
    get cw(): Brush;
    set cw(a: Brush);
    private ck;
    get cx(): Brush;
    set cx(a: Brush);
    private cl;
    get cy(): Brush;
    set cy(a: Brush);
    private v;
    get af(): number;
    set af(a: number);
    private cm;
    get fill(): Brush;
    set fill(a: Brush);
    private cu;
    get dc(): Brush;
    set dc(a: Brush);
    private z;
    get al(): number;
    set al(a: number);
    private cv;
    get dd(): Brush;
    set dd(a: Brush);
    private cn;
    get c5(): Brush;
    set c5(a: Brush);
    private co;
    get c6(): Brush;
    set c6(a: Brush);
    private x;
    get aj(): number;
    set aj(a: number);
    private cp;
    get c7(): Brush;
    set c7(a: Brush);
    private c;
    get e(): BrushCollection;
    set e(a: BrushCollection);
    private d;
    get f(): BrushCollection;
    set f(a: BrushCollection);
    private cq;
    get c8(): Brush;
    set c8(a: Brush);
    private cr;
    get c9(): Brush;
    set c9(a: Brush);
    private cs;
    get da(): Brush;
    set da(a: Brush);
    private ct;
    get db(): Brush;
    set db(a: Brush);
    private aw;
    get a7(): string;
    set a7(a: string);
    private az;
    get svgPath(): string;
    set svgPath(a: string);
    private ay;
    get svg(): string;
    set svg(a: string);
    private a;
    get b(): string[];
    set b(a: string[]);
    b9(): void;
    ca(): void;
    private l;
    get m(): FontInfo;
    set m(a: FontInfo);
    private static at;
    private ax;
    get bh(): string;
    set bh(a: string);
    private ar;
    private n;
    get q(): boolean;
    get as(): number;
    set as(a: number);
    private av;
    get a4(): string;
    set a4(a: string);
    private p;
    get t(): boolean;
    set t(a: boolean);
    private o;
    get disabled(): boolean;
    set disabled(a: boolean);
    private y;
    get ak(): number;
    set ak(a: number);
    private ab;
    get an(): number;
    set an(a: number);
    private ac;
    get ao(): number;
    set ao(a: number);
    private ad;
    get ap(): number;
    set ap(a: number);
    private aa;
    get am(): number;
    set am(a: number);
    private ae;
    get aq(): number;
    set aq(a: number);
    private w;
    get ai(): number;
    set ai(a: number);
    cc(): void;
    clicked: (sender: any, args: IconClickedEventArgs) => void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    b7(): void;
    protected u(): boolean;
    au(): any;
    a9(): string;
    g(): IconVisualModelExport;
    provideContainer(a: DomRenderer): void;
}
