import * as React from 'react';
import { XInputGroupItem } from "./XInputGroupItem";
import { ContentChildrenManager } from "igniteui-react-core";
export declare abstract class IgrXInputGroupItem<P extends IIgrXInputGroupItemProps = IIgrXInputGroupItemProps> extends React.Component<P, {}> {
    protected createImplementation(): XInputGroupItem;
    protected _implementation: any;
    protected mounted: boolean;
    get nativeElement(): HTMLElement;
    /**
     * @hidden
     */
    get i(): XInputGroupItem; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrXInputGroupItem;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): any;
    /**
     * Gets or sets name to use for the button.
    */
    get name(): string;
    set name(v: string);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
}
export interface IIgrXInputGroupItemProps {
    children?: React.ReactNode;
    /**
     * Gets or sets name to use for the button.
    */
    name?: string;
}
