/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, runOn, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, delegateRemove, enumGetBox, delegateCombine, Number_$type } from "igniteui-react-core";
import { DomWrapper_$type } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { DayOfWeek_$type } from "./DayOfWeek";
import { DayInfo } from "./DayInfo";
import { XButton } from "./XButton";
import { XIcon } from "./XIcon";
import { dateMinValue, dateGetMonth, dateNow, dateAddYears, dateFromValues, dateMaxValue, dateGetDate, dateAddDays, dateAddMonths } from "igniteui-react-core";
import { parseBool } from "igniteui-react-core";
import { SRProvider } from "igniteui-react-core";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { FirstWeek_$type } from "./FirstWeek";
import { BrushUtil } from "igniteui-react-core";
import { ObservableCollection$1 } from "igniteui-react-core";
import { SelectedValueChangedEventArgs } from "./SelectedValueChangedEventArgs";
import { CornerRadius } from "igniteui-react-core";
import { CalendarVisualModelExport } from "./CalendarVisualModelExport";
import { ButtonVisualModelExport } from "./ButtonVisualModelExport";
import { TextElementsVisualModelExport } from "./TextElementsVisualModelExport";
import { AppearanceHelper } from "igniteui-react-core";
import { NativeUI } from "igniteui-react-core";
import { FontUtil } from "igniteui-react-core";
import { truncate, intDivide, isNaN_ } from "igniteui-react-core";
import { stringIsNullOrWhiteSpace } from "igniteui-react-core";
import { timeSpanTotalDays } from "igniteui-react-core";
/**
 * @hidden
 */
export let CalendarView = /*@__PURE__*/ (() => {
    class CalendarView extends Base {
        constructor() {
            super();
            this.n = null;
            this.o = null;
            this.t = null;
            this.q = null;
            this.u = null;
            this.s = null;
            this.r = null;
            this.g = new List$1(DomWrapper_$type, 0);
            this.f = new List$1(DomWrapper_$type, 0);
            this.h = new List$1(DomWrapper_$type, 0);
            this.j = new List$1(DomWrapper_$type, 0);
            this.i = new List$1(DomWrapper_$type, 0);
            this.e = new List$1(DomWrapper_$type, 0);
            this.p = null;
            this.w = null;
            this.c = null;
            this.m = null;
            this.w = "day";
            this.p = null;
        }
        k() {
            return this.e;
        }
        l() {
            return this.i;
        }
        ao() {
        }
        an(a) {
            if (a == null) {
                this.m = null;
                return;
            }
            this.m = a;
            this.m.rootWrapper.setStyleProperty("background-color", "rgb(255, 255, 255)");
            let b = Math.round(a.rootWrapper.width());
            let c = Math.round(a.rootWrapper.height());
            this.aa();
            this.a2();
            this.a3();
            this.a0();
            let d = this.m.rootWrapper;
            d.listen("keydown", runOn(this, this.z));
            d.listen("focus", runOn(this, this.y));
        }
        x() {
            return this.w;
        }
        aa() {
            if (this.m != null) {
                this.n = this.m.createElement("div");
                this.n.setStyleProperty("display", "flex");
                this.n.setStyleProperty("width", "100%");
                this.n.setStyleProperty("height", "100%");
                this.o = this.m.createElement("div");
                this.o.setStyleProperty("height", "100%");
                this.o.setStyleProperty("width", "100%");
                this.t = this.m.createElement("div");
                this.ad();
                this.n.append(this.o);
                this.m.append(this.n);
                for (let a = 0; a < 42; a++) {
                    let b = this.m.createElement("div");
                    this.f.add(b);
                }
                this.ab();
                this.a8();
                this.q = this.m.createElement("div");
                this.q.setStyleProperty("height", "100%");
                this.m.append(this.q);
                for (let c = 0; c < 12; c++) {
                    let d = this.m.createElement("div");
                    this.h.add(d);
                }
                this.ac();
                for (let e = 0; e < 12; e++) {
                    let f = this.q.getChildAt(e);
                    f.listen("click", runOn(this, this.ai));
                }
                this.q.hide();
                this.u = this.m.createElement("div");
                this.u.setStyleProperty("height", "100%");
                this.m.append(this.u);
                for (let g = 0; g < 7; g++) {
                    let h = this.m.createElement("div");
                    this.j.add(h);
                }
                this.ae();
                for (let i = 0; i < 7; i++) {
                    let j = this.u.getChildAt(i);
                    j.listen("click", runOn(this, this.bd));
                }
                this.u.listen("wheel", runOn(this, this.be));
                this.u.hide();
            }
        }
        ad() {
            if (this.m != null) {
                this.t.setStyleProperty("display", "flex");
                this.t.setStyleProperty("flex-direction", "column");
                this.t.setStyleProperty("padding-top", "26px");
                this.t.setStyleProperty("width", "12%");
                let a = this.c.ag();
                for (let b = 0; b < 6; b++) {
                    let c = this.m.createElement("div");
                    c.setAttribute("aria-hidden", "true");
                    c.setStyleProperty("text-align", "center");
                    c.setStyleProperty("vertical-align", "middle");
                    c.setStyleProperty("height", "30px");
                    c.setStyleProperty("width", "25px");
                    c.setStyleProperty("border-width", "0px 1px 0px 0px");
                    c.setStyleProperty("border-style", "solid");
                    c.setStyleProperty("border-color", "rgb(163, 172, 184)");
                    let d = this.m.createElement("span");
                    d.setAttribute("aria-hidden", "true");
                    d.setStyleProperty("font", "14px Verdana");
                    d.setStyleProperty("color", "rgb(24, 29, 31)");
                    c.append(d);
                    this.i.add(d);
                    d.setText(a._inner[b].toString());
                    this.t.append(c);
                }
            }
        }
        a4() {
            if (this.t != null) {
                let a = this.c.ag();
                this.i.clear();
                for (let b = 0; b < 6; b++) {
                    let c = this.t.getChildAt(b);
                    let d = c.getChildAt(0);
                    d.setText(a._inner[b].toString());
                    this.i.add(d);
                }
            }
        }
        a8() {
            if (this.t != null) {
                if (this.c.af == true) {
                    this.t.show();
                    this.t.setStyleProperty("width", "12%");
                    this.t.parent().setStyleProperty("max-width", "245px");
                    this.t.parent().getChildAt(1).setStyleProperty("width", "88%");
                }
                else {
                    this.t.hide();
                    this.t.parent().setStyleProperty("max-width", "231px");
                    this.t.parent().getChildAt(1).setStyleProperty("width", "100%");
                }
            }
        }
        ab() {
            if (this.m != null) {
                this.o.setStyleProperty("display", "flex");
                this.o.setStyleProperty("flex-direction", "column");
                this.o.setStyleProperty("justify-content", "space-evenly");
                let a = this.m.createElement("div");
                a.setStyleProperty("display", "flex");
                a.setStyleProperty("justify-content", "space-evenly");
                a.setStyleProperty("width", "100%");
                a.setAttribute("role", "row");
                let b = this.m.createElement("div");
                b.setStyleProperty("width", "15%");
                let c = this.m.createElement("div");
                c.setStyleProperty("width", "20%");
                let d = this.m.createElement("div");
                d.setStyleProperty("width", "20%");
                let e = this.m.createElement("div");
                e.setStyleProperty("width", "15%");
                a.append(b);
                a.append(c);
                a.append(d);
                a.append(e);
                this.o.append(a);
                let f = this.m.createElement("div");
                f.setStyleProperty("width", "100%");
                f.setStyleProperty("height", "100%");
                f.setStyleProperty("display", "flex");
                f.setStyleProperty("flex-direction", "row");
                f.setStyleProperty("justify-content", "space-evenly");
                this.t.setStyleProperty("padding-bottom", "6px");
                f.append(this.t);
                let g = this.m.createElement("div");
                g.setStyleProperty("display", "flex");
                g.setStyleProperty("flex-direction", "column");
                g.setStyleProperty("width", "88%");
                g.setAttribute("role", "grid");
                g.setAttribute("aria-readonly", "true");
                f.append(g);
                this.o.append(f);
                let h = 0;
                for (let i = 0; i < 7; i++) {
                    let j = this.m.createElement("div");
                    j.setAttribute("role", "row");
                    j.setStyleProperty("display", "flex");
                    j.setStyleProperty("justify-content", "space-evenly");
                    if (i == 0) {
                        for (let k = 0; k < 7; k++) {
                            let l = this.m.createElement("div");
                            l.setAttribute("role", "columnheader");
                            l.setAttribute("scope", "col");
                            l.setStyleProperty("text-align", "center");
                            l.setStyleProperty("vertical-align", "middle");
                            l.setStyleProperty("width", "12%");
                            let m = this.m.createElement("span");
                            m.setStyleProperty("font", "16px Verdana");
                            m.setStyleProperty("color", "rgb(24, 29, 31)");
                            l.append(m);
                            this.e.add(m);
                            j.append(l);
                        }
                        g.append(j);
                    }
                    else {
                        for (let n = 0; n < 7; n++) {
                            let o = this.m.createElement("div");
                            o.setAttribute("role", "gridcell");
                            o.setStyleProperty("justify-content", "center");
                            let p = this.f._inner[h];
                            let q = this.m.createElement("span");
                            q.setAttribute("aria-hidden", "true");
                            p.append(q);
                            this.af(o, p, h);
                            p.parent().setStyleProperty("max-height", "30px");
                            p.parent().setStyleProperty("display", "flex");
                            o.setStyleProperty("width", "12%");
                            o.setStyleProperty("height", "100%");
                            j.append(o);
                            h++;
                        }
                        g.append(j);
                    }
                }
                this.s = this.m.createElement("div");
                this.s.setStyleProperty("display", "flex");
                this.s.setStyleProperty("padding-bottom", "4px");
                let r = this.m.createElement("div");
                r.setStyleProperty("width", "100%");
                r.setStyleProperty("justify-content", "center");
                this.r = this.m.createElement("div");
                this.r.setAttribute("aria-hidden", "true");
                let s = this.m.createElement("span");
                s.setAttribute("aria-hidden", "true");
                this.r.append(s);
                this.c.cm(r, this.r);
                this.r.parent().setAttribute("aria-hidden", "true");
                this.r.parent().parent().setAttribute("tabindex", "-1");
                this.r.parent().parent().setAttribute("aria-readonly", "true");
                this.r.parent().parent().setAttribute("aria-selected", "false");
                this.r.parent().parent().setAttribute("aria-disabled", "false");
                this.r.parent().parent().setAttribute("data-is-focusable", "true");
                this.s.append(r);
                this.o.append(this.s);
                this.a7();
                this.c.cf();
            }
        }
        ac() {
            if (this.m != null) {
                this.q.setStyleProperty("display", "flex");
                this.q.setStyleProperty("flex-direction", "row");
                this.q.setStyleProperty("flex-wrap", "wrap");
                this.q.setStyleProperty("margin", "2px");
                this.q.setStyleProperty("justify-content", "center");
                this.q.setStyleProperty("width", "100%");
                this.q.setStyleProperty("height", "100%");
                this.q.setAttribute("role", "grid");
                this.q.setAttribute("aria-readonly", "true");
                for (let a = 0; a < 12; a++) {
                    let b = this.m.createElement("div");
                    b.setStyleProperty("margin", "5px");
                    b.setAttribute("data-month", (a + 1).toString());
                    let c = this.h._inner[a];
                    c.setAttribute("aria-hidden", "true");
                    this.c.cl(b, c);
                    b.setStyleProperty("width", "28%");
                    let d = b.getChildAt(0);
                    d.setStyleProperty("width", "100%");
                    let e = this.m.createElement("span");
                    e.setAttribute("aria-hidden", "true");
                    let f;
                    let g = a + 1;
                    f = this.c.e(g, a);
                    c.parent().parent().setAttribute("aria-label", f[0]);
                    e.setText(f[1]);
                    c.append(e);
                    c.parent().setAttribute("aria-hidden", "true");
                    c.parent().parent().setAttribute("tabindex", "-1");
                    c.parent().parent().setAttribute("aria-readonly", "true");
                    c.parent().parent().setAttribute("aria-selected", "false");
                    c.parent().parent().setAttribute("aria-disabled", "false");
                    c.parent().parent().setAttribute("data-is-focusable", "true");
                    c.setAttribute("data-index", a.toString());
                    this.q.append(b);
                }
            }
        }
        bc() {
            for (let a = 0; a < 12; a++) {
                let b = this.h._inner[a];
                let c;
                let d = a + 1;
                c = this.c.e(d, a);
                b.parent().parent().setAttribute("aria-label", c[0]);
                let e = b.getChildAt(0);
                e.setText(c[1]);
            }
        }
        ae() {
            if (this.m != null) {
                this.u.setStyleProperty("width", "100%");
                this.u.setStyleProperty("height", "100%");
                let a = this.c.aq.getFullYear() - 3;
                this.u.setStyleProperty("padding", "5px");
                this.u.setAttribute("role", "grid");
                this.u.setAttribute("aria-readonly", "true");
                for (let b = 0; b < 7; b++) {
                    let c = this.m.createElement("div");
                    let d = this.j._inner[b];
                    d.setAttribute("aria-hidden", "true");
                    this.c.cn(c, d, b);
                    d.parent().setAttribute("aria-hidden", "true");
                    d.parent().parent().setAttribute("tabindex", "-1");
                    d.parent().parent().setAttribute("aria-readonly", "true");
                    d.parent().parent().setAttribute("aria-selected", "false");
                    d.parent().parent().setAttribute("aria-disabled", "false");
                    d.parent().parent().setAttribute("data-is-focusable", "true");
                    c.setStyleProperty("width", "100%");
                    c.setStyleProperty("height", "14%");
                    c.setStyleProperty("justify-content", "center");
                    let e = c.getChildAt(0);
                    e.setStyleProperty("width", "98%");
                    let f = this.m.createElement("span");
                    f.setAttribute("aria-hidden", "true");
                    f.setText(a.toString());
                    a++;
                    d.setAttribute("data-index", b.toString());
                    d.append(f);
                    this.u.append(c);
                }
            }
        }
        a7() {
            if (this.m != null) {
                if (this.c.ae == true) {
                    this.s.setStyleProperty("display", "flex");
                }
                else {
                    this.s.setStyleProperty("display", "none");
                }
            }
        }
        a2() {
            if (this.m != null) {
                let a = this.o.getChildAt(0);
                for (let b = 0; b < 4; b++) {
                    let c = this.m.createElement("div");
                    this.g.add(c);
                }
                let d = a.getChildAt(0);
                let e = this.g._inner[0];
                let f = this.m.createElement("div");
                f.setAttribute("aria-hidden", "true");
                e.append(f);
                this.c.ck(d, f, e, "prev");
                e.parent().parent().setAttribute("aria-label", "Previous Month");
                e.parent().setStyleProperty("max-height", "30px");
                e.parent().setStyleProperty("display", "flex");
                e.setAttribute("data-index", "0");
                this.av(e);
                let g = a.getChildAt(1);
                let h = this.g._inner[1];
                let i = this.m.createElement("span");
                i.setAttribute("aria-hidden", "true");
                h.append(i);
                this.c.cj(g, h, "month");
                i = h.getChildAt(0);
                let j = this.c.bx();
                i.setText(j);
                h.parent().parent().setAttribute("aria-label", "Select Month");
                h.parent().setStyleProperty("min-width", "40px");
                h.parent().setStyleProperty("max-height", "30px");
                h.parent().setStyleProperty("display", "flex");
                h.setAttribute("data-index", "1");
                this.av(h);
                let k = a.getChildAt(2);
                let l = this.g._inner[2];
                let m = this.m.createElement("span");
                m.setAttribute("aria-hidden", "true");
                l.append(m);
                this.c.cj(k, l, "year");
                m = this.g._inner[2].getChildAt(0);
                let n = this.c.by();
                m.setText(n);
                l.parent().parent().setAttribute("aria-label", "Select Year");
                l.parent().setStyleProperty("min-width", "40px");
                l.parent().setStyleProperty("max-height", "30px");
                l.parent().setStyleProperty("display", "flex");
                l.setAttribute("data-index", "2");
                this.av(l);
                let o = a.getChildAt(3);
                let p = this.g._inner[3];
                let q = this.m.createElement("div");
                q.setAttribute("aria-hidden", "true");
                p.append(q);
                this.c.ck(o, q, p, "next");
                p.parent().parent().setAttribute("aria-label", "Next Month");
                p.parent().setStyleProperty("max-height", "30px");
                p.parent().setStyleProperty("display", "flex");
                p.setAttribute("data-index", "3");
                this.av(p);
                let r = this.c.a();
                for (let s = 0; s < this.g.count; s++) {
                    if (r[s] == true) {
                        this.g._inner[s].setAttribute("data-disabled", "true");
                    }
                    else {
                        this.g._inner[s].setAttribute("data-disabled", "false");
                    }
                }
                d.listen("click", runOn(this, this.ap));
                o.listen("click", runOn(this, this.ak));
                g.listen("click", runOn(this, this.aj));
                k.listen("click", runOn(this, this.bf));
            }
        }
        bb() {
            let a = this.g._inner[1];
            let b = a.getChildAt(0);
            let c = this.c.bx();
            b.setText(c);
        }
        av(a) {
            a.setAttribute("aria-hidden", "true");
            a.parent().setAttribute("aria-hidden", "true");
            a.parent().parent().setAttribute("tabindex", "-1");
            a.parent().parent().setAttribute("aria-readonly", "true");
            a.parent().parent().setAttribute("aria-selected", "false");
            a.parent().parent().setAttribute("aria-disabled", "false");
            a.parent().parent().setAttribute("data-is-focusable", "true");
            a.setAttribute("data-section", "header");
            a.setAttribute("data-disabled", "false");
        }
        a3() {
            if (this.m != null) {
                let a = this.o.getChildAt(1).getChildAt(1).getChildAt(0);
                let b = new List$1(DayOfWeek_$type, 0);
                switch (this.c.l) {
                    case 0:
                        b.add(0);
                        b.add(1);
                        b.add(2);
                        b.add(3);
                        b.add(4);
                        b.add(5);
                        b.add(6);
                        break;
                    case 1:
                        b.add(1);
                        b.add(2);
                        b.add(3);
                        b.add(4);
                        b.add(5);
                        b.add(6);
                        b.add(0);
                        break;
                    case 2:
                        b.add(2);
                        b.add(3);
                        b.add(4);
                        b.add(5);
                        b.add(6);
                        b.add(0);
                        b.add(1);
                        break;
                    case 3:
                        b.add(3);
                        b.add(4);
                        b.add(5);
                        b.add(6);
                        b.add(0);
                        b.add(1);
                        b.add(2);
                        break;
                    case 4:
                        b.add(4);
                        b.add(5);
                        b.add(6);
                        b.add(0);
                        b.add(1);
                        b.add(2);
                        b.add(3);
                        break;
                    case 5:
                        b.add(5);
                        b.add(6);
                        b.add(0);
                        b.add(1);
                        b.add(2);
                        b.add(3);
                        b.add(4);
                        break;
                    case 6:
                        b.add(6);
                        b.add(0);
                        b.add(1);
                        b.add(2);
                        b.add(3);
                        b.add(4);
                        b.add(5);
                        break;
                }
                this.e.clear();
                for (let c = 0; c < b.count; c++) {
                    let d = a.getChildAt(c);
                    let e = d.getChildAt(0);
                    let f = this.c.d(b._inner[c]);
                    d.setAttribute("title", f[0]);
                    d.setAttribute("aria-label", f[0]);
                    e.setText(f[1]);
                    this.e.add(e);
                }
            }
        }
        a0() {
            if (this.m != null) {
                this.a1();
                this.a4();
                let a = this.o.getChildAt(1);
                let b = a.getChildAt(1);
                for (let c = 1; c < 7; c++) {
                    let d = b.getChildAt(c);
                    for (let e = 0; e < 7; e++) {
                        let f = d.getChildAt(e);
                        f.listen("click", runOn(this, this.ag));
                    }
                }
            }
        }
        a1(a = false, b = false) {
            if (this.m != null) {
                let c = null;
                let d = null;
                let e = null;
                let f = this.c.value;
                let g = this.c.aq;
                let h = this.c.av;
                for (let i = 0; i < 42; i++) {
                    let j = this.f._inner[i];
                    let k = j.getChildAt(0);
                    let l = this.c.j(i);
                    if (l != null) {
                        j.parent().parent().setAttribute("aria-label", l.c.toString() + "/" + l.b.toString() + "/" + l.d.toString());
                        j.setAttribute("data-section", "days");
                        j.setAttribute("data-index", i.toString());
                        j.setAttribute("data-date", l.b.toString() + "/" + l.c.toString() + "/" + l.d.toString());
                        j.setAttribute("data-selected", "false");
                        j.setAttribute("data-disabled", "false");
                        j.setAttribute("data-today", "false");
                        k.setText(l.b.toString());
                        if (+f != +(dateMinValue()) && l.b == f.getDate() && l.c == dateGetMonth(f) && l.d == f.getFullYear()) {
                            c = j;
                            j.parent().parent().setAttribute("aria-selected", "true");
                            j.setAttribute("data-selected", "true");
                        }
                        else if (l.b == h.getDate() && l.c == dateGetMonth(h) && l.d == h.getFullYear()) {
                            d = j;
                            j.setAttribute("data-today", "true");
                        }
                        let m = this.c.ad(i);
                        if (m) {
                            j.setAttribute("data-disabled", "true");
                        }
                        if (l.b == 1 && l.c == dateGetMonth(g)) {
                            e = j;
                        }
                    }
                }
                if (a == true) {
                    if (c != null && +f != +(dateMinValue()) && f.getFullYear() == g.getFullYear() && dateGetMonth(f) == dateGetMonth(g)) {
                        this.d(c);
                    }
                    else if (d != null && h.getFullYear() == g.getFullYear() && dateGetMonth(h) == dateGetMonth(g)) {
                        this.d(d);
                    }
                    else if (e != null) {
                        if (b == true) {
                            for (let n = 41; n >= 0; n--) {
                                let o = this.c.j(n);
                                if (o.c == dateGetMonth(g)) {
                                    let p = this.f._inner[n];
                                    let q = p.getAttribute("data-disabled");
                                    if (q == "false") {
                                        e = this.f._inner[n];
                                        break;
                                    }
                                }
                            }
                        }
                        else {
                            for (let r = 0; r < 42; r++) {
                                let s = this.c.j(r);
                                if (s.c == dateGetMonth(g)) {
                                    let t = this.f._inner[r];
                                    let u = t.getAttribute("data-disabled");
                                    if (u == "false") {
                                        e = this.f._inner[r];
                                        break;
                                    }
                                }
                            }
                        }
                        this.d(e);
                    }
                }
            }
        }
        af(a, b, c) {
            if (this.m != null) {
                b.setAttribute("aria-hidden", "true");
                let d = this.m.createElement("span");
                d.setAttribute("aria-hidden", "true");
                b.append(d);
                this.c.ci(a, b, c);
                b.parent().setAttribute("aria-hidden", "true");
                b.parent().parent().setAttribute("tabindex", "-1");
                b.parent().parent().setAttribute("aria-readonly", "true");
                b.parent().parent().setAttribute("aria-selected", "false");
                b.parent().parent().setAttribute("aria-disabled", "false");
                b.parent().parent().setAttribute("data-is-focusable", "true");
            }
        }
        as(a, b) {
            if (this.m != null) {
                let c = this.m.getSubRenderer(a);
                b.provideContainer(c);
                let d = c.getExternal(b, c.rootWrapper, c.getExternal(this.c, null, null));
            }
        }
        az(a) {
            let b = this.r.getChildAt(0);
            b.setText(a);
            this.r.parent().parent().setAttribute("aria-label", a);
        }
        aw(a, b) {
            if (this.m != null) {
                let c = this.m.getSubRenderer(a);
                b.provideContainer(c);
                let d = c.getExternal(b, c.rootWrapper, c.getExternal(this.c, null, null));
            }
        }
        ay() {
            if (this.m != null) {
                let a = this.g._inner[1].getChildAt(0);
                let b = this.c.bx();
                a.setText(b);
                let c = this.g._inner[2].getChildAt(0);
                let d = this.c.by();
                c.setText(d);
            }
        }
        at(a = false, b = false) {
            if (this.m != null) {
                this.a1(a, b);
                this.a4();
                let c = this.c.a();
                for (let d = 0; d < this.g.count; d++) {
                    if (c[d] == true) {
                        this.g._inner[d].setAttribute("data-disabled", "true");
                    }
                    else {
                        this.g._inner[d].setAttribute("data-disabled", "false");
                    }
                }
            }
        }
        ax() {
            if (this.m != null) {
                if (this.h.count != 0) {
                    let a = null;
                    let b = null;
                    let c = 0;
                    let d = 0;
                    let e = 0;
                    for (let f = 0; f < 12; f++) {
                        let g = this.h._inner[f];
                        g.setAttribute("data-section", "months");
                        g.setAttribute("data-disabled", "false");
                        g.parent().parent().setAttribute("aria-selected", "false");
                        let h = f + 1;
                        let i = this.c.value;
                        let j = this.c.av;
                        if (+i != +(dateMinValue()) && dateGetMonth(i) == h) {
                            b = g;
                            c = f;
                            g.parent().parent().setAttribute("aria-selected", "true");
                        }
                        if (dateGetMonth(j) == h) {
                            a = g;
                            d = f;
                        }
                        let k = this.c.aa(f, h);
                        if (k) {
                            g.setAttribute("data-disabled", "true");
                        }
                    }
                    for (let l = 0; l < this.h.count; l++) {
                        let m = this.h._inner[l];
                        let n = m.getAttribute("data-disabled");
                        if (n == "false") {
                            e = l;
                            break;
                        }
                    }
                    let o = this.h._inner[c].getAttribute("data-disabled");
                    let p = this.h._inner[d].getAttribute("data-disabled");
                    let q = this.h._inner[e].getAttribute("data-disabled");
                    if (b != null && o == "false") {
                        this.d(b);
                    }
                    else if (a != null && p == "false") {
                        this.d(a);
                    }
                    else if (q == "false") {
                        this.d(this.h._inner[e]);
                    }
                    else {
                        this.ar();
                    }
                }
            }
        }
        a6() {
            if (this.m != null) {
                if (this.j.count != 0) {
                    let a = this.c.aq.getFullYear();
                    let b = true;
                    this.a5(a, b);
                }
            }
        }
        a5(a, b = false) {
            if (a < this.c.au.getFullYear()) {
                a = this.c.au.getFullYear();
            }
            if (a > this.c.at.getFullYear()) {
                a = this.c.at.getFullYear();
            }
            let c = a - 3;
            let d = false;
            for (let e = 0; e < 7; e++) {
                let f = this.j._inner[e];
                f.setAttribute("data-section", "years");
                f.setAttribute("data-disabled", "false");
                f.parent().parent().setAttribute("aria-selected", "false");
                let g = this.c.ab(e, c);
                f.setAttribute("data-disabled", g.toString());
                let h = f.getChildAt(0);
                h.setText(c.toString());
                f.parent().parent().setAttribute("aria-label", c.toString());
                if (c == a && b) {
                    if (g == false) {
                        f.parent().parent().setAttribute("aria-selected", "true");
                        d = true;
                        this.d(f);
                    }
                }
                c++;
            }
            if (d == false) {
                let i = this.j._inner[3].getAttribute("data-disabled");
                if (i == "false") {
                    let j = this.j._inner[3];
                    this.d(j);
                }
            }
        }
        ar(a = false) {
            this.at();
            this.ay();
            this.w = "day";
            this.n.show();
            this.n.setStyleProperty("display", "flex");
            this.q.hide();
            this.u.hide();
            this.au(a);
            this.ah();
        }
        au(a = false) {
            let b = null;
            let c = null;
            let d = null;
            for (let e = 0; e < this.f.count; e++) {
                let f = this.f._inner[e];
                let g = parseBool(f.getAttribute("data-disabled").toString());
                let h = f.getAttribute("data-date").toString().split('/');
                let i = h[1];
                let j = parseBool(f.getAttribute("data-selected").toString());
                let k = parseBool(f.getAttribute("data-today").toString());
                if (j == true) {
                    c = f;
                }
                if (k == true) {
                    d = f;
                }
                let l = dateGetMonth(this.c.aq).toString();
                if (g == false && l == i && b == null) {
                    b = f;
                }
            }
            if (d != null) {
                b = d;
            }
            if (c != null && a == false) {
                b = c;
            }
            if (b == null) {
                for (let m = 0; m < this.g.count; m++) {
                    let n = parseBool(this.g._inner[m].getAttribute("data-disabled").toString());
                    if (n == false) {
                        b = this.g._inner[m];
                        break;
                    }
                }
            }
            if (b != null) {
                this.d(b);
            }
        }
        d(a) {
            if (a == null) {
                return false;
            }
            let b = parseBool(a.getAttribute("data-disabled").toString());
            if (b) {
                return false;
            }
            this.p = a;
            return true;
        }
        ah() {
            if (this.p != null) {
                this.p.parent().parent().focus(true);
            }
        }
        aq(a = true, b = false) {
            let c = parseBool(this.g._inner[0].getAttribute("data-disabled").toString());
            if (c) {
                return;
            }
            this.c.cc(-1);
            this.at(a, b);
            this.ay();
        }
        al(a = true, b = false) {
            let c = parseBool(this.g._inner[3].getAttribute("data-disabled").toString());
            if (c) {
                return;
            }
            this.c.cc(1);
            this.at(a, b);
            this.ay();
        }
        a9() {
            this.n.hide();
            this.q.show();
            this.q.setStyleProperty("display", "flex");
            this.u.hide();
            this.w = "month";
            this.ax();
            this.ah();
        }
        ba() {
            this.n.hide();
            this.q.hide();
            this.u.show();
            this.w = "year";
            this.a6();
            this.ah();
        }
        y(a) {
        }
        z(a) {
            let b = a.which;
            if (this.w == "day") {
                let c = this.p.getAttribute("data-section").toString();
                let d = parseInt(this.p.getAttribute("data-index").toString());
                if (c == "header") {
                    if (b == 37) {
                        if (d > 0) {
                            let e = this.g._inner[d - 1];
                            let f = this.d(e);
                            if (f == false && d > 1) {
                                e = this.g._inner[d - 2];
                                this.d(e);
                            }
                            this.ah();
                        }
                        else {
                            this.aq(false);
                            let g = parseBool(this.p.getAttribute("data-disabled").toString());
                            if (g == true) {
                                this.au();
                                this.ah();
                            }
                        }
                    }
                    else if (b == 39) {
                        if (d < 3) {
                            let h = this.g._inner[d + 1];
                            let i = this.d(h);
                            if (i == false && d < 2) {
                                h = this.g._inner[d + 2];
                                this.d(h);
                            }
                            this.ah();
                        }
                        else {
                            this.al(false);
                            let j = parseBool(this.p.getAttribute("data-disabled").toString());
                            if (j == true) {
                                this.au();
                                this.ah();
                            }
                        }
                    }
                    else if (b == 9) {
                        if (a.shiftKey) {
                            this.c.cs();
                        }
                        else {
                            a.preventDefault();
                            this.at(true);
                            this.ah();
                        }
                    }
                    else if (b == 13) {
                        a.preventDefault();
                        if (d == 0) {
                            this.aq(false);
                        }
                        else if (d == 1) {
                            this.a9();
                        }
                        else if (d == 2) {
                            this.ba();
                        }
                        else if (d == 3) {
                            this.al(false);
                        }
                    }
                }
                else if (c == "days") {
                    let k = this.p.getAttribute("data-date").toString().split('/');
                    let l = k[0];
                    let m = k[1];
                    if (b == 37) {
                        if (d == 0) {
                            this.aq(true, true);
                            this.ah();
                        }
                        else {
                            let n = this.f._inner[d - 1];
                            let o = n.getAttribute("data-date").toString().split('/');
                            let p = o[0];
                            let q = o[1];
                            if (m == q) {
                                this.d(n);
                                this.ah();
                            }
                            else {
                                this.aq();
                                let r = this.v(p, q);
                                this.d(r);
                                this.ah();
                            }
                        }
                    }
                    else if (b == 39) {
                        if (d == 41) {
                            this.al(true, false);
                            this.ah();
                        }
                        else {
                            let s = this.f._inner[d + 1];
                            let t = s.getAttribute("data-date").toString().split('/');
                            let u = t[0];
                            let v = t[1];
                            if (m == v) {
                                this.d(s);
                                this.ah();
                            }
                            else {
                                this.al();
                                let w = this.v(u, v);
                                this.d(w);
                                this.ah();
                            }
                        }
                    }
                    else if (b == 40) {
                        if (d >= 35) {
                            this.al();
                            let x = this.v(l, m);
                            let y = parseInt(x.getAttribute("data-index").toString());
                            let z = this.f._inner[y + 7];
                            let aa = z.getAttribute("data-date").toString().split('/');
                            let ab = aa[0];
                            let ac = aa[1];
                            let ad = this.v(ab, ac);
                            this.d(ad);
                            this.ah();
                        }
                        else {
                            let ae = this.f._inner[d + 7];
                            let af = ae.getAttribute("data-date").toString().split('/');
                            let ag = af[0];
                            let ah = af[1];
                            if (m == ah) {
                                this.d(ae);
                                this.ah();
                            }
                            else {
                                this.al();
                                let ai = this.v(ag, ah);
                                this.d(ai);
                                this.ah();
                            }
                        }
                    }
                    else if (b == 38) {
                        if (d <= 6) {
                            this.aq();
                            let aj = this.v(l, m);
                            let ak = parseInt(aj.getAttribute("data-index").toString());
                            let al = this.f._inner[ak - 7];
                            let am = al.getAttribute("data-date").toString().split('/');
                            let an = am[0];
                            let ao = am[1];
                            let ap = this.v(an, ao);
                            this.d(ap);
                            this.ah();
                        }
                        else {
                            let aq = this.f._inner[d - 7];
                            let ar = aq.getAttribute("data-date").toString().split('/');
                            let as = ar[0];
                            let at = ar[1];
                            if (m == at) {
                                this.d(aq);
                                this.ah();
                            }
                            else {
                                this.aq();
                                let au = this.v(as, at);
                                this.d(au);
                                this.ah();
                            }
                        }
                    }
                    else if (b == 34) {
                        this.al();
                        this.ah();
                    }
                    else if (b == 33) {
                        this.aq();
                        this.ah();
                    }
                    else if (b == 9) {
                        if (a.shiftKey) {
                            a.preventDefault();
                            let av = this.g._inner[1];
                            this.d(av);
                            this.ah();
                        }
                        else {
                            this.c.cs();
                        }
                    }
                }
            }
            else if (this.w == "month") {
                let aw = parseInt(this.p.getAttribute("data-index").toString());
                if (b == 37) {
                    if (aw == 0) {
                        let ax = this.h._inner[11];
                        this.d(ax);
                        this.ah();
                    }
                    else {
                        let ay = this.h._inner[aw - 1];
                        this.d(ay);
                        this.ah();
                    }
                }
                else if (b == 39) {
                    if (aw == 11) {
                        let az = this.h._inner[0];
                        this.d(az);
                        this.ah();
                    }
                    else {
                        let a0 = this.h._inner[aw + 1];
                        this.d(a0);
                        this.ah();
                    }
                }
                else if (b == 40) {
                    if (aw >= 9) {
                        let a1 = this.h._inner[aw - 9];
                        this.d(a1);
                        this.ah();
                    }
                    else {
                        let a2 = this.h._inner[aw + 3];
                        this.d(a2);
                        this.ah();
                    }
                }
                else if (b == 38) {
                    if (aw <= 2) {
                        let a3 = this.h._inner[aw + 9];
                        this.d(a3);
                        this.ah();
                    }
                    else {
                        let a4 = this.h._inner[aw - 3];
                        this.d(a4);
                        this.ah();
                    }
                }
                else if (b == 13) {
                    this.d(this.g._inner[1]);
                    this.ah();
                }
            }
            else if (this.w == "year") {
                let a5 = parseInt(this.p.getAttribute("data-index").toString());
                let a6 = parseInt(this.j._inner[3].getChildAt(0).getText());
                if (b == 40) {
                    this.c.cz(a6, 1);
                    this.ah();
                }
                else if (b == 38) {
                    this.c.cz(a6, -1);
                    this.ah();
                }
                else if (b == 13) {
                    this.d(this.g._inner[2]);
                    this.ah();
                }
            }
            if (b == 27) {
                this.ar();
                this.c.cs();
            }
            if (a.altKey == true) {
                if (b == 38) {
                    this.ar();
                    this.c.cs();
                }
            }
        }
        v(a, b) {
            let c = null;
            let d = null;
            for (let e = 0; e < 42; e++) {
                let f = this.f._inner[e];
                let g = f.getAttribute("data-date").toString().split('/');
                let h = g[0];
                let i = g[1];
                if (b == i && d == null) {
                    d = f;
                }
                if (b == i && a == h) {
                    c = f;
                    break;
                }
            }
            if (c == null) {
                c = d;
            }
            return c;
        }
        ap(a) {
            let b = this.g._inner[0];
            let c = parseBool(b.getAttribute("data-disabled").toString());
            if (c == true) {
                return;
            }
            this.aq();
        }
        ak(a) {
            let b = this.g._inner[3];
            let c = parseBool(b.getAttribute("data-disabled").toString());
            if (c == true) {
                return;
            }
            this.al();
        }
        aj(a) {
            let b = this.g._inner[1];
            let c = parseBool(b.getAttribute("data-disabled").toString());
            if (c == true) {
                return;
            }
            this.a9();
        }
        bf(a) {
            let b = this.g._inner[2];
            let c = parseBool(b.getAttribute("data-disabled").toString());
            if (c == true) {
                return;
            }
            this.ba();
        }
        ag(e_) {
            let a = (e_.originalEvent.currentTarget);
            let b = a.innerText;
            if (b != "") {
                let c = a.lastChild.lastChild.lastChild;
                let d = parseBool(c.getAttribute("data-disabled").toString());
                if (d == false) {
                    let e = c.getAttribute("data-date").toString().split('/');
                    let f = e[1];
                    let g = e[2];
                    this.c.co(b, f, g);
                }
            }
        }
        ai(e_) {
            let a = (e_.originalEvent.currentTarget);
            let b = a.getAttribute("data-month").toString();
            if (b != "") {
                let c = parseInt(b);
                let d = a.lastChild.lastChild.lastChild;
                let e = parseBool(d.getAttribute("data-disabled").toString());
                if (e == false) {
                    this.c.cd(c);
                    this.ar();
                }
            }
        }
        bd(e_) {
            let a = (e_.originalEvent.currentTarget);
            let b = a.innerText;
            if (b != "") {
                let c = parseInt(b);
                let d = a.lastChild.lastChild.lastChild;
                let e = parseBool(d.getAttribute("data-disabled").toString());
                if (e == false) {
                    this.c.ce(c);
                    this.ar();
                }
            }
        }
        be(e_) {
            e_.preventDefault();
            let a = (e_.originalEvent.deltaY);
            let b = parseInt(this.j._inner[3].getChildAt(0).getText());
            this.c.cz(b, a);
        }
        a() {
            let rect_ = this.m.rootWrapper.getNativeElement().getBoundingClientRect();
            let a = (rect_.top);
            let b = (rect_.left);
            let c = new Array(2);
            c[0] = a;
            c[1] = b;
            return c;
        }
        b(a) {
            let rect_ = a.getNativeElement().getBoundingClientRect();
            let b = (rect_.top);
            let c = (rect_.left);
            let d = new Array(2);
            d[0] = b;
            d[1] = c;
            return d;
        }
        am() {
        }
    }
    CalendarView.$t = /*@__PURE__*/ markType(CalendarView, 'CalendarView');
    return CalendarView;
})();
/**
 * @hidden
 */
export let XCalendar = /*@__PURE__*/ (() => {
    class XCalendar extends Base {
        constructor() {
            super();
            this.h = null;
            this.aq = dateNow();
            this.am = new Date();
            this.ai = null;
            this.aj = null;
            this.ah = null;
            this.ak = null;
            this.al = null;
            this.g = null;
            this.ap = dateMinValue();
            this.propertyChanged = null;
            this.close = null;
            this.selectedValueChanged = null;
            this.w = null;
            this.as = dateMinValue();
            this.ar = dateNow();
            this.ao = dateMinValue();
            this.an = dateMaxValue();
            this.s = 3;
            this.q = 1;
            this.c6 = BrushUtil.h(0, 255, 255, 255);
            this.dc = BrushUtil.h(255, 33, 150, 243);
            this.de = BrushUtil.h(255, 21, 112, 184);
            this.c9 = BrushUtil.h(76, 33, 150, 243);
            this.db = BrushUtil.h(50, 186, 191, 199);
            this.df = BrushUtil.h(255, 24, 29, 31);
            this.dd = BrushUtil.h(255, 255, 255, 255);
            this.da = BrushUtil.h(255, 24, 29, 31);
            this.c8 = BrushUtil.h(255, 33, 150, 243);
            this.c7 = BrushUtil.h(255, 33, 150, 243);
            this.y = false;
            this.u = null;
            this.k = 0;
            this.n = 0;
            this.z = false;
            this.am = dateAddYears(this.am, -200);
            this.ai = new ObservableCollection$1(DayInfo.$, 0);
            this.aj = new ObservableCollection$1(XButton.$, 0);
            this.ah = new ObservableCollection$1(XButton.$, 0);
            this.ak = new ObservableCollection$1(XButton.$, 0);
            this.al = new ObservableCollection$1(XButton.$, 0);
            let a = new CalendarView();
            a.c = this;
            this.h = a;
            this.h.ao();
        }
        cs() {
            if (this.close != null) {
                this.close(this);
            }
        }
        cu(a) {
            let b = this.as;
            this.as = a;
            if (this.selectedValueChanged != null) {
                this.selectedValueChanged(this, ((() => {
                    let $ret = new SelectedValueChangedEventArgs();
                    $ret.oldValue = b;
                    $ret.newValue = a;
                    return $ret;
                })()));
            }
            if (+(this.value) != +(dateMinValue())) {
                this.aq = this.value;
            }
            this.cx();
        }
        co(a, b, c) {
            let d = dateFromValues(parseInt(c), parseInt(b), parseInt(a), 0, 0, 0, 0);
            this.cu(d);
        }
        notifySizeChanged() {
            this.h.am();
        }
        destroy() {
            if (this.g != null) {
                let a = this.g;
                a.clicked = delegateRemove(a.clicked, runOn(this, this.c2));
            }
            this.provideContainer(null);
        }
        provideContainer(a) {
            this.h.an(a);
        }
        get x() {
            if (this.w == null) {
                this.w = new SRProvider(this.h.m);
                this.w.cb("Calendar");
            }
            return this.w;
        }
        get value() {
            return this.as;
        }
        set value(a) {
            let b = this.as;
            this.ap = b;
            this.as = a;
            if (+b != +(this.as)) {
                this.ct("Value", b, this.as);
            }
        }
        get av() {
            return this.ar;
        }
        set av(a) {
            let b = this.ar;
            this.ar = a;
            if (+b != +(this.ar)) {
                this.ct("Today", b, this.ar);
            }
        }
        get au() {
            return this.ao;
        }
        set au(a) {
            let b = this.ao;
            this.ao = a;
            if (+b != +(this.ao)) {
                this.ct("MinDate", b, this.ao);
            }
        }
        get at() {
            return this.an;
        }
        set at(a) {
            let b = this.an;
            this.an = a;
            if (+b != +(this.an)) {
                this.ct("MaxDate", b, this.an);
            }
        }
        get t() {
            return this.s;
        }
        set t(a) {
            let b = this.s;
            this.s = a;
            if (b != this.s) {
                this.ct("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, this.s));
            }
        }
        get r() {
            return this.q;
        }
        set r(a) {
            let b = this.q;
            this.q = a;
            if (b != this.q) {
                this.ct("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, this.q));
            }
        }
        get dg() {
            return this.c6;
        }
        set dg(a) {
            let b = this.c6;
            this.c6 = a;
            if (b != this.c6) {
                this.ct("BackgroundColor", b, this.c6);
            }
        }
        get dm() {
            return this.dc;
        }
        set dm(a) {
            let b = this.dc;
            this.dc = a;
            if (b != this.dc) {
                this.ct("SelectedDateBackgroundColor", b, this.dc);
            }
        }
        get dp() {
            return this.de;
        }
        set dp(a) {
            let b = this.de;
            this.de = a;
            if (b != this.de) {
                this.ct("SelectedFocusDateBackgroundColor", b, this.de);
            }
        }
        get dj() {
            return this.c9;
        }
        set dj(a) {
            let b = this.c9;
            this.c9 = a;
            if (b != this.c9) {
                this.ct("FocusDateBackgroundColor", b, this.c9);
            }
        }
        get dl() {
            return this.db;
        }
        set dl(a) {
            let b = this.db;
            this.db = a;
            if (b != this.db) {
                this.ct("HoverBackgroundColor", b, this.db);
            }
        }
        get dq() {
            return this.df;
        }
        set dq(a) {
            let b = this.df;
            this.df = a;
            if (b != this.df) {
                this.ct("TextColor", b, this.df);
            }
        }
        get dn() {
            return this.dd;
        }
        set dn(a) {
            let b = this.dd;
            this.dd = a;
            if (b != this.dd) {
                this.ct("SelectedDateTextColor", b, this.dd);
            }
        }
        get dk() {
            return this.da;
        }
        set dk(a) {
            let b = this.da;
            this.da = a;
            if (b != this.da) {
                this.ct("FocusDateTextColor", b, this.da);
            }
        }
        get di() {
            return this.c8;
        }
        set di(a) {
            let b = this.c8;
            this.c8 = a;
            if (b != this.c8) {
                this.ct("CurrentDateTextColor", b, this.c8);
            }
        }
        get dh() {
            return this.c7;
        }
        set dh(a) {
            let b = this.c7;
            this.c7 = a;
            if (b != this.c7) {
                this.ct("CurrentDateBorderColor", b, this.c7);
            }
        }
        get ae() {
            return this.y;
        }
        set ae(a) {
            let b = this.y;
            this.y = a;
            if (b != this.y) {
                this.ct("ShowTodayButton", b, this.y);
            }
        }
        get v() {
            return this.u;
        }
        set v(a) {
            let b = this.u;
            this.u = a;
            if (b != this.u) {
                this.ct("TextStyle", b, this.u);
            }
        }
        get l() {
            return this.k;
        }
        set l(a) {
            let b = this.k;
            this.k = a;
            if (b != this.k) {
                this.ct("FirstDayOfWeek", enumGetBox(DayOfWeek_$type, b), enumGetBox(DayOfWeek_$type, this.k));
            }
        }
        get o() {
            return this.n;
        }
        set o(a) {
            let b = this.n;
            this.n = a;
            if (b != this.n) {
                this.ct("FirstWeekOfYear", enumGetBox(FirstWeek_$type, b), enumGetBox(FirstWeek_$type, this.n));
            }
        }
        get af() {
            return this.z;
        }
        set af(a) {
            let b = this.z;
            this.z = a;
            if (b != this.z) {
                this.ct("ShowWeekNumbers", b, this.z);
            }
        }
        ct(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.cv(a, b, c);
        }
        cv(a, b, c) {
            switch (a) {
                case "Density":
                    this.c0();
                    break;
                case "BaseTheme":
                    this.c1();
                    break;
                case "Value":
                    if (+(this.value) != +(dateMinValue())) {
                        if (dateGetDate(this.value) < dateGetDate(this.au) || dateGetDate(this.value) > dateGetDate(this.at)) {
                            this.value = this.ap;
                        }
                    }
                    this.ap = this.value;
                    if (+(this.value) != +(dateMinValue())) {
                        this.aq = this.value;
                    }
                    this.cx();
                    break;
                case "Today":
                    let d = Base.compareSimple(this.av, this.au);
                    let e = Base.compareSimple(this.av, this.at);
                    if (d < 0) {
                        this.ar = this.au;
                    }
                    else if (e > 0) {
                        this.ar = this.at;
                    }
                    if (+(this.value) == +(dateMinValue())) {
                        this.aq = this.av;
                    }
                    this.cx();
                    break;
                case "MaxDate":
                case "MinDate":
                    let f = Base.compareSimple(this.au, this.at);
                    if (f >= 0) {
                        this.at = dateMaxValue();
                    }
                    let g = Base.compareSimple(this.aq, this.au);
                    let h = Base.compareSimple(this.aq, this.at);
                    if (g < 0) {
                        this.aq = this.au;
                    }
                    else if (h > 0) {
                        this.aq = this.at;
                    }
                    this.cx();
                    break;
                case "TextColor":
                case "SelectedDateTextColor":
                case "FocusDateTextColor":
                case "CurrentDateTextColor":
                case "CurrentDateBorderColor":
                case "BackgroundColor":
                case "FocusDateBackgroundColor":
                case "SelectedFocusDateBackgroundColor":
                case "SelectedDateBackgroundColor":
                case "HoverBackgroundColor":
                    this.c3();
                    break;
                case "TextStyle":
                    this.c4();
                    break;
                case "ShowTodayButton":
                    this.h.a7();
                    break;
                case "FirstDayOfWeek":
                    this.cx();
                    break;
                case "FirstWeekOfYear":
                case "ShowWeekNumbers":
                    this.h.a8();
                    this.cx();
                    break;
            }
        }
        c3() {
            for (let a = 0; a < this.aj.count; a++) {
                if (this.dq != null) {
                    this.aj._inner[a].p4 = this.dq;
                }
                if (this.dk != null) {
                    this.aj._inner[a].p0 = this.dk;
                }
                if (this.dg != null) {
                    this.aj._inner[a].pu = this.dg;
                }
                if (this.dj != null) {
                    this.aj._inner[a].pz = this.dj;
                }
                if (this.dl != null) {
                    this.aj._inner[a].p1 = this.dl;
                }
            }
            for (let b = 0; b < this.ah.count; b++) {
                if (this.dq != null) {
                    this.ah._inner[b].p4 = this.dq;
                }
                if (this.dk != null) {
                    this.ah._inner[b].p0 = this.dk;
                }
                if (this.dg != null) {
                    this.ah._inner[b].pu = this.dg;
                }
                if (this.dj != null) {
                    this.ah._inner[b].pz = this.dj;
                }
                if (this.dl != null) {
                    this.ah._inner[b].p1 = this.dl;
                }
            }
            for (let c = 0; c < this.ak.count; c++) {
                if (this.dq != null) {
                    this.ak._inner[c].p4 = this.dq;
                }
                if (this.dk != null) {
                    this.ak._inner[c].p0 = this.dk;
                }
                if (this.dg != null) {
                    this.ak._inner[c].pu = this.dg;
                }
                if (this.dj != null) {
                    this.ak._inner[c].pz = this.dj;
                }
                if (this.dl != null) {
                    this.ak._inner[c].p1 = this.dl;
                }
            }
            for (let d = 0; d < this.al.count; d++) {
                if (this.dq != null) {
                    this.al._inner[d].p4 = this.dq;
                }
                if (this.dk != null) {
                    this.al._inner[d].p0 = this.dk;
                }
                if (this.dg != null) {
                    this.al._inner[d].pu = this.dg;
                }
                if (this.dj != null) {
                    this.al._inner[d].pz = this.dj;
                }
                if (this.dl != null) {
                    this.al._inner[d].p1 = this.dl;
                }
            }
        }
        c4() {
            for (let a = 0; a < this.aj.count; a++) {
                if (this.u != null) {
                    this.aj._inner[a].aa = this.u;
                }
            }
            for (let b = 0; b < this.ah.count; b++) {
                if (this.u != null) {
                    this.ah._inner[b].aa = this.u;
                }
            }
            for (let c = 0; c < this.ak.count; c++) {
                if (this.u != null) {
                    this.ak._inner[c].aa = this.u;
                }
            }
            for (let d = 0; d < this.al.count; d++) {
                if (this.u != null) {
                    this.al._inner[d].aa = this.u;
                }
            }
        }
        cq() {
            this.cx();
            this.h.au();
            this.h.ah();
        }
        c1() {
        }
        c0() {
        }
        ch() {
            this.value = dateMinValue();
            this.h.at();
        }
        cx() {
            this.c5();
            this.h.a3();
            this.cg();
            this.h.ay();
            this.h.a6();
            this.h.at();
        }
        c5() {
            let a = !stringIsNullOrWhiteSpace(this.x.b1("Today")) ? this.x.b1("Today") : "Today";
            this.h.az(a);
            this.h.bc();
            this.h.bb();
        }
        cf() {
            this.cg();
        }
        ci(a, b, c) {
            let d = new XButton();
            this.h.as(a, d);
            d.n = this.r;
            d.r = this.t;
            d.aa = this.u;
            d.d3 = -1;
            d.e = 1;
            if (this.u != null) {
                d.aa = this.u;
            }
            let e = new CornerRadius(0, 2);
            d.kt = e;
            d.k0 = e;
            d.dk = 0;
            d.appendButtonContent(b);
            d.p4 = this.dq;
            d.p0 = this.dk;
            d.pu = this.dg;
            d.pz = this.dj;
            d.p1 = this.dl;
            d.bu = 30;
            d.bt = 30;
            this.ah.add(d);
            d.h2 = "btnDays" + c.toString();
        }
        cm(a, b) {
            let c = new XButton();
            this.h.as(a, c);
            c.n = this.r;
            c.r = this.t;
            c.aa = this.u;
            c.d3 = -1;
            c.e = 1;
            if (this.u != null) {
                c.aa = this.u;
            }
            let d = new CornerRadius(0, 2);
            c.kt = d;
            c.k0 = d;
            c.dk = 0;
            c.appendButtonContent(b);
            let e = !stringIsNullOrWhiteSpace(this.x.b1("Today")) ? this.x.b1("Today") : "Today";
            this.h.az(e);
            c.p4 = this.dq;
            c.p0 = this.dk;
            c.pu = this.dg;
            c.pz = this.dj;
            c.p1 = this.dl;
            this.g = c;
            let f = this.g;
            f.clicked = delegateCombine(f.clicked, runOn(this, this.c2));
        }
        c2(a, b) {
            this.aq = this.av;
            this.cg();
            this.h.ar(true);
        }
        cl(a, b) {
            let c = new XButton();
            this.h.as(a, c);
            c.n = this.r;
            c.r = this.t;
            c.aa = this.u;
            c.d3 = -1;
            c.e = 1;
            if (this.u != null) {
                c.aa = this.u;
            }
            let d = new CornerRadius(0, 2);
            c.kt = d;
            c.k0 = d;
            c.dk = 0;
            c.appendButtonContent(b);
            c.p4 = this.dq;
            c.p0 = this.dk;
            c.pu = this.dg;
            c.pz = this.dj;
            c.p1 = this.dl;
            c.bu = 40;
            this.ak.add(c);
        }
        e(a, b) {
            let c = new Array(2);
            c[0] = "";
            c[1] = "";
            switch (a) {
                case 1:
                    c[0] = !stringIsNullOrWhiteSpace(this.x.b1("January_Full")) ? this.x.b1("January_Full") : "January";
                    c[1] = !stringIsNullOrWhiteSpace(this.x.b1("January_Short")) ? this.x.b1("January_Short") : "Jan";
                    break;
                case 2:
                    c[0] = !stringIsNullOrWhiteSpace(this.x.b1("February_Full")) ? this.x.b1("February_Full") : "February";
                    c[1] = !stringIsNullOrWhiteSpace(this.x.b1("February_Short")) ? this.x.b1("February_Short") : "Feb";
                    break;
                case 3:
                    c[0] = !stringIsNullOrWhiteSpace(this.x.b1("March_Full")) ? this.x.b1("March_Full") : "March";
                    c[1] = !stringIsNullOrWhiteSpace(this.x.b1("March_Short")) ? this.x.b1("March_Short") : "Mar";
                    break;
                case 4:
                    c[0] = !stringIsNullOrWhiteSpace(this.x.b1("April_Full")) ? this.x.b1("April_Full") : "April";
                    c[1] = !stringIsNullOrWhiteSpace(this.x.b1("April_Short")) ? this.x.b1("April_Short") : "Apr";
                    break;
                case 5:
                    c[0] = !stringIsNullOrWhiteSpace(this.x.b1("May_Full")) ? this.x.b1("May_Full") : "May";
                    c[1] = !stringIsNullOrWhiteSpace(this.x.b1("May_Short")) ? this.x.b1("May_Short") : "May";
                    break;
                case 6:
                    c[0] = !stringIsNullOrWhiteSpace(this.x.b1("June_Full")) ? this.x.b1("June_Full") : "June";
                    c[1] = !stringIsNullOrWhiteSpace(this.x.b1("June_Short")) ? this.x.b1("June_Short") : "Jun";
                    break;
                case 7:
                    c[0] = !stringIsNullOrWhiteSpace(this.x.b1("July_Full")) ? this.x.b1("July_Full") : "July";
                    c[1] = !stringIsNullOrWhiteSpace(this.x.b1("July_Short")) ? this.x.b1("July_Short") : "Jul";
                    break;
                case 8:
                    c[0] = !stringIsNullOrWhiteSpace(this.x.b1("August_Full")) ? this.x.b1("August_Full") : "August";
                    c[1] = !stringIsNullOrWhiteSpace(this.x.b1("August_Short")) ? this.x.b1("August_Short") : "Aug";
                    break;
                case 9:
                    c[0] = !stringIsNullOrWhiteSpace(this.x.b1("September_Full")) ? this.x.b1("September_Full") : "September";
                    c[1] = !stringIsNullOrWhiteSpace(this.x.b1("September_Short")) ? this.x.b1("September_Short") : "Sep";
                    break;
                case 10:
                    c[0] = !stringIsNullOrWhiteSpace(this.x.b1("October_Full")) ? this.x.b1("October_Full") : "October";
                    c[1] = !stringIsNullOrWhiteSpace(this.x.b1("October_Short")) ? this.x.b1("October_Short") : "Oct";
                    break;
                case 11:
                    c[0] = !stringIsNullOrWhiteSpace(this.x.b1("November_Full")) ? this.x.b1("November_Full") : "November";
                    c[1] = !stringIsNullOrWhiteSpace(this.x.b1("November_Short")) ? this.x.b1("November_Short") : "Nov";
                    break;
                case 12:
                    c[0] = !stringIsNullOrWhiteSpace(this.x.b1("December_Full")) ? this.x.b1("December_Full") : "December";
                    c[1] = !stringIsNullOrWhiteSpace(this.x.b1("December_Short")) ? this.x.b1("December_Short") : "Dec";
                    break;
            }
            this.ak._inner[b].h2 = "btnMonth" + c[1];
            return c;
        }
        cn(a, b, c) {
            let d = new XButton();
            this.h.as(a, d);
            d.n = this.r;
            d.r = this.t;
            d.aa = this.u;
            d.d3 = -1;
            d.e = 1;
            if (this.u != null) {
                d.aa = this.u;
            }
            let e = new CornerRadius(0, 2);
            d.kt = e;
            d.k0 = e;
            d.dk = 0;
            d.appendButtonContent(b);
            d.p4 = this.dq;
            d.p0 = this.dk;
            d.pu = this.dg;
            d.pz = this.dj;
            d.p1 = this.dl;
            d.h2 = "btnYear" + c.toString();
            this.al.add(d);
        }
        cg() {
            if (+(this.aq) == +(dateMinValue())) {
                this.aq = dateNow();
            }
            this.ai.clear();
            let a = dateAddDays(this.aq, -(this.aq.getDate() - 1));
            let b = this.l;
            let c = a.getDay();
            while (c != b) {
                a = dateAddDays(a, -1);
                c = a.getDay();
            }
            while (this.ai.count < 42) {
                let d = new DayInfo();
                d.b = a.getDate();
                d.c = dateGetMonth(a);
                d.d = a.getFullYear();
                d.a = a.getDay();
                this.ai.add(d);
                a = dateAddDays(a, 1);
            }
        }
        ag() {
            let a = new List$1(Number_$type, 0);
            if (this.af == false) {
                for (let b = 0; b < 6; b++) {
                    a.add(b);
                }
                return a;
            }
            let c = dateFromValues(this.aq.getFullYear(), dateGetMonth(this.aq), 1, 0, 0, 0, 0);
            for (let d = 0; d < 6; d++) {
                let e = 0;
                if (this.o == 2) {
                    e = this.ba(c, this.o, this.l);
                }
                else {
                    e = this.ba(c, this.o, this.l);
                }
                if (this.o == 0 || this.o == 2) {
                    if (e == 2 && a._inner[d - 1] == 53) {
                        let f = c;
                        for (let g = 0; g < 6; g++) {
                            if (f.getDay() == this.l) {
                                if (f.getDate() > 1) {
                                    a._inner[d - 1] = 1;
                                }
                                else {
                                    e = 1;
                                }
                            }
                            else if (f.getDay() < this.l) {
                                f = dateAddDays(f, 1);
                            }
                            else if (f.getDay() > this.l) {
                                f = dateAddDays(f, -1);
                            }
                        }
                    }
                }
                a.add(e);
                c = dateAddDays(c, 7);
            }
            return a;
        }
        a9(a) {
            let b = dateAddMonths(dateAddDays(a, -a.getDate() + 1), -dateGetMonth(a) + 1);
            let c = dateAddDays(dateAddYears(b, 1), -1);
            let d = [6, 7, 8, 9, 10, 4, 5];
            let e = truncate(timeSpanTotalDays((+a - +b)));
            let f = e + d[b.getDay()];
            let g = intDivide(f, 7);
            switch (g) {
                case 0: return this.a9(dateAddDays(b, -1));
                case 53: if (c.getDay() < 4) {
                    return 1;
                }
                else {
                    return g;
                }
                default: return g;
            }
        }
        ba(a, b, c) {
            if (c < 0 || c > 6) {
                return -1;
            }
            switch (b) {
                case 0: return (this.a8(a, c));
                case 1: return (this.bb(a, c, 7));
                case 2: return (this.bb(a, c, 4));
            }
            return -1;
        }
        a8(a, b) {
            let c = this.a7(a) - 1;
            let d = a.getDay();
            let e = d - (c % 7);
            let f = (e - b + 14) % 7;
            return (intDivide((c + f), 7) + 1);
        }
        bb(a, b, c) {
            let d;
            let e;
            let f;
            let g = this.a7(a) - 1;
            let h = a.getDay();
            d = h - (g % 7);
            e = (b - d + 14) % 7;
            if (e != 0 && e >= c) {
                e -= 7;
            }
            f = g - e;
            if (f >= 0) {
                return (intDivide(f, 7) + 1);
            }
            if (a <= dateAddDays(this.au, g)) {
                return this.bc(b, c);
            }
            return (this.bb(dateAddDays(a, -(g + 1)), b, c));
        }
        bc(a, b) {
            let c = this.a7(this.au) - 1;
            let d = this.m(this.au) - c % 7;
            let e = (a + 7 - d) % 7;
            if (e == 0 || e >= b) {
                return 1;
            }
            let f = 365 - 1;
            let g = d - 1 - (f % 7);
            let h = (a - g + 14) % 7;
            let i = f - h;
            if (h >= b) {
                i += 7;
            }
            return (intDivide(i, 7) + 1);
        }
        a7(a) {
            return this.a6(a, 1);
        }
        m(a) {
            return ((intDivide(a.getTime(), 0xC92A69C000) + 1) % 7);
        }
        a6(a, b) {
            let c = this.bd(a.getFullYear(), dateGetMonth(a), a.getDate());
            let d = (intDivide(c, 0xC92A69C000));
            let e = intDivide(d, 146097);
            d -= e * 146097;
            let f = intDivide(d, 36524);
            if (f == 4) {
                f = 3;
            }
            d -= f * 36524;
            let g = intDivide(d, 1461);
            d -= g * 1461;
            let h = intDivide(d, 365);
            if (h == 4) {
                h = 3;
            }
            if (b == 0) {
                return e * 400 + f * 100 + g * 4 + h + 1;
            }
            d -= h * 365;
            if (b == 1) {
                return d + 1;
            }
            let i = h == 3 && (g != 24 || f == 3);
            let j = i ? XCalendar.c : XCalendar.b;
            let k = d >> 5 + 1;
            while (d >= j[k]) {
                k++;
            }
            if (b == 2) {
                return k;
            }
            return d - j[k - 1] + 1;
        }
        bd(a, b, c) {
            if (a >= 1 && a <= 9999 && b >= 1 && b <= 12) {
                let d = XCalendar.ac(a) ? XCalendar.c : XCalendar.b;
                if (c >= 1 && c <= d[b] - d[b - 1]) {
                    let e = a - 1;
                    let f = e * 365 + intDivide(e, 4) - intDivide(e, 100) + intDivide(e, 400) + d[b - 1] + c - 1;
                    return f * 0xC92A69C000;
                }
            }
            return -1;
        }
        static ac(a) {
            return a % 4 == 0 && (a % 100 != 0 || a % 400 == 0);
        }
        ck(a, b, c, d) {
            let e = new XButton();
            this.h.as(a, e);
            e.n = this.r;
            e.r = this.t;
            e.aa = this.u;
            e.d3 = -1;
            e.e = 1;
            let f = new CornerRadius(0, 2);
            e.kt = f;
            e.k0 = f;
            e.dk = 0;
            let g = new XIcon();
            this.h.aw(b, g);
            if (d == "prev") {
                g.svgPath = XCalendar.bk;
                e.h2 = "btnPrev";
            }
            else if (d == "next") {
                g.svgPath = XCalendar.bl;
                e.h2 = "btnNext";
            }
            e.appendButtonContent(c);
            e.p4 = this.dq;
            e.p0 = this.dk;
            e.pu = this.dg;
            e.pz = this.dj;
            e.p1 = this.dl;
            e.bu = 28;
            e.bt = 28;
            this.aj.add(e);
        }
        cj(a, b, c) {
            let d = new XButton();
            this.h.as(a, d);
            d.n = this.r;
            d.r = this.t;
            d.aa = this.u;
            d.d3 = -1;
            d.e = 1;
            if (this.u != null) {
                d.aa = this.u;
            }
            let e = new CornerRadius(0, 2);
            d.kt = e;
            d.k0 = e;
            d.dk = 0;
            d.appendButtonContent(b);
            d.p4 = this.dq;
            d.p0 = this.dk;
            d.pu = this.dg;
            d.pz = this.dj;
            d.p1 = this.dl;
            d.bu = 40;
            if (c == "month") {
                d.h2 = "btnMonth";
            }
            else if (c == "year") {
                d.h2 = "btnYear";
            }
            this.aj.add(d);
        }
        a() {
            let a = new Array(4);
            a[0] = false;
            a[1] = false;
            a[2] = false;
            a[3] = false;
            let b = this.aq.getFullYear();
            let c = dateGetMonth(this.aq);
            if (b == this.au.getFullYear() && b == this.at.getFullYear()) {
                this.aj._inner[2].disabled = true;
                if (c == dateGetMonth(this.au) && c == dateGetMonth(this.at)) {
                    this.aj._inner[0].disabled = true;
                    this.aj._inner[1].disabled = true;
                    this.aj._inner[3].disabled = true;
                }
                else if (c == dateGetMonth(this.au)) {
                    this.aj._inner[0].disabled = true;
                    this.aj._inner[1].disabled = false;
                    this.aj._inner[3].disabled = false;
                }
                else if (c == dateGetMonth(this.at)) {
                    this.aj._inner[0].disabled = false;
                    this.aj._inner[1].disabled = false;
                    this.aj._inner[3].disabled = true;
                }
                else {
                    this.aj._inner[0].disabled = false;
                    this.aj._inner[1].disabled = false;
                    this.aj._inner[3].disabled = false;
                }
            }
            else {
                this.aj._inner[0].disabled = false;
                this.aj._inner[2].disabled = false;
                this.aj._inner[3].disabled = false;
                if (b == this.au.getFullYear()) {
                    if (c == dateGetMonth(this.au)) {
                        this.aj._inner[0].disabled = true;
                        this.aj._inner[1].disabled = false;
                        this.aj._inner[3].disabled = false;
                    }
                    else {
                        this.aj._inner[0].disabled = false;
                        this.aj._inner[1].disabled = false;
                        this.aj._inner[3].disabled = false;
                    }
                }
                else if (b == this.at.getFullYear()) {
                    if (c == dateGetMonth(this.at)) {
                        this.aj._inner[0].disabled = false;
                        this.aj._inner[1].disabled = false;
                        this.aj._inner[3].disabled = true;
                    }
                    else {
                        this.aj._inner[0].disabled = false;
                        this.aj._inner[1].disabled = false;
                        this.aj._inner[3].disabled = false;
                    }
                }
                else if (b > this.at.getFullYear() || b < this.au.getFullYear()) {
                    this.aj._inner[0].disabled = true;
                    this.aj._inner[1].disabled = true;
                    this.aj._inner[3].disabled = true;
                }
            }
            for (let d = 0; d < this.aj.count; d++) {
                a[d] = this.aj._inner[d].disabled;
            }
            return a;
        }
        bx() {
            let a = dateGetMonth(this.aq);
            let b = "";
            switch (a) {
                case 1:
                    b = !stringIsNullOrWhiteSpace(this.x.b1("January_Short")) ? this.x.b1("January_Short") : "Jan";
                    break;
                case 2:
                    b = !stringIsNullOrWhiteSpace(this.x.b1("February_Short")) ? this.x.b1("February_Short") : "Feb";
                    break;
                case 3:
                    b = !stringIsNullOrWhiteSpace(this.x.b1("March_Short")) ? this.x.b1("March_Short") : "Mar";
                    break;
                case 4:
                    b = !stringIsNullOrWhiteSpace(this.x.b1("April_Short")) ? this.x.b1("April_Short") : "Apr";
                    break;
                case 5:
                    b = !stringIsNullOrWhiteSpace(this.x.b1("May_Short")) ? this.x.b1("May_Short") : "May";
                    break;
                case 6:
                    b = !stringIsNullOrWhiteSpace(this.x.b1("June_Short")) ? this.x.b1("June_Short") : "Jun";
                    break;
                case 7:
                    b = !stringIsNullOrWhiteSpace(this.x.b1("July_Short")) ? this.x.b1("July_Short") : "Jul";
                    break;
                case 8:
                    b = !stringIsNullOrWhiteSpace(this.x.b1("August_Short")) ? this.x.b1("August_Short") : "Aug";
                    break;
                case 9:
                    b = !stringIsNullOrWhiteSpace(this.x.b1("September_Short")) ? this.x.b1("September_Short") : "Sep";
                    break;
                case 10:
                    b = !stringIsNullOrWhiteSpace(this.x.b1("October_Short")) ? this.x.b1("October_Short") : "Oct";
                    break;
                case 11:
                    b = !stringIsNullOrWhiteSpace(this.x.b1("November_Short")) ? this.x.b1("November_Short") : "Nov";
                    break;
                case 12:
                    b = !stringIsNullOrWhiteSpace(this.x.b1("December_Short")) ? this.x.b1("December_Short") : "Dec";
                    break;
            }
            return b;
        }
        by() {
            let a = this.aq.getFullYear().toString();
            return a;
        }
        d(a) {
            let b = new Array(2);
            b[0] = "";
            b[1] = "";
            if (a == 0) {
                b[0] = !stringIsNullOrWhiteSpace(this.x.b1("Sunday_Full")) ? this.x.b1("Sunday_Full") : "Sunday";
                b[1] = !stringIsNullOrWhiteSpace(this.x.b1("Sunday_Single")) ? this.x.b1("Sunday_Single") : "S";
            }
            else if (a == 1) {
                b[0] = !stringIsNullOrWhiteSpace(this.x.b1("Monday_Full")) ? this.x.b1("Monday_Full") : "Monday";
                b[1] = !stringIsNullOrWhiteSpace(this.x.b1("Monday_Single")) ? this.x.b1("Monday_Single") : "M";
            }
            else if (a == 2) {
                b[0] = !stringIsNullOrWhiteSpace(this.x.b1("Tuesday_Full")) ? this.x.b1("Tuesday_Full") : "Tuesday";
                b[1] = !stringIsNullOrWhiteSpace(this.x.b1("Tuesday_Single")) ? this.x.b1("Tuesday_Single") : "T";
            }
            else if (a == 3) {
                b[0] = !stringIsNullOrWhiteSpace(this.x.b1("Wednesday_Full")) ? this.x.b1("Wednesday_Full") : "Wednesday";
                b[1] = !stringIsNullOrWhiteSpace(this.x.b1("Wednesday_Single")) ? this.x.b1("Wednesday_Single") : "W";
            }
            else if (a == 4) {
                b[0] = !stringIsNullOrWhiteSpace(this.x.b1("Thursday_Full")) ? this.x.b1("Thursday_Full") : "Thursday";
                b[1] = !stringIsNullOrWhiteSpace(this.x.b1("Thursday_Single")) ? this.x.b1("Thursday_Single") : "T";
            }
            else if (a == 5) {
                b[0] = !stringIsNullOrWhiteSpace(this.x.b1("Friday_Full")) ? this.x.b1("Friday_Full") : "Friday";
                b[1] = !stringIsNullOrWhiteSpace(this.x.b1("Friday_Single")) ? this.x.b1("Friday_Single") : "F";
            }
            else if (a == 6) {
                b[0] = !stringIsNullOrWhiteSpace(this.x.b1("Saturday_Full")) ? this.x.b1("Saturday_Full") : "Saturday";
                b[1] = !stringIsNullOrWhiteSpace(this.x.b1("Saturday_Single")) ? this.x.b1("Saturday_Single") : "S";
            }
            return b;
        }
        j(a) {
            return this.ai._inner[a];
        }
        ad(a) {
            let b = this.ai._inner[a];
            let c = this.ah._inner[a];
            if (+(this.value) != +(dateMinValue()) && b.b == this.value.getDate() && b.c == dateGetMonth(this.value) && b.d == this.value.getFullYear()) {
                c.p4 = this.dn;
                c.p0 = this.dn;
                c.pu = this.dm;
                c.pz = this.dp;
                c.pv = this.dg;
            }
            else if (b.b == this.av.getDate() && b.c == dateGetMonth(this.av) && b.d == this.av.getFullYear()) {
                c.p4 = this.di;
                ;
                c.p0 = this.dk;
                c.pu = this.dg;
                c.pz = this.dj;
                c.pv = this.dh;
                c.br = 1;
            }
            else if (b.a != 0 && b.a != 6 && b.c == dateGetMonth(this.aq)) {
                c.p4 = this.dq;
                c.p0 = this.dk;
                c.pu = this.dg;
                c.pz = this.dj;
                c.pv = this.dg;
            }
            else {
                c.p4 = this.dq;
                c.p0 = this.dk;
                c.pu = this.dg;
                c.pz = this.dj;
                c.pv = this.dg;
            }
            if (b.d >= this.au.getFullYear() && b.d <= this.at.getFullYear()) {
                if (b.d == this.au.getFullYear() && b.d == this.at.getFullYear()) {
                    if (b.c == dateGetMonth(this.au) && b.c == dateGetMonth(this.at)) {
                        if (b.b >= this.au.getDate() && b.b <= this.at.getDate()) {
                            c.disabled = false;
                        }
                        else {
                            c.disabled = true;
                        }
                    }
                    else if (b.c >= dateGetMonth(this.au) && b.c <= dateGetMonth(this.at)) {
                        if (b.c == dateGetMonth(this.au)) {
                            if (b.b >= this.au.getDate()) {
                                c.disabled = false;
                            }
                            else {
                                c.disabled = true;
                            }
                        }
                        else if (b.c == dateGetMonth(this.at)) {
                            if (b.b <= this.at.getDate()) {
                                c.disabled = false;
                            }
                            else {
                                c.disabled = true;
                            }
                        }
                        else {
                            c.disabled = false;
                        }
                    }
                    else {
                        c.disabled = true;
                    }
                }
                else {
                    if (b.d == this.au.getFullYear()) {
                        if (b.c >= dateGetMonth(this.au)) {
                            if (b.c == dateGetMonth(this.au)) {
                                if (b.b >= this.au.getDate()) {
                                    c.disabled = false;
                                }
                                else {
                                    c.disabled = true;
                                }
                            }
                            else {
                                c.disabled = false;
                            }
                        }
                        else {
                            c.disabled = true;
                        }
                    }
                    else if (b.d == this.at.getFullYear()) {
                        if (b.c <= dateGetMonth(this.at)) {
                            if (b.c == dateGetMonth(this.at)) {
                                if (b.b <= this.at.getDate()) {
                                    c.disabled = false;
                                }
                                else {
                                    c.disabled = true;
                                }
                            }
                            else {
                                c.disabled = false;
                            }
                        }
                        else {
                            c.disabled = true;
                        }
                    }
                    else {
                        c.disabled = false;
                    }
                }
            }
            else {
                c.disabled = true;
            }
            return c.disabled;
        }
        aa(a, b) {
            if (this.aq.getFullYear() >= this.au.getFullYear() && this.aq.getFullYear() <= this.at.getFullYear()) {
                if (this.aq.getFullYear() == this.au.getFullYear() && this.aq.getFullYear() == this.at.getFullYear()) {
                    if (b < dateGetMonth(this.au) || b > dateGetMonth(this.at)) {
                        this.ak._inner[a].disabled = true;
                    }
                    else {
                        this.ak._inner[a].disabled = false;
                    }
                }
                else if (this.aq.getFullYear() == this.au.getFullYear()) {
                    if (b < dateGetMonth(this.au)) {
                        this.ak._inner[a].disabled = true;
                    }
                    else {
                        this.ak._inner[a].disabled = false;
                    }
                }
                else if (this.aq.getFullYear() == this.at.getFullYear()) {
                    if (b > dateGetMonth(this.at)) {
                        this.ak._inner[a].disabled = true;
                    }
                    else {
                        this.ak._inner[a].disabled = false;
                    }
                }
                else {
                    this.ak._inner[a].disabled = false;
                }
            }
            else {
                this.ak._inner[a].disabled = true;
            }
            return this.ak._inner[a].disabled;
        }
        ab(a, b) {
            if (b < this.au.getFullYear() || b > this.at.getFullYear()) {
                this.al._inner[a].disabled = true;
            }
            else {
                this.al._inner[a].disabled = false;
            }
            return this.al._inner[a].disabled;
        }
        cc(a) {
            this.aq = dateAddMonths(this.aq, a);
            this.cg();
        }
        cd(a) {
            this.aq = dateFromValues(this.aq.getFullYear(), a, this.aq.getDate(), 0, 0, 0, 0);
            this.cg();
        }
        ce(a) {
            let b = dateGetMonth(this.aq);
            let c = this.aq.getDate();
            if (a == this.au.getFullYear() && a == this.at.getFullYear()) {
                if (b < dateGetMonth(this.au)) {
                    b = dateGetMonth(this.au);
                    if (c < this.au.getDate()) {
                        c = this.au.getDate();
                    }
                }
                else if (b > dateGetMonth(this.at)) {
                    b = dateGetMonth(this.at);
                    if (c > this.at.getDate()) {
                        c = this.at.getDate();
                    }
                }
                else if (b == dateGetMonth(this.au) && b == dateGetMonth(this.at)) {
                    if (c < this.au.getDate()) {
                        c = this.au.getDate();
                    }
                    else if (c > this.at.getDate()) {
                        c = this.at.getDate();
                    }
                }
                else if (b == dateGetMonth(this.au)) {
                    if (c < this.au.getDate()) {
                        c = this.au.getDate();
                    }
                }
                else if (b == dateGetMonth(this.at)) {
                    if (c > this.at.getDate()) {
                        c = this.at.getDate();
                    }
                }
            }
            else if (a == this.au.getFullYear()) {
                if (b < dateGetMonth(this.au)) {
                    b = dateGetMonth(this.au);
                    if (c < this.au.getDate()) {
                        c = this.au.getDate();
                    }
                }
                else if (b == dateGetMonth(this.au)) {
                    if (c < this.au.getDate()) {
                        c = this.au.getDate();
                    }
                }
            }
            else if (a == this.at.getFullYear()) {
                if (b > dateGetMonth(this.at)) {
                    b = dateGetMonth(this.at);
                    if (c > this.at.getDate()) {
                        c = this.at.getDate();
                    }
                }
                else if (b == dateGetMonth(this.at)) {
                    if (c > this.at.getDate()) {
                        c = this.at.getDate();
                    }
                }
            }
            this.aq = dateFromValues(a, b, c, 0, 0, 0, 0);
            this.cg();
        }
        cz(a, b) {
            if (b < 0) {
                a--;
            }
            else {
                a++;
            }
            this.h.a5(a);
        }
        cy() {
            this.h.ar();
        }
        bj() {
            return this.f();
        }
        bs() {
            let a = this.f();
            return a.o();
        }
        f() {
            let a = new CalendarVisualModelExport();
            a.i = this.t;
            a.h = this.r;
            a.e = AppearanceHelper.a(this.dm);
            a.g = AppearanceHelper.a(this.dp);
            a.c = AppearanceHelper.a(this.dj);
            a.f = AppearanceHelper.a(this.dn);
            a.d = AppearanceHelper.a(this.dk);
            a.b = AppearanceHelper.a(this.di);
            a.a = AppearanceHelper.a(this.dh);
            a.j = new List$1(ButtonVisualModelExport.$, 0);
            a.k = new List$1(TextElementsVisualModelExport.$, 0);
            a.l = new List$1(TextElementsVisualModelExport.$, 0);
            let b = this.h.x();
            a.n = b;
            let c = this.h.a();
            let d = c[0];
            let e = c[1];
            if (b == "day") {
                for (let f = 0; f < this.aj.count; f++) {
                    if (this.aj._inner[f].h2 == null) {
                        this.aj._inner[f].h2 = "header" + f.toString();
                    }
                    let g = this.aj._inner[f].d7();
                    g.s = g.s - d;
                    g.q = g.q - e;
                    a.j.add(g);
                }
                for (let h = 0; h < this.ah.count; h++) {
                    if (this.ah._inner[h].h2 == null) {
                        this.ah._inner[h].h2 = "days" + h.toString();
                    }
                    let i = this.ah._inner[h].d7();
                    i.s = i.s - d;
                    i.q = i.q - e;
                    a.j.add(i);
                }
                if (this.ae == true) {
                    this.g.h2 = "todayButton";
                    let j = this.g.d7();
                    j.s = j.s - d;
                    j.q = j.q - e;
                    a.j.add(j);
                }
                let k = this.h.k();
                for (let l = 0; l < k.count; l++) {
                    let m = new TextElementsVisualModelExport();
                    let n = this.h.b(k._inner[l]);
                    m.e = n[0] - d;
                    m.d = n[1] - e;
                    m.c = NativeUI.d(k._inner[l].parent());
                    m.f = NativeUI.k(k._inner[l].parent());
                    m.b = AppearanceHelper.a(NativeUI.al(k._inner[l]));
                    m.g = k._inner[l].getText();
                    a.k.add(m);
                }
                if (this.af == true) {
                    let o = this.h.l();
                    for (let p = 0; p < o.count; p++) {
                        let q = new TextElementsVisualModelExport();
                        let r = this.h.b(o._inner[p]);
                        q.e = r[0] - d;
                        q.d = r[1] - e;
                        q.c = NativeUI.d(o._inner[p].parent());
                        q.f = NativeUI.k(o._inner[p].parent());
                        q.b = AppearanceHelper.a(NativeUI.al(o._inner[p]));
                        q.a = AppearanceHelper.a(NativeUI.ak(o._inner[p]));
                        q.g = o._inner[p].getText();
                        a.l.add(q);
                    }
                }
            }
            else if (b == "month") {
                for (let s = 0; s < this.ak.count; s++) {
                    if (this.ak._inner[s].h2 == null) {
                        this.ak._inner[s].h2 = "months" + s.toString();
                    }
                    let t = this.ak._inner[s].d7();
                    t.s = t.s - d;
                    t.q = t.q - e;
                    a.j.add(t);
                }
            }
            else if (b == "year") {
                for (let u = 0; u < this.al.count; u++) {
                    if (this.al._inner[u].h2 == null) {
                        this.al._inner[u].h2 = "years" + u.toString();
                    }
                    let v = this.al._inner[u].d7();
                    v.s = v.s - d;
                    v.q = v.q - e;
                    a.j.add(v);
                }
            }
            if (this.v != null) {
                let w = this.v;
                if (this.h != null && w.q == null) {
                    let x = this.h.m;
                    let y = FontUtil.getFontInfoFromString(x, w.fontString);
                    w.q = y.q;
                    w.f = y.f;
                    w.r = y.r;
                    w.t = y.t;
                    w.u = y.u;
                    w.v = y.v;
                }
                if (w.q != null) {
                    a.p = w.q;
                }
                if (!isNaN_(w.f)) {
                    a.m = w.f;
                }
                if (w.v != null) {
                    a.t = w.v;
                }
                if (w.t != null) {
                    a.r = w.t;
                }
                if (w.r != null) {
                    a.q = w.t;
                }
            }
            return a;
        }
    }
    XCalendar.$t = /*@__PURE__*/ markType(XCalendar, 'XCalendar', Base.$, [INotifyPropertyChanged_$type]);
    XCalendar.bk = "M15.41 16.59L10.83 12l4.58-4.59L14 6l-6 6 6 6 1.41-1.41z";
    XCalendar.bl = "M8.59 16.59L13.17 12 8.59 7.41 10 6l6 6-6 6-1.41-1.41z";
    XCalendar.b = [0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334, 365];
    XCalendar.c = [0, 31, 60, 91, 121, 152, 182, 213, 244, 274, 305, 335, 366];
    return XCalendar;
})();
