/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, typeCast, Delegate_$type, fromEnum, runOn, markType, Point_$type, typeGetValue, INotifyPropertyChanged_$type, PropertyChangedEventArgs, enumGetBox, EventArgs, delegateCombine, fromEn, toNullable, Number_$type, String_$type } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { ScaleTransform } from "igniteui-react-core";
import { NativeUI } from "igniteui-react-core";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { KeyFrameAnimationFactory } from "igniteui-react-core";
import { AnimationKeyFrameEffect } from "igniteui-react-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-react-core";
import { stringReplace, stringIsNullOrEmpty } from "igniteui-react-core";
import { TransformGroup } from "igniteui-react-core";
import { TranslateTransform } from "igniteui-react-core";
import { SuffixShiftType_$type } from "./SuffixShiftType";
import { PrefixShiftType_$type } from "./PrefixShiftType";
import { LabelShiftType_$type } from "./LabelShiftType";
import { HorizontalAlignment_$type } from "igniteui-react-core";
import { MouseButtonEventArgs } from "igniteui-react-core";
import { KeyEventArgs } from "igniteui-react-core";
import { InputShiftType_$type } from "./InputShiftType";
import { isNaN_ } from "igniteui-react-core";
import { SuffixVisualModelExport } from "./SuffixVisualModelExport";
import { PrefixVisualModelExport } from "./PrefixVisualModelExport";
import { InputGroupDisplayType_$type } from "./InputGroupDisplayType";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { CornerRadius } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { ThemeResolver } from "./ThemeResolver";
import { ObservableCollection$1 } from "igniteui-react-core";
import { AnimationKeyFrameProperty } from "igniteui-react-core";
import { InputGroupVisualModelExport } from "./InputGroupVisualModelExport";
import { AppearanceHelper } from "igniteui-react-core";
import { LabelVisualModelExport } from "./LabelVisualModelExport";
import { InputVisualModelExport } from "./InputVisualModelExport";
import { Dictionary$2 } from "igniteui-react-core";
import { Theme } from "./Theme";
import { DeviceUtils } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
import { FontUtil } from "igniteui-react-core";
import { MaskParsingService } from "./MaskParsingService";
import { InputChangeEventArgs } from "./InputChangeEventArgs";
import { MaskOptions } from "./MaskOptions";
/**
 * @hidden
 */
export let InputGroupView = /*@__PURE__*/ (() => {
    class InputGroupView extends Base {
        constructor() {
            super();
            this.d = null;
            this.l = null;
            this.e = null;
            this.i = new List$1(Delegate_$type, 0);
            this.z = null;
            this.f = true;
            this.n = null;
            this.o = null;
            this.p = null;
            this.t = null;
            this.r = null;
            this.q = null;
            this.m = null;
        }
        ak() {
        }
        ac(a) {
            if (typeCast(XLabel.$, a) !== null) {
                a.bc = "flex-start";
            }
        }
        ae(a) {
        }
        ad() {
        }
        g() {
            return true;
        }
        get w() {
            return this.n;
        }
        get as() {
            return null;
        }
        get h() {
            return true;
        }
        ah(a) {
            if (a == null) {
                for (let b of fromEnum(this.i)) {
                    b();
                }
                this.i.clear();
            }
            this.l = a;
            a.rootWrapper.setStyleProperty("position", "relative");
            a.rootWrapper.setStyleProperty("box-sizing", "border-box");
            a.rootWrapper.setStyleProperty("border-width", "0px");
            a.rootWrapper.setStyleProperty("border-style", "solid");
            let c = this.v;
            this.i.add(c.listen("focusin", runOn(this, this.aj)));
            this.i.add(c.listen("focusout", runOn(this, this.am)));
            let d = this.l.createElement("div");
            d.setStyleProperty("position", "absolute");
            d.setStyleProperty("width", "100%");
            d.setStyleProperty("height", "100%");
            d.setStyleProperty("border-style", "solid");
            d.setStyleProperty("box-sizing", "border-box");
            d.setStyleProperty("left", "0px");
            d.setStyleProperty("top", "0px");
            this.l.append(d);
            this.m = d;
            let e = this.l.createElement("div");
            e.addClass("ig-input-content");
            e.setStyleProperty("width", "100%");
            e.setStyleProperty("position", "relative");
            e.setStyleProperty("display", "flex");
            e.setStyleProperty("flex-direction", "row");
            e.setStyleProperty("flex-wrap", "no-wrap");
            e.setStyleProperty("flex-flow", "row nowrap");
            e.setStyleProperty("flex-grow", "1");
            e.setStyleProperty("align-items", "center");
            e.setStyleProperty("padding-top", "1.125rem");
            this.p = e;
            this.i.add(e.listen("click", runOn(this, this.aa)));
            this.l.append(e);
            this.l.getPortal(e, "ChildContent", (f) => {
                let comp_ = f.componentRef;
                this.t = comp_;
                this.p.setStyleProperty("flex-direction", "row");
            }, true);
            let f = this.l.createElement("div");
            f.setStyleProperty("position", "absolute");
            f.setStyleProperty("width", "100%");
            f.setStyleProperty("background-color", "rgba(0, 0, 0, 0.54)");
            f.setStyleProperty("height", "1px");
            f.setStyleProperty("pointer-events", "none");
            f.setStyleProperty("left", "0px");
            f.setStyleProperty("bottom", "1px");
            f.setStyleProperty("overflow", "visible");
            let g = this.l.createElement("span");
            g.setStyleProperty("width", "100%");
            g.setStyleProperty("height", "2px");
            g.setStyleProperty("display", "block");
            g.setStyleProperty("pointer-events", "none");
            NativeUI.af(g, ((() => {
                let $ret = new ScaleTransform();
                $ret.l = 0.5;
                $ret.m = 1;
                return $ret;
            })()));
            g.setStyleProperty("opacity", "0");
            this.r = g;
            f.append(this.r);
            this.q = f;
            this.l.append(f);
            this.d.j3();
        }
        get s() {
            return this.p;
        }
        get v() {
            return this.l.rootWrapper;
        }
        get u() {
            return this.m;
        }
        get x() {
            return this.q;
        }
        get y() {
            return this.r;
        }
        aq(a) {
            if (this.z != a) {
                this.z = a;
                if (this.o != null) {
                    this.o.setAttribute("d", this.z);
                }
            }
        }
        ap() {
            switch (this.d.s) {
                case 1:
                    this.p.setStyleProperty("padding-top", "1.125rem");
                    break;
                case 2:
                    this.p.setStyleProperty("padding-top", ".94737rem");
                    break;
                case 3:
                    this.p.setStyleProperty("padding-top", ".81818rem");
                    break;
            }
        }
        aa(a) {
        }
        al() {
            if (this.g()) {
            }
        }
        j() {
            let a = this.l.rootWrapper.getStyleProperty("height");
            return parseFloat(stringReplace(a, "px", ""));
        }
        ag() {
            this.f = true;
        }
        ai() {
            this.f = false;
            for (let a of fromEnum(this.i)) {
                a();
            }
            this.i.clear();
        }
        ar(a) {
            if (a != null) {
                this.l.rootWrapper.setStyleProperty("font", a.fontString);
            }
        }
        k(a) {
            return a.view.i();
        }
        af() {
            if (KeyFrameAnimationFactory.h == null) {
                KeyFrameAnimationFactory.h = this.l;
            }
        }
        a(a) {
            return new AnimationKeyFrameEffect(0, this.u, 0, null, a);
        }
        c(a) {
            return new AnimationKeyFrameEffect(0, this.x, 0, null, a);
        }
        b(a) {
            return new AnimationKeyFrameEffect(0, this.r, 0, null, a);
        }
        ao(a) {
        }
        ab(a) {
            this.p.append(a);
        }
        an(a) {
            this.p.removeChild(a);
        }
        aj(a) {
            this.d.jz();
        }
        am(a) {
            this.d.j1();
        }
    }
    InputGroupView.$t = /*@__PURE__*/ markType(InputGroupView, 'InputGroupView');
    return InputGroupView;
})();
/**
 * @hidden
 */
export let SuffixView = /*@__PURE__*/ (() => {
    class SuffixView extends Base {
        constructor() {
            super();
            this.a = null;
            this.g = null;
            this.b = null;
            this.e = new List$1(Delegate_$type, 0);
            this.c = true;
            this.h = null;
        }
        o() {
        }
        d() {
            return true;
        }
        get r() {
            return null;
        }
        m(a) {
            if (a == null) {
                for (let b of fromEnum(this.e)) {
                    b();
                }
                this.e.clear();
            }
            this.g = a;
            this.g.rootWrapper.setStyleProperty("display", "inline-block");
            let c = this.g.createElement("div");
            c.addClass("ig-suffix-content");
            this.g.append(c);
            c.setStyleProperty("cursor", "pointer");
            this.h = c;
            this.g.getPortal(c, "ChildContent", (d) => {
            }, true);
            this.a.am();
        }
        q() {
            let a = new TransformGroup();
            a.j.add(((() => {
                let $ret = new TranslateTransform();
                $ret.k = this.a.k == 2 ? (this.f() * -0.25) : 0;
                return $ret;
            })()));
            a.j.add(((() => {
                let $ret = new ScaleTransform();
                $ret.l = 1;
                $ret.m = 1;
                return $ret;
            })()));
            NativeUI.af(this.g.rootWrapper, a);
            this.g.rootWrapper.setStyleProperty("transform-origin", "0px 0px");
        }
        f() {
            let a = this.g.rootWrapper.getStyleProperty("height");
            return parseFloat(stringReplace(a, "px", ""));
        }
        p() {
            if (this.d()) {
            }
        }
        i(a) {
            this.a.aj();
        }
        j(a) {
            this.a.ak();
        }
        l() {
            this.c = true;
            this.e.add(this.g.rootWrapper.listen("mouseenter", runOn(this, this.i)));
            this.e.add(this.g.rootWrapper.listen("mouseleave", runOn(this, this.j)));
        }
        n() {
            this.c = false;
            for (let a of fromEnum(this.e)) {
                a();
            }
            this.e.clear();
        }
        k(a) {
            this.h.append(a);
        }
    }
    SuffixView.$t = /*@__PURE__*/ markType(SuffixView, 'SuffixView');
    return SuffixView;
})();
/**
 * @hidden
 */
export let PrefixView = /*@__PURE__*/ (() => {
    class PrefixView extends Base {
        constructor() {
            super();
            this.a = null;
            this.g = null;
            this.b = null;
            this.e = new List$1(Delegate_$type, 0);
            this.c = true;
            this.h = null;
        }
        o() {
        }
        d() {
            return true;
        }
        get r() {
            return null;
        }
        m(a) {
            if (a == null) {
                for (let b of fromEnum(this.e)) {
                    b();
                }
                this.e.clear();
            }
            this.g = a;
            this.g.rootWrapper.setStyleProperty("display", "inline-block");
            let c = this.g.createElement("div");
            c.addClass("ig-prefix-content");
            this.g.append(c);
            c.setStyleProperty("cursor", "pointer");
            this.h = c;
            this.g.getPortal(c, "ChildContent", (d) => {
            }, true);
            this.a.am();
        }
        q() {
            let a = new TransformGroup();
            a.j.add(((() => {
                let $ret = new TranslateTransform();
                $ret.k = this.a.k == 2 ? (this.f() * -0.25) : 0;
                return $ret;
            })()));
            a.j.add(((() => {
                let $ret = new ScaleTransform();
                $ret.l = 1;
                $ret.m = 1;
                return $ret;
            })()));
            NativeUI.af(this.g.rootWrapper, a);
            this.g.rootWrapper.setStyleProperty("transform-origin", "0px 0px");
        }
        f() {
            let a = this.g.rootWrapper.getStyleProperty("height");
            return parseFloat(stringReplace(a, "px", ""));
        }
        p() {
            if (this.d()) {
            }
        }
        i(a) {
            this.a.aj();
        }
        j(a) {
            this.a.ak();
        }
        l() {
            this.c = true;
            this.e.add(this.g.rootWrapper.listen("mouseenter", runOn(this, this.i)));
            this.e.add(this.g.rootWrapper.listen("mouseleave", runOn(this, this.j)));
        }
        n() {
            this.c = false;
            for (let a of fromEnum(this.e)) {
                a();
            }
            this.e.clear();
        }
        k(a) {
            this.h.append(a);
        }
    }
    PrefixView.$t = /*@__PURE__*/ markType(PrefixView, 'PrefixView');
    return PrefixView;
})();
/**
 * @hidden
 */
export let LabelView = /*@__PURE__*/ (() => {
    class LabelView extends Base {
        constructor() {
            super();
            this.c = null;
            this.k = null;
            this.d = null;
            this.h = new List$1(Delegate_$type, 0);
            this.o = null;
            this.e = true;
            this.l = null;
            this.m = null;
        }
        ab() {
        }
        f() {
            return true;
        }
        get n() {
            return this.l;
        }
        get aj() {
            return null;
        }
        get g() {
            return true;
        }
        s() {
            if (KeyFrameAnimationFactory.h == null) {
                KeyFrameAnimationFactory.h = this.k;
            }
        }
        b(a) {
            return new AnimationKeyFrameEffect(0, this.k.rootWrapper, 0, null, a);
        }
        a(a) {
            return new AnimationKeyFrameEffect(0, this.k.rootWrapper, 0, null, a);
        }
        w(a) {
            if (a == null) {
                for (let b of fromEnum(this.h)) {
                    b();
                }
                this.h.clear();
            }
            this.k = a;
            this.k.rootWrapper.setStyleProperty("display", "inline-block");
            this.k.rootWrapper.setStyleProperty("position", "relative");
            let c = this.k.createElement("label");
            c.setStyleProperty("position", "relative");
            c.setStyleProperty("display", "inline-block");
            c.setStyleProperty("white-space", "nowrap");
            c.setStyleProperty("text-overflow", "ellipsis");
            c.setStyleProperty("line-height", "1");
            c.setStyleProperty("overflow", "hidden");
            c.setStyleProperty("height", "1.125rem");
            c.setStyleProperty("backface-visibility", "hidden");
            NativeUI.q(this.k.rootWrapper, this.c.cz);
            c.setStyleProperty("outline-style", "none");
            c.setStyleProperty("box-shadow", "none");
            c.setStyleProperty("font-family", "Verdana");
            c.setStyleProperty("font-size", "1rem");
            this.l = c;
            this.k.append(this.l);
            this.c.ch();
        }
        j() {
            return this.c.l == 0 ? (this.i() * 0.5) : 0;
        }
        af() {
            this.c.bi = "block";
            let a = new TransformGroup();
            a.j.add(((() => {
                let $ret = new TranslateTransform();
                $ret.k = this.c.l == 0 ? (this.i() * 0.5) : 0;
                return $ret;
            })()));
            a.j.add(((() => {
                let $ret = new ScaleTransform();
                $ret.l = 1;
                $ret.m = 1;
                return $ret;
            })()));
            NativeUI.af(this.k.rootWrapper, a);
            this.l.setStyleProperty("height", "1.125rem");
            this.k.rootWrapper.setStyleProperty("position", "absolute");
            this.k.rootWrapper.setStyleProperty("transform-origin", "0px 0px");
        }
        ag() {
            switch (this.c.s) {
                case 1:
                    this.k.rootWrapper.setStyleProperty("margin-top", "0px");
                    break;
                case 2:
                    this.k.rootWrapper.setStyleProperty("margin-top", "-.125rem");
                    break;
                case 3:
                    this.k.rootWrapper.setStyleProperty("margin-top", "-.25rem");
                    break;
            }
        }
        ae() {
            this.l.setText(this.c.text != null ? this.c.text : "");
        }
        ah(a) {
            if (this.o != a) {
                this.o = a;
                if (this.m != null) {
                    this.m.setAttribute("d", this.o);
                }
            }
        }
        y() {
            if (this.k != null) {
                this.k.rootWrapper.setStyleProperty("display", this.c.bi);
                this.l.setStyleProperty("display", this.c.bi);
                let ext_ = this.k.getExternal(this.c, null, null);
                if (ext_ && ext_._onDisplayChanged) {
                    ext_._onDisplayChanged();
                }
                ;
            }
        }
        t() {
            if (this.k != null) {
                this.k.rootWrapper.setStyleProperty("align-items", this.c.ba);
                this.l.setStyleProperty("align-items", this.c.ba);
                let ext_ = this.k.getExternal(this.c, null, null);
                if (ext_ && ext_._onAlignItemsChanged) {
                    ext_._onAlignItemsChanged();
                }
                ;
            }
        }
        u() {
            if (this.k != null) {
                this.k.rootWrapper.setStyleProperty("align-self", this.c.bc);
                this.l.setStyleProperty("align-self", this.c.bc);
                let ext_ = this.k.getExternal(this.c, null, null);
                if (ext_ && ext_._onAlignSelfChanged) {
                    ext_._onAlignSelfChanged();
                }
                ;
            }
        }
        z() {
            if (this.k != null) {
                this.k.rootWrapper.setStyleProperty("flex-direction", this.c.bl);
                this.l.setStyleProperty("flex-direction", this.c.bl);
                let ext_ = this.k.getExternal(this.c, null, null);
                if (ext_ && ext_._onFlexDirectionChanged) {
                    ext_._onFlexDirectionChanged();
                }
                ;
            }
        }
        aa() {
            if (this.k != null) {
                this.k.rootWrapper.setStyleProperty("flex-grow", this.c.bn);
                this.l.setStyleProperty("flex-grow", this.c.bn);
                let ext_ = this.k.getExternal(this.c, null, null);
                if (ext_ && ext_._onFlexGrowChanged) {
                    ext_._onFlexGrowChanged();
                }
                ;
            }
        }
        p(a) {
        }
        ac() {
            if (this.f()) {
            }
        }
        i() {
            let a = this.k.rootWrapper.getStyleProperty("height");
            return parseFloat(stringReplace(a, "px", ""));
        }
        q(a) {
            this.c.ce();
        }
        r(a) {
            this.c.cf();
        }
        v() {
            this.e = true;
            this.h.add(this.k.rootWrapper.listen("mouseenter", runOn(this, this.q)));
            this.h.add(this.k.rootWrapper.listen("mouseleave", runOn(this, this.r)));
        }
        x() {
            this.e = false;
            for (let a of fromEnum(this.h)) {
                a();
            }
            this.h.clear();
        }
        ai(a) {
            if (a != null) {
                this.l.setStyleProperty("font", a.fontString);
            }
        }
        ad(a) {
            NativeUI.q(this.l, a);
        }
    }
    LabelView.$t = /*@__PURE__*/ markType(LabelView, 'LabelView');
    return LabelView;
})();
/**
 * @hidden
 */
export let InputView = /*@__PURE__*/ (() => {
    class InputView extends Base {
        constructor() {
            super();
            this.b = null;
            this.l = null;
            this.c = null;
            this.j = new List$1(Delegate_$type, 0);
            this.g = false;
            this.f = false;
            this.r = null;
            this.d = true;
            this.m = null;
            this.n = null;
            this.g = false;
        }
        as() {
        }
        h() {
            return true;
        }
        get q() {
            return this.m;
        }
        get bd() {
            return null;
        }
        get i() {
            return true;
        }
        ap(a) {
            if (a == null) {
                for (let b of fromEnum(this.j)) {
                    b();
                }
                this.j.clear();
            }
            this.l = a;
            this.l.rootWrapper.setStyleProperty("display", "inline-block");
            let c = this.l.createElement("input");
            c.setAttribute("type", this.b.b8);
            c.setStyleProperty("position", "relative");
            c.setStyleProperty("box-sizing", "border-box");
            c.setStyleProperty("display", "inline-block");
            c.setStyleProperty("border", "none");
            c.setStyleProperty("height", "2rem");
            c.setStyleProperty("line-height", "0");
            c.setStyleProperty("width", "100%");
            c.setStyleProperty("min-width", "0");
            c.setStyleProperty("overflow", "visible");
            c.setStyleProperty("background", "transparent");
            c.setStyleProperty("background-position-x", "initial");
            c.setStyleProperty("background-position-y", "initial");
            c.setStyleProperty("background-size", "initial");
            c.setStyleProperty("background-repeat-x", "initial");
            c.setStyleProperty("background-repeat-y", "initial");
            c.setStyleProperty("background-attachment", "initial");
            c.setStyleProperty("background-origin", "initial");
            c.setStyleProperty("background-color", "transparent");
            NativeUI.q(c, this.b.d4);
            c.setStyleProperty("outline-style", "none");
            c.setStyleProperty("box-shadow", "none");
            c.setStyleProperty("border-top", "0.1875rem solid transparent");
            c.setStyleProperty("padding-bottom", "0.1875rem");
            c.setStyleProperty("text-align", this.t(this.b.dy));
            c.setStyleProperty("font-family", "Verdana");
            c.setStyleProperty("font-size", "1rem");
            this.j.add(c.listen("change", runOn(this, this.y)));
            this.j.add(c.listen("input", runOn(this, this.z)));
            this.j.add(c.listen("focus", runOn(this, this.ae)));
            this.j.add(c.listen("blur", runOn(this, this.x)));
            this.j.add(c.listen("mouseenter", runOn(this, this.v)));
            this.j.add(c.listen("mouseleave", runOn(this, this.w)));
            this.j.add(c.listen("keydown", runOn(this, this.af)));
            this.j.add(c.listen("keyup", runOn(this, this.ah)));
            this.j.add(c.listen("keypress", runOn(this, this.ag)));
            this.j.add(c.listen("paste", runOn(this, this.ak)));
            this.j.add(c.listen("dragenter", runOn(this, this.ac)));
            this.j.add(c.listen("dragleave", runOn(this, this.ad)));
            this.j.add(c.listen("compositionstart", runOn(this, this.ab)));
            this.j.add(c.listen("compositionend", runOn(this, this.aa)));
            this.j.add(c.listen("mousedown", runOn(this, this.ai)));
            this.j.add(c.listen("mouseup", runOn(this, this.aj)));
            this.m = c;
            this.l.append(this.m);
            this.am();
            this.b.dl();
        }
        a0(a) {
            if (a) {
                this.m.setAttribute("readonly", a.toString());
            }
            else {
                this.m.getNativeElement().removeAttribute("readonly");
            }
        }
        ay(a) {
            if (a) {
                this.m.setAttribute("disabled", "true");
            }
            else {
                this.m.getNativeElement().removeAttribute("disabled");
            }
        }
        a5(a) {
            this.m.setStyleProperty("text-align", this.t(a));
        }
        a4(a) {
            if (a) {
                this.m.removeClass("ig-input-hide-spinner");
            }
            else {
                this.m.addClass("ig-input-hide-spinner");
            }
        }
        ab(a) {
            this.g = true;
            this.b.c3();
        }
        aa(a) {
            this.g = false;
            let b = null;
            if (a.originalEvent != null) {
                b = (a.originalEvent.data);
            }
            this.b.c2(b);
        }
        t(a) {
            switch (a) {
                case 0: return "left";
                case 2: return "right";
                case 1: return "center";
            }
            return "left";
        }
        aw() {
            this.m.setAttribute("type", this.b.b8);
            if (this.b.b8 == "date") {
                this.m.setStyleProperty("line-height", "normal");
            }
            else {
                this.m.setStyleProperty("line-height", "0");
            }
        }
        au() {
            this.m.setAttribute("placeholder", this.b.cg);
        }
        a9() {
            switch (this.b.z) {
                case 1:
                    this.m.setStyleProperty("height", "2rem");
                    this.m.setStyleProperty("font-size", "1rem");
                    break;
                case 2:
                    this.m.setStyleProperty("height", "1.68421rem");
                    this.m.setStyleProperty("font-size", "1rem");
                    break;
                case 3:
                    this.m.setStyleProperty("height", "1.45455rem");
                    this.m.setStyleProperty("font-size", ".95455rem");
                    break;
            }
        }
        a8() {
            let a = this.k();
            if (isNaN_(a) || a == 0) {
                if (!this.f) {
                    this.f = true;
                    this.l.setTimeout(() => {
                        this.f = false;
                        this.a8();
                    }, 100);
                }
            }
            let b = new TransformGroup();
            b.j.add(((() => {
                let $ret = new TranslateTransform();
                $ret.k = this.b.o == 2 ? (this.k() * -0.25) : 0;
                return $ret;
            })()));
            b.j.add(((() => {
                let $ret = new ScaleTransform();
                $ret.l = 1;
                $ret.m = 1;
                return $ret;
            })()));
            NativeUI.af(this.l.rootWrapper, b);
            this.l.rootWrapper.setStyleProperty("transform-origin", "0px 0px");
        }
        k() {
            let a = this.l.rootWrapper.getStyleProperty("height");
            let b = parseFloat(stringReplace(a, "px", ""));
            return b;
        }
        ax(a) {
            this.m.setProperty("value", a);
        }
        az(a) {
            this.m.setAttribute("name", a);
        }
        x(a) {
            this.b.cz();
        }
        ae(a) {
            this.b.c7();
        }
        ai(a) {
            let b = this.bc(a);
            this.b.dd(b);
            if (b.handled) {
                a.preventDefault();
            }
        }
        aj(a) {
            let b = this.bc(a);
            this.b.dg(b);
            if (b.handled) {
                a.preventDefault();
            }
        }
        bc(a) {
            let b = new MouseButtonEventArgs();
            b.position = { $type: Point_$type, x: a.offsetX, y: a.offsetY };
            return b;
        }
        y(a) {
            this.b.c0();
        }
        z(a) {
            this.b.c1();
        }
        af(a) {
            let b = new KeyEventArgs(0, a);
            this.b.da(b);
        }
        ah(a) {
            let b = new KeyEventArgs(0, a);
            this.b.dc(b);
        }
        ag(a) {
            let b = new KeyEventArgs(0, a);
            this.b.db(b);
        }
        ak(a) {
            this.b.dh();
        }
        ac(a) {
            this.b.c5();
        }
        ad(a) {
            this.b.c6();
        }
        ba(a) {
            if (this.r != a) {
                this.r = a;
                if (this.n != null) {
                    this.n.setAttribute("d", this.r);
                }
            }
        }
        s() {
            return this.m.getProperty("value");
        }
        u(a) {
        }
        a7() {
            if (this.h()) {
                if (this.b.as) {
                    this.m.setAttribute("tabindex", this.b.be.toString());
                }
                else {
                    this.m.getNativeElement().removeAttribute("tabindex");
                }
            }
        }
        p() {
            let a = this.m.getProperty("selectionStart");
            return typeGetValue(a);
        }
        o() {
            let a = this.m.getProperty("selectionEnd");
            return typeGetValue(a);
        }
        a3(a) {
            this.m.setProperty("selectionStart", a);
        }
        a1(a) {
            this.m.setProperty("selectionEnd", a);
        }
        at() {
            if (this.h()) {
            }
        }
        v(a) {
            this.b.de();
        }
        w(a) {
            this.b.df();
        }
        an() {
            this.d = true;
            this.j.add(this.m.listen("change", runOn(this, this.y)));
            this.j.add(this.m.listen("input", runOn(this, this.z)));
            this.j.add(this.m.listen("focus", runOn(this, this.ae)));
            this.j.add(this.m.listen("blur", runOn(this, this.x)));
            this.j.add(this.m.listen("mouseenter", runOn(this, this.v)));
            this.j.add(this.m.listen("mouseleave", runOn(this, this.w)));
            this.j.add(this.m.listen("keydown", runOn(this, this.af)));
            this.j.add(this.m.listen("paste", runOn(this, this.ak)));
            this.j.add(this.m.listen("dragenter", runOn(this, this.ac)));
            this.j.add(this.m.listen("dragleave", runOn(this, this.ad)));
            this.j.add(this.m.listen("compositionstart", runOn(this, this.ab)));
            this.j.add(this.m.listen("compositionend", runOn(this, this.aa)));
            this.j.add(this.m.listen("mousedown", runOn(this, this.ai)));
            this.j.add(this.m.listen("mouseup", runOn(this, this.aj)));
        }
        aq() {
            this.d = false;
            for (let a of fromEnum(this.j)) {
                a();
            }
            this.j.clear();
        }
        bb(a) {
            if (a != null) {
                this.m.setStyleProperty("font", a.fontString);
            }
        }
        a6() {
        }
        ao() {
            if (this.m != null) {
                let a = this.m.getNativeElement();
                a.blur();
            }
        }
        ar(a) {
            if (this.m != null) {
                this.m.focus(a);
            }
        }
        av() {
            if (this.m != null) {
                let nativeInput_ = this.m;
                nativeInput_.getNativeElement().select();
            }
        }
        a2(a, b) {
            if (this.m != null) {
                let c = this.m.getNativeElement();
                c.setSelectionRange(a, b);
            }
        }
        al() {
            if (KeyFrameAnimationFactory.h == null) {
                KeyFrameAnimationFactory.h = this.l;
            }
        }
        a(a) {
            return new AnimationKeyFrameEffect(0, this.l.rootWrapper, 0, null, a);
        }
        am() {
            if (InputView.e) {
                return;
            }
            let a = "\r\n.ig-input-hide-spinner::-webkit-outer-spin-button,\r\n.ig-input-hide-spinner::-webkit-inner-spin-button {\r\n    -webkit-appearance: none;\r\n    margin: 0;\r\n}";
            let b = this.l.createElement("style");
            b.setRawText(a);
            document.head.appendChild(b.getNativeElement());
            InputView.e = true;
        }
    }
    InputView.$t = /*@__PURE__*/ markType(InputView, 'InputView');
    InputView.e = false;
    return InputView;
})();
/**
 * @hidden
 */
export let XInputGroupItem = /*@__PURE__*/ (() => {
    class XInputGroupItem extends Base {
        constructor() {
            super(...arguments);
            this.c = null;
            this.a = null;
            this.propertyChanged = null;
        }
        get e() {
            return this.c;
        }
        set e(a) {
            let b = this.c;
            this.c = a;
            if (b != this.c) {
                this.g("Name", b, a);
            }
        }
        get b() {
            return this.a;
        }
        set b(a) {
            let b = this.a;
            this.a = a;
            if (b != this.a) {
                this.g("InputGroup", b, a);
            }
        }
        g(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.h(a, b, c);
        }
        h(a, b, c) {
        }
    }
    XInputGroupItem.$t = /*@__PURE__*/ markType(XInputGroupItem, 'XInputGroupItem', Base.$, [INotifyPropertyChanged_$type]);
    return XInputGroupItem;
})();
/**
 * @hidden
 */
export let XSuffix = /*@__PURE__*/ (() => {
    class XSuffix extends XInputGroupItem {
        constructor() {
            super();
            this._view = null;
            this.j = 0;
            this.v = "ig-suffix-" + XSuffix.s++;
            this.u = null;
            this.n = false;
            this.m = false;
            this.o = false;
            let a = new SuffixView();
            a.a = this;
            this.view = a;
            this.view.o();
        }
        get view() {
            return this._view;
        }
        set view(a) {
            this._view = a;
        }
        destroy() {
            this.provideContainer(null);
        }
        get k() {
            return this.j;
        }
        set k(a) {
            let b = this.j;
            this.j = a;
            if (b != this.j) {
                this.g("ShiftType", enumGetBox(SuffixShiftType_$type, b), enumGetBox(SuffixShiftType_$type, a));
            }
        }
        h(a, b, c) {
            super.h(a, b, c);
            switch (a) {
                case "InputGroup":
                    this.ai();
                    break;
                case "ShiftType":
                    this.al();
                    break;
            }
        }
        al() {
            this.view.q();
        }
        ai() {
            this.view.q();
        }
        ap() {
        }
        ao() {
        }
        aj() {
            this.q = true;
        }
        ak() {
            this.q = false;
        }
        get z() {
            return this.v;
        }
        set z(a) {
            let b = this.v;
            this.v = a;
            if (b != this.v) {
                this.g("Id", b, a);
            }
        }
        get w() {
            return this.u;
        }
        set w(a) {
            let b = this.u;
            this.u = a;
            if (b != this.u) {
                this.g("AriaLabel", b, a);
            }
        }
        get q() {
            return this.n;
        }
        set q(a) {
            let b = this.n;
            this.n = a;
            if (b != this.n) {
                this.g("IsHover", b, a);
            }
        }
        get disabled() {
            return this.m;
        }
        set disabled(a) {
            let b = this.m;
            this.m = a;
            if (b != this.m) {
                this.g("IsDisabled", b, a);
            }
        }
        am() {
        }
        onDetachedFromUI() {
            this.view.n();
        }
        onAttachedToUI() {
            this.view.l();
        }
        r() {
            return this.view.d();
        }
        t() {
            return this.i();
        }
        y() {
            let a = this.i();
            return a.e();
        }
        i() {
            let a = new SuffixVisualModelExport();
            a.a = this.k;
            a.c = this.q;
            a.b = this.disabled;
            a.d = this.e;
            return a;
        }
        appendContentChild(a) {
            this.view.k(a);
        }
        provideContainer(a) {
            this.view.m(a);
        }
    }
    XSuffix.$t = /*@__PURE__*/ markType(XSuffix, 'XSuffix', XInputGroupItem.$);
    XSuffix.s = 0;
    return XSuffix;
})();
/**
 * @hidden
 */
export let XPrefix = /*@__PURE__*/ (() => {
    class XPrefix extends XInputGroupItem {
        constructor() {
            super();
            this._view = null;
            this.j = 0;
            this.v = "ig-prefix-" + XPrefix.s++;
            this.u = null;
            this.n = false;
            this.m = false;
            this.o = false;
            let a = new PrefixView();
            a.a = this;
            this.view = a;
            this.view.o();
        }
        get view() {
            return this._view;
        }
        set view(a) {
            this._view = a;
        }
        destroy() {
            this.provideContainer(null);
        }
        get k() {
            return this.j;
        }
        set k(a) {
            let b = this.j;
            this.j = a;
            if (b != this.j) {
                this.g("ShiftType", enumGetBox(PrefixShiftType_$type, b), enumGetBox(PrefixShiftType_$type, a));
            }
        }
        h(a, b, c) {
            super.h(a, b, c);
            switch (a) {
                case "InputGroup":
                    this.ai();
                    break;
                case "ShiftType":
                    this.al();
                    break;
            }
        }
        al() {
            this.view.q();
        }
        ai() {
            this.view.q();
        }
        ap() {
        }
        ao() {
        }
        aj() {
            this.q = true;
        }
        ak() {
            this.q = false;
        }
        get z() {
            return this.v;
        }
        set z(a) {
            let b = this.v;
            this.v = a;
            if (b != this.v) {
                this.g("Id", b, a);
            }
        }
        get w() {
            return this.u;
        }
        set w(a) {
            let b = this.u;
            this.u = a;
            if (b != this.u) {
                this.g("AriaLabel", b, a);
            }
        }
        get q() {
            return this.n;
        }
        set q(a) {
            let b = this.n;
            this.n = a;
            if (b != this.n) {
                this.g("IsHover", b, a);
            }
        }
        get disabled() {
            return this.m;
        }
        set disabled(a) {
            let b = this.m;
            this.m = a;
            if (b != this.m) {
                this.g("IsDisabled", b, a);
            }
        }
        am() {
        }
        onDetachedFromUI() {
            this.view.n();
        }
        onAttachedToUI() {
            this.view.l();
        }
        r() {
            return this.view.d();
        }
        t() {
            return this.i();
        }
        y() {
            let a = this.i();
            return a.e();
        }
        i() {
            let a = new PrefixVisualModelExport();
            a.a = this.k;
            a.c = this.q;
            a.b = this.disabled;
            a.d = this.e;
            return a;
        }
        appendContentChild(a) {
            this.view.k(a);
        }
        provideContainer(a) {
            this.view.m(a);
        }
    }
    XPrefix.$t = /*@__PURE__*/ markType(XPrefix, 'XPrefix', XInputGroupItem.$);
    XPrefix.s = 0;
    return XPrefix;
})();
/**
 * @hidden
 */
export let XInputGroup = /*@__PURE__*/ (() => {
    class XInputGroup extends Base {
        constructor() {
            super();
            this.c = 0;
            this.r = 1;
            this.q = 1;
            this.aj = false;
            this.n = 0;
            this._view = null;
            this.w = null;
            this.u = null;
            this.lostFocus = null;
            this.gotFocus = null;
            this.dw = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 0), "BorderWidth");
            this.dx = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 0), "FocusBorderWidth");
            this.kv = XInputGroup.m.y(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 0), "CornerRadius");
            this.ol = XInputGroup.m.ai(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 0), "ContentPadding");
            this.m9 = XInputGroup.m.ad(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 0), "BorderColor");
            this.na = XInputGroup.m.ad(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 0), "FocusBorderColor");
            this.nb = XInputGroup.m.ad(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 0), "FocusLabelColor");
            this.d5 = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineWidth");
            this.d4 = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineRippleWidth");
            this.d1 = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 0), "HoverUnderlineWidth");
            this.ne = XInputGroup.m.ad(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineColor");
            this.nf = XInputGroup.m.ad(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineRippleColor");
            this.nd = XInputGroup.m.ad(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 0), "HoverUnderlineColor");
            this.nc = XInputGroup.m.ad(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 0), "FocusUnderlineColor");
            this.d2 = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineOpacity");
            this.d0 = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 0), "HoverUnderlineOpacity");
            this.dy = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 0), "FocusUnderlineOpacity");
            this.dz = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 0), "FocusUnderlineRippleOpacity");
            this.d3 = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineRippleOpacity");
            this.m8 = XInputGroup.m.ad(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 0), "BackgroundColor");
            this.dl = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 1), "BorderWidth");
            this.dm = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 1), "FocusBorderWidth");
            this.ku = XInputGroup.m.y(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 1), "CornerRadius");
            this.ok = XInputGroup.m.ai(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 1), "ContentPadding");
            this.m1 = XInputGroup.m.ad(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 1), "BorderColor");
            this.m2 = XInputGroup.m.ad(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 1), "FocusBorderColor");
            this.m3 = XInputGroup.m.ad(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 1), "FocusLabelColor");
            this.dv = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 1), "UnderlineWidth");
            this.du = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 1), "UnderlineRippleWidth");
            this.dr = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 1), "HoverUnderlineWidth");
            this.m6 = XInputGroup.m.ad(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 1), "UnderlineColor");
            this.m7 = XInputGroup.m.ad(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 1), "UnderlineRippleColor");
            this.m5 = XInputGroup.m.ad(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 1), "HoverUnderlineColor");
            this.m4 = XInputGroup.m.ad(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 1), "FocusUnderlineColor");
            this.ds = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 1), "UnderlineOpacity");
            this.dq = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 1), "HoverUnderlineOpacity");
            this.dn = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 1), "FocusUnderlineOpacity");
            this.dp = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 1), "FocusUnderlineRippleOpacity");
            this.dt = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 1), "UnderlineRippleOpacity");
            this.m0 = XInputGroup.m.ad(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 1), "BackgroundColor");
            this.db = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 2), "BorderWidth");
            this.dc = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 2), "FocusBorderWidth");
            this.kt = XInputGroup.m.y(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 2), "CornerRadius");
            this.oj = XInputGroup.m.ai(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 2), "ContentPadding");
            this.mt = XInputGroup.m.ad(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 2), "BorderColor");
            this.mu = XInputGroup.m.ad(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 2), "FocusBorderColor");
            this.mv = XInputGroup.m.ad(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 2), "FocusLabelColor");
            this.dk = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 2), "UnderlineWidth");
            this.dj = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 2), "UnderlineRippleWidth");
            this.dg = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 2), "HoverUnderlineWidth");
            this.my = XInputGroup.m.ad(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 2), "UnderlineColor");
            this.mz = XInputGroup.m.ad(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 2), "UnderlineRippleColor");
            this.mx = XInputGroup.m.ad(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 2), "HoverUnderlineColor");
            this.mw = XInputGroup.m.ad(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 2), "FocusUnderlineColor");
            this.dh = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 2), "UnderlineOpacity");
            this.df = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 2), "HoverUnderlineOpacity");
            this.dd = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 2), "FocusUnderlineOpacity");
            this.de = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 2), "FocusUnderlineRippleOpacity");
            this.di = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 2), "UnderlineRippleOpacity");
            this.ms = XInputGroup.m.ad(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 2), "BackgroundColor");
            this.d6 = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 3), "BorderWidth");
            this.d7 = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 3), "FocusBorderWidth");
            this.kw = XInputGroup.m.y(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 3), "CornerRadius");
            this.om = XInputGroup.m.ai(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 3), "ContentPadding");
            this.nh = XInputGroup.m.ad(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 3), "BorderColor");
            this.ni = XInputGroup.m.ad(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 3), "FocusBorderColor");
            this.nj = XInputGroup.m.ad(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 3), "FocusLabelColor");
            this.ef = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 3), "UnderlineWidth");
            this.ee = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 3), "UnderlineRippleWidth");
            this.eb = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 3), "HoverUnderlineWidth");
            this.nm = XInputGroup.m.ad(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 3), "UnderlineColor");
            this.nn = XInputGroup.m.ad(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 3), "UnderlineRippleColor");
            this.nl = XInputGroup.m.ad(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 3), "HoverUnderlineColor");
            this.nk = XInputGroup.m.ad(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 3), "FocusUnderlineColor");
            this.ec = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 3), "UnderlineOpacity");
            this.ea = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 3), "HoverUnderlineOpacity");
            this.d8 = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 3), "FocusUnderlineOpacity");
            this.d9 = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 3), "FocusUnderlineRippleOpacity");
            this.ed = XInputGroup.m.i(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 3), "UnderlineRippleOpacity");
            this.ng = XInputGroup.m.ad(XInputGroup.o, enumGetBox(InputGroupDisplayType_$type, 3), "BackgroundColor");
            this.k0 = ThemeResolver.af(XInputGroup.o, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "BorderColor");
            this.k1 = ThemeResolver.af(XInputGroup.o, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "FocusBorderColor");
            this.as = ThemeResolver.k(XInputGroup.o, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "BorderWidth");
            this.at = ThemeResolver.k(XInputGroup.o, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "FocusBorderWidth");
            this.ki = ThemeResolver.aa(XInputGroup.o, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "CornerRadius");
            this.n8 = ThemeResolver.ak(XInputGroup.o, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "ContentPadding");
            this.a1 = ThemeResolver.k(XInputGroup.o, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineWidth");
            this.a0 = ThemeResolver.k(XInputGroup.o, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineRippleWidth");
            this.ax = ThemeResolver.k(XInputGroup.o, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "HoverUnderlineWidth");
            this.k4 = ThemeResolver.af(XInputGroup.o, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineColor");
            this.k5 = ThemeResolver.af(XInputGroup.o, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineRippleColor");
            this.k3 = ThemeResolver.af(XInputGroup.o, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "HoverUnderlineColor");
            this.k2 = ThemeResolver.af(XInputGroup.o, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "FocusUnderlineColor");
            this.ay = ThemeResolver.k(XInputGroup.o, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineOpacity");
            this.aw = ThemeResolver.k(XInputGroup.o, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "HoverUnderlineOpacity");
            this.au = ThemeResolver.k(XInputGroup.o, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "FocusUnderlineOpacity");
            this.av = ThemeResolver.k(XInputGroup.o, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "FocusUnderlineRippleOpacity");
            this.az = ThemeResolver.k(XInputGroup.o, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineRippleOpacity");
            this.kz = ThemeResolver.af(XInputGroup.o, XInputGroup.m, enumGetBox(InputGroupDisplayType_$type, 0), "BackgroundColor");
            this.bc = NaN;
            this.bn = NaN;
            this.k7 = null;
            this.kl = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.ob = new Thickness(1, NaN, NaN, NaN, NaN);
            this.cf = NaN;
            this.ce = NaN;
            this.br = NaN;
            this.l3 = null;
            this.l4 = null;
            this.lo = null;
            this.ln = null;
            this.cc = NaN;
            this.bq = NaN;
            this.bo = NaN;
            this.bp = NaN;
            this.cd = NaN;
            this.k6 = null;
            this.bs = NaN;
            this.bt = NaN;
            this.lr = null;
            this.lq = null;
            this.km = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.oc = new Thickness(1, NaN, NaN, NaN, NaN);
            this.b1 = NaN;
            this.b0 = NaN;
            this.bx = NaN;
            this.lu = null;
            this.lv = null;
            this.lt = null;
            this.ls = null;
            this.by = NaN;
            this.bw = NaN;
            this.bu = NaN;
            this.bv = NaN;
            this.bz = NaN;
            this.lp = null;
            this.bd = NaN;
            this.be = NaN;
            this.lh = null;
            this.lg = null;
            this.kk = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.oa = new Thickness(1, NaN, NaN, NaN, NaN);
            this.bm = NaN;
            this.bl = NaN;
            this.bi = NaN;
            this.lk = null;
            this.ll = null;
            this.lj = null;
            this.li = null;
            this.bj = NaN;
            this.bh = NaN;
            this.bf = NaN;
            this.bg = NaN;
            this.bk = NaN;
            this.lf = null;
            this.a2 = NaN;
            this.a3 = NaN;
            this.la = null;
            this.k9 = null;
            this.kj = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.n9 = new Thickness(1, NaN, NaN, NaN, NaN);
            this.bb = NaN;
            this.ba = NaN;
            this.a7 = NaN;
            this.ld = null;
            this.le = null;
            this.lc = null;
            this.lb = null;
            this.a8 = NaN;
            this.a6 = NaN;
            this.a4 = NaN;
            this.a5 = NaN;
            this.a9 = NaN;
            this.k8 = null;
            this.b2 = NaN;
            this.b3 = NaN;
            this.ly = null;
            this.lx = null;
            this.kn = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.od = new Thickness(1, NaN, NaN, NaN, NaN);
            this.cb = NaN;
            this.ca = NaN;
            this.b7 = NaN;
            this.l1 = null;
            this.l2 = null;
            this.l0 = null;
            this.lz = null;
            this.b8 = NaN;
            this.b6 = NaN;
            this.b4 = NaN;
            this.b5 = NaN;
            this.b9 = NaN;
            this.lw = null;
            this.ad = false;
            this.z = false;
            this.af = false;
            this.ab = false;
            this.ae = false;
            this.aa = false;
            this.x = false;
            this.lm = null;
            this.ff = "ig-inputgroup-" + XInputGroup.fc++;
            this.ac = false;
            this.propertyChanged = null;
            this.f = new XInputGroupInputCollection();
            this.v = null;
            this.ah = false;
            this.y = false;
            this.ag = false;
            this.fd = toNullable(Number_$type, null);
            let a = new InputGroupView();
            a.d = this;
            this.view = a;
            this.view.ak();
            let b = this.f;
            b.collectionChanged = delegateCombine(b.collectionChanged, runOn(this, this.jl));
            let c = this.f;
            c.collectionResetting = delegateCombine(c.collectionResetting, runOn(this, this.jm));
        }
        jm(a, b) {
            this.kb();
            this.view.ad();
        }
        appendContentChild(a) {
            this.view.ab(a);
        }
        j7(a) {
            this.view.an(a);
        }
        get d() {
            return this.c;
        }
        set d(a) {
            let b = this.c;
            this.c = a;
            if (b != this.c) {
                this.j2("DisplayType", enumGetBox(InputGroupDisplayType_$type, b), enumGetBox(InputGroupDisplayType_$type, a));
            }
        }
        get t() {
            return this.r;
        }
        set t(a) {
            let b = this.r;
            this.r = a;
            if (b != this.r) {
                this.j2("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        get s() {
            return this.q;
        }
        set s(a) {
            let b = this.q;
            this.q = a;
            if (b != this.q) {
                this.j2("ActualDensity", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        js(a) {
            for (let b = 0; b < this.inputs.count; b++) {
                if (typeCast(XLabel.$, this.inputs._inner[b]) !== null) {
                    a(this.inputs._inner[b]);
                }
            }
        }
        jt(a) {
            for (let b = 0; b < this.inputs.count; b++) {
                if (typeCast(XPrefix.$, this.inputs._inner[b]) !== null) {
                    a(this.inputs._inner[b]);
                }
            }
        }
        jr(a) {
            for (let b = 0; b < this.inputs.count; b++) {
                if (typeCast(XInput.$, this.inputs._inner[b]) !== null) {
                    a(this.inputs._inner[b]);
                }
            }
        }
        ju(a) {
            for (let b = 0; b < this.inputs.count; b++) {
                if (typeCast(XSuffix.$, this.inputs._inner[b]) !== null) {
                    a(this.inputs._inner[b]);
                }
            }
        }
        jl(a, b) {
            if (b.oldItems != null) {
                for (let c of fromEn(b.oldItems)) {
                    let d = c;
                    if (d != null) {
                        d.b = null;
                    }
                    this.view.ae(d);
                }
            }
            if (b.newItems != null) {
                for (let e of fromEn(b.newItems)) {
                    let f = e;
                    if (f != null) {
                        f.b = this;
                    }
                    this.view.ac(f);
                }
            }
            this.j9();
            this.aj = true;
            try {
                this.kh();
            }
            finally {
                this.aj = false;
            }
            this.ke();
            this.kd();
            this.kf();
            this.kg();
            this.kb();
        }
        get p() {
            return this.n;
        }
        set p(a) {
            let b = this.n;
            this.n = a;
            if (b != this.n) {
                this.j2("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        }
        get view() {
            return this._view;
        }
        set view(a) {
            this._view = a;
        }
        destroy() {
            this.provideContainer(null);
        }
        j2(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.j5(a, b, c);
        }
        j5(a, b, c) {
            switch (a) {
                case "BaseTheme":
                    this.ka(this.p);
                    this.kc();
                    this.js((d) => d.p = this.p == 0 ? 2 : this.p);
                    break;
                case "ActualBorderColor":
                case "ActualBackgroundColor":
                case "ActualBorderWidth":
                case "ActualFocusBorderColor":
                case "ActualFocusBorderWidth":
                case "ActualCornerRadius":
                case "ActualContentPadding":
                case "ActualUnderlineOpacity":
                case "ActualUnderlineRippleOpacity":
                case "ActualUnderlineRippleWidth":
                case "ActualUnderlineRippleColor":
                case "ActualUnderlineColor":
                case "ActualHoverUnderlineColor":
                case "ActualUnderlineWidth":
                case "ActualHoverUnderlineWidth":
                case "ActualHoverUnderlineOpacity":
                case "ActualFocusUnderlineColor":
                case "ActualFocusUnderlineOpacity":
                case "ActualFocusUnderlineRippleOpacity":
                case "IsHovered":
                    this.ag = true;
                    this.ah = true;
                    this.y = true;
                    this.kb();
                    break;
                case "BorderColor":
                case "BackgroundColor":
                case "BorderWidth":
                case "FocusBorderColor":
                case "FocusBorderWidth":
                case "CornerRadius":
                case "ContentPadding":
                case "UnderlineOpacity":
                case "UnderlineRippleOpacity":
                case "UnderlineRippleWidth":
                case "UnderlineRippleColor":
                case "UnderlineColor":
                case "HoverUnderlineColor":
                case "UnderlineWidth":
                case "HoverUnderlineWidth":
                case "HoverUnderlineOpacity":
                case "FocusUnderlineColor":
                case "FocusUnderlineOpacity":
                case "FocusUnderlineRippleOpacity":
                case "LineTypeBorderColor":
                case "LineTypeBackgroundColor":
                case "LineTypeBorderWidth":
                case "LineTypeFocusBorderColor":
                case "LineTypeFocusBorderWidth":
                case "LineTypeCornerRadius":
                case "LineTypeContentPadding":
                case "LineTypeUnderlineOpacity":
                case "LineTypeUnderlineRippleOpacity":
                case "LineTypeUnderlineRippleWidth":
                case "LineTypeUnderlineRippleColor":
                case "LineTypeUnderlineColor":
                case "LineTypeHoverUnderlineColor":
                case "LineTypeUnderlineWidth":
                case "LineTypeHoverUnderlineWidth":
                case "LineTypeHoverUnderlineOpacity":
                case "LineTypeFocusUnderlineColor":
                case "LineTypeFocusUnderlineOpacity":
                case "LineTypeFocusUnderlineRippleOpacity":
                case "BoxTypeBorderColor":
                case "BoxTypeBackgroundColor":
                case "BoxTypeBorderWidth":
                case "BoxTypeFocusBorderColor":
                case "BoxTypeFocusBorderWidth":
                case "BoxTypeCornerRadius":
                case "BoxTypeContentPadding":
                case "BoxTypeUnderlineOpacity":
                case "BoxTypeUnderlineRippleOpacity":
                case "BoxTypeUnderlineRippleWidth":
                case "BoxTypeUnderlineRippleColor":
                case "BoxTypeUnderlineColor":
                case "BoxTypeHoverUnderlineColor":
                case "BoxTypeUnderlineWidth":
                case "BoxTypeHoverUnderlineWidth":
                case "BoxTypeHoverUnderlineOpacity":
                case "BoxTypeFocusUnderlineColor":
                case "BoxTypeFocusUnderlineOpacity":
                case "BoxTypeFocusUnderlineRippleOpacity":
                case "BorderTypeBorderColor":
                case "BorderTypeBackgroundColor":
                case "BorderTypeBorderWidth":
                case "BorderTypeFocusBorderColor":
                case "BorderTypeFocusBorderWidth":
                case "BorderTypeCornerRadius":
                case "BorderTypeContentPadding":
                case "BorderTypeUnderlineOpacity":
                case "BorderTypeUnderlineRippleOpacity":
                case "BorderTypeUnderlineRippleWidth":
                case "BorderTypeUnderlineRippleColor":
                case "BorderTypeUnderlineColor":
                case "BorderTypeHoverUnderlineColor":
                case "BorderTypeUnderlineWidth":
                case "BorderTypeHoverUnderlineWidth":
                case "BorderTypeHoverUnderlineOpacity":
                case "BorderTypeFocusUnderlineColor":
                case "BorderTypeFocusUnderlineOpacity":
                case "BorderTypeFocusUnderlineRippleOpacity":
                case "DisplayType":
                    this.kc();
                    break;
                case "ActualDensity":
                    this.view.ap();
                    this.kc();
                    break;
                case "Density":
                    this.s = this.t == 0 ? 1 : this.t;
                    break;
                case "IsFocused":
                    this.j0();
                    this.kb();
                    break;
                case "IsExpanded":
                    this.z = true;
                    this.ai = this.an;
                    break;
                case "ActualIsExpanded":
                    this.jv();
                    break;
                case "IsDisabled":
                    NativeUI.u(this.view.v, !this.disabled);
                    break;
            }
        }
        static kr(a, b) {
            return new CornerRadius(1, !isNaN_(a.c) ? a.c : b.c, !isNaN_(a.d) ? a.d : b.d, !isNaN_(a.b) ? a.b : b.b, !isNaN_(a.a) ? a.a : b.a);
        }
        static oh(a, b) {
            return new Thickness(1, !isNaN_(a.left) ? a.left : b.left, !isNaN_(a.top) ? a.top : b.top, !isNaN_(a.right) ? a.right : b.right, !isNaN_(a.bottom) ? a.bottom : b.bottom);
        }
        ke() {
            this.js((a) => {
                a.t = this.s;
                a.p = this.p == 0 ? 2 : this.p;
                switch (this.d) {
                    case 0:
                        a.l = 0;
                        break;
                    case 1:
                        a.l = 1;
                        break;
                    case 2:
                    case 3:
                        a.l = 2;
                        break;
                }
                a.ck(this.ai, false);
            });
        }
        kf() {
            this.jt((a) => {
                switch (this.d) {
                    case 0:
                        a.k = 0;
                        break;
                    case 1:
                        a.k = 1;
                        break;
                    case 2:
                    case 3:
                        a.k = 2;
                        break;
                }
            });
        }
        kd() {
            this.jr((a) => {
                a.aa = this.s;
                switch (this.d) {
                    case 0:
                        a.o = 0;
                        break;
                    case 1:
                        a.o = 1;
                        break;
                    case 2:
                    case 3:
                        a.o = 2;
                        break;
                }
                a.dq(this.ar, false);
            });
        }
        kg() {
            this.ju((a) => {
                switch (this.d) {
                    case 0:
                        a.k = 0;
                        break;
                    case 1:
                        a.k = 1;
                        break;
                    case 2:
                    case 3:
                        a.k = 2;
                        break;
                }
            });
        }
        kc() {
            this.ke();
            this.kd();
            this.kf();
            this.kg();
            switch (this.d) {
                case 0:
                    this.l6 = this.md != null ? this.md : this.ns != null ? this.ns : this.m9;
                    this.l5 = this.mc != null ? this.mc : this.nr != null ? this.nr : this.m8;
                    this.cg = !isNaN_(this.c0) ? this.c0 : !isNaN_(this.el) ? this.el : this.dw;
                    this.l7 = this.no != null ? this.no : this.nt != null ? this.nt : this.na;
                    this.ch = !isNaN_(this.eg) ? this.eg : !isNaN_(this.em) ? this.em : this.dx;
                    this.ko = XInputGroup.kr(this.ks, XInputGroup.kr(this.kx, this.kv));
                    this.oe = XInputGroup.oh(this.oi, XInputGroup.oh(this.on, this.ol));
                    this.cm = !isNaN_(this.e5) ? this.e5 : !isNaN_(this.er) ? this.er : this.d2;
                    this.cn = !isNaN_(this.e6) ? this.e6 : !isNaN_(this.es) ? this.es : this.d3;
                    this.co = !isNaN_(this.e7) ? this.e7 : !isNaN_(this.et) ? this.et : this.d4;
                    this.mb = this.n7 != null ? this.n7 : this.nx != null ? this.nx : this.nf;
                    this.ma = this.n6 != null ? this.n6 : this.nw != null ? this.nw : this.ne;
                    this.l9 = this.nq != null ? this.nq : this.nv != null ? this.nv : this.nd;
                    this.cp = !isNaN_(this.e8) ? this.e8 : !isNaN_(this.eu) ? this.eu : this.d5;
                    this.cl = !isNaN_(this.ek) ? this.ek : !isNaN_(this.eq) ? this.eq : this.d1;
                    this.ck = !isNaN_(this.ej) ? this.ej : !isNaN_(this.ep) ? this.ep : this.d0;
                    this.l8 = this.np != null ? this.np : this.nu != null ? this.nu : this.nc;
                    this.ci = !isNaN_(this.eh) ? this.eh : !isNaN_(this.en) ? this.en : this.dy;
                    this.cj = !isNaN_(this.ei) ? this.ei : !isNaN_(this.eo) ? this.eo : this.dz;
                    break;
                case 1:
                    this.l6 = this.md != null ? this.md : this.mm != null ? this.mm : this.m1;
                    this.l5 = this.mc != null ? this.mc : this.ml != null ? this.ml : this.m0;
                    this.cg = !isNaN_(this.c0) ? this.c0 : !isNaN_(this.c1) ? this.c1 : this.dl;
                    this.l7 = this.no != null ? this.no : this.mn != null ? this.mn : this.m2;
                    this.ch = !isNaN_(this.eg) ? this.eg : !isNaN_(this.c2) ? this.c2 : this.dm;
                    this.ko = XInputGroup.kr(this.ks, XInputGroup.kr(this.kq, this.ku));
                    this.oe = XInputGroup.oh(this.oi, XInputGroup.oh(this.og, this.ok));
                    this.cm = !isNaN_(this.e5) ? this.e5 : !isNaN_(this.c7) ? this.c7 : this.ds;
                    this.cn = !isNaN_(this.e6) ? this.e6 : !isNaN_(this.c8) ? this.c8 : this.dt;
                    this.co = !isNaN_(this.e7) ? this.e7 : !isNaN_(this.c9) ? this.c9 : this.du;
                    this.mb = this.n7 != null ? this.n7 : this.mr != null ? this.mr : this.m7;
                    this.ma = this.n6 != null ? this.n6 : this.mq != null ? this.mq : this.m6;
                    this.l9 = this.nq != null ? this.nq : this.mp != null ? this.mp : this.m5;
                    this.cp = !isNaN_(this.e8) ? this.e8 : !isNaN_(this.da) ? this.da : this.dv;
                    this.cl = !isNaN_(this.ek) ? this.ek : !isNaN_(this.c6) ? this.c6 : this.dr;
                    this.ck = !isNaN_(this.ej) ? this.ej : !isNaN_(this.c5) ? this.c5 : this.dq;
                    this.l8 = this.np != null ? this.np : this.mo != null ? this.mo : this.m4;
                    this.ci = !isNaN_(this.eh) ? this.eh : !isNaN_(this.c3) ? this.c3 : this.dn;
                    this.cj = !isNaN_(this.ei) ? this.ei : !isNaN_(this.c4) ? this.c4 : this.dp;
                    break;
                case 2:
                    this.l6 = this.md != null ? this.md : this.mf != null ? this.mf : this.mt;
                    this.l5 = this.mc != null ? this.mc : this.me != null ? this.me : this.ms;
                    this.cg = !isNaN_(this.c0) ? this.c0 : !isNaN_(this.cq) ? this.cq : this.db;
                    this.l7 = this.no != null ? this.no : this.mg != null ? this.mg : this.mu;
                    this.ch = !isNaN_(this.eg) ? this.eg : !isNaN_(this.cr) ? this.cr : this.dc;
                    this.ko = XInputGroup.kr(this.ks, XInputGroup.kr(this.kp, this.kt));
                    this.oe = XInputGroup.oh(this.oi, XInputGroup.oh(this.of, this.oj));
                    this.cm = !isNaN_(this.e5) ? this.e5 : !isNaN_(this.cw) ? this.cw : this.dh;
                    this.cn = !isNaN_(this.e6) ? this.e6 : !isNaN_(this.cx) ? this.cx : this.di;
                    this.co = !isNaN_(this.e7) ? this.e7 : !isNaN_(this.cy) ? this.cy : this.dj;
                    this.mb = this.n7 != null ? this.n7 : this.mk != null ? this.mk : this.mz;
                    this.ma = this.n6 != null ? this.n6 : this.mj != null ? this.mj : this.my;
                    this.l9 = this.nq != null ? this.nq : this.mi != null ? this.mi : this.mx;
                    this.cp = !isNaN_(this.e8) ? this.e8 : !isNaN_(this.cz) ? this.cz : this.dk;
                    this.cl = !isNaN_(this.ek) ? this.ek : !isNaN_(this.cv) ? this.cv : this.dg;
                    this.ck = !isNaN_(this.ej) ? this.ej : !isNaN_(this.cu) ? this.cu : this.df;
                    this.l8 = this.np != null ? this.np : this.mh != null ? this.mh : this.mw;
                    this.ci = !isNaN_(this.eh) ? this.eh : !isNaN_(this.cs) ? this.cs : this.dd;
                    this.cj = !isNaN_(this.ei) ? this.ei : !isNaN_(this.ct) ? this.ct : this.de;
                    break;
                case 3:
                    this.l6 = this.md != null ? this.md : this.nz != null ? this.nz : this.nh;
                    this.l5 = this.mc != null ? this.mc : this.ny != null ? this.ny : this.ng;
                    this.cg = !isNaN_(this.c0) ? this.c0 : !isNaN_(this.ev) ? this.ev : this.d6;
                    this.l7 = this.no != null ? this.no : this.n0 != null ? this.n0 : this.ni;
                    this.ch = !isNaN_(this.eg) ? this.eg : !isNaN_(this.ew) ? this.ew : this.d7;
                    this.ko = XInputGroup.kr(this.ks, XInputGroup.kr(this.ky, this.kw));
                    this.oe = XInputGroup.oh(this.oi, XInputGroup.oh(this.oo, this.om));
                    this.cm = !isNaN_(this.e5) ? this.e5 : !isNaN_(this.e1) ? this.e1 : this.ec;
                    this.cn = !isNaN_(this.e6) ? this.e6 : !isNaN_(this.e2) ? this.e2 : this.ed;
                    this.co = !isNaN_(this.e7) ? this.e7 : !isNaN_(this.e3) ? this.e3 : this.ee;
                    this.mb = this.n7 != null ? this.n7 : this.n4 != null ? this.n4 : this.nn;
                    this.ma = this.n6 != null ? this.n6 : this.n3 != null ? this.n3 : this.nm;
                    this.l9 = this.nq != null ? this.nq : this.n2 != null ? this.n2 : this.nl;
                    this.cp = !isNaN_(this.e8) ? this.e8 : !isNaN_(this.e4) ? this.e4 : this.ef;
                    this.cl = !isNaN_(this.ek) ? this.ek : !isNaN_(this.e0) ? this.e0 : this.eb;
                    this.ck = !isNaN_(this.ej) ? this.ej : !isNaN_(this.ez) ? this.ez : this.ea;
                    this.l8 = this.np != null ? this.np : this.n1 != null ? this.n1 : this.nk;
                    this.ci = !isNaN_(this.eh) ? this.eh : !isNaN_(this.ex) ? this.ex : this.d8;
                    this.cj = !isNaN_(this.ei) ? this.ei : !isNaN_(this.ey) ? this.ey : this.d9;
                    break;
            }
        }
        kb() {
            this.js((a) => {
            });
            this.jr((a) => {
            });
            let a = this.view.v;
            let b = this.view.u;
            let c = this.view.x;
            let d = this.view.y;
            let e = this.v != null && this.v.playState == 1;
            let f = this.w != null && this.w.playState == 1;
            let g = this.u != null && this.u.playState == 1;
            NativeUI.o(a, this.ko);
            NativeUI.o(b, this.ko);
            NativeUI.m(a, this.l5);
            NativeUI.z(a, this.oe);
            if (this.ao) {
                if (!g) {
                    NativeUI.n(b, this.l7);
                    NativeUI.p(b, new Thickness(0, this.ch));
                }
                if (!f) {
                    NativeUI.m(c, this.l8);
                }
            }
            else {
                if (!f) {
                    if (this.ap) {
                        NativeUI.m(c, this.l9);
                        NativeUI.y(c, this.ck);
                        NativeUI.t(c, this.cl);
                    }
                    else {
                        NativeUI.m(c, this.ma);
                        NativeUI.y(c, this.cm);
                        NativeUI.t(c, this.cp);
                    }
                }
                if (!g) {
                    NativeUI.n(b, this.l6);
                    NativeUI.p(b, new Thickness(0, this.cg));
                }
                if (!f) {
                    NativeUI.m(a, this.l5);
                }
            }
            if (!e) {
                NativeUI.m(d, this.mb);
                NativeUI.t(d, this.co);
                NativeUI.y(d, this.cn);
            }
        }
        get a() {
            let a = new AnimationKeyFrameEffectTiming();
            a.g = 300;
            a.b = 0;
            return a;
        }
        onChildrenMutated() {
            this.jr((a) => a.view.a8());
            this.js((a) => a.view.af());
            this.jt((a) => a.view.q());
            this.ju((a) => a.view.q());
        }
        jp() {
            this.view.af();
            let a = false;
            if (this.w == null) {
                this.w = KeyFrameAnimationFactory.f.c(this.view.c(this.a).m(new AnimationKeyFrameProperty(2, this.l6)).m(new AnimationKeyFrameProperty(2, this.l7)));
            }
            if (this.u == null) {
                this.u = KeyFrameAnimationFactory.f.c(this.view.a(this.a).m(new AnimationKeyFrameProperty(3, this.l6), new AnimationKeyFrameProperty(4, this.d == 2 || this.d == 3 ? new Thickness(0, this.cg) : new Thickness(0, 0))).m(new AnimationKeyFrameProperty(3, this.l7), new AnimationKeyFrameProperty(4, this.d == 2 || this.d == 3 ? new Thickness(0, this.ch) : new Thickness(0, 0))));
            }
            if (this.v == null) {
                this.v = KeyFrameAnimationFactory.f.c(this.view.b(this.a).m(new AnimationKeyFrameProperty(2, this.l7), new AnimationKeyFrameProperty(14, ((() => {
                    let $ret = new ScaleTransform();
                    $ret.l = 0.5;
                    $ret.m = 1;
                    return $ret;
                })())), new AnimationKeyFrameProperty(1, 0)).m(new AnimationKeyFrameProperty(2, this.l7), new AnimationKeyFrameProperty(14, ((() => {
                    let $ret = new ScaleTransform();
                    $ret.l = 1;
                    $ret.m = 1;
                    return $ret;
                })())), new AnimationKeyFrameProperty(1, 1)));
            }
        }
        get al() {
            let a = false;
            this.jr((b) => {
                if (b.at) {
                    a = true;
                }
            });
            return a;
        }
        j1() {
            this.ai = this.z ? this.an : this.al ? true : false;
            this.ao = false;
            if (null != this.lostFocus) {
                this.lostFocus(this, EventArgs.empty);
            }
        }
        ka(a) {
            this.dw = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 0), "BorderWidth");
            this.dx = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 0), "FocusBorderWidth");
            this.kv = XInputGroup.m.y(a, enumGetBox(InputGroupDisplayType_$type, 0), "CornerRadius");
            this.ol = XInputGroup.m.ai(a, enumGetBox(InputGroupDisplayType_$type, 0), "ContentPadding");
            this.m9 = XInputGroup.m.ad(a, enumGetBox(InputGroupDisplayType_$type, 0), "BorderColor");
            this.na = XInputGroup.m.ad(a, enumGetBox(InputGroupDisplayType_$type, 0), "FocusBorderColor");
            this.nb = XInputGroup.m.ad(a, enumGetBox(InputGroupDisplayType_$type, 0), "FocusLabelColor");
            this.d5 = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineWidth");
            this.d4 = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineRippleWidth");
            this.d1 = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 0), "HoverUnderlineWidth");
            this.ne = XInputGroup.m.ad(a, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineColor");
            this.nf = XInputGroup.m.ad(a, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineRippleColor");
            this.nd = XInputGroup.m.ad(a, enumGetBox(InputGroupDisplayType_$type, 0), "HoverUnderlineColor");
            this.nc = XInputGroup.m.ad(a, enumGetBox(InputGroupDisplayType_$type, 0), "FocusUnderlineColor");
            this.d2 = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineOpacity");
            this.d0 = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 0), "HoverUnderlineOpacity");
            this.dy = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 0), "FocusUnderlineOpacity");
            this.dz = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 0), "FocusUnderlineRippleOpacity");
            this.d3 = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 0), "UnderlineRippleOpacity");
            this.m8 = XInputGroup.m.ad(a, enumGetBox(InputGroupDisplayType_$type, 0), "BackgroundColor");
            this.dl = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 1), "BorderWidth");
            this.dm = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 1), "FocusBorderWidth");
            this.ku = XInputGroup.m.y(a, enumGetBox(InputGroupDisplayType_$type, 1), "CornerRadius");
            this.ok = XInputGroup.m.ai(a, enumGetBox(InputGroupDisplayType_$type, 1), "ContentPadding");
            this.m1 = XInputGroup.m.ad(a, enumGetBox(InputGroupDisplayType_$type, 1), "BorderColor");
            this.m2 = XInputGroup.m.ad(a, enumGetBox(InputGroupDisplayType_$type, 1), "FocusBorderColor");
            this.m3 = XInputGroup.m.ad(a, enumGetBox(InputGroupDisplayType_$type, 1), "FocusLabelColor");
            this.dv = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 1), "UnderlineWidth");
            this.du = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 1), "UnderlineRippleWidth");
            this.dr = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 1), "HoverUnderlineWidth");
            this.m6 = XInputGroup.m.ad(a, enumGetBox(InputGroupDisplayType_$type, 1), "UnderlineColor");
            this.m7 = XInputGroup.m.ad(a, enumGetBox(InputGroupDisplayType_$type, 1), "UnderlineRippleColor");
            this.m5 = XInputGroup.m.ad(a, enumGetBox(InputGroupDisplayType_$type, 1), "HoverUnderlineColor");
            this.m4 = XInputGroup.m.ad(a, enumGetBox(InputGroupDisplayType_$type, 1), "FocusUnderlineColor");
            this.ds = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 1), "UnderlineOpacity");
            this.dq = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 1), "HoverUnderlineOpacity");
            this.dn = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 1), "FocusUnderlineOpacity");
            this.dp = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 1), "FocusUnderlineRippleOpacity");
            this.dt = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 1), "UnderlineRippleOpacity");
            this.m0 = XInputGroup.m.ad(a, enumGetBox(InputGroupDisplayType_$type, 1), "BackgroundColor");
            this.db = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 2), "BorderWidth");
            this.dc = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 2), "FocusBorderWidth");
            this.kt = XInputGroup.m.y(a, enumGetBox(InputGroupDisplayType_$type, 2), "CornerRadius");
            this.oj = XInputGroup.m.ai(a, enumGetBox(InputGroupDisplayType_$type, 2), "ContentPadding");
            this.mt = XInputGroup.m.ad(a, enumGetBox(InputGroupDisplayType_$type, 2), "BorderColor");
            this.mu = XInputGroup.m.ad(a, enumGetBox(InputGroupDisplayType_$type, 2), "FocusBorderColor");
            this.mv = XInputGroup.m.ad(a, enumGetBox(InputGroupDisplayType_$type, 2), "FocusLabelColor");
            this.dk = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 2), "UnderlineWidth");
            this.dj = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 2), "UnderlineRippleWidth");
            this.dg = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 2), "HoverUnderlineWidth");
            this.my = XInputGroup.m.ad(a, enumGetBox(InputGroupDisplayType_$type, 2), "UnderlineColor");
            this.mz = XInputGroup.m.ad(a, enumGetBox(InputGroupDisplayType_$type, 2), "UnderlineRippleColor");
            this.mx = XInputGroup.m.ad(a, enumGetBox(InputGroupDisplayType_$type, 2), "HoverUnderlineColor");
            this.mw = XInputGroup.m.ad(a, enumGetBox(InputGroupDisplayType_$type, 2), "FocusUnderlineColor");
            this.dh = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 2), "UnderlineOpacity");
            this.df = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 2), "HoverUnderlineOpacity");
            this.dd = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 2), "FocusUnderlineOpacity");
            this.de = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 2), "FocusUnderlineRippleOpacity");
            this.di = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 2), "UnderlineRippleOpacity");
            this.ms = XInputGroup.m.ad(a, enumGetBox(InputGroupDisplayType_$type, 2), "BackgroundColor");
            this.d6 = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 3), "BorderWidth");
            this.d7 = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 3), "FocusBorderWidth");
            this.kw = XInputGroup.m.y(a, enumGetBox(InputGroupDisplayType_$type, 3), "CornerRadius");
            this.om = XInputGroup.m.ai(a, enumGetBox(InputGroupDisplayType_$type, 3), "ContentPadding");
            this.nh = XInputGroup.m.ad(a, enumGetBox(InputGroupDisplayType_$type, 3), "BorderColor");
            this.ni = XInputGroup.m.ad(a, enumGetBox(InputGroupDisplayType_$type, 3), "FocusBorderColor");
            this.nj = XInputGroup.m.ad(a, enumGetBox(InputGroupDisplayType_$type, 3), "FocusLabelColor");
            this.ef = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 3), "UnderlineWidth");
            this.ee = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 3), "UnderlineRippleWidth");
            this.eb = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 3), "HoverUnderlineWidth");
            this.nm = XInputGroup.m.ad(a, enumGetBox(InputGroupDisplayType_$type, 3), "UnderlineColor");
            this.nn = XInputGroup.m.ad(a, enumGetBox(InputGroupDisplayType_$type, 3), "UnderlineRippleColor");
            this.nl = XInputGroup.m.ad(a, enumGetBox(InputGroupDisplayType_$type, 3), "HoverUnderlineColor");
            this.nk = XInputGroup.m.ad(a, enumGetBox(InputGroupDisplayType_$type, 3), "FocusUnderlineColor");
            this.ec = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 3), "UnderlineOpacity");
            this.ea = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 3), "HoverUnderlineOpacity");
            this.d8 = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 3), "FocusUnderlineOpacity");
            this.d9 = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 3), "FocusUnderlineRippleOpacity");
            this.ed = XInputGroup.m.i(a, enumGetBox(InputGroupDisplayType_$type, 3), "UnderlineRippleOpacity");
            this.ng = XInputGroup.m.ad(a, enumGetBox(InputGroupDisplayType_$type, 3), "BackgroundColor");
        }
        jv() {
            this.jp();
            if (this.ai) {
                this.js((a) => a.ck(true, !this.aj));
                this.jr((a) => a.dq(this.ar, !this.aj));
            }
            else {
                this.js((a) => a.ck(false, !this.aj));
                this.jr((a) => a.dq(this.ar, !this.aj));
            }
        }
        j0() {
            this.jp();
            if (this.ao) {
                let a = 1;
                this.js((b) => b.al = true);
                this.j4(a);
            }
            else {
                let b = -1;
                this.js((c) => c.al = false);
                this.j4(b);
            }
        }
        jz() {
            this.ai = this.z ? this.an : true;
            this.ao = true;
            if (null != this.gotFocus) {
                this.gotFocus(this, EventArgs.empty);
            }
        }
        kh() {
            if (this.z) {
                this.ai = this.z;
            }
            else if (this.ao) {
                this.ai = true;
            }
            else {
                this.ai = this.al ? true : false;
            }
        }
        j4(a) {
            if ((a > 0 && this.w.playbackRate < 0) || (a < 0 && this.w.playbackRate > 0)) {
                this.w.reverse();
                this.w.finished.f((b) => {
                    if (this.w != null) {
                        this.w.commitStyles();
                    }
                    if (this.ah) {
                        this.w = null;
                        this.ah = false;
                    }
                });
                this.u.reverse();
                this.u.finished.f((b) => {
                    if (this.u != null) {
                        this.u.commitStyles();
                    }
                    if (this.y) {
                        this.u = null;
                        this.y = false;
                    }
                });
                this.v.reverse();
                this.v.finished.f((b) => {
                    if (this.v != null) {
                        this.v.commitStyles();
                    }
                    if (this.ag) {
                        this.v = null;
                        this.ag = false;
                    }
                });
            }
            else {
                this.w.play();
                this.w.finished.f((b) => {
                    if (this.w != null) {
                        this.w.commitStyles();
                    }
                    if (this.ah) {
                        this.w = null;
                        this.ah = false;
                    }
                });
                this.u.play();
                this.u.finished.f((b) => {
                    if (this.u != null) {
                        this.u.commitStyles();
                    }
                    if (this.y) {
                        this.u = null;
                        this.y = false;
                    }
                });
                this.v.play();
                this.v.finished.f((b) => {
                    if (this.v != null) {
                        this.v.commitStyles();
                    }
                    if (this.ag) {
                        this.v = null;
                        this.ag = false;
                    }
                });
            }
        }
        get l6() {
            return this.k0;
        }
        set l6(a) {
            let b = this.k0;
            this.k0 = a;
            if (b != this.k0) {
                this.j2("ActualBorderColor", b, a);
            }
        }
        get l7() {
            return this.k1;
        }
        set l7(a) {
            let b = this.k1;
            this.k1 = a;
            if (b != this.k1) {
                this.j2("ActualFocusBorderColor", b, a);
            }
        }
        get cg() {
            return this.as;
        }
        set cg(a) {
            let b = this.as;
            this.as = a;
            if (b != this.as) {
                this.j2("ActualBorderWidth", b, a);
            }
        }
        get ch() {
            return this.at;
        }
        set ch(a) {
            let b = this.at;
            this.at = a;
            if (b != this.at) {
                this.j2("ActualFocusBorderWidth", b, a);
            }
        }
        get ko() {
            return this.ki;
        }
        set ko(a) {
            let b = this.ki;
            this.ki = a;
            if (b != this.ki) {
                this.j2("ActualCornerRadius", b, a);
            }
        }
        get oe() {
            return this.n8;
        }
        set oe(a) {
            let b = this.n8;
            this.n8 = a;
            if (b != this.n8) {
                this.j2("ActualContentPadding", b, a);
            }
        }
        get cp() {
            return this.a1;
        }
        set cp(a) {
            let b = this.a1;
            this.a1 = a;
            if (b != this.a1) {
                this.j2("ActualUnderlineWidth", b, a);
            }
        }
        get co() {
            return this.a0;
        }
        set co(a) {
            let b = this.a0;
            this.a0 = a;
            if (b != this.a0) {
                this.j2("ActualUnderlineRippleWidth", b, a);
            }
        }
        get cl() {
            return this.ax;
        }
        set cl(a) {
            let b = this.ax;
            this.ax = a;
            if (b != this.ax) {
                this.j2("ActualHoverUnderlineWidth", b, a);
            }
        }
        get ma() {
            return this.k4;
        }
        set ma(a) {
            let b = this.k4;
            this.k4 = a;
            if (b != this.k4) {
                this.j2("ActualUnderlineColor", b, a);
            }
        }
        get mb() {
            return this.k5;
        }
        set mb(a) {
            let b = this.k5;
            this.k5 = a;
            if (b != this.k5) {
                this.j2("ActualUnderlineRippleColor", b, a);
            }
        }
        get l9() {
            return this.k3;
        }
        set l9(a) {
            let b = this.k3;
            this.k3 = a;
            if (b != this.k3) {
                this.j2("ActualHoverUnderlineColor", b, a);
            }
        }
        get l8() {
            return this.k2;
        }
        set l8(a) {
            let b = this.k2;
            this.ln = a;
            if (b != this.k2) {
                this.j2("ActualFocusUnderlineColor", b, a);
            }
        }
        get cm() {
            return this.ay;
        }
        set cm(a) {
            let b = this.ay;
            this.ay = a;
            if (b != this.ay) {
                this.j2("ActualUnderlineOpacity", b, a);
            }
        }
        get ck() {
            return this.aw;
        }
        set ck(a) {
            let b = this.aw;
            this.aw = a;
            if (b != this.aw) {
                this.j2("ActualHoverUnderlineOpacity", b, a);
            }
        }
        get ci() {
            return this.au;
        }
        set ci(a) {
            let b = this.au;
            this.au = a;
            if (b != this.au) {
                this.j2("ActualFocusUnderlineOpacity", b, a);
            }
        }
        get cj() {
            return this.av;
        }
        set cj(a) {
            let b = this.av;
            this.av = a;
            if (b != this.av) {
                this.j2("ActualFocusUnderlineRippleOpacity", b, a);
            }
        }
        get cn() {
            return this.az;
        }
        set cn(a) {
            let b = this.az;
            this.az = a;
            if (b != this.az) {
                this.j2("ActualUnderlineRippleOpacity", b, a);
            }
        }
        get l5() {
            return this.kz;
        }
        set l5(a) {
            let b = this.kz;
            this.kz = a;
            if (b != this.kz) {
                this.j2("ActualBackgroundColor", b, a);
            }
        }
        get c0() {
            return this.bc;
        }
        set c0(a) {
            let b = this.bc;
            this.bc = a;
            if (b != this.bc) {
                this.j2("BorderWidth", b, a);
            }
        }
        get eg() {
            return this.bn;
        }
        set eg(a) {
            let b = this.bn;
            this.bn = a;
            if (b != this.bn) {
                this.j2("FocusBorderWidth", b, a);
            }
        }
        get md() {
            return this.k7;
        }
        set md(a) {
            let b = this.k7;
            this.k7 = a;
            if (b != this.k7) {
                this.j2("BorderColor", b, a);
            }
        }
        get ks() {
            return this.kl;
        }
        set ks(a) {
            let b = this.kl;
            this.kl = a;
            if (b != this.kl) {
                this.j2("CornerRadius", b, a);
            }
        }
        get oi() {
            return this.ob;
        }
        set oi(a) {
            let b = this.ob;
            this.ob = a;
            if (b != this.ob) {
                this.j2("ContentPadding", b, a);
            }
        }
        get e8() {
            return this.cf;
        }
        set e8(a) {
            let b = this.cf;
            this.cf = a;
            if (b != this.cf) {
                this.j2("UnderlineWidth", b, a);
            }
        }
        get e7() {
            return this.ce;
        }
        set e7(a) {
            let b = this.ce;
            this.ce = a;
            if (b != this.ce) {
                this.j2("UnderlineRippleWidth", b, a);
            }
        }
        get ek() {
            return this.br;
        }
        set ek(a) {
            let b = this.br;
            this.br = a;
            if (b != this.br) {
                this.j2("HoverUnderlineWidth", b, a);
            }
        }
        get n6() {
            return this.l3;
        }
        set n6(a) {
            let b = this.l3;
            this.l3 = a;
            if (b != this.l3) {
                this.j2("UnderlineColor", b, a);
            }
        }
        get n7() {
            return this.l4;
        }
        set n7(a) {
            let b = this.l4;
            this.l4 = a;
            if (b != this.l4) {
                this.j2("UnderlineRippleColor", b, a);
            }
        }
        get nq() {
            return this.lo;
        }
        set nq(a) {
            let b = this.lo;
            this.lo = a;
            if (b != this.lo) {
                this.j2("HoverUnderlineColor", b, a);
            }
        }
        get np() {
            return this.ln;
        }
        set np(a) {
            let b = this.ln;
            this.ln = a;
            if (b != this.ln) {
                this.j2("FocusUnderlineColor", b, a);
            }
        }
        get e5() {
            return this.cc;
        }
        set e5(a) {
            let b = this.cc;
            this.cc = a;
            if (b != this.cc) {
                this.j2("UnderlineOpacity", b, a);
            }
        }
        get ej() {
            return this.bq;
        }
        set ej(a) {
            let b = this.bq;
            this.bq = a;
            if (b != this.bq) {
                this.j2("HoverUnderlineOpacity", b, a);
            }
        }
        get eh() {
            return this.bo;
        }
        set eh(a) {
            let b = this.bo;
            this.bo = a;
            if (b != this.bo) {
                this.j2("FocusUnderlineOpacity", b, a);
            }
        }
        get ei() {
            return this.bp;
        }
        set ei(a) {
            let b = this.bp;
            this.bp = a;
            if (b != this.bp) {
                this.j2("FocusUnderlineRippleOpacity", b, a);
            }
        }
        get e6() {
            return this.cd;
        }
        set e6(a) {
            let b = this.cd;
            this.cd = a;
            if (b != this.cd) {
                this.j2("UnderlineRippleOpacity", b, a);
            }
        }
        get mc() {
            return this.k6;
        }
        set mc(a) {
            let b = this.k6;
            this.k6 = a;
            if (b != this.k6) {
                this.j2("BackgroundColor", b, a);
            }
        }
        get el() {
            return this.bs;
        }
        set el(a) {
            let b = this.bs;
            this.bs = a;
            if (b != this.bs) {
                this.j2("LineTypeBorderWidth", b, a);
            }
        }
        get em() {
            return this.bt;
        }
        set em(a) {
            let b = this.bt;
            this.bt = a;
            if (b != this.bt) {
                this.j2("LineTypeFocusBorderWidth", b, a);
            }
        }
        get nt() {
            return this.lr;
        }
        set nt(a) {
            let b = this.lr;
            this.lr = a;
            if (b != this.lr) {
                this.j2("LineTypeFocusBorderColor", b, a);
            }
        }
        get ns() {
            return this.lq;
        }
        set ns(a) {
            let b = this.lq;
            this.lq = a;
            if (b != this.lq) {
                this.j2("LineTypeBorderColor", b, a);
            }
        }
        get kx() {
            return this.km;
        }
        set kx(a) {
            let b = this.km;
            this.km = a;
            if (b != this.km) {
                this.j2("LineTypeCornerRadius", b, a);
            }
        }
        get on() {
            return this.oc;
        }
        set on(a) {
            let b = this.oc;
            this.oc = a;
            if (b != this.oc) {
                this.j2("LineTypeContentPadding", b, a);
            }
        }
        get eu() {
            return this.b1;
        }
        set eu(a) {
            let b = this.b1;
            this.b1 = a;
            if (b != this.b1) {
                this.j2("LineTypeUnderlineWidth", b, a);
            }
        }
        get et() {
            return this.b0;
        }
        set et(a) {
            let b = this.b0;
            this.b0 = a;
            if (b != this.b0) {
                this.j2("LineTypeUnderlineRippleWidth", b, a);
            }
        }
        get eq() {
            return this.bx;
        }
        set eq(a) {
            let b = this.bx;
            this.bx = a;
            if (b != this.bx) {
                this.j2("LineTypeHoverUnderlineWidth", b, a);
            }
        }
        get nw() {
            return this.lu;
        }
        set nw(a) {
            let b = this.lu;
            this.lu = a;
            if (b != this.lu) {
                this.j2("LineTypeUnderlineColor", b, a);
            }
        }
        get nx() {
            return this.lv;
        }
        set nx(a) {
            let b = this.lv;
            this.lv = a;
            if (b != this.lv) {
                this.j2("LineTypeUnderlineRippleColor", b, a);
            }
        }
        get nv() {
            return this.lt;
        }
        set nv(a) {
            let b = this.lt;
            this.lo = a;
            if (b != this.lt) {
                this.j2("LineTypeHoverUnderlineColor", b, a);
            }
        }
        get nu() {
            return this.ls;
        }
        set nu(a) {
            let b = this.ls;
            this.ls = a;
            if (b != this.ls) {
                this.j2("LineTypeFocusUnderlineColor", b, a);
            }
        }
        get er() {
            return this.by;
        }
        set er(a) {
            let b = this.by;
            this.by = a;
            if (b != this.by) {
                this.j2("LineTypeUnderlineOpacity", b, a);
            }
        }
        get ep() {
            return this.bw;
        }
        set ep(a) {
            let b = this.bw;
            this.bw = a;
            if (b != this.bw) {
                this.j2("LineTypeHoverUnderlineOpacity", b, a);
            }
        }
        get en() {
            return this.bu;
        }
        set en(a) {
            let b = this.bu;
            this.bu = a;
            if (b != this.bu) {
                this.j2("LineTypeFocusUnderlineOpacity", b, a);
            }
        }
        get eo() {
            return this.bv;
        }
        set eo(a) {
            let b = this.bv;
            this.bv = a;
            if (b != this.bv) {
                this.j2("LineTypeFocusUnderlineRippleOpacity", b, a);
            }
        }
        get es() {
            return this.bz;
        }
        set es(a) {
            let b = this.bz;
            this.bz = a;
            if (b != this.bz) {
                this.j2("LineTypeUnderlineRippleOpacity", b, a);
            }
        }
        get nr() {
            return this.lp;
        }
        set nr(a) {
            let b = this.lp;
            this.lp = a;
            if (b != this.lp) {
                this.j2("LineTypeBackgroundColor", b, a);
            }
        }
        get c1() {
            return this.bd;
        }
        set c1(a) {
            let b = this.bd;
            this.bd = a;
            if (b != this.bd) {
                this.j2("BoxTypeBorderWidth", b, a);
            }
        }
        get c2() {
            return this.be;
        }
        set c2(a) {
            let b = this.be;
            this.be = a;
            if (b != this.be) {
                this.j2("BoxTypeFocusBorderWidth", b, a);
            }
        }
        get mn() {
            return this.lh;
        }
        set mn(a) {
            let b = this.lh;
            this.lh = a;
            if (b != this.lh) {
                this.j2("BoxTypeFocusBorderColor", b, a);
            }
        }
        get mm() {
            return this.lg;
        }
        set mm(a) {
            let b = this.lg;
            this.lg = a;
            if (b != this.lg) {
                this.j2("BoxTypeBorderColor", b, a);
            }
        }
        get kq() {
            return this.kk;
        }
        set kq(a) {
            let b = this.kk;
            this.kk = a;
            if (b != this.kk) {
                this.j2("BoxTypeCornerRadius", b, a);
            }
        }
        get og() {
            return this.oa;
        }
        set og(a) {
            let b = this.oa;
            this.oa = a;
            if (b != this.oa) {
                this.j2("BoxTypeContentPadding", b, a);
            }
        }
        get da() {
            return this.bm;
        }
        set da(a) {
            let b = this.bm;
            this.bm = a;
            if (b != this.bm) {
                this.j2("BoxTypeUnderlineWidth", b, a);
            }
        }
        get c9() {
            return this.bl;
        }
        set c9(a) {
            let b = this.bl;
            this.bl = a;
            if (b != this.bl) {
                this.j2("BoxTypeUnderlineRippleWidth", b, a);
            }
        }
        get c6() {
            return this.bi;
        }
        set c6(a) {
            let b = this.bi;
            this.bi = a;
            if (b != this.bi) {
                this.j2("BoxTypeHoverUnderlineWidth", b, a);
            }
        }
        get mq() {
            return this.lk;
        }
        set mq(a) {
            let b = this.lk;
            this.lk = a;
            if (b != this.lk) {
                this.j2("BoxTypeUnderlineColor", b, a);
            }
        }
        get mr() {
            return this.ll;
        }
        set mr(a) {
            let b = this.ll;
            this.ll = a;
            if (b != this.ll) {
                this.j2("BoxTypeUnderlineRippleColor", b, a);
            }
        }
        get mp() {
            return this.lj;
        }
        set mp(a) {
            let b = this.lj;
            this.lo = a;
            if (b != this.lj) {
                this.j2("BoxTypeHoverUnderlineColor", b, a);
            }
        }
        get mo() {
            return this.li;
        }
        set mo(a) {
            let b = this.li;
            this.li = a;
            if (b != this.li) {
                this.j2("BoxTypeFocusUnderlineColor", b, a);
            }
        }
        get c7() {
            return this.bj;
        }
        set c7(a) {
            let b = this.bj;
            this.bj = a;
            if (b != this.bj) {
                this.j2("BoxTypeUnderlineOpacity", b, a);
            }
        }
        get c5() {
            return this.bh;
        }
        set c5(a) {
            let b = this.bh;
            this.bh = a;
            if (b != this.bh) {
                this.j2("BoxTypeHoverUnderlineOpacity", b, a);
            }
        }
        get c3() {
            return this.bf;
        }
        set c3(a) {
            let b = this.bf;
            this.bf = a;
            if (b != this.bf) {
                this.j2("BoxTypeFocusUnderlineOpacity", b, a);
            }
        }
        get c4() {
            return this.bg;
        }
        set c4(a) {
            let b = this.bg;
            this.bg = a;
            if (b != this.bg) {
                this.j2("BoxTypeFocusUnderlineRippleOpacity", b, a);
            }
        }
        get c8() {
            return this.bk;
        }
        set c8(a) {
            let b = this.bk;
            this.bk = a;
            if (b != this.bk) {
                this.j2("BoxTypeUnderlineRippleOpacity", b, a);
            }
        }
        get ml() {
            return this.lf;
        }
        set ml(a) {
            let b = this.lf;
            this.lf = a;
            if (b != this.lf) {
                this.j2("BoxTypeBackgroundColor", b, a);
            }
        }
        get cq() {
            return this.a2;
        }
        set cq(a) {
            let b = this.a2;
            this.a2 = a;
            if (b != this.a2) {
                this.j2("BorderTypeBorderWidth", b, a);
            }
        }
        get cr() {
            return this.a3;
        }
        set cr(a) {
            let b = this.a3;
            this.a3 = a;
            if (b != this.a3) {
                this.j2("BorderTypeFocusBorderWidth", b, a);
            }
        }
        get mg() {
            return this.la;
        }
        set mg(a) {
            let b = this.la;
            this.la = a;
            if (b != this.la) {
                this.j2("BorderTypeFocusBorderColor", b, a);
            }
        }
        get mf() {
            return this.k9;
        }
        set mf(a) {
            let b = this.k9;
            this.k9 = a;
            if (b != this.k9) {
                this.j2("BorderTypeBorderColor", b, a);
            }
        }
        get kp() {
            return this.kj;
        }
        set kp(a) {
            let b = this.kj;
            this.kj = a;
            if (b != this.kj) {
                this.j2("BorderTypeCornerRadius", b, a);
            }
        }
        get of() {
            return this.n9;
        }
        set of(a) {
            let b = this.n9;
            this.n9 = a;
            if (b != this.n9) {
                this.j2("BorderTypeContentPadding", b, a);
            }
        }
        get cz() {
            return this.bb;
        }
        set cz(a) {
            let b = this.bb;
            this.bb = a;
            if (b != this.bb) {
                this.j2("BorderTypeUnderlineWidth", b, a);
            }
        }
        get cy() {
            return this.ba;
        }
        set cy(a) {
            let b = this.ba;
            this.ba = a;
            if (b != this.ba) {
                this.j2("BorderTypeUnderlineRippleWidth", b, a);
            }
        }
        get cv() {
            return this.a7;
        }
        set cv(a) {
            let b = this.a7;
            this.a7 = a;
            if (b != this.a7) {
                this.j2("BorderTypeHoverUnderlineWidth", b, a);
            }
        }
        get mj() {
            return this.ld;
        }
        set mj(a) {
            let b = this.ld;
            this.ld = a;
            if (b != this.ld) {
                this.j2("BorderTypeUnderlineColor", b, a);
            }
        }
        get mk() {
            return this.le;
        }
        set mk(a) {
            let b = this.le;
            this.le = a;
            if (b != this.le) {
                this.j2("BorderTypeUnderlineRippleColor", b, a);
            }
        }
        get mi() {
            return this.lc;
        }
        set mi(a) {
            let b = this.lc;
            this.lo = a;
            if (b != this.lc) {
                this.j2("BorderTypeHoverUnderlineColor", b, a);
            }
        }
        get mh() {
            return this.lb;
        }
        set mh(a) {
            let b = this.lb;
            this.lb = a;
            if (b != this.lb) {
                this.j2("BorderTypeFocusUnderlineColor", b, a);
            }
        }
        get cw() {
            return this.a8;
        }
        set cw(a) {
            let b = this.a8;
            this.a8 = a;
            if (b != this.a8) {
                this.j2("BorderTypeUnderlineOpacity", b, a);
            }
        }
        get cu() {
            return this.a6;
        }
        set cu(a) {
            let b = this.a6;
            this.a6 = a;
            if (b != this.a6) {
                this.j2("BorderTypeHoverUnderlineOpacity", b, a);
            }
        }
        get cs() {
            return this.a4;
        }
        set cs(a) {
            let b = this.a4;
            this.a4 = a;
            if (b != this.a4) {
                this.j2("BorderTypeFocusUnderlineOpacity", b, a);
            }
        }
        get ct() {
            return this.a5;
        }
        set ct(a) {
            let b = this.a5;
            this.a5 = a;
            if (b != this.a5) {
                this.j2("BorderTypeFocusUnderlineRippleOpacity", b, a);
            }
        }
        get cx() {
            return this.a9;
        }
        set cx(a) {
            let b = this.a9;
            this.a9 = a;
            if (b != this.a9) {
                this.j2("BorderTypeUnderlineRippleOpacity", b, a);
            }
        }
        get me() {
            return this.k8;
        }
        set me(a) {
            let b = this.k8;
            this.k8 = a;
            if (b != this.k8) {
                this.j2("BorderTypeBackgroundColor", b, a);
            }
        }
        get ev() {
            return this.b2;
        }
        set ev(a) {
            let b = this.b2;
            this.b2 = a;
            if (b != this.b2) {
                this.j2("SearchTypeBorderWidth", b, a);
            }
        }
        get ew() {
            return this.b3;
        }
        set ew(a) {
            let b = this.b3;
            this.b3 = a;
            if (b != this.b3) {
                this.j2("SearchTypeFocusBorderWidth", b, a);
            }
        }
        get n0() {
            return this.ly;
        }
        set n0(a) {
            let b = this.ly;
            this.ly = a;
            if (b != this.ly) {
                this.j2("SearchTypeFocusBorderColor", b, a);
            }
        }
        get nz() {
            return this.lx;
        }
        set nz(a) {
            let b = this.lx;
            this.lx = a;
            if (b != this.lx) {
                this.j2("SearchTypeBorderColor", b, a);
            }
        }
        get ky() {
            return this.kn;
        }
        set ky(a) {
            let b = this.kn;
            this.kn = a;
            if (b != this.kn) {
                this.j2("SearchTypeCornerRadius", b, a);
            }
        }
        get oo() {
            return this.od;
        }
        set oo(a) {
            let b = this.od;
            this.od = a;
            if (b != this.od) {
                this.j2("SearchTypeContentPadding", b, a);
            }
        }
        get e4() {
            return this.cb;
        }
        set e4(a) {
            let b = this.cb;
            this.cb = a;
            if (b != this.cb) {
                this.j2("SearchTypeUnderlineWidth", b, a);
            }
        }
        get e3() {
            return this.ca;
        }
        set e3(a) {
            let b = this.ca;
            this.ca = a;
            if (b != this.ca) {
                this.j2("SearchTypeUnderlineRippleWidth", b, a);
            }
        }
        get e0() {
            return this.b7;
        }
        set e0(a) {
            let b = this.b7;
            this.b7 = a;
            if (b != this.b7) {
                this.j2("SearchTypeHoverUnderlineWidth", b, a);
            }
        }
        get n3() {
            return this.l1;
        }
        set n3(a) {
            let b = this.l1;
            this.l1 = a;
            if (b != this.l1) {
                this.j2("SearchTypeUnderlineColor", b, a);
            }
        }
        get n4() {
            return this.l2;
        }
        set n4(a) {
            let b = this.l2;
            this.l2 = a;
            if (b != this.l2) {
                this.j2("SearchTypeUnderlineRippleColor", b, a);
            }
        }
        get n2() {
            return this.l0;
        }
        set n2(a) {
            let b = this.l0;
            this.lo = a;
            if (b != this.l0) {
                this.j2("SearchTypeHoverUnderlineColor", b, a);
            }
        }
        get n1() {
            return this.lz;
        }
        set n1(a) {
            let b = this.lz;
            this.lz = a;
            if (b != this.lz) {
                this.j2("SearchTypeFocusUnderlineColor", b, a);
            }
        }
        get e1() {
            return this.b8;
        }
        set e1(a) {
            let b = this.b8;
            this.b8 = a;
            if (b != this.b8) {
                this.j2("SearchTypeUnderlineOpacity", b, a);
            }
        }
        get ez() {
            return this.b6;
        }
        set ez(a) {
            let b = this.b6;
            this.b6 = a;
            if (b != this.b6) {
                this.j2("SearchTypeHoverUnderlineOpacity", b, a);
            }
        }
        get ex() {
            return this.b4;
        }
        set ex(a) {
            let b = this.b4;
            this.b4 = a;
            if (b != this.b4) {
                this.j2("SearchTypeFocusUnderlineOpacity", b, a);
            }
        }
        get ey() {
            return this.b5;
        }
        set ey(a) {
            let b = this.b5;
            this.b5 = a;
            if (b != this.b5) {
                this.j2("SearchTypeFocusUnderlineRippleOpacity", b, a);
            }
        }
        get e2() {
            return this.b9;
        }
        set e2(a) {
            let b = this.b9;
            this.b9 = a;
            if (b != this.b9) {
                this.j2("SearchTypeUnderlineRippleOpacity", b, a);
            }
        }
        get ny() {
            return this.lw;
        }
        set ny(a) {
            let b = this.lw;
            this.lw = a;
            if (b != this.lw) {
                this.j2("SearchTypeBackgroundColor", b, a);
            }
        }
        get an() {
            return this.ad;
        }
        set an(a) {
            let b = this.ad;
            this.ad = a;
            if (b != this.ad) {
                this.j2("IsExpanded", b, a);
            }
        }
        j8() {
            this.ad = false;
            this.z = false;
            this.kh();
        }
        get ap() {
            return this.af;
        }
        set ap(a) {
            let b = this.af;
            this.af = a;
            if (b != this.af) {
                this.j2("IsHovered", b, a);
            }
        }
        get ao() {
            return this.ae;
        }
        set ao(a) {
            let b = this.ae;
            this.ae = a;
            if (b != this.ae) {
                this.j2("IsFocused", b, a);
            }
        }
        get ai() {
            return this.x;
        }
        set ai(a) {
            let b = this.x;
            this.x = a;
            if (b != this.x) {
                this.j2("ActualIsExpanded", b, a);
            }
        }
        get no() {
            return this.lm;
        }
        set no(a) {
            let b = this.lm;
            this.lm = a;
            if (b != this.lm) {
                this.j2("FocusBorderColor", b, a);
            }
        }
        get hk() {
            return this.ff;
        }
        set hk(a) {
            let b = this.ff;
            this.ff = a;
            if (b != this.ff) {
                this.j2("Id", b, a);
            }
        }
        get disabled() {
            return this.ac;
        }
        set disabled(a) {
            let b = this.ac;
            this.ac = a;
            if (b != this.ac) {
                this.j2("IsDisabled", b, a);
            }
        }
        j3() {
        }
        onDetachedFromUI() {
            this.view.ai();
        }
        onAttachedToUI() {
            this.view.ag();
        }
        ensureShift() {
            this.jr((a) => a.view.a8());
            this.js((a) => a.view.af());
            this.jt((a) => a.view.q());
            this.ju((a) => a.view.q());
        }
        aq() {
            return this.view.g();
        }
        fe() {
            return this.b();
        }
        hb() {
            let a = this.b();
            return a.y();
        }
        b() {
            let a = new InputGroupVisualModelExport();
            a.f = this.s;
            a.e = this.p;
            a.b = AppearanceHelper.a(this.l6);
            a.o = this.cg;
            a.p = this.ch;
            a.z = this.ko;
            a.aa = this.oe;
            a.x = this.cp;
            a.w = this.co;
            a.t = this.cl;
            a.c = AppearanceHelper.a(this.ma);
            a.d = AppearanceHelper.a(this.mb);
            a.u = this.cm;
            a.s = this.ck;
            a.q = this.ci;
            a.r = this.cj;
            a.v = this.cn;
            a.a = AppearanceHelper.a(this.l5);
            a.g = this.ai;
            a.j = this.ap;
            a.i = this.ao;
            a.h = this.disabled;
            a.m = new List$1(PrefixVisualModelExport.$, 0);
            a.l = new List$1(LabelVisualModelExport.$, 0);
            a.k = new List$1(InputVisualModelExport.$, 0);
            a.n = new List$1(SuffixVisualModelExport.$, 0);
            for (let b = 0; b < this.inputs.count; b++) {
                if (typeCast(XPrefix.$, this.inputs._inner[b]) !== null) {
                    if (this.inputs._inner[b].e == null) {
                        this.inputs._inner[b].e = "Prefix" + a.m.count.toString();
                    }
                    a.m.add1(this.inputs._inner[b].t());
                }
                else if (typeCast(XLabel.$, this.inputs._inner[b]) !== null) {
                    if (this.inputs._inner[b].e == null) {
                        this.inputs._inner[b].e = "Label" + a.l.count.toString();
                    }
                    a.l.add1(this.inputs._inner[b].au());
                }
                else if (typeCast(XInput.$, this.inputs._inner[b]) !== null) {
                    if (this.inputs._inner[b].e == null) {
                        this.inputs._inner[b].e = "Input" + a.k.count.toString();
                    }
                    a.k.add1(this.inputs._inner[b].bg());
                }
                else if (typeCast(XSuffix.$, this.inputs._inner[b]) !== null) {
                    if (this.inputs._inner[b].e == null) {
                        this.inputs._inner[b].e = "Suffix" + a.n.count.toString();
                    }
                    a.n.add1(this.inputs._inner[b].t());
                }
            }
            return a;
        }
        provideContainer(a) {
            this.view.ah(a);
        }
        get inputs() {
            return this.f;
        }
        get fb() {
            if (!this.fd.hasValue) {
                let a = 0;
                this.js((b) => a++);
                this.fd = toNullable(Number_$type, a);
            }
            return this.fd.value;
        }
        j9() {
            this.fd = toNullable(Number_$type, null);
        }
        get ak() {
            return this.fb > 0;
        }
        get ar() {
            return !this.ak || this.ai;
        }
    }
    XInputGroup.$t = /*@__PURE__*/ markType(XInputGroup, 'XInputGroup', Base.$, [INotifyPropertyChanged_$type]);
    XInputGroup.o = 2;
    XInputGroup.fc = 0;
    XInputGroup.j = /*@__PURE__*/ new Theme(1, /*@__PURE__*/ ((() => {
        let $ret = new Dictionary$2(String_$type, Base.$, 0);
        return $ret;
    })()), /*@__PURE__*/ ((() => {
        let $ret = new Dictionary$2(Base.$, Theme.$, 0);
        $ret.addItem(enumGetBox(InputGroupDisplayType_$type, 2), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("BorderWidth", DeviceUtils.g(1));
            $ret.addItem("FocusBorderWidth", DeviceUtils.g(2));
            $ret.addItem("CornerRadius", new CornerRadius(1, 4, 4, 4, 4));
            $ret.addItem("ContentPadding", new Thickness(1, 16, 0, 16, 0));
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("FocusBorderColor", BrushUtil.h(255, 0, 153, 155));
            $ret.addItem("FocusLabelColor", BrushUtil.h(255, 0, 153, 155));
            $ret.addItem("UnderlineWidth", DeviceUtils.g(1));
            $ret.addItem("UnderlineRippleWidth", DeviceUtils.g(2));
            $ret.addItem("HoverUnderlineWidth", DeviceUtils.g(2));
            $ret.addItem("UnderlineColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("UnderlineRippleColor", BrushUtil.h(255, 0, 153, 155));
            $ret.addItem("HoverUnderlineColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("FocusUnderlineColor", BrushUtil.h(255, 0, 153, 155));
            $ret.addItem("UnderlineOpacity", 0);
            $ret.addItem("HoverUnderlineOpacity", 0);
            $ret.addItem("FocusUnderlineOpacity", 0);
            $ret.addItem("FocusUnderlineRippleOpacity", 0);
            $ret.addItem("UnderlineRippleOpacity", 0);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(InputGroupDisplayType_$type, 1), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("BorderWidth", DeviceUtils.g(0));
            $ret.addItem("FocusBorderWidth", DeviceUtils.g(0));
            $ret.addItem("CornerRadius", new CornerRadius(1, 4, 4, 0, 0));
            $ret.addItem("ContentPadding", new Thickness(1, 16, 0, 16, 0));
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("FocusBorderColor", BrushUtil.h(255, 0, 153, 155));
            $ret.addItem("FocusLabelColor", BrushUtil.h(255, 0, 153, 155));
            $ret.addItem("UnderlineWidth", DeviceUtils.g(1));
            $ret.addItem("UnderlineRippleWidth", DeviceUtils.g(2));
            $ret.addItem("HoverUnderlineWidth", DeviceUtils.g(2));
            $ret.addItem("UnderlineColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("UnderlineRippleColor", BrushUtil.h(255, 0, 153, 155));
            $ret.addItem("HoverUnderlineColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("FocusUnderlineColor", BrushUtil.h(255, 0, 153, 155));
            $ret.addItem("UnderlineOpacity", 1);
            $ret.addItem("HoverUnderlineOpacity", 1);
            $ret.addItem("FocusUnderlineOpacity", 1);
            $ret.addItem("FocusUnderlineRippleOpacity", 1);
            $ret.addItem("UnderlineRippleOpacity", 0);
            $ret.addItem("BackgroundColor", BrushUtil.h(20, 0, 0, 0));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(InputGroupDisplayType_$type, 0), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("BorderWidth", DeviceUtils.g(0));
            $ret.addItem("FocusBorderWidth", DeviceUtils.g(0));
            $ret.addItem("CornerRadius", new CornerRadius(0, 0));
            $ret.addItem("ContentPadding", new Thickness(0, 0));
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("FocusBorderColor", BrushUtil.h(255, 0, 153, 155));
            $ret.addItem("FocusLabelColor", BrushUtil.h(255, 0, 153, 155));
            $ret.addItem("UnderlineWidth", DeviceUtils.g(1));
            $ret.addItem("UnderlineRippleWidth", DeviceUtils.g(2));
            $ret.addItem("HoverUnderlineWidth", DeviceUtils.g(2));
            $ret.addItem("UnderlineColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("UnderlineRippleColor", BrushUtil.h(255, 0, 153, 155));
            $ret.addItem("HoverUnderlineColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("FocusUnderlineColor", BrushUtil.h(255, 0, 153, 155));
            $ret.addItem("UnderlineOpacity", 1);
            $ret.addItem("HoverUnderlineOpacity", 1);
            $ret.addItem("FocusUnderlineOpacity", 1);
            $ret.addItem("FocusUnderlineRippleOpacity", 1);
            $ret.addItem("UnderlineRippleOpacity", 0);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(InputGroupDisplayType_$type, 3), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("BorderWidth", DeviceUtils.g(1));
            $ret.addItem("FocusBorderWidth", DeviceUtils.g(2));
            $ret.addItem("CornerRadius", new CornerRadius(0, 4));
            $ret.addItem("ContentPadding", new Thickness(1, 16, 0, 16, 0));
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("FocusBorderColor", BrushUtil.h(255, 0, 153, 155));
            $ret.addItem("FocusLabelColor", BrushUtil.h(255, 0, 153, 155));
            $ret.addItem("UnderlineWidth", DeviceUtils.g(1));
            $ret.addItem("UnderlineRippleWidth", DeviceUtils.g(2));
            $ret.addItem("HoverUnderlineWidth", DeviceUtils.g(2));
            $ret.addItem("UnderlineColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("UnderlineRippleColor", BrushUtil.h(255, 0, 153, 155));
            $ret.addItem("HoverUnderlineColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("FocusUnderlineColor", BrushUtil.h(255, 0, 153, 155));
            $ret.addItem("UnderlineOpacity", 0);
            $ret.addItem("HoverUnderlineOpacity", 0);
            $ret.addItem("FocusUnderlineOpacity", 0);
            $ret.addItem("FocusUnderlineRippleOpacity", 0);
            $ret.addItem("UnderlineRippleOpacity", 0);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            return $ret;
        })())));
        return $ret;
    })()));
    XInputGroup.i = /*@__PURE__*/ new Theme(1, /*@__PURE__*/ ((() => {
        let $ret = new Dictionary$2(String_$type, Base.$, 0);
        return $ret;
    })()), /*@__PURE__*/ ((() => {
        let $ret = new Dictionary$2(Base.$, Theme.$, 0);
        $ret.addItem(enumGetBox(InputGroupDisplayType_$type, 2), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("BorderWidth", DeviceUtils.g(1));
            $ret.addItem("FocusBorderWidth", DeviceUtils.g(2));
            $ret.addItem("CornerRadius", new CornerRadius(0, 4));
            $ret.addItem("ContentPadding", new Thickness(1, 16, 0, 16, 0));
            $ret.addItem("BorderColor", BrushUtil.h(255, 186, 191, 199));
            $ret.addItem("FocusBorderColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("FocusLabelColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("UnderlineWidth", DeviceUtils.g(1));
            $ret.addItem("UnderlineRippleWidth", DeviceUtils.g(2));
            $ret.addItem("HoverUnderlineWidth", DeviceUtils.g(2));
            $ret.addItem("UnderlineColor", BrushUtil.h(255, 186, 191, 199));
            $ret.addItem("UnderlineRippleColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("HoverUnderlineColor", BrushUtil.h(255, 186, 191, 199));
            $ret.addItem("FocusUnderlineColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("UnderlineOpacity", 0);
            $ret.addItem("HoverUnderlineOpacity", 0);
            $ret.addItem("FocusUnderlineOpacity", 0);
            $ret.addItem("FocusUnderlineRippleOpacity", 0);
            $ret.addItem("UnderlineRippleOpacity", 0);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(InputGroupDisplayType_$type, 1), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("BorderWidth", DeviceUtils.g(0));
            $ret.addItem("FocusBorderWidth", DeviceUtils.g(0));
            $ret.addItem("CornerRadius", new CornerRadius(1, 4, 4, 0, 0));
            $ret.addItem("ContentPadding", new Thickness(1, 16, 0, 16, 0));
            $ret.addItem("BorderColor", BrushUtil.h(255, 186, 191, 199));
            $ret.addItem("FocusBorderColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("FocusLabelColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("UnderlineWidth", DeviceUtils.g(1));
            $ret.addItem("UnderlineRippleWidth", DeviceUtils.g(2));
            $ret.addItem("HoverUnderlineWidth", DeviceUtils.g(2));
            $ret.addItem("UnderlineColor", BrushUtil.h(255, 186, 191, 199));
            $ret.addItem("UnderlineRippleColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("HoverUnderlineColor", BrushUtil.h(255, 186, 191, 199));
            $ret.addItem("FocusUnderlineColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("UnderlineOpacity", 1);
            $ret.addItem("HoverUnderlineOpacity", 1);
            $ret.addItem("FocusUnderlineOpacity", 1);
            $ret.addItem("FocusUnderlineRippleOpacity", 1);
            $ret.addItem("UnderlineRippleOpacity", 0);
            $ret.addItem("BackgroundColor", BrushUtil.h(20, 0, 0, 0));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(InputGroupDisplayType_$type, 0), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("BorderWidth", DeviceUtils.g(0));
            $ret.addItem("FocusBorderWidth", DeviceUtils.g(0));
            $ret.addItem("CornerRadius", new CornerRadius(0, 0));
            $ret.addItem("ContentPadding", new Thickness(0, 0));
            $ret.addItem("BorderColor", BrushUtil.h(255, 186, 191, 199));
            $ret.addItem("FocusBorderColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("FocusLabelColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("UnderlineWidth", DeviceUtils.g(1));
            $ret.addItem("UnderlineRippleWidth", DeviceUtils.g(2));
            $ret.addItem("HoverUnderlineWidth", DeviceUtils.g(2));
            $ret.addItem("UnderlineColor", BrushUtil.h(255, 186, 191, 199));
            $ret.addItem("UnderlineRippleColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("HoverUnderlineColor", BrushUtil.h(255, 186, 191, 199));
            $ret.addItem("FocusUnderlineColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("UnderlineOpacity", 1);
            $ret.addItem("HoverUnderlineOpacity", 1);
            $ret.addItem("FocusUnderlineOpacity", 1);
            $ret.addItem("FocusUnderlineRippleOpacity", 1);
            $ret.addItem("UnderlineRippleOpacity", 0);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(InputGroupDisplayType_$type, 3), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("BorderWidth", DeviceUtils.g(1));
            $ret.addItem("FocusBorderWidth", DeviceUtils.g(2));
            $ret.addItem("CornerRadius", new CornerRadius(0, 4));
            $ret.addItem("ContentPadding", new Thickness(1, 16, 0, 16, 0));
            $ret.addItem("BorderColor", BrushUtil.h(255, 186, 191, 199));
            $ret.addItem("FocusBorderColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("FocusLabelColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("UnderlineWidth", DeviceUtils.g(1));
            $ret.addItem("UnderlineRippleWidth", DeviceUtils.g(2));
            $ret.addItem("HoverUnderlineWidth", DeviceUtils.g(2));
            $ret.addItem("UnderlineColor", BrushUtil.h(255, 186, 191, 199));
            $ret.addItem("UnderlineRippleColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("HoverUnderlineColor", BrushUtil.h(255, 186, 191, 199));
            $ret.addItem("FocusUnderlineColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("UnderlineOpacity", 0);
            $ret.addItem("HoverUnderlineOpacity", 0);
            $ret.addItem("FocusUnderlineOpacity", 0);
            $ret.addItem("FocusUnderlineRippleOpacity", 0);
            $ret.addItem("UnderlineRippleOpacity", 0);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            return $ret;
        })())));
        return $ret;
    })()));
    XInputGroup.n5 = /*@__PURE__*/ BrushUtil.h(255, 105, 136, 255);
    XInputGroup.l = /*@__PURE__*/ new Theme(1, /*@__PURE__*/ ((() => {
        let $ret = new Dictionary$2(String_$type, Base.$, 0);
        return $ret;
    })()), /*@__PURE__*/ ((() => {
        let $ret = new Dictionary$2(Base.$, Theme.$, 0);
        $ret.addItem(enumGetBox(InputGroupDisplayType_$type, 2), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("BorderWidth", DeviceUtils.g(1));
            $ret.addItem("FocusBorderWidth", DeviceUtils.g(2));
            $ret.addItem("CornerRadius", new CornerRadius(0, 4));
            $ret.addItem("ContentPadding", new Thickness(1, 8, 0, 8, 0));
            $ret.addItem("BorderColor", BrushUtil.h(25, 0, 0, 0));
            $ret.addItem("FocusBorderColor", XInputGroup.n5);
            $ret.addItem("FocusLabelColor", XInputGroup.n5);
            $ret.addItem("UnderlineWidth", DeviceUtils.g(1));
            $ret.addItem("UnderlineRippleWidth", DeviceUtils.g(2));
            $ret.addItem("HoverUnderlineWidth", DeviceUtils.g(2));
            $ret.addItem("UnderlineColor", BrushUtil.h(25, 0, 0, 0));
            $ret.addItem("UnderlineRippleColor", XInputGroup.n5);
            $ret.addItem("HoverUnderlineColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("FocusUnderlineColor", XInputGroup.n5);
            $ret.addItem("UnderlineOpacity", 0);
            $ret.addItem("HoverUnderlineOpacity", 0);
            $ret.addItem("FocusUnderlineOpacity", 0);
            $ret.addItem("FocusUnderlineRippleOpacity", 0);
            $ret.addItem("UnderlineRippleOpacity", 0);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(InputGroupDisplayType_$type, 1), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("BorderWidth", DeviceUtils.g(0));
            $ret.addItem("FocusBorderWidth", DeviceUtils.g(0));
            $ret.addItem("CornerRadius", new CornerRadius(1, 4, 4, 0, 0));
            $ret.addItem("ContentPadding", new Thickness(1, 16, 0, 16, 0));
            $ret.addItem("BorderColor", BrushUtil.h(255, 186, 191, 199));
            $ret.addItem("FocusBorderColor", XInputGroup.n5);
            $ret.addItem("FocusLabelColor", XInputGroup.n5);
            $ret.addItem("UnderlineWidth", DeviceUtils.g(1));
            $ret.addItem("UnderlineRippleWidth", DeviceUtils.g(2));
            $ret.addItem("HoverUnderlineWidth", DeviceUtils.g(2));
            $ret.addItem("UnderlineColor", BrushUtil.h(255, 186, 191, 199));
            $ret.addItem("UnderlineRippleColor", XInputGroup.n5);
            $ret.addItem("HoverUnderlineColor", BrushUtil.h(255, 186, 191, 199));
            $ret.addItem("FocusUnderlineColor", XInputGroup.n5);
            $ret.addItem("UnderlineOpacity", 1);
            $ret.addItem("HoverUnderlineOpacity", 1);
            $ret.addItem("FocusUnderlineOpacity", 1);
            $ret.addItem("FocusUnderlineRippleOpacity", 1);
            $ret.addItem("UnderlineRippleOpacity", 0);
            $ret.addItem("BackgroundColor", BrushUtil.h(25, 0, 0, 0));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(InputGroupDisplayType_$type, 0), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("BorderWidth", DeviceUtils.g(0));
            $ret.addItem("FocusBorderWidth", DeviceUtils.g(0));
            $ret.addItem("CornerRadius", new CornerRadius(0, 0));
            $ret.addItem("ContentPadding", new Thickness(0, 0));
            $ret.addItem("BorderColor", BrushUtil.h(255, 186, 191, 199));
            $ret.addItem("FocusBorderColor", XInputGroup.n5);
            $ret.addItem("FocusLabelColor", XInputGroup.n5);
            $ret.addItem("UnderlineWidth", DeviceUtils.g(1));
            $ret.addItem("UnderlineRippleWidth", DeviceUtils.g(2));
            $ret.addItem("HoverUnderlineWidth", DeviceUtils.g(2));
            $ret.addItem("UnderlineColor", BrushUtil.h(255, 186, 191, 199));
            $ret.addItem("UnderlineRippleColor", XInputGroup.n5);
            $ret.addItem("HoverUnderlineColor", BrushUtil.h(255, 186, 191, 199));
            $ret.addItem("FocusUnderlineColor", XInputGroup.n5);
            $ret.addItem("UnderlineOpacity", 1);
            $ret.addItem("HoverUnderlineOpacity", 1);
            $ret.addItem("FocusUnderlineOpacity", 1);
            $ret.addItem("FocusUnderlineRippleOpacity", 1);
            $ret.addItem("UnderlineRippleOpacity", 0);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(InputGroupDisplayType_$type, 3), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("BorderWidth", DeviceUtils.g(1));
            $ret.addItem("FocusBorderWidth", DeviceUtils.g(2));
            $ret.addItem("CornerRadius", new CornerRadius(0, 4));
            $ret.addItem("ContentPadding", new Thickness(1, 16, 0, 16, 0));
            $ret.addItem("BorderColor", BrushUtil.h(255, 186, 191, 199));
            $ret.addItem("FocusBorderColor", XInputGroup.n5);
            $ret.addItem("FocusLabelColor", XInputGroup.n5);
            $ret.addItem("UnderlineWidth", DeviceUtils.g(1));
            $ret.addItem("UnderlineRippleWidth", DeviceUtils.g(2));
            $ret.addItem("HoverUnderlineWidth", DeviceUtils.g(2));
            $ret.addItem("UnderlineColor", BrushUtil.h(255, 186, 191, 199));
            $ret.addItem("UnderlineRippleColor", XInputGroup.n5);
            $ret.addItem("HoverUnderlineColor", BrushUtil.h(255, 186, 191, 199));
            $ret.addItem("FocusUnderlineColor", XInputGroup.n5);
            $ret.addItem("UnderlineOpacity", 0);
            $ret.addItem("HoverUnderlineOpacity", 0);
            $ret.addItem("FocusUnderlineOpacity", 0);
            $ret.addItem("FocusUnderlineRippleOpacity", 0);
            $ret.addItem("UnderlineRippleOpacity", 0);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            return $ret;
        })())));
        return $ret;
    })()));
    XInputGroup.k = /*@__PURE__*/ new Theme(1, /*@__PURE__*/ ((() => {
        let $ret = new Dictionary$2(String_$type, Base.$, 0);
        return $ret;
    })()), /*@__PURE__*/ ((() => {
        let $ret = new Dictionary$2(Base.$, Theme.$, 0);
        $ret.addItem(enumGetBox(InputGroupDisplayType_$type, 2), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("BorderWidth", DeviceUtils.g(1));
            $ret.addItem("FocusBorderWidth", DeviceUtils.g(2));
            $ret.addItem("CornerRadius", new CornerRadius(0, 4));
            $ret.addItem("ContentPadding", new Thickness(1, 8, 0, 8, 0));
            $ret.addItem("BorderColor", BrushUtil.h(51, 255, 255, 255));
            $ret.addItem("FocusBorderColor", XInputGroup.n5);
            $ret.addItem("FocusLabelColor", XInputGroup.n5);
            $ret.addItem("UnderlineWidth", DeviceUtils.g(1));
            $ret.addItem("UnderlineRippleWidth", DeviceUtils.g(2));
            $ret.addItem("HoverUnderlineWidth", DeviceUtils.g(2));
            $ret.addItem("UnderlineColor", BrushUtil.h(51, 255, 255, 255));
            $ret.addItem("UnderlineRippleColor", XInputGroup.n5);
            $ret.addItem("HoverUnderlineColor", BrushUtil.h(51, 255, 255, 255));
            $ret.addItem("FocusUnderlineColor", XInputGroup.n5);
            $ret.addItem("UnderlineOpacity", 0);
            $ret.addItem("HoverUnderlineOpacity", 0);
            $ret.addItem("FocusUnderlineOpacity", 0);
            $ret.addItem("FocusUnderlineRippleOpacity", 0);
            $ret.addItem("UnderlineRippleOpacity", 0);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(InputGroupDisplayType_$type, 1), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("BorderWidth", DeviceUtils.g(0));
            $ret.addItem("FocusBorderWidth", DeviceUtils.g(0));
            $ret.addItem("CornerRadius", new CornerRadius(1, 4, 4, 0, 0));
            $ret.addItem("ContentPadding", new Thickness(1, 16, 0, 16, 0));
            $ret.addItem("BorderColor", BrushUtil.h(51, 255, 255, 255));
            $ret.addItem("FocusBorderColor", XInputGroup.n5);
            $ret.addItem("FocusLabelColor", XInputGroup.n5);
            $ret.addItem("UnderlineWidth", DeviceUtils.g(1));
            $ret.addItem("UnderlineRippleWidth", DeviceUtils.g(2));
            $ret.addItem("HoverUnderlineWidth", DeviceUtils.g(2));
            $ret.addItem("UnderlineColor", BrushUtil.h(51, 255, 255, 255));
            $ret.addItem("UnderlineRippleColor", XInputGroup.n5);
            $ret.addItem("HoverUnderlineColor", BrushUtil.h(51, 255, 255, 255));
            $ret.addItem("FocusUnderlineColor", XInputGroup.n5);
            $ret.addItem("UnderlineOpacity", 1);
            $ret.addItem("HoverUnderlineOpacity", 1);
            $ret.addItem("FocusUnderlineOpacity", 1);
            $ret.addItem("FocusUnderlineRippleOpacity", 1);
            $ret.addItem("UnderlineRippleOpacity", 0);
            $ret.addItem("BackgroundColor", BrushUtil.h(128, 55, 63, 86));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(InputGroupDisplayType_$type, 0), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("BorderWidth", DeviceUtils.g(0));
            $ret.addItem("FocusBorderWidth", DeviceUtils.g(0));
            $ret.addItem("CornerRadius", new CornerRadius(0, 0));
            $ret.addItem("ContentPadding", new Thickness(0, 0));
            $ret.addItem("BorderColor", BrushUtil.h(51, 255, 255, 255));
            $ret.addItem("FocusBorderColor", XInputGroup.n5);
            $ret.addItem("FocusLabelColor", XInputGroup.n5);
            $ret.addItem("UnderlineWidth", DeviceUtils.g(1));
            $ret.addItem("UnderlineRippleWidth", DeviceUtils.g(2));
            $ret.addItem("HoverUnderlineWidth", DeviceUtils.g(2));
            $ret.addItem("UnderlineColor", BrushUtil.h(51, 255, 255, 255));
            $ret.addItem("UnderlineRippleColor", XInputGroup.n5);
            $ret.addItem("HoverUnderlineColor", BrushUtil.h(51, 255, 255, 255));
            $ret.addItem("FocusUnderlineColor", XInputGroup.n5);
            $ret.addItem("UnderlineOpacity", 1);
            $ret.addItem("HoverUnderlineOpacity", 1);
            $ret.addItem("FocusUnderlineOpacity", 1);
            $ret.addItem("FocusUnderlineRippleOpacity", 1);
            $ret.addItem("UnderlineRippleOpacity", 0);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(InputGroupDisplayType_$type, 3), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("BorderWidth", DeviceUtils.g(1));
            $ret.addItem("FocusBorderWidth", DeviceUtils.g(2));
            $ret.addItem("CornerRadius", new CornerRadius(0, 4));
            $ret.addItem("ContentPadding", new Thickness(1, 16, 0, 16, 0));
            $ret.addItem("BorderColor", BrushUtil.h(51, 255, 255, 255));
            $ret.addItem("FocusBorderColor", XInputGroup.n5);
            $ret.addItem("FocusLabelColor", XInputGroup.n5);
            $ret.addItem("UnderlineWidth", DeviceUtils.g(1));
            $ret.addItem("UnderlineRippleWidth", DeviceUtils.g(2));
            $ret.addItem("HoverUnderlineWidth", DeviceUtils.g(2));
            $ret.addItem("UnderlineColor", BrushUtil.h(51, 255, 255, 255));
            $ret.addItem("UnderlineRippleColor", XInputGroup.n5);
            $ret.addItem("HoverUnderlineColor", BrushUtil.h(51, 255, 255, 255));
            $ret.addItem("FocusUnderlineColor", XInputGroup.n5);
            $ret.addItem("UnderlineOpacity", 0);
            $ret.addItem("HoverUnderlineOpacity", 0);
            $ret.addItem("FocusUnderlineOpacity", 0);
            $ret.addItem("FocusUnderlineRippleOpacity", 0);
            $ret.addItem("UnderlineRippleOpacity", 0);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            return $ret;
        })())));
        return $ret;
    })()));
    XInputGroup.m = /*@__PURE__*/ new ThemeResolver(1, /*@__PURE__*/ ((() => {
        let $ret = new Dictionary$2(BaseControlTheme_$type, Theme.$, 0);
        $ret.addItem(2, XInputGroup.j);
        $ret.addItem(1, XInputGroup.i);
        $ret.addItem(3, XInputGroup.l);
        $ret.addItem(4, XInputGroup.k);
        return $ret;
    })()), 2);
    return XInputGroup;
})();
/**
 * @hidden
 */
export let XInputGroupInputCollection = /*@__PURE__*/ (() => {
    class XInputGroupInputCollection extends ObservableCollection$1 {
        constructor() {
            super(XInputGroupItem.$, 0);
            this.collectionResetting = null;
        }
        p() {
            if (this.collectionResetting != null) {
                this.collectionResetting(this, null);
            }
            super.p();
        }
    }
    XInputGroupInputCollection.$t = /*@__PURE__*/ markType(XInputGroupInputCollection, 'XInputGroupInputCollection', /*@__PURE__*/ ObservableCollection$1.$.specialize(XInputGroupItem.$));
    return XInputGroupInputCollection;
})();
/**
 * @hidden
 */
export let XLabel = /*@__PURE__*/ (() => {
    class XLabel extends XInputGroupItem {
        constructor() {
            super();
            this.n = 0;
            this._view = null;
            this.aa = null;
            this.z = null;
            this.r = 0;
            this.q = 1;
            this.cr = ThemeResolver.ah(XLabel.o, XLabel.da, XLabel.c3);
            this.co = ThemeResolver.ah(XLabel.o, XLabel.c7, XLabel.c0);
            this.cp = ThemeResolver.ah(XLabel.o, XLabel.c8, XLabel.c1);
            this.cq = ThemeResolver.ah(XLabel.o, XLabel.c9, XLabel.c2);
            this.u = null;
            this.cv = XLabel.db;
            this.cs = XLabel.c4;
            this.ct = XLabel.c5;
            this.k = 0;
            this.af = false;
            this.ad = false;
            this.v = null;
            this.cu = null;
            this.a2 = "ig-label-" + XLabel.at++;
            this.ay = "inline-block";
            this.az = "inline-block";
            this.a0 = null;
            this.av = "center";
            this.aw = "center";
            this.ar = 0;
            this.ab = false;
            this.a1 = null;
            this.ax = null;
            this.a3 = null;
            this.ae = false;
            this.ai = false;
            this.ac = false;
            this.ah = false;
            this.ag = false;
            this.ap = false;
            let a = new LabelView();
            a.c = this;
            this.view = a;
            this.view.ab();
        }
        get p() {
            return this.n;
        }
        set p(a) {
            let b = this.n;
            this.n = a;
            if (b != this.n) {
                this.g("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        }
        get view() {
            return this._view;
        }
        set view(a) {
            this._view = a;
        }
        destroy() {
            this.provideContainer(null);
        }
        get i() {
            let a = new AnimationKeyFrameEffectTiming();
            a.g = 300;
            a.b = 0;
            return a;
        }
        b8() {
            this.view.s();
            let a = false;
            if (this.aa == null) {
                let b = new TransformGroup();
                b.j.add(((() => {
                    let $ret = new TranslateTransform();
                    $ret.k = this.view.j();
                    return $ret;
                })()));
                b.j.add(((() => {
                    let $ret = new ScaleTransform();
                    $ret.l = 1;
                    $ret.m = 1;
                    return $ret;
                })()));
                let c = -(this.view.i() * 1.3);
                if (this.s == 2) {
                    c = -(this.view.i() * 1.05);
                }
                if (this.s == 3) {
                    c = -(this.view.i() * 1.01);
                }
                let d = new TransformGroup();
                d.j.add(((() => {
                    let $ret = new TranslateTransform();
                    $ret.k = this.l == 2 ? c : -(this.view.i() * 0.65);
                    return $ret;
                })()));
                d.j.add(((() => {
                    let $ret = new ScaleTransform();
                    $ret.l = 0.75;
                    $ret.m = 0.75;
                    return $ret;
                })()));
                this.aa = KeyFrameAnimationFactory.f.c(this.view.b(this.i).m(new AnimationKeyFrameProperty(14, b), new AnimationKeyFrameProperty(2, BrushUtil.h(0, 255, 255, 255))).m(new AnimationKeyFrameProperty(14, d), new AnimationKeyFrameProperty(2, BrushUtil.h(this.l == 2 ? 255 : 0, 255, 255, 255))));
            }
            if (this.z == null) {
                this.z = KeyFrameAnimationFactory.f.c(this.view.a(this.i).m(new AnimationKeyFrameProperty(7, this.cz)).m(new AnimationKeyFrameProperty(7, this.cw)));
            }
        }
        ci(a, b) {
            if ((b > 0 && a.playbackRate < 0) || (b < 0 && a.playbackRate > 0)) {
                a.reverse();
                if (this.ap) {
                    a.finish();
                    this.b9(a);
                    return;
                }
                a.finished.f((c) => this.b9(a));
            }
            else {
                a.play();
                if (this.ap) {
                    a.finish();
                    this.b9(a);
                    return;
                }
                a.finished.f((c) => this.b9(a));
            }
        }
        b9(a) {
            a.commitStyles();
            if (a == this.aa && this.ah) {
                this.aa = null;
            }
            if (a == this.z && this.ag) {
                this.z = null;
            }
        }
        h(a, b, c) {
            super.h(a, b, c);
            switch (a) {
                case "BaseTheme":
                    this.cl(this.p);
                    this.cn();
                    break;
                case "TextColor":
                case "HoverTextColor":
                case "TextStyle":
                case "HighlightTextColor":
                case "HoverHighlightTextColor":
                    this.cn();
                    break;
                case "ActualTextColor":
                case "ActualHoverTextColor":
                case "ActualTextStyle":
                case "ActualHighlightTextColor":
                case "ActualHoverHighlightTextColor":
                    if (this.aa != null) {
                        if (this.aa.playState == 3) {
                            this.aa = null;
                        }
                        else {
                            this.ah = true;
                        }
                    }
                    if (this.z != null) {
                        if (this.z.playState == 3) {
                            this.z = null;
                        }
                        else {
                            this.ag = true;
                        }
                    }
                    this.cm();
                    break;
                case "Text":
                    this.view.ae();
                    break;
                case "Density":
                    this.s = this.t == 0 ? 1 : this.t;
                    break;
                case "ActualDensity":
                    this.view.ag();
                    this.view.af();
                    break;
                case "InputGroup":
                    this.view.af();
                    break;
                case "IsHighlighted":
                    this.cc();
                    break;
                case "IsShifted":
                    this.cd();
                    break;
                case "ShiftType":
                    if (this.aa != null) {
                        if (this.aa.playState == 3) {
                            this.aa = null;
                        }
                        else {
                            this.ah = true;
                        }
                    }
                    this.cg();
                    break;
                case "Display":
                    this.view.y();
                    break;
                case "FlexDirection":
                    this.view.z();
                    break;
                case "FlexGrow":
                    this.view.aa();
                    break;
                case "AlignItems":
                    this.view.t();
                    break;
                case "AlignSelf":
                    this.view.u();
                    break;
            }
        }
        cg() {
            this.view.af();
        }
        cd() {
            this.b8();
            let a = 1;
            let b = this.an;
            if (!b) {
                a = -1;
            }
            this.ci(this.aa, a);
        }
        cc() {
            this.b8();
            let a = 1;
            let b = this.al;
            if (!b) {
                a = -1;
            }
            this.ci(this.z, a);
        }
        cn() {
            this.cz = this.df != null ? this.df : XLabel.db;
            this.cy = this.de != null ? this.de : XLabel.db;
            this.cw = this.dc != null ? this.dc : XLabel.c4;
            this.w = this.y != null ? this.y : XLabel.x;
        }
        cm() {
            if (this.w != null) {
                this.view.ai(this.w);
            }
            this.view.ad(this.cz);
        }
        cl(a) {
            XLabel.db = ThemeResolver.ah(a, XLabel.da, XLabel.c3);
            XLabel.c4 = ThemeResolver.ah(a, XLabel.c7, XLabel.c0);
            XLabel.c6 = ThemeResolver.ah(a, XLabel.c9, XLabel.c2);
            XLabel.c5 = ThemeResolver.ah(a, XLabel.c8, XLabel.c1);
        }
        get t() {
            return this.r;
        }
        set t(a) {
            let b = this.r;
            this.r = a;
            if (b != this.r) {
                this.g("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        get s() {
            return this.q;
        }
        set s(a) {
            let b = this.q;
            this.q = a;
            if (b != this.q) {
                this.g("ActualDensity", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        get cz() {
            return this.cr;
        }
        set cz(a) {
            let b = this.cr;
            this.cr = a;
            if (b != this.cr) {
                this.g("ActualTextColor", b, a);
            }
        }
        get cw() {
            return this.co;
        }
        set cw(a) {
            let b = this.co;
            this.co = a;
            if (b != this.co) {
                this.g("ActualHighlightTextColor", b, a);
            }
        }
        get cx() {
            return this.cp;
        }
        set cx(a) {
            let b = this.cp;
            this.cp = a;
            if (b != this.cp) {
                this.g("ActualHoverHighlightTextColor", b, a);
            }
        }
        get cy() {
            return this.cq;
        }
        set cy(a) {
            let b = this.cq;
            this.cq = a;
            if (b != this.cq) {
                this.g("ActualHoverTextColor", b, a);
            }
        }
        get w() {
            return this.u;
        }
        set w(a) {
            let b = this.u;
            this.u = a;
            if (b != this.u) {
                this.g("ActualTextStyle", b, a);
            }
        }
        get df() {
            return this.cv;
        }
        set df(a) {
            let b = this.cv;
            this.cv = a;
            if (b != this.cv) {
                this.g("TextColor", b, a);
            }
        }
        get dc() {
            return this.cs;
        }
        set dc(a) {
            let b = this.cs;
            this.cs = a;
            if (b != this.cs) {
                this.g("HighlightTextColor", b, a);
            }
        }
        get dd() {
            return this.ct;
        }
        set dd(a) {
            let b = this.ct;
            this.ct = a;
            if (b != this.ct) {
                this.g("HoverHighlightTextColor", b, a);
            }
        }
        get l() {
            return this.k;
        }
        set l(a) {
            let b = this.k;
            this.k = a;
            if (b != this.k) {
                this.g("ShiftType", enumGetBox(LabelShiftType_$type, b), enumGetBox(LabelShiftType_$type, a));
            }
        }
        get an() {
            return this.af;
        }
        set an(a) {
            let b = this.af;
            this.af = a;
            if (b != this.af) {
                this.g("IsShifted", b, a);
            }
        }
        ck(a, b = true) {
            let c = this.ap;
            if (!b) {
                this.ap = true;
            }
            try {
                this.an = a;
            }
            finally {
                if (!b) {
                    this.ap = c;
                }
            }
        }
        get al() {
            return this.ad;
        }
        set al(a) {
            let b = this.ad;
            this.ad = a;
            if (b != this.ad) {
                this.g("IsHighlighted", b, a);
            }
        }
        ce() {
            this.am = true;
        }
        cf() {
            this.am = false;
        }
        get y() {
            return this.v;
        }
        set y(a) {
            let b = this.v;
            this.v = a;
            if (b != this.v) {
                this.g("TextStyle", b, a);
            }
        }
        get de() {
            return this.cu;
        }
        set de(a) {
            let b = this.cu;
            this.cu = a;
            if (b != this.cu) {
                this.g("HoverTextColor", b, a);
            }
        }
        get bu() {
            return this.a2;
        }
        set bu(a) {
            let b = this.a2;
            this.a2 = a;
            if (b != this.a2) {
                this.g("Id", b, a);
            }
        }
        get bi() {
            return this.ay;
        }
        set bi(a) {
            let b = this.ay;
            this.ay = a;
            if (b != this.ay) {
                this.g("Display", b, a);
            }
        }
        get bl() {
            return this.az;
        }
        set bl(a) {
            let b = this.az;
            this.az = a;
            if (b != this.az) {
                this.g("FlexDirection", b, a);
            }
        }
        get bn() {
            return this.a0;
        }
        set bn(a) {
            let b = this.a0;
            this.a0 = a;
            if (b != this.a0) {
                this.g("FlexGrow", b, a);
            }
        }
        get ba() {
            return this.av;
        }
        set ba(a) {
            let b = this.av;
            this.av = a;
            if (b != this.av) {
                this.g("AlignItems", b, a);
            }
        }
        get bc() {
            return this.aw;
        }
        set bc(a) {
            let b = this.aw;
            this.aw = a;
            if (b != this.aw) {
                this.g("AlignSelf", b, a);
            }
        }
        get aj() {
            return this.ab;
        }
        get as() {
            return this.ar;
        }
        set as(a) {
            let b = this.ar;
            this.ar = a;
            this.ab = true;
            if (b != this.ar) {
                this.g("TabIndex", b, a);
            }
        }
        get bp() {
            return this.a1;
        }
        set bp(a) {
            let b = this.a1;
            this.a1 = a;
            if (b != this.a1) {
                this.g("TabIndex", b, a);
            }
        }
        get be() {
            return this.ax;
        }
        set be(a) {
            let b = this.ax;
            this.ax = a;
            if (b != this.ax) {
                this.g("AriaLabel", b, a);
            }
        }
        get text() {
            return this.a3;
        }
        set text(a) {
            let b = this.a3;
            this.a3 = a;
            if (b != this.a3) {
                this.g("Text", b, a);
            }
        }
        get am() {
            return this.ae;
        }
        set am(a) {
            let b = this.ae;
            this.ae = a;
            if (b != this.ae) {
                this.g("IsHover", b, a);
            }
        }
        get aq() {
            return this.ai;
        }
        set aq(a) {
            let b = this.ai;
            this.ai = a;
            if (b != this.ai) {
                this.g("Value", b, a);
            }
        }
        get disabled() {
            return this.ac;
        }
        set disabled(a) {
            let b = this.ac;
            this.ac = a;
            if (b != this.ac) {
                this.g("IsDisabled", b, a);
            }
        }
        ch() {
            this.view.ae();
        }
        onDetachedFromUI() {
            this.view.x();
        }
        onAttachedToUI() {
            this.view.v();
        }
        ao() {
            return this.view.f();
        }
        au() {
            return this.j();
        }
        bk() {
            let a = this.j();
            return a.q();
        }
        j() {
            let a = new LabelVisualModelExport();
            let b = this.view.n;
            a.c = this.p;
            a.e = this.t;
            a.d = this.s;
            a.a = AppearanceHelper.a(NativeUI.al(b));
            a.b = this.l;
            a.i = this.an;
            a.g = this.al;
            a.m = this.bi;
            a.n = this.bl;
            a.o = this.bn;
            a.l = this.ba;
            a.r = this.text;
            a.h = this.am;
            a.j = this.aq;
            a.f = this.disabled;
            a.p = this.e;
            if (this.w != null) {
                let c = this.w;
                if (this.view != null && c.q == null) {
                    let d = this.view.k;
                    let e = FontUtil.getFontInfoFromString(d, c.fontString);
                    c.q = e.q;
                    c.f = e.f;
                    c.r = e.r;
                    c.t = e.t;
                    c.u = e.u;
                    c.v = e.v;
                }
                if (c.q != null) {
                    a.s = c.q;
                }
                if (!isNaN_(c.f)) {
                    a.k = c.f;
                }
                if (c.v != null) {
                    a.w = c.v;
                }
                if (c.t != null) {
                    a.u = c.t;
                }
                if (c.r != null) {
                    a.t = c.t;
                }
            }
            return a;
        }
        provideContainer(a) {
            this.view.w(a);
        }
    }
    XLabel.$t = /*@__PURE__*/ markType(XLabel, 'XLabel', XInputGroupItem.$);
    XLabel.da = /*@__PURE__*/ BrushUtil.h(221, 0, 0, 0);
    XLabel.c7 = /*@__PURE__*/ BrushUtil.h(255, 0, 153, 155);
    XLabel.c9 = /*@__PURE__*/ BrushUtil.h(221, 0, 0, 0);
    XLabel.c8 = /*@__PURE__*/ BrushUtil.h(255, 0, 153, 155);
    XLabel.c3 = /*@__PURE__*/ BrushUtil.h(255, 24, 29, 31);
    XLabel.c0 = /*@__PURE__*/ BrushUtil.h(255, 33, 150, 243);
    XLabel.c2 = /*@__PURE__*/ BrushUtil.h(255, 24, 29, 31);
    XLabel.c1 = /*@__PURE__*/ BrushUtil.h(255, 33, 150, 243);
    XLabel.o = 2;
    XLabel.db = /*@__PURE__*/ ThemeResolver.ah(XLabel.o, XLabel.da, XLabel.c3);
    XLabel.c4 = /*@__PURE__*/ ThemeResolver.ah(XLabel.o, XLabel.c7, XLabel.c0);
    XLabel.c6 = /*@__PURE__*/ ThemeResolver.ah(XLabel.o, XLabel.c9, XLabel.c2);
    XLabel.c5 = /*@__PURE__*/ ThemeResolver.ah(XLabel.o, XLabel.c8, XLabel.c1);
    XLabel.x = null;
    XLabel.at = 0;
    return XLabel;
})();
/**
 * @hidden
 */
export let XInput = /*@__PURE__*/ (() => {
    class XInput extends XInputGroupItem {
        constructor() {
            super();
            this.u = null;
            this.a7 = 0;
            this.a8 = 0;
            this.q = 0;
            this.bp = "";
            this.bj = "";
            this.ah = false;
            this.bk = null;
            this.ai = false;
            this.aq = false;
            this._view = null;
            this.n = 0;
            this.v = 0;
            this.y = 1;
            this.x = 1;
            this.bo = null;
            this.br = "_";
            this.ak = false;
            this.ar = true;
            this.d0 = XInput.d6;
            this.dz = XInput.d5;
            this.ab = null;
            this.d2 = XInput.d6;
            this.keyDown = null;
            this.keyUp = null;
            this.keyPress = null;
            this.gotFocus = null;
            this.lostFocus = null;
            this.mouseDown = null;
            this.mouseUp = null;
            this.ac = null;
            this.bn = "text";
            this.bq = "text";
            this.d1 = null;
            this.bm = "ig-input-" + XInput.bf++;
            this.a9 = 0;
            this.aj = false;
            this.bl = null;
            this.bi = null;
            this.an = false;
            this.bh = null;
            this.bs = null;
            this.am = false;
            this.al = false;
            this.ao = false;
            this.dx = 0;
            this.change = null;
            this.changing = null;
            this.compositionStart = null;
            this.compositionEnd = null;
            this.ap = true;
            this.ag = null;
            this.a0 = false;
            this.u = new MaskParsingService();
            let a = new InputView();
            a.b = this;
            this.view = a;
            this.view.as();
            XInput.ae = new FontInfo();
            XInput.ae.q = "Verdana";
        }
        get view() {
            return this._view;
        }
        set view(a) {
            this._view = a;
        }
        destroy() {
            this.provideContainer(null);
        }
        get o() {
            return this.n;
        }
        set o(a) {
            let b = this.n;
            this.n = a;
            if (b != this.n) {
                this.g("ShiftType", enumGetBox(InputShiftType_$type, b), enumGetBox(InputShiftType_$type, a));
            }
        }
        get w() {
            return this.v;
        }
        set w(a) {
            let b = this.v;
            this.v = a;
            if (b != this.v) {
                this.g("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        }
        get aa() {
            return this.y;
        }
        set aa(a) {
            let b = this.y;
            this.y = a;
            if (b != this.y) {
                this.g("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        get z() {
            return this.x;
        }
        set z(a) {
            let b = this.x;
            this.x = a;
            if (b != this.x) {
                this.g("ActualDensity", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        get ce() {
            return this.bo;
        }
        set ce(a) {
            let b = this.bo;
            this.bo = a;
            if (b != this.bo) {
                this.g("Mask", b, a);
            }
        }
        get ci() {
            return this.br;
        }
        set ci(a) {
            let b = this.br;
            this.br = a;
            if (b != this.br) {
                this.g("PromptChar", b, a);
            }
        }
        get au() {
            return this.ak;
        }
        set au(a) {
            let b = this.ak;
            this.ak = a;
            if (b != this.ak) {
                this.g("IncludeLiterals", b, a);
            }
        }
        get a1() {
            return this.ar;
        }
        set a1(a) {
            let b = this.ar;
            this.ar = a;
            if (b != this.ar) {
                this.g("ShowSpinner", b, a);
            }
        }
        h(a, b, c) {
            super.h(a, b, c);
            switch (a) {
                case "TextColor":
                case "HoverTextColor":
                case "TextStyle":
                    this.dv();
                    break;
                case "ActualTextColor":
                case "ActualHoverTextColor":
                case "ActualTextStyle":
                    this.du();
                    break;
                case "Value":
                    if (!this.al) {
                        this.view.ax(this.cq);
                        if (this.b != null) {
                            this.b.kh();
                        }
                        if (this.ce != null && !this.aq) {
                            this.dw(this.cq);
                        }
                    }
                    break;
                case "Name":
                    this.view.az(this.e);
                    break;
                case "Density":
                    this.z = this.aa == 0 ? 1 : this.aa;
                    break;
                case "ActualDensity":
                    this.view.a9();
                    this.view.a8();
                    break;
                case "InputGroup":
                    this.c8();
                    break;
                case "ShiftType":
                    this.dj();
                    break;
                case "InputType":
                    this.dk();
                    break;
                case "Placeholder":
                    this.di();
                    break;
                case "Mask":
                    this.cg = this.ce;
                    break;
                case "PromptChar": break;
                case "IncludeLiterals": break;
                case "IsShown":
                    this.c9();
                    break;
                case "IsDisabled":
                    this.view.ay(this.am);
                    break;
                case "IsReadOnly":
                    this.view.a0(this.ao);
                    break;
                case "TextAlignment":
                    this.view.a5(this.dy);
                    break;
                case "ShowSpinner":
                    this.view.a4(this.a1);
                    break;
                case "TabIndex":
                    this.view.a7();
                    break;
            }
        }
        di() {
            this.view.au();
        }
        dk() {
            this.view.aw();
        }
        dj() {
            this.view.a8();
        }
        c8() {
            this.view.a8();
        }
        dv() {
            this.d4 = this.d8 != null ? this.d8 : XInput.d6;
            this.d3 = this.d7 != null ? this.d7 : XInput.d6;
            this.ad = this.af != null ? this.af : XInput.ae;
        }
        du() {
            if (this.ad != null) {
                this.view.bb(this.ad);
            }
            NativeUI.q(this.view.q, this.d4);
            this.view.a6();
        }
        get d4() {
            return this.d0;
        }
        set d4(a) {
            let b = this.d0;
            this.d0 = a;
            if (b != this.d0) {
                this.g("ActualTextColor", b, a);
            }
        }
        get d3() {
            return this.dz;
        }
        set d3(a) {
            let b = this.dz;
            this.dz = a;
            if (b != this.dz) {
                this.g("ActualHoverTextColor", b, a);
            }
        }
        get ad() {
            return this.ab;
        }
        set ad(a) {
            let b = this.ab;
            this.ab = a;
            if (b != this.ab) {
                this.g("ActualTextStyle", b, a);
            }
        }
        get d8() {
            return this.d2;
        }
        set d8(a) {
            let b = this.d2;
            this.d2 = a;
            if (b != this.d2) {
                this.g("TextColor", b, a);
            }
        }
        cz() {
            if (this.ce != null) {
                this.ds(this.cq);
            }
            if (null != this.lostFocus) {
                this.lostFocus(this, EventArgs.empty);
            }
        }
        c7() {
            if (this.ce != null) {
                this.dt(this.cq);
            }
            if (null != this.gotFocus) {
                this.gotFocus(this, EventArgs.empty);
            }
        }
        da(a) {
            if (this.ce != null) {
                let b = a.keyCode;
                if ((b == 17 && b == 90) || (b == 17 && b == 89)) {
                    a.preventDefault();
                }
                this.q = b;
                this.a8 = this.bb();
                this.a7 = this.ba();
            }
            if (null != this.keyDown) {
                this.keyDown(this, a);
            }
        }
        dc(a) {
            if (null != this.keyUp) {
                this.keyUp(this, a);
            }
        }
        db(a) {
            if (null != this.keyPress) {
                this.keyPress(this, a);
            }
        }
        dd(a) {
            if (null != this.mouseDown) {
                this.mouseDown(this, a);
            }
        }
        dg(a) {
            if (null != this.mouseUp) {
                this.mouseUp(this, a);
            }
        }
        dh() {
            if (this.ce != null) {
                this.bp = this.cq;
                this.a8 = this.bb();
            }
        }
        c5() {
            if (this.ce != null) {
                if (!this.ah) {
                    this.dt(this.bj);
                }
            }
        }
        c6() {
            if (this.ce != null) {
                if (!this.ah) {
                    this.ds(this.cq);
                }
            }
        }
        c0() {
            this.al = true;
            this.cq = this.view.s();
            if (this.change != null) {
                this.change(this, ((() => {
                    let $ret = new InputChangeEventArgs();
                    $ret.value = this.cq;
                    $ret.isCompositionInProgress = this.view.g;
                    return $ret;
                })()));
            }
            this.al = false;
        }
        c1() {
            this.al = true;
            this.cq = this.view.s();
            this.al = false;
            if (this.ce != null) {
                this.aq = true;
                if (this.ai) {
                    this.a8 = this.bb();
                }
                if (this.cq.length < this.bp.length && this.q == 229) {
                    this.q = 8;
                }
                let a = this.bb();
                let b = this.ba();
                let c = "";
                switch (this.q) {
                    case 46:
                        this.a7 = this.a8 == this.a7 ? ++this.a7 : this.a7;
                        break;
                    case 8:
                        this.a8 = this.bb();
                        break;
                    default:
                        c = this.cq.substr(this.a8, this.ba() - this.a8);
                        break;
                }
                let d = new MaskOptions();
                d.a = this.ce;
                d.b = this.ci;
                let e = this.u.a(this.bp, c, d, this.a8, this.a7);
                this.cq = e.b;
                if (this.q == 8) {
                    e.a = this.a8;
                }
                this.dr(e.a, e.a);
                let f = this.u.i(this.cq, d);
                this.bj = this.au ? this.cq : f;
                this.cs();
                this.aq = false;
            }
            this.al = true;
            if (this.changing != null) {
                this.changing(this, ((() => {
                    let $ret = new InputChangeEventArgs();
                    $ret.value = this.cq;
                    $ret.isCompositionInProgress = this.view.g;
                    return $ret;
                })()));
            }
            this.al = false;
        }
        c3() {
            if (this.compositionStart != null) {
                this.compositionStart(this, new EventArgs());
            }
        }
        c2(a) {
            if (this.compositionEnd != null) {
                this.compositionEnd(this, ((() => {
                    let $ret = new InputChangeEventArgs();
                    $ret.value = a;
                    return $ret;
                })()));
            }
        }
        de() {
            this.aw = true;
        }
        df() {
            this.aw = false;
        }
        get af() {
            return this.ac;
        }
        set af(a) {
            let b = this.ac;
            this.ac = a;
            if (b != this.ac) {
                this.g("TextStyle", b, a);
            }
        }
        get b8() {
            return this.bn;
        }
        set b8(a) {
            let b = this.bn;
            this.bn = a;
            if (b != this.bn) {
                this.g("InputType", b, a);
            }
        }
        get cg() {
            return this.bq;
        }
        set cg(a) {
            let b = this.bq;
            this.bq = a;
            if (b != this.bq) {
                this.g("Placeholder", b, a);
            }
        }
        get d7() {
            return this.d1;
        }
        set d7(a) {
            let b = this.d1;
            this.d1 = a;
            if (b != this.d1) {
                this.g("HoverTextColor", b, a);
            }
        }
        get b5() {
            return this.bm;
        }
        set b5(a) {
            let b = this.bm;
            this.bm = a;
            if (b != this.bm) {
                this.g("Id", b, a);
            }
        }
        get as() {
            return this.aj;
        }
        get be() {
            return this.a9;
        }
        set be(a) {
            let b = this.a9;
            this.a9 = a;
            this.aj = true;
            if (b != this.a9) {
                this.g("TabIndex", b, a);
            }
        }
        cu() {
            this.a9 = 0;
            this.aj = false;
            this.view.a7();
        }
        get b2() {
            return this.bl;
        }
        set b2(a) {
            let b = this.bl;
            this.bl = a;
            if (b != this.bl) {
                this.g("TabIndex", b, a);
            }
        }
        get bx() {
            return this.bi;
        }
        set bx(a) {
            let b = this.bi;
            this.bi = a;
            if (b != this.bi) {
                this.g("AriaLabel", b, a);
            }
        }
        get aw() {
            return this.an;
        }
        set aw(a) {
            let b = this.an;
            this.an = a;
            if (b != this.an) {
                this.g("IsHover", b, a);
            }
        }
        get cq() {
            return this.bs;
        }
        set cq(a) {
            let b = this.bs;
            this.bs = a;
            if (b != this.bs) {
                this.g("Value", b, a);
            }
        }
        get at() {
            return !stringIsNullOrEmpty(this.cq);
        }
        get disabled() {
            return this.am;
        }
        set disabled(a) {
            let b = this.am;
            this.am = a;
            if (b != this.am) {
                this.g("IsDisabled", b, a);
            }
        }
        get readonly() {
            return this.ao;
        }
        set readonly(a) {
            let b = this.ao;
            this.ao = a;
            if (b != this.ao) {
                this.g("IsReadOnly", b, this.ao);
            }
        }
        get dy() {
            return this.dx;
        }
        set dy(a) {
            let b = this.dx;
            this.dx = a;
            if (b != this.dx) {
                this.g("TextAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.dx));
            }
        }
        dl() {
        }
        onDetachedFromUI() {
            this.view.aq();
        }
        onAttachedToUI() {
            this.view.an();
        }
        az() {
            return this.view.h();
        }
        bg() {
            return this.j();
        }
        b1() {
            let a = this.j();
            return a.n();
        }
        j() {
            let a = new InputVisualModelExport();
            let b = this.view.q;
            a.h = this.view.l.rootWrapper.getNativeElement().offsetTop;
            a.f = this.view.l.rootWrapper.getNativeElement().offsetLeft;
            a.b = this.o;
            a.c = this.z;
            a.j = this.ce;
            a.m = this.ci;
            a.d = this.au;
            a.a = AppearanceHelper.a(NativeUI.al(b));
            a.i = this.b8;
            a.l = this.cg;
            a.e = this.aw;
            a.t = this.cq;
            a.k = this.e;
            if (this.ad != null) {
                let c = this.ad;
                if (this.view != null && c.q == null) {
                    let d = this.view.l;
                    let e = FontUtil.getFontInfoFromString(d, c.fontString);
                    c.q = e.q;
                    c.f = e.f;
                    c.r = e.r;
                    c.t = e.t;
                    c.u = e.u;
                    c.v = e.v;
                }
                if (c.q != null) {
                    a.o = c.q;
                }
                if (!isNaN_(c.f)) {
                    a.g = c.f;
                }
                if (c.v != null) {
                    a.s = c.v;
                }
                if (c.t != null) {
                    a.q = c.t;
                }
                if (c.r != null) {
                    a.p = c.t;
                }
            }
            return a;
        }
        dr(a, b) {
            this.view.a2(a, b);
        }
        provideContainer(a) {
            this.view.ap(a);
        }
        ct() {
            this.cz();
            this.view.ao();
        }
        focus(a = false) {
            this.c7();
            this.view.ar(a);
        }
        dp() {
            this.view.av();
        }
        dt(a) {
            this.aq = true;
            let b = new MaskOptions();
            b.a = this.ce;
            b.b = this.ci;
            this.cq = this.u.h(this.cq, b);
            this.bp = this.cq;
            this.aq = false;
        }
        ds(a) {
            this.aq = true;
            let b = new MaskOptions();
            b.a = this.ce;
            b.b = this.ci;
            if (a == this.u.h(null, b)) {
                this.cq = "";
            }
            this.aq = false;
        }
        dw(a) {
            let b = new MaskOptions();
            b.a = this.ce;
            b.b = this.ci;
            if (this.ci != null && this.ci.length > 1) {
                b.b = this.ci.substr(0, 1);
            }
            this.cq = a != null ? this.u.h(a, b) : "";
            this.bj = this.au ? this.cq : a;
            if (this.changing != null) {
                this.changing(this, ((() => {
                    let $ret = new InputChangeEventArgs();
                    $ret.value = this.cq;
                    $ret.isCompositionInProgress = this.view.g;
                    return $ret;
                })()));
            }
        }
        cs() {
            this.bp = this.cq;
            this.ai = false;
            this.a8 = 0;
            this.a7 = 0;
            this.q = 0;
        }
        bb() {
            let a = this.view.p();
            let b = this.view.o();
            return a == b && this.ai ? b - this.bk.length : a;
        }
        ba() {
            return this.view.o();
        }
        get selectionStart() {
            return this.bb();
        }
        set selectionStart(a) {
            this.view.a3(a);
        }
        get selectionEnd() {
            return this.ba();
        }
        set selectionEnd(a) {
            this.view.a1(a);
        }
        get ay() {
            return this.ap;
        }
        set ay(a) {
            let b = this.ap;
            this.ap = a;
            if (b != this.ap) {
                this.g("IsShown", b, a);
            }
        }
        dq(a, b = true) {
            let c = this.a0;
            if (!b) {
                this.a0 = true;
            }
            try {
                this.ay = a;
            }
            finally {
                if (!b) {
                    this.a0 = c;
                }
            }
        }
        c9() {
            this.cw();
            this.dm(this.ag, this.ay);
        }
        cw() {
            this.view.al();
            if (this.ag == null) {
                this.ag = KeyFrameAnimationFactory.f.c(this.view.a(this.i).m(new AnimationKeyFrameProperty(1, 0)).m(new AnimationKeyFrameProperty(1, 1)));
            }
        }
        get i() {
            let a = new AnimationKeyFrameEffectTiming();
            a.g = 300;
            a.b = 0;
            return a;
        }
        dm(a, b) {
            let c = a.playbackRate < 0;
            if (b != c) {
                a.play();
            }
            else {
                a.reverse();
            }
            if (this.a0) {
                a.finish();
                a.commitStyles();
                return;
            }
            a.finished.f((d) => a.commitStyles());
        }
    }
    XInput.$t = /*@__PURE__*/ markType(XInput, 'XInput', XInputGroupItem.$);
    XInput.d6 = /*@__PURE__*/ BrushUtil.h(221, 0, 0, 0);
    XInput.d5 = /*@__PURE__*/ BrushUtil.h(221, 0, 0, 0);
    XInput.ae = null;
    XInput.bf = 0;
    return XInput;
})();
