/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, typeGetValue, EnumUtil, markType } from "igniteui-react-core";
import { ElevationMode_$type } from "igniteui-react-core";
import { Theme } from "./Theme";
/**
 * @hidden
 */
export let ThemeResolver = /*@__PURE__*/ (() => {
    class ThemeResolver extends Base {
        static ah(a, b, c) {
            if (a == 1) {
                return c;
            }
            return b;
        }
        static r(a, b, c) {
            if (a == 1) {
                return c;
            }
            return b;
        }
        static m(a, b, c) {
            if (a == 1) {
                return c;
            }
            return b;
        }
        static ac(a, b, c) {
            if (a == 1) {
                return c;
            }
            return b;
        }
        static am(a, b, c) {
            if (a == 1) {
                return c;
            }
            return b;
        }
        static g(a, b, c) {
            if (a == 1) {
                return c;
            }
            return b;
        }
        static a(a) {
            return new Theme(0, a);
        }
        static ag(a, b, c) {
            return b.ae(a, c);
        }
        static af(a, b, c, d) {
            return b.ad(a, c, d);
        }
        static q(a, b, c) {
            return b.o(a, c);
        }
        static p(a, b, c, d) {
            return b.n(a, c, d);
        }
        static l(a, b, c) {
            return b.j(a, c);
        }
        static k(a, b, c, d) {
            return b.i(a, c, d);
        }
        static x(a, b, c) {
            return b.v(a, c);
        }
        static w(a, b, c, d) {
            return b.u(a, c, d);
        }
        static f(a, b, c) {
            return b.d(a, c);
        }
        static e(a, b, c, d) {
            return b.c(a, c, d);
        }
        static ab(a, b, c) {
            return b.z(a, c);
        }
        static aa(a, b, c, d) {
            return b.y(a, c, d);
        }
        static al(a, b, c) {
            return b.aj(a, c);
        }
        static ak(a, b, c, d) {
            return b.ai(a, c, d);
        }
        constructor(a, ..._rest) {
            super();
            this.b = 0;
            this.h = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        this.h = c;
                        this.b = d;
                    }
                    break;
            }
        }
        t(a, b) {
            if (this.h.containsKey(a)) {
                return this.h.item(a).item(b);
            }
            else {
                return this.h.item(this.b).item(b);
            }
        }
        s(a, b, c) {
            if (this.h.containsKey(a)) {
                let d = this.h.item(a).c;
                return d.item(b).item(c);
            }
            else {
                let e = this.h.item(this.b).c;
                return e.item(b).item(c);
            }
        }
        ae(a, b) {
            return this.t(a, b);
        }
        ad(a, b, c) {
            return this.s(a, b, c);
        }
        o(a, b) {
            return typeGetValue(this.t(a, b));
        }
        n(a, b, c) {
            return typeGetValue(this.s(a, b, c));
        }
        j(a, b) {
            return this.t(a, b);
        }
        i(a, b, c) {
            return this.s(a, b, c);
        }
        v(a, b) {
            return this.t(a, b);
        }
        u(a, b, c) {
            return this.s(a, b, c);
        }
        d(a, b) {
            return EnumUtil.getEnumValue(ElevationMode_$type, this.t(a, b));
        }
        c(a, b, c) {
            return EnumUtil.getEnumValue(ElevationMode_$type, this.s(a, b, c));
        }
        z(a, b) {
            return this.t(a, b);
        }
        y(a, b, c) {
            return this.s(a, b, c);
        }
        aj(a, b) {
            return this.t(a, b);
        }
        ai(a, b, c) {
            return this.s(a, b, c);
        }
    }
    ThemeResolver.$t = /*@__PURE__*/ markType(ThemeResolver, 'ThemeResolver');
    return ThemeResolver;
})();
