/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, typeGetValue, EnumUtil, markType } from "igniteui-react-core";
import { ElevationMode_$type } from "igniteui-react-core";
import { Theme } from "./Theme";
/**
 * @hidden
 */
var ThemeResolver = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ThemeResolver, _super);
    function ThemeResolver(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = _super.call(this) || this;
        _this.b = 0;
        _this.h = null;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0: break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    _this.h = c;
                    _this.b = d;
                }
                break;
        }
        return _this;
    }
    ThemeResolver.ah = function (a, b, c) {
        if (a == 1) {
            return c;
        }
        return b;
    };
    ThemeResolver.r = function (a, b, c) {
        if (a == 1) {
            return c;
        }
        return b;
    };
    ThemeResolver.m = function (a, b, c) {
        if (a == 1) {
            return c;
        }
        return b;
    };
    ThemeResolver.ac = function (a, b, c) {
        if (a == 1) {
            return c;
        }
        return b;
    };
    ThemeResolver.am = function (a, b, c) {
        if (a == 1) {
            return c;
        }
        return b;
    };
    ThemeResolver.g = function (a, b, c) {
        if (a == 1) {
            return c;
        }
        return b;
    };
    ThemeResolver.a = function (a) {
        return new Theme(0, a);
    };
    ThemeResolver.ag = function (a, b, c) {
        return b.ae(a, c);
    };
    ThemeResolver.af = function (a, b, c, d) {
        return b.ad(a, c, d);
    };
    ThemeResolver.q = function (a, b, c) {
        return b.o(a, c);
    };
    ThemeResolver.p = function (a, b, c, d) {
        return b.n(a, c, d);
    };
    ThemeResolver.l = function (a, b, c) {
        return b.j(a, c);
    };
    ThemeResolver.k = function (a, b, c, d) {
        return b.i(a, c, d);
    };
    ThemeResolver.x = function (a, b, c) {
        return b.v(a, c);
    };
    ThemeResolver.w = function (a, b, c, d) {
        return b.u(a, c, d);
    };
    ThemeResolver.f = function (a, b, c) {
        return b.d(a, c);
    };
    ThemeResolver.e = function (a, b, c, d) {
        return b.c(a, c, d);
    };
    ThemeResolver.ab = function (a, b, c) {
        return b.z(a, c);
    };
    ThemeResolver.aa = function (a, b, c, d) {
        return b.y(a, c, d);
    };
    ThemeResolver.al = function (a, b, c) {
        return b.aj(a, c);
    };
    ThemeResolver.ak = function (a, b, c, d) {
        return b.ai(a, c, d);
    };
    ThemeResolver.prototype.t = function (a, b) {
        if (this.h.containsKey(a)) {
            return this.h.item(a).item(b);
        }
        else {
            return this.h.item(this.b).item(b);
        }
    };
    ThemeResolver.prototype.s = function (a, b, c) {
        if (this.h.containsKey(a)) {
            var d = this.h.item(a).c;
            return d.item(b).item(c);
        }
        else {
            var e = this.h.item(this.b).c;
            return e.item(b).item(c);
        }
    };
    ThemeResolver.prototype.ae = function (a, b) {
        return this.t(a, b);
    };
    ThemeResolver.prototype.ad = function (a, b, c) {
        return this.s(a, b, c);
    };
    ThemeResolver.prototype.o = function (a, b) {
        return typeGetValue(this.t(a, b));
    };
    ThemeResolver.prototype.n = function (a, b, c) {
        return typeGetValue(this.s(a, b, c));
    };
    ThemeResolver.prototype.j = function (a, b) {
        return this.t(a, b);
    };
    ThemeResolver.prototype.i = function (a, b, c) {
        return this.s(a, b, c);
    };
    ThemeResolver.prototype.v = function (a, b) {
        return this.t(a, b);
    };
    ThemeResolver.prototype.u = function (a, b, c) {
        return this.s(a, b, c);
    };
    ThemeResolver.prototype.d = function (a, b) {
        return EnumUtil.getEnumValue(ElevationMode_$type, this.t(a, b));
    };
    ThemeResolver.prototype.c = function (a, b, c) {
        return EnumUtil.getEnumValue(ElevationMode_$type, this.s(a, b, c));
    };
    ThemeResolver.prototype.z = function (a, b) {
        return this.t(a, b);
    };
    ThemeResolver.prototype.y = function (a, b, c) {
        return this.s(a, b, c);
    };
    ThemeResolver.prototype.aj = function (a, b) {
        return this.t(a, b);
    };
    ThemeResolver.prototype.ai = function (a, b, c) {
        return this.s(a, b, c);
    };
    ThemeResolver.$t = markType(ThemeResolver, 'ThemeResolver');
    return ThemeResolver;
}(Base));
export { ThemeResolver };
