import { ButtonClickEventArgs as ButtonClickEventArgs_internal } from "./ButtonClickEventArgs";
var IgrButtonClickEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrButtonClickEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrButtonClickEventArgs.prototype.createImplementation = function () {
        return new ButtonClickEventArgs_internal();
    };
    Object.defineProperty(IgrButtonClickEventArgs.prototype, "nativeElement", {
        get: function () {
            return this._implementation.nativeElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrButtonClickEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrButtonClickEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrButtonClickEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    return IgrButtonClickEventArgs;
}());
export { IgrButtonClickEventArgs };
