import { __extends } from "tslib";
import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { XInputGroupItem as XInputGroupItem_internal } from './XInputGroupItem';
import { IgrXInputGroupItem as IgrXInputGroupItem } from './igr-x-input-group-item';
var IgrXInputGroupInputCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrXInputGroupInputCollection, _super);
    function IgrXInputGroupInputCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgrXInputGroupItem.$type) {
            IgrXInputGroupItem.$type = markType(IgrXInputGroupItem, "IgrXInputGroupItem");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrXInputGroupInputCollection.prototype._createInnerColl = function () {
        if (!IgrXInputGroupItem.$type) {
            IgrXInputGroupItem.$type = markType(IgrXInputGroupItem, "IgrXInputGroupItem");
        }
        var coll = new SyncableObservableCollection$2(IgrXInputGroupItem.$type, XInputGroupItem_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = IgrXInputGroupItem._createFromInternal(int);
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    };
    return IgrXInputGroupInputCollection;
}(IgCollection));
export { IgrXInputGroupInputCollection };
