import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer } from "igniteui-react-core";
import { XRipple } from "./XRipple";
import { Size } from "igniteui-react-core";
import { AnimationKeyFrameEffect } from "igniteui-react-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { BaseControlTheme } from "igniteui-react-core";
import { CheckboxLabelPosition } from "./CheckboxLabelPosition";
import { ThemeResolver } from "./ThemeResolver";
import { CheckboxChangeEventArgs } from "./CheckboxChangeEventArgs";
import { CheckboxVisualModelExport } from "./CheckboxVisualModelExport";
import { Theme } from "./Theme";
/**
 * @hidden
 */
export declare class CheckboxView extends Base {
    static $t: Type;
    constructor();
    c: XCheckbox;
    af(): void;
    i(): boolean;
    private l;
    private f;
    private j;
    ad(a: DomRenderer): void;
    private v;
    aj(): void;
    al(): Size;
    ai(): void;
    ag(): void;
    private w;
    private z;
    private y;
    private h;
    private x;
    aa(): void;
    a(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    b(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    private ab;
    private g;
    private r;
    private m;
    private q;
    get t(): any;
    get s(): any;
    get e(): XRipple;
    private n;
    private o;
    get u(): any;
    private d;
    private p;
    ac(): void;
    ae(): void;
    ah(): void;
    ak(a: Brush, b: Brush): void;
    k(): number;
}
/**
 * @hidden
 */
export declare class XCheckbox extends Base implements INotifyPropertyChanged {
    static $t: Type;
    constructor();
    private _view;
    get view(): CheckboxView;
    set view(a: CheckboxView);
    private l;
    get n(): BaseControlTheme;
    set n(a: BaseControlTheme);
    destroy(): void;
    protected co(a: string, b: any, c: any): void;
    private cu;
    protected cq(a: string, b: any, c: any): void;
    private s;
    private ct;
    private cw;
    ag: boolean;
    private c6;
    get dl(): Brush;
    set dl(a: Brush);
    private c1;
    get db(): Brush;
    set db(a: Brush);
    private c3;
    get dd(): Brush;
    set dd(a: Brush);
    private c5;
    get dk(): Brush;
    set dk(a: Brush);
    private c0;
    get da(): Brush;
    set da(a: Brush);
    private c7;
    get dm(): Brush;
    set dm(a: Brush);
    private c4;
    get de(): Brush;
    set de(a: Brush);
    static g: Theme;
    static h: Theme;
    static j: Theme;
    static i: Theme;
    static k: ThemeResolver;
    static m: BaseControlTheme;
    bv: string;
    dj: Brush;
    dg: Brush;
    as: number;
    df: Brush;
    at: number;
    dh: Brush;
    au: number;
    di: Brush;
    private cx;
    private a5;
    get bf(): string;
    set bf(a: string);
    private c2;
    get dc(): Brush;
    set dc(a: Brush);
    private cz;
    get c9(): Brush;
    set c9(a: Brush);
    private ak;
    get aq(): number;
    set aq(a: number);
    private ah;
    get an(): number;
    set an(a: number);
    private al;
    get ar(): number;
    set ar(a: number);
    private am;
    get av(): number;
    set av(a: number);
    private aj;
    get ap(): number;
    set ap(a: number);
    private ai;
    get ao(): number;
    set ao(a: number);
    private cy;
    get c8(): Brush;
    set c8(a: Brush);
    private static a1;
    private a9;
    get b1(): string;
    set b1(a: string);
    private static a0;
    private a8;
    get bz(): string;
    set bz(a: string);
    private ba;
    get labelId(): string;
    set labelId(a: string);
    private bb;
    get ca(): string;
    set ca(a: string);
    private ax;
    private t;
    get aa(): boolean;
    get az(): number;
    set az(a: number);
    private aw;
    get ay(): number;
    set ay(a: number);
    private a7;
    get bn(): string;
    set bn(a: string);
    private a6;
    get bm(): string;
    set bm(a: string);
    private a2;
    get a4(): any;
    set a4(a: any);
    private w;
    get focused(): boolean;
    set focused(a: boolean);
    change: (sender: any, args: CheckboxChangeEventArgs) => void;
    private d;
    get e(): CheckboxLabelPosition;
    set e(a: CheckboxLabelPosition);
    private q;
    get y(): boolean;
    set y(a: boolean);
    private u;
    get checked(): boolean;
    set checked(a: boolean);
    private x;
    get indeterminate(): boolean;
    set indeterminate(a: boolean);
    private v;
    get disabled(): boolean;
    set disabled(a: boolean);
    private r;
    get z(): boolean;
    set z(a: boolean);
    cp(): void;
    private get a();
    private ck;
    toggle(): void;
    private cv;
    private o;
    private p;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    onContentReady(): void;
    protected af(): boolean;
    a3(): any;
    by(): string;
    b(): CheckboxVisualModelExport;
    provideContainer(a: DomRenderer): void;
}
