import { Type } from "igniteui-react-core";
/**
 * Indicates some simple date formats to be used.
 */
export declare enum FirstWeek {
    /**
     * First Day of Year is Start of First Week
     */
    FirstDay = 0,
    /**
     * First Full Week in year is First Week
     */
    FirstFullWeek = 1,
    /**
     * First Four Day Week in year is First Week
     */
    FirstFourDayWeek = 2
}
/**
 * @hidden
 */
export declare let FirstWeek_$type: Type;
